import { Component, Input, Output, EventEmitter, ViewChild } from '@angular/core';
import { REPLICATION_CONFIG_HTML } from './replication-config.component.html';
import { REGISTRY_CONFIG_STYLES } from '../registry-config.component.css';
var ReplicationConfigComponent = (function () {
    function ReplicationConfigComponent() {
        this.configChange = new EventEmitter();
        this.showSubTitle = false;
    }
    Object.defineProperty(ReplicationConfigComponent.prototype, "replicationConfig", {
        get: function () {
            return this.config;
        },
        set: function (cfg) {
            this.config = cfg;
            this.configChange.emit(this.config);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ReplicationConfigComponent.prototype, "editable", {
        get: function () {
            return this.replicationConfig &&
                this.replicationConfig.verify_remote_cert &&
                this.replicationConfig.verify_remote_cert.editable;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ReplicationConfigComponent.prototype, "isValid", {
        get: function () {
            return this.replicationConfigForm && this.replicationConfigForm.valid;
        },
        enumerable: true,
        configurable: true
    });
    return ReplicationConfigComponent;
}());
export { ReplicationConfigComponent };
ReplicationConfigComponent.decorators = [
    { type: Component, args: [{
                selector: 'replication-config',
                template: REPLICATION_CONFIG_HTML,
                styles: [REGISTRY_CONFIG_STYLES]
            },] },
];
/** @nocollapse */
ReplicationConfigComponent.ctorParameters = function () { return []; };
ReplicationConfigComponent.propDecorators = {
    'configChange': [{ type: Output },],
    'replicationConfig': [{ type: Input },],
    'showSubTitle': [{ type: Input },],
    'replicationConfigForm': [{ type: ViewChild, args: ["replicationConfigFrom",] },],
};
//# sourceMappingURL=replication-config.component.js.map