import { Component, Input, Output, EventEmitter, ViewChild, Inject } from '@angular/core';
import { SYSTEM_SETTINGS_HTML } from './system-settings.component.html';
import { REGISTRY_CONFIG_STYLES } from '../registry-config.component.css';
import { SERVICE_CONFIG } from '../../service.config';
var SystemSettingsComponent = (function () {
    function SystemSettingsComponent(configInfo) {
        this.configInfo = configInfo;
        this.downloadLink = "/api/systeminfo/getcert";
        this.configChange = new EventEmitter();
        this.showSubTitle = false;
        this.hasAdminRole = false;
        this.hasCAFile = false;
        this.withAdmiral = false;
        if (this.configInfo && this.configInfo.systemInfoEndpoint) {
            this.downloadLink = this.configInfo.systemInfoEndpoint + "/getcert";
        }
    }
    Object.defineProperty(SystemSettingsComponent.prototype, "systemSettings", {
        get: function () {
            return this.config;
        },
        set: function (cfg) {
            this.config = cfg;
            this.configChange.emit(this.config);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SystemSettingsComponent.prototype, "editable", {
        get: function () {
            return this.systemSettings &&
                this.systemSettings.token_expiration &&
                this.systemSettings.token_expiration.editable;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SystemSettingsComponent.prototype, "isValid", {
        get: function () {
            return this.systemSettingsForm && this.systemSettingsForm.valid;
        },
        enumerable: true,
        configurable: true
    });
    SystemSettingsComponent.prototype.setRepoReadOnlyValue = function ($event) {
        this.systemSettings.read_only.value = $event;
    };
    Object.defineProperty(SystemSettingsComponent.prototype, "canDownloadCert", {
        get: function () {
            return this.hasAdminRole && this.hasCAFile;
        },
        enumerable: true,
        configurable: true
    });
    return SystemSettingsComponent;
}());
export { SystemSettingsComponent };
SystemSettingsComponent.decorators = [
    { type: Component, args: [{
                selector: 'system-settings',
                template: SYSTEM_SETTINGS_HTML,
                styles: [REGISTRY_CONFIG_STYLES]
            },] },
];
/** @nocollapse */
SystemSettingsComponent.ctorParameters = function () { return [
    { type: undefined, decorators: [{ type: Inject, args: [SERVICE_CONFIG,] },] },
]; };
SystemSettingsComponent.propDecorators = {
    'configChange': [{ type: Output },],
    'systemSettings': [{ type: Input },],
    'showSubTitle': [{ type: Input },],
    'hasAdminRole': [{ type: Input },],
    'hasCAFile': [{ type: Input },],
    'withAdmiral': [{ type: Input },],
    'systemSettingsForm': [{ type: ViewChild, args: ["systemConfigFrom",] },],
};
//# sourceMappingURL=system-settings.component.js.map