import { Component, Input, Output, EventEmitter, ViewChild } from '@angular/core';
import { DATETIME_PICKER_TEMPLATE } from './datetime-picker.component.html';
var DatePickerComponent = (function () {
    function DatePickerComponent() {
        this.search = new EventEmitter();
    }
    DatePickerComponent.prototype.ngOnChanges = function () {
        this.dateInput = this.dateInput.trim();
    };
    Object.defineProperty(DatePickerComponent.prototype, "dateInvalid", {
        get: function () {
            return (this.searchTime.errors && this.searchTime.errors.dateValidator && (this.searchTime.dirty || this.searchTime.touched)) || false;
        },
        enumerable: true,
        configurable: true
    });
    DatePickerComponent.prototype.convertDate = function (strDate) {
        if (/^(0[1-9]|[12][0-9]|3[01])[- /.](0[1-9]|1[012])[- /.](19|20)\d\d$/.test(strDate)) {
            var parts = strDate.split(/[-\/]/);
            strDate = parts[2] /*Year*/ + '-' + parts[1] /*Month*/ + '-' + parts[0] /*Date*/;
        }
        return strDate;
    };
    DatePickerComponent.prototype.doSearch = function () {
        var searchTerm = '';
        if (this.searchTime.valid && this.dateInput) {
            var timestamp = new Date(this.convertDate(this.searchTime.value)).getTime() / 1000;
            if (this.oneDayOffset) {
                timestamp += 3600 * 24;
            }
            searchTerm = timestamp.toString();
        }
        this.search.emit(searchTerm);
    };
    return DatePickerComponent;
}());
export { DatePickerComponent };
DatePickerComponent.decorators = [
    { type: Component, args: [{
                selector: 'hbr-datetime',
                template: DATETIME_PICKER_TEMPLATE
            },] },
];
/** @nocollapse */
DatePickerComponent.ctorParameters = function () { return []; };
DatePickerComponent.propDecorators = {
    'dateInput': [{ type: Input },],
    'oneDayOffset': [{ type: Input },],
    'searchTime': [{ type: ViewChild, args: ['searchTime',] },],
    'search': [{ type: Output },],
};
//# sourceMappingURL=datetime-picker.component.js.map