import { OnInit, OnDestroy, ChangeDetectorRef } from '@angular/core';
import { Endpoint } from '../service/interface';
import { EndpointService } from '../service/endpoint.service';
import { TranslateService } from '@ngx-translate/core';
import { ErrorHandler } from '../error-handler/index';
import { ConfirmationAcknowledgement } from '../confirmation-dialog/confirmation-state-message';
import { ConfirmationDialogComponent } from '../confirmation-dialog/confirmation-dialog.component';
import { Subscription } from 'rxjs/Subscription';
import { CreateEditEndpointComponent } from '../create-edit-endpoint/create-edit-endpoint.component';
import { Comparator } from 'clarity-angular';
import { BatchInfo } from "../confirmation-dialog/confirmation-batch-message";
export declare class EndpointComponent implements OnInit, OnDestroy {
    private endpointService;
    private errorHandler;
    private translateService;
    private ref;
    createEditEndpointComponent: CreateEditEndpointComponent;
    confirmationDialogComponent: ConfirmationDialogComponent;
    targets: Endpoint[];
    target: Endpoint;
    targetName: string;
    subscription: Subscription;
    loading: boolean;
    creationTimeComparator: Comparator<Endpoint>;
    timerHandler: any;
    selectedRow: Endpoint[];
    batchDelectionInfos: BatchInfo[];
    readonly initEndpoint: Endpoint;
    constructor(endpointService: EndpointService, errorHandler: ErrorHandler, translateService: TranslateService, ref: ChangeDetectorRef);
    ngOnInit(): void;
    ngOnDestroy(): void;
    selectedChange(): void;
    retrieve(): void;
    doSearchTargets(targetName: string): void;
    refreshTargets(): void;
    reload($event: any): void;
    openModal(): void;
    editTargets(targets: Endpoint[]): void;
    deleteTargets(targets: Endpoint[]): void;
    confirmDeletion(message: ConfirmationAcknowledgement): void;
    delOperate(id: number | string, name: string): Promise<void>;
    forceRefreshView(duration: number): void;
}
