import { Component, Input, Output, EventEmitter } from '@angular/core';
import { COPY_INPUT_HTML } from './copy-input.html';
import { PUSH_IMAGE_STYLE } from './push-image.css';
var CopyInputComponent = (function () {
    function CopyInputComponent() {
        this.inputSize = 40;
        this.headerTitle = "Copy Input";
        this.defaultValue = "N/A";
        this.iconMode = false;
        this.state = 0 /* NORMAL */;
        this.onCopySuccess = new EventEmitter();
        this.onCopyError = new EventEmitter();
    }
    CopyInputComponent.prototype.ngOnInit = function () { };
    CopyInputComponent.prototype.onSuccess = function ($event) {
        this.state = 1 /* SUCCESS */;
        this.onCopySuccess.emit($event);
    };
    CopyInputComponent.prototype.onError = function (error) {
        this.state = 2 /* ERROR */;
        this.onCopyError.emit(error);
    };
    CopyInputComponent.prototype.reset = function () {
        this.state = 0 /* NORMAL */;
    };
    CopyInputComponent.prototype.setPullCommendShow = function () {
        this.iconMode = false;
    };
    Object.defineProperty(CopyInputComponent.prototype, "isCopied", {
        get: function () {
            return this.state === 1 /* SUCCESS */;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CopyInputComponent.prototype, "hasCopyError", {
        get: function () {
            return this.state === 2 /* ERROR */;
        },
        enumerable: true,
        configurable: true
    });
    return CopyInputComponent;
}());
export { CopyInputComponent };
CopyInputComponent.decorators = [
    { type: Component, args: [{
                selector: 'hbr-copy-input',
                styles: [PUSH_IMAGE_STYLE],
                template: COPY_INPUT_HTML,
                providers: []
            },] },
];
/** @nocollapse */
CopyInputComponent.ctorParameters = function () { return []; };
CopyInputComponent.propDecorators = {
    'inputSize': [{ type: Input },],
    'headerTitle': [{ type: Input },],
    'defaultValue': [{ type: Input },],
    'iconMode': [{ type: Input },],
    'onCopySuccess': [{ type: Output },],
    'onCopyError': [{ type: Output },],
};
//# sourceMappingURL=copy-input.component.js.map