import { Component, Input, ViewChild } from '@angular/core';
import { PUSH_IMAGE_STYLE } from './push-image.css';
import { PUSH_IMAGE_HTML } from './push-image.html';
var PushImageButtonComponent = (function () {
    function PushImageButtonComponent() {
        this.registryUrl = "unknown";
        this.projectName = "unknown";
    }
    Object.defineProperty(PushImageButtonComponent.prototype, "tagCommand", {
        get: function () {
            return "docker tag SOURCE_IMAGE[:TAG] " + this.registryUrl + "/" + this.projectName + "/IMAGE[:TAG]";
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PushImageButtonComponent.prototype, "pushCommand", {
        get: function () {
            return "docker push " + this.registryUrl + "/" + this.projectName + "/IMAGE[:TAG]";
        },
        enumerable: true,
        configurable: true
    });
    PushImageButtonComponent.prototype.onclick = function () {
        if (this.tagCopyInput) {
            this.tagCopyInput.reset();
        }
        if (this.pushCopyInput) {
            this.pushCopyInput.reset();
        }
        if (this.copyAlert) {
            this.copyAlert.close();
        }
    };
    PushImageButtonComponent.prototype.onCpError = function ($event) {
        if (this.copyAlert) {
            this.copyAlert.showInlineError("PUSH_IMAGE.COPY_ERROR");
        }
    };
    return PushImageButtonComponent;
}());
export { PushImageButtonComponent };
PushImageButtonComponent.decorators = [
    { type: Component, args: [{
                selector: 'hbr-push-image-button',
                template: PUSH_IMAGE_HTML,
                styles: [PUSH_IMAGE_STYLE],
                providers: []
            },] },
];
/** @nocollapse */
PushImageButtonComponent.ctorParameters = function () { return []; };
PushImageButtonComponent.propDecorators = {
    'registryUrl': [{ type: Input },],
    'projectName': [{ type: Input },],
    'tagCopyInput': [{ type: ViewChild, args: ["tagCopy",] },],
    'pushCopyInput': [{ type: ViewChild, args: ["pushCopy",] },],
    'copyAlert': [{ type: ViewChild, args: ["copyAlert",] },],
};
//# sourceMappingURL=push-image.component.js.map