import { OnInit, ChangeDetectorRef, EventEmitter, OnChanges, SimpleChanges } from '@angular/core';
import { Router } from '@angular/router';
import { TranslateService } from '@ngx-translate/core';
import { Comparator } from 'clarity-angular';
import { SystemInfo, SystemInfoService, RepositoryService, RepositoryItem, TagService } from '../service/index';
import { ErrorHandler } from '../error-handler/error-handler';
import { ConfirmationButtons } from '../shared/shared.const';
import { ConfirmationDialogComponent } from '../confirmation-dialog/confirmation-dialog.component';
import { ConfirmationAcknowledgement } from '../confirmation-dialog/confirmation-state-message';
import { State } from "clarity-angular";
import { BatchInfo } from "../confirmation-dialog/confirmation-batch-message";
export declare class RepositoryListviewComponent implements OnChanges, OnInit {
    private errorHandler;
    private translateService;
    private repositoryService;
    private systemInfoService;
    private tagService;
    private ref;
    private router;
    signedCon: {
        [key: string]: any | string[];
    };
    projectId: number;
    projectName: string;
    urlPrefix: string;
    hasSignedIn: boolean;
    hasProjectAdminRole: boolean;
    repoClickEvent: EventEmitter<RepositoryItem>;
    lastFilteredRepoName: string;
    repositories: RepositoryItem[];
    systemInfo: SystemInfo;
    selectedRow: RepositoryItem[];
    loading: boolean;
    confirmationDialog: ConfirmationDialogComponent;
    batchDelectionInfos: BatchInfo[];
    pullCountComparator: Comparator<RepositoryItem>;
    tagsCountComparator: Comparator<RepositoryItem>;
    pageSize: number;
    currentPage: number;
    totalCount: number;
    currentState: State;
    constructor(errorHandler: ErrorHandler, translateService: TranslateService, repositoryService: RepositoryService, systemInfoService: SystemInfoService, tagService: TagService, ref: ChangeDetectorRef, router: Router);
    readonly registryUrl: string;
    readonly withNotary: boolean;
    readonly withClair: boolean;
    readonly isClairDBReady: boolean;
    readonly showDBStatusWarning: boolean;
    ngOnChanges(changes: SimpleChanges): void;
    ngOnInit(): void;
    confirmDeletion(message: ConfirmationAcknowledgement): void;
    delOperate(repoName: string): Promise<void>;
    doSearchRepoNames(repoName: string): void;
    saveSignatures(event: {
        [key: string]: string[];
    }): void;
    deleteRepos(repoLists: RepositoryItem[]): void;
    getTagInfo(repoName: string): Promise<void>;
    signedDataSet(repoName: string): void;
    confirmationDialogSet(summaryTitle: string, signature: string, repoName: string, summaryKey: string, button: ConfirmationButtons): void;
    selectedChange(): void;
    refresh(): void;
    clrLoad(state: State): void;
    getStateAfterDeletion(): State;
    watchRepoClickEvt(repo: RepositoryItem): void;
}
