import { OnInit, ChangeDetectorRef, EventEmitter, OnChanges, SimpleChanges } from '@angular/core';
import { TranslateService } from '@ngx-translate/core';
import { Comparator } from 'clarity-angular';
import { SystemInfo, SystemInfoService, RepositoryService, RepositoryItem } from '../service/index';
import { ErrorHandler } from '../error-handler/error-handler';
import { ConfirmationButtons } from '../shared/shared.const';
import { ConfirmationDialogComponent } from '../confirmation-dialog/confirmation-dialog.component';
import { ConfirmationAcknowledgement } from '../confirmation-dialog/confirmation-state-message';
import { TagClickEvent } from '../service/interface';
import { State } from "clarity-angular";
import { TagService } from '../service/index';
export declare class RepositoryStackviewComponent implements OnChanges, OnInit {
    private errorHandler;
    private translateService;
    private repositoryService;
    private systemInfoService;
    private translate;
    private tagService;
    private ref;
    signedCon: {
        [key: string]: any | string[];
    };
    projectId: number;
    projectName: string;
    hasSignedIn: boolean;
    hasProjectAdminRole: boolean;
    tagClickEvent: EventEmitter<TagClickEvent>;
    lastFilteredRepoName: string;
    repositories: RepositoryItem[];
    systemInfo: SystemInfo;
    loading: boolean;
    confirmationDialog: ConfirmationDialogComponent;
    pullCountComparator: Comparator<RepositoryItem>;
    tagsCountComparator: Comparator<RepositoryItem>;
    pageSize: number;
    currentPage: number;
    totalCount: number;
    currentState: State;
    constructor(errorHandler: ErrorHandler, translateService: TranslateService, repositoryService: RepositoryService, systemInfoService: SystemInfoService, translate: TranslateService, tagService: TagService, ref: ChangeDetectorRef);
    readonly registryUrl: string;
    readonly withNotary: boolean;
    readonly withClair: boolean;
    readonly isClairDBReady: boolean;
    readonly showDBStatusWarning: boolean;
    confirmDeletion(message: ConfirmationAcknowledgement): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngOnInit(): void;
    doSearchRepoNames(repoName: string): void;
    saveSignatures(event: {
        [key: string]: string[];
    }): void;
    deleteRepo(repoName: string): void;
    getTagInfo(repoName: string): Promise<void>;
    signedDataSet(repoName: string): void;
    confirmationDialogSet(summaryTitle: string, signature: string, repoName: string, summaryKey: string, button: ConfirmationButtons): void;
    refresh(): void;
    watchTagClickEvt(tagClickEvt: TagClickEvent): void;
    clrLoad(state: State): void;
    getStateAfterDeletion(): State;
}
