var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Observable } from 'rxjs/Observable';
import { Injectable, Inject } from "@angular/core";
import 'rxjs/add/observable/of';
import { SERVICE_CONFIG } from '../service.config';
import { Http } from '@angular/http';
import { buildHttpRequestOptions, HTTP_GET_OPTIONS } from '../utils';
/**
 * Define service methods to handle the access log related things.
 *
 * @export
 * @abstract
 * @class AccessLogService
 */
var AccessLogService = (function () {
    function AccessLogService() {
    }
    return AccessLogService;
}());
export { AccessLogService };
/**
 * Implement a default service for access log.
 *
 * @export
 * @class AccessLogDefaultService
 * @extends {AccessLogService}
 */
var AccessLogDefaultService = (function (_super) {
    __extends(AccessLogDefaultService, _super);
    function AccessLogDefaultService(http, config) {
        var _this = _super.call(this) || this;
        _this.http = http;
        _this.config = config;
        return _this;
    }
    AccessLogDefaultService.prototype.getAuditLogs = function (projectId, queryParams) {
        return Observable.of({});
    };
    AccessLogDefaultService.prototype.getRecentLogs = function (queryParams) {
        var url = this.config.logBaseEndpoint ? this.config.logBaseEndpoint : "";
        if (url === '') {
            url = '/api/logs';
        }
        return this.http.get(url, queryParams ? buildHttpRequestOptions(queryParams) : HTTP_GET_OPTIONS).toPromise()
            .then(function (response) {
            var result = {
                metadata: {
                    xTotalCount: 0
                },
                data: []
            };
            var xHeader = "0";
            if (response && response.headers) {
                xHeader = response.headers.get("X-Total-Count");
            }
            if (result && result.metadata) {
                result.metadata.xTotalCount = parseInt(xHeader ? xHeader : "0", 0);
                if (result.metadata.xTotalCount > 0) {
                    result.data = response.json();
                }
            }
            return result;
        })
            .catch(function (error) { return Promise.reject(error); });
    };
    return AccessLogDefaultService;
}(AccessLogService));
export { AccessLogDefaultService };
AccessLogDefaultService.decorators = [
    { type: Injectable },
];
/** @nocollapse */
AccessLogDefaultService.ctorParameters = function () { return [
    { type: Http, },
    { type: undefined, decorators: [{ type: Inject, args: [SERVICE_CONFIG,] },] },
]; };
//# sourceMappingURL=access-log.service.js.map