var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Injectable, Inject } from "@angular/core";
import 'rxjs/add/observable/of';
import { SERVICE_CONFIG } from '../service.config';
import { Http } from '@angular/http';
import { HTTP_JSON_OPTIONS, HTTP_GET_OPTIONS } from '../utils';
/**
 * Service used to get and save registry-related configurations.
 *
 * @export
 * @abstract
 * @class ConfigurationService
 */
var ConfigurationService = (function () {
    function ConfigurationService() {
    }
    return ConfigurationService;
}());
export { ConfigurationService };
var ConfigurationDefaultService = (function (_super) {
    __extends(ConfigurationDefaultService, _super);
    function ConfigurationDefaultService(http, config) {
        var _this = _super.call(this) || this;
        _this.http = http;
        _this.config = config;
        _this._baseUrl = _this.config && _this.config.configurationEndpoint ?
            _this.config.configurationEndpoint : "/api/configurations";
        return _this;
    }
    ConfigurationDefaultService.prototype.getConfigurations = function () {
        return this.http.get(this._baseUrl, HTTP_GET_OPTIONS).toPromise()
            .then(function (response) { return response.json(); })
            .catch(function (error) { return Promise.reject(error); });
    };
    ConfigurationDefaultService.prototype.saveConfigurations = function (changedConfigs) {
        if (!changedConfigs) {
            return Promise.reject("Bad argument!");
        }
        return this.http.put(this._baseUrl, JSON.stringify(changedConfigs), HTTP_JSON_OPTIONS)
            .toPromise()
            .then(function () { })
            .catch(function (error) { return Promise.reject(error); });
    };
    return ConfigurationDefaultService;
}(ConfigurationService));
export { ConfigurationDefaultService };
ConfigurationDefaultService.decorators = [
    { type: Injectable },
];
/** @nocollapse */
ConfigurationDefaultService.ctorParameters = function () { return [
    { type: Http, },
    { type: undefined, decorators: [{ type: Inject, args: [SERVICE_CONFIG,] },] },
]; };
//# sourceMappingURL=configuration.service.js.map