var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Injectable, Inject } from "@angular/core";
import 'rxjs/add/observable/of';
import { Http } from '@angular/http';
import { SERVICE_CONFIG } from '../service.config';
import { HTTP_GET_OPTIONS } from '../utils';
/**
 * Define the service methods to handle the job log related things.
 *
 * @export
 * @abstract
 * @class JobLogService
 */
var JobLogService = (function () {
    function JobLogService() {
    }
    return JobLogService;
}());
export { JobLogService };
/**
 * Implement default service for job log service.
 *
 * @export
 * @class JobLogDefaultService
 * @extends {ReplicationService}
 */
var JobLogDefaultService = (function (_super) {
    __extends(JobLogDefaultService, _super);
    function JobLogDefaultService(http, config) {
        var _this = _super.call(this) || this;
        _this.http = http;
        _this._replicationJobBaseUrl = config.replicationJobEndpoint ?
            config.replicationJobEndpoint : '/api/jobs/replication';
        _this._scanningJobBaseUrl = config.scanJobEndpoint ? config.scanJobEndpoint : "/api/jobs/scan";
        _this._supportedJobTypes = ["replication", "scan"];
        return _this;
    }
    JobLogDefaultService.prototype._getJobLog = function (logUrl) {
        return this.http.get(logUrl, HTTP_GET_OPTIONS).toPromise()
            .then(function (response) { return response.text(); })
            .catch(function (error) { return Promise.reject(error); });
    };
    JobLogDefaultService.prototype._isSupportedJobType = function (jobType) {
        if (this._supportedJobTypes.find(function (t) { return t === jobType; })) {
            return true;
        }
        return false;
    };
    JobLogDefaultService.prototype.getJobLog = function (jobType, jobId) {
        if (!this._isSupportedJobType(jobType)) {
            return Promise.reject("Unsupport job type: " + jobType);
        }
        if (!jobId || jobId <= 0) {
            return Promise.reject('Bad argument');
        }
        var logUrl = this._replicationJobBaseUrl + "/" + jobId + "/log";
        if (jobType === "scan") {
            logUrl = this._scanningJobBaseUrl + "/" + jobId + "/log";
        }
        return this._getJobLog(logUrl);
    };
    return JobLogDefaultService;
}(JobLogService));
export { JobLogDefaultService };
JobLogDefaultService.decorators = [
    { type: Injectable },
];
/** @nocollapse */
JobLogDefaultService.ctorParameters = function () { return [
    { type: Http, },
    { type: undefined, decorators: [{ type: Inject, args: [SERVICE_CONFIG,] },] },
]; };
//# sourceMappingURL=job-log.service.js.map