var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Inject, Injectable } from "@angular/core";
import { Http } from "@angular/http";
import { SERVICE_CONFIG } from "../service.config";
import { buildHttpRequestOptions, HTTP_JSON_OPTIONS } from "../utils";
import { RequestQueryParams } from "./RequestQueryParams";
var LabelService = (function () {
    function LabelService() {
    }
    return LabelService;
}());
export { LabelService };
var LabelDefaultService = (function (_super) {
    __extends(LabelDefaultService, _super);
    function LabelDefaultService(config, http) {
        var _this = _super.call(this) || this;
        _this.http = http;
        _this._labelUrl = config.labelEndpoint ? config.labelEndpoint : "/api/labels";
        return _this;
    }
    LabelDefaultService.prototype.getLabels = function (scope, projectId, name, queryParams) {
        if (!queryParams) {
            queryParams = new RequestQueryParams();
        }
        if (scope) {
            queryParams.set('scope', scope);
        }
        if (projectId) {
            queryParams.set('project_id', '' + projectId);
        }
        if (name) {
            queryParams.set('name', '' + name);
        }
        return this.http.get(this._labelUrl, buildHttpRequestOptions(queryParams)).toPromise()
            .then(function (response) { return response.json(); })
            .catch(function (error) { return Promise.reject(error); });
    };
    LabelDefaultService.prototype.getGLabels = function (name, queryParams) {
        if (!queryParams) {
            queryParams = new RequestQueryParams();
        }
        queryParams.set('scope', 'g');
        if (name) {
            queryParams.set('name', '' + name);
        }
        return this.http.get(this._labelUrl, buildHttpRequestOptions(queryParams)).toPromise()
            .then(function (response) { return response.json(); })
            .catch(function (error) { return Promise.reject(error); });
    };
    LabelDefaultService.prototype.getPLabels = function (projectId, name, queryParams) {
        if (!queryParams) {
            queryParams = new RequestQueryParams();
        }
        queryParams.set('scope', 'p');
        if (projectId) {
            queryParams.set('project_id', '' + projectId);
        }
        if (name) {
            queryParams.set('name', '' + name);
        }
        return this.http.get(this._labelUrl, buildHttpRequestOptions(queryParams)).toPromise()
            .then(function (response) { return response.json(); })
            .catch(function (error) { return Promise.reject(error); });
    };
    LabelDefaultService.prototype.createLabel = function (label) {
        if (!label) {
            return Promise.reject('Invalid label.');
        }
        return this.http.post(this._labelUrl, JSON.stringify(label), HTTP_JSON_OPTIONS).toPromise()
            .then(function (response) { return response.status; })
            .catch(function (error) { return Promise.reject(error); });
    };
    LabelDefaultService.prototype.getLabel = function (id) {
        if (!id || id <= 0) {
            return Promise.reject('Bad request argument.');
        }
        var reqUrl = this._labelUrl + "/" + id;
        return this.http.get(reqUrl).toPromise()
            .then(function (response) { return response.json(); })
            .catch(function (error) { return Promise.reject(error); });
    };
    LabelDefaultService.prototype.updateLabel = function (id, label) {
        if (!id || id <= 0) {
            return Promise.reject('Bad request argument.');
        }
        if (!label) {
            return Promise.reject('Invalid endpoint.');
        }
        var reqUrl = this._labelUrl + "/" + id;
        return this.http.put(reqUrl, JSON.stringify(label), HTTP_JSON_OPTIONS).toPromise()
            .then(function (response) { return response.status; })
            .catch(function (error) { return Promise.reject(error); });
    };
    LabelDefaultService.prototype.deleteLabel = function (id) {
        if (!id || id <= 0) {
            return Promise.reject('Bad request argument.');
        }
        var reqUrl = this._labelUrl + "/" + id;
        return this.http.delete(reqUrl).toPromise()
            .then(function (response) { return response.status; })
            .catch(function (error) { return Promise.reject(error); });
    };
    return LabelDefaultService;
}(LabelService));
export { LabelDefaultService };
LabelDefaultService.decorators = [
    { type: Injectable },
];
/** @nocollapse */
LabelDefaultService.ctorParameters = function () { return [
    { type: undefined, decorators: [{ type: Inject, args: [SERVICE_CONFIG,] },] },
    { type: Http, },
]; };
//# sourceMappingURL=label.service.js.map