var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Observable } from 'rxjs/Observable';
import 'rxjs/add/observable/of';
import { Injectable, Inject } from "@angular/core";
import { SERVICE_CONFIG } from '../service.config';
import { Http } from '@angular/http';
import { buildHttpRequestOptions, HTTP_JSON_OPTIONS } from '../utils';
/**
 * Get the vulnerabilities scanning results for the specified tag.
 *
 * @export
 * @abstract
 * @class ScanningResultService
 */
var ScanningResultService = (function () {
    function ScanningResultService() {
    }
    return ScanningResultService;
}());
export { ScanningResultService };
var ScanningResultDefaultService = (function (_super) {
    __extends(ScanningResultDefaultService, _super);
    function ScanningResultDefaultService(http, config) {
        var _this = _super.call(this) || this;
        _this.http = http;
        _this.config = config;
        _this._baseUrl = '/api/repositories';
        if (_this.config && _this.config.vulnerabilityScanningBaseEndpoint) {
            _this._baseUrl = _this.config.vulnerabilityScanningBaseEndpoint;
        }
        return _this;
    }
    ScanningResultDefaultService.prototype.getVulnerabilityScanningSummary = function (repoName, tagId, queryParams) {
        if (!repoName || repoName.trim() === '' || !tagId || tagId.trim() === '') {
            return Promise.reject('Bad argument');
        }
        return Observable.of({});
    };
    ScanningResultDefaultService.prototype.getVulnerabilityScanningResults = function (repoName, tagId, queryParams) {
        if (!repoName || repoName.trim() === '' || !tagId || tagId.trim() === '') {
            return Promise.reject('Bad argument');
        }
        return this.http.get(this._baseUrl + "/" + repoName + "/tags/" + tagId + "/vulnerability/details", buildHttpRequestOptions(queryParams)).toPromise()
            .then(function (response) { return response.json(); })
            .catch(function (error) { return Promise.reject(error); });
    };
    ScanningResultDefaultService.prototype.startVulnerabilityScanning = function (repoName, tagId) {
        if (!repoName || repoName.trim() === '' || !tagId || tagId.trim() === '') {
            return Promise.reject('Bad argument');
        }
        return this.http.post(this._baseUrl + "/" + repoName + "/tags/" + tagId + "/scan", HTTP_JSON_OPTIONS).toPromise()
            .then(function () { return true; })
            .catch(function (error) { return Promise.reject(error); });
    };
    ScanningResultDefaultService.prototype.startScanningAll = function () {
        return this.http.post(this._baseUrl + "/scanAll", HTTP_JSON_OPTIONS).toPromise()
            .then(function () { return true; })
            .catch(function (error) { return Promise.reject(error); });
    };
    return ScanningResultDefaultService;
}(ScanningResultService));
export { ScanningResultDefaultService };
ScanningResultDefaultService.decorators = [
    { type: Injectable },
];
/** @nocollapse */
ScanningResultDefaultService.ctorParameters = function () { return [
    { type: Http, },
    { type: undefined, decorators: [{ type: Inject, args: [SERVICE_CONFIG,] },] },
]; };
//# sourceMappingURL=scanning.service.js.map