var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { RequestQueryParams } from './RequestQueryParams';
import { Injectable, Inject } from "@angular/core";
import 'rxjs/add/observable/of';
import { Http } from '@angular/http';
import { SERVICE_CONFIG } from '../service.config';
import { buildHttpRequestOptions, HTTP_JSON_OPTIONS, HTTP_GET_OPTIONS } from '../utils';
/**
 * For getting tag signatures.
 * This is temporary, will be removed in future.
 *
 * @export
 * @class VerifiedSignature
 */
var VerifiedSignature = (function () {
    function VerifiedSignature() {
    }
    return VerifiedSignature;
}());
export { VerifiedSignature };
/**
 * Define the service methods to handle the repository tag related things.
 *
 * @export
 * @abstract
 * @class TagService
 */
var TagService = (function () {
    function TagService() {
    }
    return TagService;
}());
export { TagService };
/**
 * Implement default service for tag.
 *
 * @export
 * @class TagDefaultService
 * @extends {TagService}
 */
var TagDefaultService = (function (_super) {
    __extends(TagDefaultService, _super);
    function TagDefaultService(http, config) {
        var _this = _super.call(this) || this;
        _this.http = http;
        _this.config = config;
        _this._baseUrl = _this.config.repositoryBaseEndpoint ? _this.config.repositoryBaseEndpoint : '/api/repositories';
        _this._labelUrl = _this.config.labelEndpoint ? _this.config.labelEndpoint : '/api/labels';
        return _this;
    }
    //Private methods
    //These two methods are temporary, will be deleted in future after API refactored 
    TagDefaultService.prototype._getTags = function (repositoryName, queryParams) {
        if (!queryParams) {
            queryParams = new RequestQueryParams();
        }
        queryParams.set('detail', '1');
        var url = this._baseUrl + "/" + repositoryName + "/tags";
        return this.http.get(url, buildHttpRequestOptions(queryParams)).toPromise()
            .then(function (response) { return response.json(); })
            .catch(function (error) { return Promise.reject(error); });
    };
    TagDefaultService.prototype._getSignatures = function (repositoryName) {
        var url = this._baseUrl + "/" + repositoryName + "/signatures";
        return this.http.get(url, HTTP_GET_OPTIONS).toPromise()
            .then(function (response) { return response.json(); })
            .catch(function (error) { return Promise.reject(error); });
    };
    TagDefaultService.prototype.getTags = function (repositoryName, queryParams) {
        if (!repositoryName) {
            return Promise.reject("Bad argument");
        }
        return this._getTags(repositoryName, queryParams);
    };
    TagDefaultService.prototype.deleteTag = function (repositoryName, tag) {
        if (!repositoryName || !tag) {
            return Promise.reject("Bad argument");
        }
        var url = this._baseUrl + "/" + repositoryName + "/tags/" + tag;
        return this.http.delete(url, HTTP_JSON_OPTIONS).toPromise()
            .then(function (response) { return response; })
            .catch(function (error) { return Promise.reject(error); });
    };
    TagDefaultService.prototype.getTag = function (repositoryName, tag, queryParams) {
        if (!repositoryName || !tag) {
            return Promise.reject("Bad argument");
        }
        var url = this._baseUrl + "/" + repositoryName + "/tags/" + tag;
        return this.http.get(url, HTTP_GET_OPTIONS).toPromise()
            .then(function (response) { return response.json(); })
            .catch(function (error) { return Promise.reject(error); });
    };
    TagDefaultService.prototype.addLabelToImages = function (repoName, tagName, labelId) {
        if (!labelId || !tagName || !repoName) {
            return Promise.reject('Invalid parameters.');
        }
        var _addLabelToImageUrl = this._baseUrl + "/" + repoName + "/tags/" + tagName + "/labels";
        return this.http.post(_addLabelToImageUrl, { id: labelId }, HTTP_JSON_OPTIONS).toPromise()
            .then(function (response) { return response.status; })
            .catch(function (error) { return Promise.reject(error); });
    };
    TagDefaultService.prototype.deleteLabelToImages = function (repoName, tagName, labelId) {
        if (!labelId || !tagName || !repoName) {
            return Promise.reject('Invalid parameters.');
        }
        var _addLabelToImageUrl = this._baseUrl + "/" + repoName + "/tags/" + tagName + "/labels/" + labelId;
        return this.http.delete(_addLabelToImageUrl).toPromise()
            .then(function (response) { return response.status; })
            .catch(function (error) { return Promise.reject(error); });
    };
    return TagDefaultService;
}(TagService));
export { TagDefaultService };
TagDefaultService.decorators = [
    { type: Injectable },
];
/** @nocollapse */
TagDefaultService.ctorParameters = function () { return [
    { type: Http, },
    { type: undefined, decorators: [{ type: Inject, args: [SERVICE_CONFIG,] },] },
]; };
//# sourceMappingURL=tag.service.js.map