import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { HttpModule, Http } from '@angular/http';
import { ClarityModule } from 'clarity-angular';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { TranslateModule, TranslateLoader, MissingTranslationHandler } from '@ngx-translate/core';
import { MyMissingTranslationHandler } from '../i18n/missing-trans.handler';
import { TranslateHttpLoader } from '@ngx-translate/http-loader';
import { TranslatorJsonLoader } from '../i18n/local-json.loader';
import { SERVICE_CONFIG } from '../service.config';
import { CookieService, CookieModule } from 'ngx-cookie';
import { ClipboardModule } from '../third-party/ngx-clipboard/index';
/*export function HttpLoaderFactory(http: Http) {
    return new TranslateHttpLoader(http, 'i18n/lang/', '-lang.json');
}

export function LocalJsonLoaderFactory() {
    return new TranslatorJsonLoader();
}*/
export function GeneralTranslatorLoader(http, config) {
    if (config && config.langMessageLoader === 'http') {
        var prefix = config.langMessagePathForHttpLoader ? config.langMessagePathForHttpLoader : "i18n/lang/";
        var suffix = config.langMessageFileSuffixForHttpLoader ? config.langMessageFileSuffixForHttpLoader : "-lang.json";
        return new TranslateHttpLoader(http, prefix, suffix);
    }
    else {
        return new TranslatorJsonLoader(config);
    }
}
/**
 *
 * Module for sharing common modules
 *
 * @export
 * @class SharedModule
 */
var SharedModule = (function () {
    function SharedModule() {
    }
    return SharedModule;
}());
export { SharedModule };
SharedModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule,
                    HttpModule,
                    FormsModule,
                    ReactiveFormsModule,
                    ClipboardModule,
                    CookieModule.forRoot(),
                    ClarityModule.forRoot(),
                    TranslateModule.forRoot({
                        loader: {
                            provide: TranslateLoader,
                            useFactory: (GeneralTranslatorLoader),
                            deps: [Http, SERVICE_CONFIG]
                        },
                        missingTranslationHandler: {
                            provide: MissingTranslationHandler,
                            useClass: MyMissingTranslationHandler
                        }
                    }),
                ],
                exports: [
                    CommonModule,
                    HttpModule,
                    FormsModule,
                    ReactiveFormsModule,
                    CookieModule,
                    ClipboardModule,
                    ClarityModule,
                    TranslateModule,
                ],
                providers: [CookieService]
            },] },
];
/** @nocollapse */
SharedModule.ctorParameters = function () { return []; };
//# sourceMappingURL=shared.module.js.map