(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/http'), require('rxjs/Observable'), require('rxjs/add/operator/toPromise'), require('rxjs/add/observable/of'), require('rxjs/Subject'), require('rxjs/add/operator/debounceTime'), require('rxjs/add/operator/distinctUntilChanged'), require('@ngx-translate/core'), require('@angular/router'), require('@angular/forms'), require('rxjs/Rx'), require('@angular/common'), require('clarity-angular'), require('@ngx-translate/http-loader'), require('ngx-cookie'), require('@angular/platform-browser')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/http', 'rxjs/Observable', 'rxjs/add/operator/toPromise', 'rxjs/add/observable/of', 'rxjs/Subject', 'rxjs/add/operator/debounceTime', 'rxjs/add/operator/distinctUntilChanged', '@ngx-translate/core', '@angular/router', '@angular/forms', 'rxjs/Rx', '@angular/common', 'clarity-angular', '@ngx-translate/http-loader', 'ngx-cookie', '@angular/platform-browser'], factory) :
	(factory((global.harborui = global.harborui || {}),global.ng.core,global.ng.http,global.Rx,global.Rx.Observable.prototype,global.Rx.Observable,global.rxjs.Subject,null,null,global.ngx.translate,global.ng.router,global.ng.forms,global.Rx,global.ng.common,global.ng.clarity,global.ngx.translate,global.ngx.cookie,global.ng.platformBrowser));
}(this, (function (exports,_angular_core,_angular_http,rxjs_Observable,rxjs_add_operator_toPromise,rxjs_add_observable_of,rxjs_Subject,rxjs_add_operator_debounceTime,rxjs_add_operator_distinctUntilChanged,_ngxTranslate_core,_angular_router,_angular_forms,rxjs_Rx,_angular_common,clarityAngular,_ngxTranslate_httpLoader,ngxCookie,_angular_platformBrowser) { 'use strict';

var Filter = (function () {
    function Filter(kind, pattern) {
        this.kind = kind;
        this.pattern = pattern;
    }
    return Filter;
}());
var Trigger = (function () {
    function Trigger(kind, param) {
        this.kind = kind;
        this.schedule_param = param;
    }
    return Trigger;
}());

(function (VulnerabilitySeverity) {
    VulnerabilitySeverity[VulnerabilitySeverity["_SEVERITY"] = 0] = "_SEVERITY";
    VulnerabilitySeverity[VulnerabilitySeverity["NONE"] = 1] = "NONE";
    VulnerabilitySeverity[VulnerabilitySeverity["UNKNOWN"] = 2] = "UNKNOWN";
    VulnerabilitySeverity[VulnerabilitySeverity["LOW"] = 3] = "LOW";
    VulnerabilitySeverity[VulnerabilitySeverity["MEDIUM"] = 4] = "MEDIUM";
    VulnerabilitySeverity[VulnerabilitySeverity["HIGH"] = 5] = "HIGH";
})(exports.VulnerabilitySeverity || (exports.VulnerabilitySeverity = {}));

var SERVICE_CONFIG = new _angular_core.OpaqueToken("service.config");

/**
 * Convert the different async channels to the Promise<T> type.
 *
 * @export
 * @template T
 * @param {(Observable<T> | Promise<T> | T)} async
 * @returns {Promise<T>}
 */
function toPromise(async) {
    if (!async) {
        return Promise.reject("Bad argument");
    }
    if (async instanceof rxjs_Observable.Observable) {
        var obs = async;
        return obs.toPromise();
    }
    else {
        return Promise.resolve(async);
    }
}
/**
 * The default cookie key used to store current used language preference.
 */
var DEFAULT_LANG_COOKIE_KEY = 'harbor-lang';
/**
 * Declare what languages are supported now.
 */
var DEFAULT_SUPPORTING_LANGS = ['en-us', 'zh-cn', 'es-es'];
/**
 * The default language.
 */
var DEFAULT_LANG = 'en-us';
var HTTP_JSON_OPTIONS = new _angular_http.RequestOptions({
    headers: new _angular_http.Headers({
        "Content-Type": 'application/json',
        "Accept": 'application/json'
    })
});
var HTTP_GET_OPTIONS = new _angular_http.RequestOptions({
    headers: new _angular_http.Headers({
        "Content-Type": 'application/json',
        "Accept": 'application/json',
        "Cache-Control": 'no-cache',
        "Pragma": 'no-cache'
    })
});
/**
 * Build http request options
 *
 * @export
 * @param {RequestQueryParams} params
 * @returns {RequestOptions}
 */
function buildHttpRequestOptions(params) {
    var reqOptions = new _angular_http.RequestOptions({
        headers: new _angular_http.Headers({
            "Content-Type": 'application/json',
            "Accept": 'application/json',
            "Cache-Control": 'no-cache',
            "Pragma": 'no-cache'
        })
    });
    if (params) {
        reqOptions.search = params;
    }
    return reqOptions;
}
/** Button events to pass to `DebugElement.triggerEventHandler` for RouterLink event handler */

/** Simulate element click. Defaults to mouse left-button click event. */

/**
 * Comparator for fields with specific type.
 *
 */
var CustomComparator = (function () {
    function CustomComparator(fieldName, type) {
        this.fieldName = fieldName;
        this.type = type;
    }
    CustomComparator.prototype.compare = function (a, b) {
        var comp = 0;
        if (a && b) {
            var fieldA = a[this.fieldName];
            var fieldB = b[this.fieldName];
            switch (this.type) {
                case "number":
                    comp = fieldB - fieldA;
                    break;
                case "date":
                    comp = new Date(fieldB).getTime() - new Date(fieldA).getTime();
                    break;
            }
        }
        return comp;
    };
    return CustomComparator;
}());
/**
 * The default page size
 */
var DEFAULT_PAGE_SIZE = 15;
/**
 * The state of vulnerability scanning
 */
var VULNERABILITY_SCAN_STATUS = {
    unknown: "n/a",
    pending: "pending",
    running: "running",
    error: "error",
    stopped: "stopped",
    finished: "finished"
};
/**
 * Calculate page number by state
 */
function calculatePage(state) {
    if (!state || !state.page) {
        return 1;
    }
    return Math.ceil((state.page.to + 1) / state.page.size);
}
/**
 * Filter columns via RegExp
 *
 * @export
 * @param {State} state
 * @returns {void}
 */
function doFiltering(items, state) {
    if (!items || items.length === 0) {
        return items;
    }
    if (!state || !state.filters || state.filters.length === 0) {
        return items;
    }
    state.filters.forEach(function (filter) {
        items = items.filter(function (item) {
            if (filter['property'].indexOf('.') !== -1) {
                var arr_1 = filter['property'].split('.');
                if (Array.isArray(item[arr_1[0]]) && item[arr_1[0]].length) {
                    return item[arr_1[0]].some(function (data) {
                        return regexpFilter(filter['value'], data[arr_1[1]]);
                    });
                }
            }
            else {
                return regexpFilter(filter['value'], item[filter['property']]);
            }
        });
    });
    return items;
}
/**
 * Match items via RegExp
 *
 * @export
 * @param {string} terms
 * @param {*} testedValue
 * @returns {boolean}
 */
function regexpFilter(terms, testedValue) {
    var reg = new RegExp('.*' + terms + '.*', 'i');
    return reg.test(testedValue);
}
/**
 * Sorting the data by column
 *
 * @export
 * @template T
 * @param {T[]} items
 * @param {State} state
 * @returns {T[]}
 */
function doSorting(items, state) {
    if (!items || items.length === 0) {
        return items;
    }
    if (!state || !state.sort) {
        return items;
    }
    return items.sort(function (a, b) {
        var comp = 0;
        if (typeof state.sort.by !== "string") {
            comp = state.sort.by.compare(a, b);
        }
        else {
            var propA = a[state.sort.by.toString()], propB = b[state.sort.by.toString()];
            if (typeof propA === "string") {
                comp = propA.localeCompare(propB);
            }
            else {
                if (propA > propB) {
                    comp = 1;
                }
                else if (propA < propB) {
                    comp = -1;
                }
            }
        }
        if (state.sort.reverse) {
            comp = -comp;
        }
        return comp;
    });
}
/**
 * Compare the two objects to adjust if they're equal
 *
 * @export
 * @param {*} a
 * @param {*} b
 * @returns {boolean}
 */
function compareValue(a, b) {
    if ((a && !b) || (!a && b))
        return false;
    if (!a && !b)
        return true;
    return JSON.stringify(a) === JSON.stringify(b);
}
/**
 * Check if the object is null or empty '{}'
 *
 * @export
 * @param {*} obj
 * @returns {boolean}
 */
function isEmptyObject(obj) {
    return !obj || JSON.stringify(obj) === "{}";
}
/**
 * Deeper clone all
 *
 * @export
 * @param {*} srcObj
 * @returns {*}
 */
function clone(srcObj) {
    if (!srcObj) {
        return null;
    }
    
    return JSON.parse(JSON.stringify(srcObj));
}

var __extends = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * Get System information about current backend server.
 * @abstract
 * @class
 */
var SystemInfoService = (function () {
    function SystemInfoService() {
    }
    return SystemInfoService;
}());
var SystemInfoDefaultService = (function (_super) {
    __extends(SystemInfoDefaultService, _super);
    function SystemInfoDefaultService(config, http) {
        var _this = _super.call(this) || this;
        _this.config = config;
        _this.http = http;
        return _this;
    }
    SystemInfoDefaultService.prototype.getSystemInfo = function () {
        var url = this.config.systemInfoEndpoint ? this.config.systemInfoEndpoint : '/api/systeminfo';
        return this.http.get(url, HTTP_GET_OPTIONS)
            .toPromise()
            .then(function (systemInfo) { return systemInfo.json(); })
            .catch(function (error) { return Promise.reject(error); });
    };
    return SystemInfoDefaultService;
}(SystemInfoService));
SystemInfoDefaultService.decorators = [
    { type: _angular_core.Injectable },
];
/** @nocollapse */
SystemInfoDefaultService.ctorParameters = function () { return [
    { type: undefined, decorators: [{ type: _angular_core.Inject, args: [SERVICE_CONFIG,] },] },
    { type: _angular_http.Http, },
]; };

var __extends$1 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * Define service methods to handle the access log related things.
 *
 * @export
 * @abstract
 * @class AccessLogService
 */
var AccessLogService = (function () {
    function AccessLogService() {
    }
    return AccessLogService;
}());
/**
 * Implement a default service for access log.
 *
 * @export
 * @class AccessLogDefaultService
 * @extends {AccessLogService}
 */
var AccessLogDefaultService = (function (_super) {
    __extends$1(AccessLogDefaultService, _super);
    function AccessLogDefaultService(http, config) {
        var _this = _super.call(this) || this;
        _this.http = http;
        _this.config = config;
        return _this;
    }
    AccessLogDefaultService.prototype.getAuditLogs = function (projectId, queryParams) {
        return rxjs_Observable.Observable.of({});
    };
    AccessLogDefaultService.prototype.getRecentLogs = function (queryParams) {
        var url = this.config.logBaseEndpoint ? this.config.logBaseEndpoint : "";
        if (url === '') {
            url = '/api/logs';
        }
        return this.http.get(url, queryParams ? buildHttpRequestOptions(queryParams) : HTTP_GET_OPTIONS).toPromise()
            .then(function (response) {
            var result = {
                metadata: {
                    xTotalCount: 0
                },
                data: []
            };
            var xHeader = "0";
            if (response && response.headers) {
                xHeader = response.headers.get("X-Total-Count");
            }
            if (result && result.metadata) {
                result.metadata.xTotalCount = parseInt(xHeader ? xHeader : "0", 0);
                if (result.metadata.xTotalCount > 0) {
                    result.data = response.json();
                }
            }
            return result;
        })
            .catch(function (error) { return Promise.reject(error); });
    };
    return AccessLogDefaultService;
}(AccessLogService));
AccessLogDefaultService.decorators = [
    { type: _angular_core.Injectable },
];
/** @nocollapse */
AccessLogDefaultService.ctorParameters = function () { return [
    { type: _angular_http.Http, },
    { type: undefined, decorators: [{ type: _angular_core.Inject, args: [SERVICE_CONFIG,] },] },
]; };

var __extends$3 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * Wrap the class 'URLSearchParams' for future extending requirements.
 * Currently no extra methods provided.
 *
 * @export
 * @class RequestQueryParams
 * @extends {URLSearchParams}
 */
var RequestQueryParams = (function (_super) {
    __extends$3(RequestQueryParams, _super);
    function RequestQueryParams() {
        return _super.call(this) || this;
    }
    return RequestQueryParams;
}(_angular_http.URLSearchParams));

var __extends$2 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * Define the service methods to handle the endpoint related things.
 *
 * @export
 * @abstract
 * @class EndpointService
 */
var EndpointService = (function () {
    function EndpointService() {
    }
    return EndpointService;
}());
/**
 * Implement default service for endpoint.
 *
 * @export
 * @class EndpointDefaultService
 * @extends {EndpointService}
 */
var EndpointDefaultService = (function (_super) {
    __extends$2(EndpointDefaultService, _super);
    function EndpointDefaultService(config, http) {
        var _this = _super.call(this) || this;
        _this.http = http;
        _this._endpointUrl = config.targetBaseEndpoint ? config.targetBaseEndpoint : '/api/targets';
        return _this;
    }
    EndpointDefaultService.prototype.getEndpoints = function (endpointName, queryParams) {
        if (!queryParams) {
            queryParams = new RequestQueryParams();
        }
        if (endpointName) {
            queryParams.set('name', endpointName);
        }
        var requestUrl = "" + this._endpointUrl;
        return this.http
            .get(requestUrl, buildHttpRequestOptions(queryParams))
            .toPromise()
            .then(function (response) { return response.json(); })
            .catch(function (error) { return Promise.reject(error); });
    };
    EndpointDefaultService.prototype.getEndpoint = function (endpointId) {
        if (!endpointId || endpointId <= 0) {
            return Promise.reject('Bad request argument.');
        }
        var requestUrl = this._endpointUrl + "/" + endpointId;
        return this.http
            .get(requestUrl, HTTP_GET_OPTIONS)
            .toPromise()
            .then(function (response) { return response.json(); })
            .catch(function (error) { return Promise.reject(error); });
    };
    EndpointDefaultService.prototype.createEndpoint = function (endpoint) {
        if (!endpoint) {
            return Promise.reject('Invalid endpoint.');
        }
        var requestUrl = "" + this._endpointUrl;
        return this.http
            .post(requestUrl, JSON.stringify(endpoint), HTTP_JSON_OPTIONS)
            .toPromise()
            .then(function (response) { return response.status; })
            .catch(function (error) { return Promise.reject(error); });
    };
    EndpointDefaultService.prototype.updateEndpoint = function (endpointId, endpoint) {
        if (!endpointId || endpointId <= 0) {
            return Promise.reject('Bad request argument.');
        }
        if (!endpoint) {
            return Promise.reject('Invalid endpoint.');
        }
        var requestUrl = this._endpointUrl + "/" + endpointId;
        return this.http
            .put(requestUrl, JSON.stringify(endpoint), HTTP_JSON_OPTIONS)
            .toPromise()
            .then(function (response) { return response.status; })
            .catch(function (error) { return Promise.reject(error); });
    };
    EndpointDefaultService.prototype.deleteEndpoint = function (endpointId) {
        if (!endpointId || endpointId <= 0) {
            return Promise.reject('Bad request argument.');
        }
        var requestUrl = this._endpointUrl + "/" + endpointId;
        return this.http
            .delete(requestUrl)
            .toPromise()
            .then(function (response) { return response.status; })
            .catch(function (error) { return Promise.reject(error); });
    };
    EndpointDefaultService.prototype.pingEndpoint = function (endpoint) {
        if (!endpoint) {
            return Promise.reject('Invalid endpoint.');
        }
        var requestUrl = this._endpointUrl + "/ping";
        return this.http
            .post(requestUrl, endpoint, HTTP_JSON_OPTIONS)
            .toPromise()
            .then(function (response) { return response.status; })
            .catch(function (error) { return Promise.reject(error); });
    };
    EndpointDefaultService.prototype.getEndpointWithReplicationRules = function (endpointId) {
        if (!endpointId || endpointId <= 0) {
            return Promise.reject('Bad request argument.');
        }
        var requestUrl = this._endpointUrl + "/" + endpointId + "/policies";
        return this.http
            .get(requestUrl, HTTP_GET_OPTIONS)
            .toPromise()
            .then(function (response) { return response.json(); })
            .catch(function (error) { return Promise.reject(error); });
    };
    return EndpointDefaultService;
}(EndpointService));
EndpointDefaultService.decorators = [
    { type: _angular_core.Injectable },
];
/** @nocollapse */
EndpointDefaultService.ctorParameters = function () { return [
    { type: undefined, decorators: [{ type: _angular_core.Inject, args: [SERVICE_CONFIG,] },] },
    { type: _angular_http.Http, },
]; };

var __extends$4 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * Define the service methods to handle the replication (rule and job) related things.
 *
 * @export
 * @abstract
 * @class ReplicationService
 */
var ReplicationService = (function () {
    function ReplicationService() {
    }
    return ReplicationService;
}());
/**
 * Implement default service for replication rule and job.
 *
 * @export
 * @class ReplicationDefaultService
 * @extends {ReplicationService}
 */
var ReplicationDefaultService = (function (_super) {
    __extends$4(ReplicationDefaultService, _super);
    function ReplicationDefaultService(http, config) {
        var _this = _super.call(this) || this;
        _this.http = http;
        _this._ruleBaseUrl = config.replicationRuleEndpoint ? config.replicationRuleEndpoint : '/api/policies/replication';
        _this._jobBaseUrl = config.replicationJobEndpoint ? config.replicationJobEndpoint : '/api/jobs/replication';
        _this._replicateUrl = config.replicationBaseEndpoint ? config.replicationBaseEndpoint : '/api/replications';
        return _this;
    }
    //Private methods
    //Check if the rule object is valid
    ReplicationDefaultService.prototype._isValidRule = function (rule) {
        return rule !== undefined && rule != null && rule.name !== undefined && rule.name.trim() !== '' && rule.targets.length !== 0;
    };
    ReplicationDefaultService.prototype.getReplicationRules = function (projectId, ruleName, queryParams) {
        if (!queryParams) {
            queryParams = new RequestQueryParams();
        }
        if (projectId) {
            queryParams.set('project_id', '' + projectId);
        }
        if (ruleName) {
            queryParams.set('name', ruleName);
        }
        return this.http.get(this._ruleBaseUrl, buildHttpRequestOptions(queryParams)).toPromise()
            .then(function (response) { return response.json(); })
            .catch(function (error) { return Promise.reject(error); });
    };
    ReplicationDefaultService.prototype.getReplicationRule = function (ruleId) {
        if (!ruleId) {
            return Promise.reject("Bad argument");
        }
        var url = this._ruleBaseUrl + "/" + ruleId;
        return this.http.get(url, HTTP_GET_OPTIONS).toPromise()
            .then(function (response) { return response.json(); })
            .catch(function (error) { return Promise.reject(error); });
    };
    ReplicationDefaultService.prototype.createReplicationRule = function (replicationRule) {
        if (!this._isValidRule(replicationRule)) {
            return Promise.reject('Bad argument');
        }
        return this.http.post(this._ruleBaseUrl, JSON.stringify(replicationRule), HTTP_JSON_OPTIONS).toPromise()
            .then(function (response) { return response; })
            .catch(function (error) { return Promise.reject(error); });
    };
    ReplicationDefaultService.prototype.updateReplicationRule = function (id, rep) {
        if (!this._isValidRule(rep)) {
            return Promise.reject('Bad argument');
        }
        var url = this._ruleBaseUrl + "/" + id;
        return this.http.put(url, JSON.stringify(rep), HTTP_JSON_OPTIONS).toPromise()
            .then(function (response) { return response; })
            .catch(function (error) { return Promise.reject(error); });
    };
    ReplicationDefaultService.prototype.deleteReplicationRule = function (ruleId) {
        if (!ruleId || ruleId <= 0) {
            return Promise.reject('Bad argument');
        }
        var url = this._ruleBaseUrl + "/" + ruleId;
        return this.http.delete(url, HTTP_JSON_OPTIONS).toPromise()
            .then(function (response) { return response; })
            .catch(function (error) { return Promise.reject(error); });
    };
    ReplicationDefaultService.prototype.replicateRule = function (ruleId) {
        if (!ruleId) {
            return Promise.reject("Bad argument");
        }
        var url = "" + this._replicateUrl;
        return this.http.post(url, { policy_id: ruleId }, HTTP_JSON_OPTIONS).toPromise()
            .then(function (response) { return response; })
            .catch(function (error) { return Promise.reject(error); });
    };
    ReplicationDefaultService.prototype.enableReplicationRule = function (ruleId, enablement) {
        if (!ruleId || ruleId <= 0) {
            return Promise.reject('Bad argument');
        }
        var url = this._ruleBaseUrl + "/" + ruleId + "/enablement";
        return this.http.put(url, { enabled: enablement }, HTTP_JSON_OPTIONS).toPromise()
            .then(function (response) { return response; })
            .catch(function (error) { return Promise.reject(error); });
    };
    ReplicationDefaultService.prototype.disableReplicationRule = function (ruleId) {
        if (!ruleId || ruleId <= 0) {
            return Promise.reject('Bad argument');
        }
        var url = this._ruleBaseUrl + "/" + ruleId + "/enablement";
        return this.http.put(url, { enabled: 0 }, HTTP_JSON_OPTIONS).toPromise()
            .then(function (response) { return response; })
            .catch(function (error) { return Promise.reject(error); });
    };
    ReplicationDefaultService.prototype.getJobs = function (ruleId, queryParams) {
        if (!ruleId || ruleId <= 0) {
            return Promise.reject('Bad argument');
        }
        if (!queryParams) {
            queryParams = new RequestQueryParams();
        }
        queryParams.set('policy_id', '' + ruleId);
        return this.http.get(this._jobBaseUrl, buildHttpRequestOptions(queryParams)).toPromise()
            .then(function (response) {
            var result = {
                metadata: {
                    xTotalCount: 0
                },
                data: []
            };
            if (response && response.headers) {
                var xHeader = response.headers.get("X-Total-Count");
                if (xHeader) {
                    result.metadata.xTotalCount = parseInt(xHeader, 0);
                }
            }
            result.data = response.json();
            if (result.metadata.xTotalCount === 0) {
                if (result.data && result.data.length > 0) {
                    result.metadata.xTotalCount = result.data.length;
                }
            }
            return result;
        })
            .catch(function (error) { return Promise.reject(error); });
    };
    ReplicationDefaultService.prototype.getJobLog = function (jobId) {
        if (!jobId || jobId <= 0) {
            return Promise.reject('Bad argument');
        }
        var logUrl = this._jobBaseUrl + "/" + jobId + "/log";
        return this.http.get(logUrl, HTTP_GET_OPTIONS).toPromise()
            .then(function (response) { return response.text(); })
            .catch(function (error) { return Promise.reject(error); });
    };
    ReplicationDefaultService.prototype.stopJobs = function (jobId) {
        return this.http.put(this._jobBaseUrl, JSON.stringify({ 'policy_id': jobId, 'status': 'stop' }), HTTP_JSON_OPTIONS).toPromise()
            .then(function (response) { return response; })
            .catch(function (error) { return Promise.reject(error); });
    };
    return ReplicationDefaultService;
}(ReplicationService));
ReplicationDefaultService.decorators = [
    { type: _angular_core.Injectable },
];
/** @nocollapse */
ReplicationDefaultService.ctorParameters = function () { return [
    { type: _angular_http.Http, },
    { type: undefined, decorators: [{ type: _angular_core.Inject, args: [SERVICE_CONFIG,] },] },
]; };

var __extends$5 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * Define service methods for handling the repository related things.
 * Loose couple with project module.
 *
 * @export
 * @abstract
 * @class RepositoryService
 */
var RepositoryService = (function () {
    function RepositoryService() {
    }
    return RepositoryService;
}());
/**
 * Implement default service for repository.
 *
 * @export
 * @class RepositoryDefaultService
 * @extends {RepositoryService}
 */
var RepositoryDefaultService = (function (_super) {
    __extends$5(RepositoryDefaultService, _super);
    function RepositoryDefaultService(http, config) {
        var _this = _super.call(this) || this;
        _this.http = http;
        _this.config = config;
        return _this;
    }
    RepositoryDefaultService.prototype.getRepositories = function (projectId, repositoryName, queryParams) {
        if (!projectId) {
            return Promise.reject('Bad argument');
        }
        if (!queryParams) {
            queryParams = new RequestQueryParams();
        }
        queryParams.set('project_id', '' + projectId);
        if (repositoryName && repositoryName.trim() !== '') {
            queryParams.set('q', repositoryName);
        }
        var url = this.config.repositoryBaseEndpoint ? this.config.repositoryBaseEndpoint : '/api/repositories';
        return this.http.get(url, buildHttpRequestOptions(queryParams)).toPromise()
            .then(function (response) {
            var result = {
                metadata: { xTotalCount: 0 },
                data: []
            };
            if (response && response.headers) {
                var xHeader = response.headers.get('X-Total-Count');
                if (xHeader) {
                    result.metadata.xTotalCount = parseInt(xHeader, 0);
                }
            }
            result.data = response.json();
            if (result.metadata.xTotalCount === 0) {
                if (result.data && result.data.length > 0) {
                    result.metadata.xTotalCount = result.data.length;
                }
            }
            return result;
        })
            .catch(function (error) { return Promise.reject(error); });
    };
    RepositoryDefaultService.prototype.updateRepositoryDescription = function (repositoryName, description, queryParams) {
        if (!queryParams) {
            queryParams = new RequestQueryParams();
        }
        var baseUrl = this.config.repositoryBaseEndpoint ? this.config.repositoryBaseEndpoint : '/api/repositories';
        var url = baseUrl + "/" + repositoryName;
        return this.http.put(url, { 'description': description }, HTTP_JSON_OPTIONS).toPromise()
            .then(function (response) { return response; })
            .catch(function (error) { return Promise.reject(error); });
    };
    RepositoryDefaultService.prototype.deleteRepository = function (repositoryName) {
        if (!repositoryName) {
            return Promise.reject('Bad argument');
        }
        var url = this.config.repositoryBaseEndpoint ? this.config.repositoryBaseEndpoint : '/api/repositories';
        url = url + "/" + repositoryName;
        return this.http.delete(url, HTTP_JSON_OPTIONS).toPromise()
            .then(function (response) { return response; })
            .catch(function (error) { return Promise.reject(error); });
    };
    return RepositoryDefaultService;
}(RepositoryService));
RepositoryDefaultService.decorators = [
    { type: _angular_core.Injectable },
];
/** @nocollapse */
RepositoryDefaultService.ctorParameters = function () { return [
    { type: _angular_http.Http, },
    { type: undefined, decorators: [{ type: _angular_core.Inject, args: [SERVICE_CONFIG,] },] },
]; };

var __extends$6 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * For getting tag signatures.
 * This is temporary, will be removed in future.
 *
 * @export
 * @class VerifiedSignature
 */
var VerifiedSignature = (function () {
    function VerifiedSignature() {
    }
    return VerifiedSignature;
}());
/**
 * Define the service methods to handle the repository tag related things.
 *
 * @export
 * @abstract
 * @class TagService
 */
var TagService = (function () {
    function TagService() {
    }
    return TagService;
}());
/**
 * Implement default service for tag.
 *
 * @export
 * @class TagDefaultService
 * @extends {TagService}
 */
var TagDefaultService = (function (_super) {
    __extends$6(TagDefaultService, _super);
    function TagDefaultService(http, config) {
        var _this = _super.call(this) || this;
        _this.http = http;
        _this.config = config;
        _this._baseUrl = _this.config.repositoryBaseEndpoint ? _this.config.repositoryBaseEndpoint : '/api/repositories';
        _this._labelUrl = _this.config.labelEndpoint ? _this.config.labelEndpoint : '/api/labels';
        return _this;
    }
    //Private methods
    //These two methods are temporary, will be deleted in future after API refactored 
    TagDefaultService.prototype._getTags = function (repositoryName, queryParams) {
        if (!queryParams) {
            queryParams = new RequestQueryParams();
        }
        queryParams.set('detail', '1');
        var url = this._baseUrl + "/" + repositoryName + "/tags";
        return this.http.get(url, buildHttpRequestOptions(queryParams)).toPromise()
            .then(function (response) { return response.json(); })
            .catch(function (error) { return Promise.reject(error); });
    };
    TagDefaultService.prototype._getSignatures = function (repositoryName) {
        var url = this._baseUrl + "/" + repositoryName + "/signatures";
        return this.http.get(url, HTTP_GET_OPTIONS).toPromise()
            .then(function (response) { return response.json(); })
            .catch(function (error) { return Promise.reject(error); });
    };
    TagDefaultService.prototype.getTags = function (repositoryName, queryParams) {
        if (!repositoryName) {
            return Promise.reject("Bad argument");
        }
        return this._getTags(repositoryName, queryParams);
    };
    TagDefaultService.prototype.deleteTag = function (repositoryName, tag) {
        if (!repositoryName || !tag) {
            return Promise.reject("Bad argument");
        }
        var url = this._baseUrl + "/" + repositoryName + "/tags/" + tag;
        return this.http.delete(url, HTTP_JSON_OPTIONS).toPromise()
            .then(function (response) { return response; })
            .catch(function (error) { return Promise.reject(error); });
    };
    TagDefaultService.prototype.getTag = function (repositoryName, tag, queryParams) {
        if (!repositoryName || !tag) {
            return Promise.reject("Bad argument");
        }
        var url = this._baseUrl + "/" + repositoryName + "/tags/" + tag;
        return this.http.get(url, HTTP_GET_OPTIONS).toPromise()
            .then(function (response) { return response.json(); })
            .catch(function (error) { return Promise.reject(error); });
    };
    TagDefaultService.prototype.addLabelToImages = function (repoName, tagName, labelId) {
        if (!labelId || !tagName || !repoName) {
            return Promise.reject('Invalid parameters.');
        }
        var _addLabelToImageUrl = this._baseUrl + "/" + repoName + "/tags/" + tagName + "/labels";
        return this.http.post(_addLabelToImageUrl, { id: labelId }, HTTP_JSON_OPTIONS).toPromise()
            .then(function (response) { return response.status; })
            .catch(function (error) { return Promise.reject(error); });
    };
    TagDefaultService.prototype.deleteLabelToImages = function (repoName, tagName, labelId) {
        if (!labelId || !tagName || !repoName) {
            return Promise.reject('Invalid parameters.');
        }
        var _addLabelToImageUrl = this._baseUrl + "/" + repoName + "/tags/" + tagName + "/labels/" + labelId;
        return this.http.delete(_addLabelToImageUrl).toPromise()
            .then(function (response) { return response.status; })
            .catch(function (error) { return Promise.reject(error); });
    };
    return TagDefaultService;
}(TagService));
TagDefaultService.decorators = [
    { type: _angular_core.Injectable },
];
/** @nocollapse */
TagDefaultService.ctorParameters = function () { return [
    { type: _angular_http.Http, },
    { type: undefined, decorators: [{ type: _angular_core.Inject, args: [SERVICE_CONFIG,] },] },
]; };

var __extends$7 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * Get the vulnerabilities scanning results for the specified tag.
 *
 * @export
 * @abstract
 * @class ScanningResultService
 */
var ScanningResultService = (function () {
    function ScanningResultService() {
    }
    return ScanningResultService;
}());
var ScanningResultDefaultService = (function (_super) {
    __extends$7(ScanningResultDefaultService, _super);
    function ScanningResultDefaultService(http, config) {
        var _this = _super.call(this) || this;
        _this.http = http;
        _this.config = config;
        _this._baseUrl = '/api/repositories';
        if (_this.config && _this.config.vulnerabilityScanningBaseEndpoint) {
            _this._baseUrl = _this.config.vulnerabilityScanningBaseEndpoint;
        }
        return _this;
    }
    ScanningResultDefaultService.prototype.getVulnerabilityScanningSummary = function (repoName, tagId, queryParams) {
        if (!repoName || repoName.trim() === '' || !tagId || tagId.trim() === '') {
            return Promise.reject('Bad argument');
        }
        return rxjs_Observable.Observable.of({});
    };
    ScanningResultDefaultService.prototype.getVulnerabilityScanningResults = function (repoName, tagId, queryParams) {
        if (!repoName || repoName.trim() === '' || !tagId || tagId.trim() === '') {
            return Promise.reject('Bad argument');
        }
        return this.http.get(this._baseUrl + "/" + repoName + "/tags/" + tagId + "/vulnerability/details", buildHttpRequestOptions(queryParams)).toPromise()
            .then(function (response) { return response.json(); })
            .catch(function (error) { return Promise.reject(error); });
    };
    ScanningResultDefaultService.prototype.startVulnerabilityScanning = function (repoName, tagId) {
        if (!repoName || repoName.trim() === '' || !tagId || tagId.trim() === '') {
            return Promise.reject('Bad argument');
        }
        return this.http.post(this._baseUrl + "/" + repoName + "/tags/" + tagId + "/scan", HTTP_JSON_OPTIONS).toPromise()
            .then(function () { return true; })
            .catch(function (error) { return Promise.reject(error); });
    };
    ScanningResultDefaultService.prototype.startScanningAll = function () {
        return this.http.post(this._baseUrl + "/scanAll", HTTP_JSON_OPTIONS).toPromise()
            .then(function () { return true; })
            .catch(function (error) { return Promise.reject(error); });
    };
    return ScanningResultDefaultService;
}(ScanningResultService));
ScanningResultDefaultService.decorators = [
    { type: _angular_core.Injectable },
];
/** @nocollapse */
ScanningResultDefaultService.ctorParameters = function () { return [
    { type: _angular_http.Http, },
    { type: undefined, decorators: [{ type: _angular_core.Inject, args: [SERVICE_CONFIG,] },] },
]; };

var __extends$8 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * Service used to get and save registry-related configurations.
 *
 * @export
 * @abstract
 * @class ConfigurationService
 */
var ConfigurationService = (function () {
    function ConfigurationService() {
    }
    return ConfigurationService;
}());
var ConfigurationDefaultService = (function (_super) {
    __extends$8(ConfigurationDefaultService, _super);
    function ConfigurationDefaultService(http, config) {
        var _this = _super.call(this) || this;
        _this.http = http;
        _this.config = config;
        _this._baseUrl = _this.config && _this.config.configurationEndpoint ?
            _this.config.configurationEndpoint : "/api/configurations";
        return _this;
    }
    ConfigurationDefaultService.prototype.getConfigurations = function () {
        return this.http.get(this._baseUrl, HTTP_GET_OPTIONS).toPromise()
            .then(function (response) { return response.json(); })
            .catch(function (error) { return Promise.reject(error); });
    };
    ConfigurationDefaultService.prototype.saveConfigurations = function (changedConfigs) {
        if (!changedConfigs) {
            return Promise.reject("Bad argument!");
        }
        return this.http.put(this._baseUrl, JSON.stringify(changedConfigs), HTTP_JSON_OPTIONS)
            .toPromise()
            .then(function () { })
            .catch(function (error) { return Promise.reject(error); });
    };
    return ConfigurationDefaultService;
}(ConfigurationService));
ConfigurationDefaultService.decorators = [
    { type: _angular_core.Injectable },
];
/** @nocollapse */
ConfigurationDefaultService.ctorParameters = function () { return [
    { type: _angular_http.Http, },
    { type: undefined, decorators: [{ type: _angular_core.Inject, args: [SERVICE_CONFIG,] },] },
]; };

var __extends$9 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * Define the service methods to handle the job log related things.
 *
 * @export
 * @abstract
 * @class JobLogService
 */
var JobLogService = (function () {
    function JobLogService() {
    }
    return JobLogService;
}());
/**
 * Implement default service for job log service.
 *
 * @export
 * @class JobLogDefaultService
 * @extends {ReplicationService}
 */
var JobLogDefaultService = (function (_super) {
    __extends$9(JobLogDefaultService, _super);
    function JobLogDefaultService(http, config) {
        var _this = _super.call(this) || this;
        _this.http = http;
        _this._replicationJobBaseUrl = config.replicationJobEndpoint ?
            config.replicationJobEndpoint : '/api/jobs/replication';
        _this._scanningJobBaseUrl = config.scanJobEndpoint ? config.scanJobEndpoint : "/api/jobs/scan";
        _this._supportedJobTypes = ["replication", "scan"];
        return _this;
    }
    JobLogDefaultService.prototype._getJobLog = function (logUrl) {
        return this.http.get(logUrl, HTTP_GET_OPTIONS).toPromise()
            .then(function (response) { return response.text(); })
            .catch(function (error) { return Promise.reject(error); });
    };
    JobLogDefaultService.prototype._isSupportedJobType = function (jobType) {
        if (this._supportedJobTypes.find(function (t) { return t === jobType; })) {
            return true;
        }
        return false;
    };
    JobLogDefaultService.prototype.getJobLog = function (jobType, jobId) {
        if (!this._isSupportedJobType(jobType)) {
            return Promise.reject("Unsupport job type: " + jobType);
        }
        if (!jobId || jobId <= 0) {
            return Promise.reject('Bad argument');
        }
        var logUrl = this._replicationJobBaseUrl + "/" + jobId + "/log";
        if (jobType === "scan") {
            logUrl = this._scanningJobBaseUrl + "/" + jobId + "/log";
        }
        return this._getJobLog(logUrl);
    };
    return JobLogDefaultService;
}(JobLogService));
JobLogDefaultService.decorators = [
    { type: _angular_core.Injectable },
];
/** @nocollapse */
JobLogDefaultService.ctorParameters = function () { return [
    { type: _angular_http.Http, },
    { type: undefined, decorators: [{ type: _angular_core.Inject, args: [SERVICE_CONFIG,] },] },
]; };

var __extends$10 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * Define the service methods to handle the Prject related things.
 *
 * @export
 * @abstract
 * @class ProjectService
 */
var ProjectService = (function () {
    function ProjectService() {
    }
    return ProjectService;
}());
/**
 * Implement default service for project.
 *
 * @export
 * @class ProjectDefaultService
 * @extends {ProjectService}
 */
var ProjectDefaultService = (function (_super) {
    __extends$10(ProjectDefaultService, _super);
    function ProjectDefaultService(http, config) {
        var _this = _super.call(this) || this;
        _this.http = http;
        _this.config = config;
        return _this;
    }
    ProjectDefaultService.prototype.getProject = function (projectId) {
        if (!projectId) {
            return Promise.reject('Bad argument');
        }
        var baseUrl = this.config.projectBaseEndpoint ? this.config.projectBaseEndpoint : '/api/projects';
        return this.http
            .get(baseUrl + "/" + projectId, HTTP_GET_OPTIONS)
            .map(function (response) { return response.json(); })
            .catch(function (error) { return rxjs_Observable.Observable.throw(error); });
    };
    ProjectDefaultService.prototype.listProjects = function (name, isPublic, page, pageSize) {
        var baseUrl = this.config.projectBaseEndpoint ? this.config.projectBaseEndpoint : '/api/projects';
        var params = new RequestQueryParams();
        if (page && pageSize) {
            params.set('page', page + '');
            params.set('page_size', pageSize + '');
        }
        if (name && name.trim() !== "") {
            params.set('name', name);
        }
        if (isPublic !== undefined) {
            params.set('public', '' + isPublic);
        }
        // let options = new RequestOptions({ headers: this.getHeaders, search: params });
        return this.http
            .get(baseUrl, buildHttpRequestOptions(params))
            .map(function (response) { return response.json(); })
            .catch(function (error) { return rxjs_Observable.Observable.throw(error); });
    };
    ProjectDefaultService.prototype.updateProjectPolicy = function (projectId, projectPolicy) {
        var baseUrl = this.config.projectBaseEndpoint ? this.config.projectBaseEndpoint : '/api/projects';
        return this.http
            .put(baseUrl + "/" + projectId, {
            'metadata': {
                'public': projectPolicy.Public ? 'true' : 'false',
                'enable_content_trust': projectPolicy.ContentTrust ? 'true' : 'false',
                'prevent_vul': projectPolicy.PreventVulImg ? 'true' : 'false',
                'severity': projectPolicy.PreventVulImgSeverity,
                'auto_scan': projectPolicy.ScanImgOnPush ? 'true' : 'false'
            }
        }, HTTP_JSON_OPTIONS)
            .map(function (response) { return response.status; })
            .catch(function (error) { return rxjs_Observable.Observable.throw(error); });
    };
    return ProjectDefaultService;
}(ProjectService));
ProjectDefaultService.decorators = [
    { type: _angular_core.Injectable },
];
/** @nocollapse */
ProjectDefaultService.ctorParameters = function () { return [
    { type: _angular_http.Http, },
    { type: undefined, decorators: [{ type: _angular_core.Inject, args: [SERVICE_CONFIG,] },] },
]; };

var __extends$11 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var LabelService = (function () {
    function LabelService() {
    }
    return LabelService;
}());
var LabelDefaultService = (function (_super) {
    __extends$11(LabelDefaultService, _super);
    function LabelDefaultService(config, http) {
        var _this = _super.call(this) || this;
        _this.http = http;
        _this._labelUrl = config.labelEndpoint ? config.labelEndpoint : "/api/labels";
        return _this;
    }
    LabelDefaultService.prototype.getLabels = function (scope, projectId, name, queryParams) {
        if (!queryParams) {
            queryParams = new RequestQueryParams();
        }
        if (scope) {
            queryParams.set('scope', scope);
        }
        if (projectId) {
            queryParams.set('project_id', '' + projectId);
        }
        if (name) {
            queryParams.set('name', '' + name);
        }
        return this.http.get(this._labelUrl, buildHttpRequestOptions(queryParams)).toPromise()
            .then(function (response) { return response.json(); })
            .catch(function (error) { return Promise.reject(error); });
    };
    LabelDefaultService.prototype.getGLabels = function (name, queryParams) {
        if (!queryParams) {
            queryParams = new RequestQueryParams();
        }
        queryParams.set('scope', 'g');
        if (name) {
            queryParams.set('name', '' + name);
        }
        return this.http.get(this._labelUrl, buildHttpRequestOptions(queryParams)).toPromise()
            .then(function (response) { return response.json(); })
            .catch(function (error) { return Promise.reject(error); });
    };
    LabelDefaultService.prototype.getPLabels = function (projectId, name, queryParams) {
        if (!queryParams) {
            queryParams = new RequestQueryParams();
        }
        queryParams.set('scope', 'p');
        if (projectId) {
            queryParams.set('project_id', '' + projectId);
        }
        if (name) {
            queryParams.set('name', '' + name);
        }
        return this.http.get(this._labelUrl, buildHttpRequestOptions(queryParams)).toPromise()
            .then(function (response) { return response.json(); })
            .catch(function (error) { return Promise.reject(error); });
    };
    LabelDefaultService.prototype.createLabel = function (label) {
        if (!label) {
            return Promise.reject('Invalid label.');
        }
        return this.http.post(this._labelUrl, JSON.stringify(label), HTTP_JSON_OPTIONS).toPromise()
            .then(function (response) { return response.status; })
            .catch(function (error) { return Promise.reject(error); });
    };
    LabelDefaultService.prototype.getLabel = function (id) {
        if (!id || id <= 0) {
            return Promise.reject('Bad request argument.');
        }
        var reqUrl = this._labelUrl + "/" + id;
        return this.http.get(reqUrl).toPromise()
            .then(function (response) { return response.json(); })
            .catch(function (error) { return Promise.reject(error); });
    };
    LabelDefaultService.prototype.updateLabel = function (id, label) {
        if (!id || id <= 0) {
            return Promise.reject('Bad request argument.');
        }
        if (!label) {
            return Promise.reject('Invalid endpoint.');
        }
        var reqUrl = this._labelUrl + "/" + id;
        return this.http.put(reqUrl, JSON.stringify(label), HTTP_JSON_OPTIONS).toPromise()
            .then(function (response) { return response.status; })
            .catch(function (error) { return Promise.reject(error); });
    };
    LabelDefaultService.prototype.deleteLabel = function (id) {
        if (!id || id <= 0) {
            return Promise.reject('Bad request argument.');
        }
        var reqUrl = this._labelUrl + "/" + id;
        return this.http.delete(reqUrl).toPromise()
            .then(function (response) { return response.status; })
            .catch(function (error) { return Promise.reject(error); });
    };
    return LabelDefaultService;
}(LabelService));
LabelDefaultService.decorators = [
    { type: _angular_core.Injectable },
];
/** @nocollapse */
LabelDefaultService.ctorParameters = function () { return [
    { type: undefined, decorators: [{ type: _angular_core.Inject, args: [SERVICE_CONFIG,] },] },
    { type: _angular_http.Http, },
]; };

var __extends$12 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * Declare interface for error handling
 *
 * @export
 * @abstract
 * @class ErrorHandler
 */
var ErrorHandler = (function () {
    function ErrorHandler() {
    }
    return ErrorHandler;
}());
var DefaultErrorHandler = (function (_super) {
    __extends$12(DefaultErrorHandler, _super);
    function DefaultErrorHandler() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DefaultErrorHandler.prototype.error = function (error) {
        console.error("[Default error handler]: ", error);
    };
    DefaultErrorHandler.prototype.warning = function (warning) {
        console.warn("[Default warning handler]: ", warning);
    };
    DefaultErrorHandler.prototype.info = function (info) {
        console.info("[Default info handler]: ", info);
    };
    DefaultErrorHandler.prototype.log = function (log) {
        console.log("[Default log handler]: ", log);
    };
    return DefaultErrorHandler;
}(ErrorHandler));
DefaultErrorHandler.decorators = [
    { type: _angular_core.Injectable },
];
/** @nocollapse */
DefaultErrorHandler.ctorParameters = function () { return []; };

/**
 * Define the inline template and styles with ts variables
 */
/**
 * Define the inline template and styles with ts variables
 */ var LOG_TEMPLATE = "\n<div>\n    <h2 class=\"h2-log-override\" *ngIf=\"withTitle\">{{'SIDE_NAV.LOGS' | translate}}</h2>\n    <div class=\"row flex-items-xs-between flex-items-xs-bottom\">\n        <div></div>\n        <div class=\"action-head-pos rightPos\">\n            <hbr-filter [withDivider]=\"true\" filterPlaceholder='{{\"AUDIT_LOG.FILTER_PLACEHOLDER\" | translate}}' (filter)=\"doFilter($event)\" [currentValue]=\"currentTerm\"></hbr-filter>\n            <span (click)=\"refresh()\" class=\"refresh-btn\">\n            <clr-icon shape=\"refresh\" [hidden]=\"inProgress\" ng-disabled=\"inProgress\"></clr-icon>\n            <span class=\"spinner spinner-inline\" [hidden]=\"!inProgress\"></span>\n            </span>\n        </div>\n    </div>\n    <div>\n        <clr-datagrid (clrDgRefresh)=\"load($event)\" [clrDgLoading]=\"loading\">\n            <clr-dg-column [clrDgField]=\"'username'\">{{'AUDIT_LOG.USERNAME' | translate}}</clr-dg-column>\n            <clr-dg-column [clrDgField]=\"'repo_name'\">{{'AUDIT_LOG.REPOSITORY_NAME' | translate}}</clr-dg-column>\n            <clr-dg-column [clrDgField]=\"'repo_tag'\">{{'AUDIT_LOG.TAGS' | translate}}</clr-dg-column>\n            <clr-dg-column [clrDgField]=\"'operation'\">{{'AUDIT_LOG.OPERATION' | translate}}</clr-dg-column>\n            <clr-dg-column [clrDgSortBy]=\"opTimeComparator\">{{'AUDIT_LOG.TIMESTAMP' | translate}}</clr-dg-column>\n            <clr-dg-placeholder>We couldn't find any logs!</clr-dg-placeholder>\n            <clr-dg-row *ngFor=\"let l of recentLogs\">\n                <clr-dg-cell>{{l.username}}</clr-dg-cell>\n                <clr-dg-cell>{{l.repo_name}}</clr-dg-cell>\n                <clr-dg-cell>{{l.repo_tag}}</clr-dg-cell>\n                <clr-dg-cell>{{l.operation}}</clr-dg-cell>\n                <clr-dg-cell>{{l.op_time | date: 'short'}}</clr-dg-cell>\n            </clr-dg-row>\n            <clr-dg-footer>\n            {{pagination.firstItem + 1}} - {{pagination.lastItem + 1}}\n    {{'AUDIT_LOG.OF' | translate}} {{pagination.totalItems}} {{'AUDIT_LOG.ITEMS' | translate}}\n            <clr-dg-pagination #pagination [(clrDgPage)]=\"currentPage\" [clrDgPageSize]=\"pageSize\" [clrDgTotalItems]=\"totalCount\"></clr-dg-pagination>\n            </clr-dg-footer>\n        </clr-datagrid>\n    </div>\n</div>\n";
var LOG_STYLES = "\n.h2-log-override {\n    margin-top: 0px !important;\n}\n\n.action-head-pos {\n    padding-right: 18px;\n    height: 24px;\n}\n\n.refresh-btn {\n    cursor: pointer;\n}\n\n.refresh-btn:hover {\n    color: #007CBB;\n}\n\n.custom-lines-button {\n    padding: 0px !important;\n    min-width: 25px !important;\n}\n\n.lines-button-toggole {\n    font-size: 16px;\n    text-decoration: underline;\n}\n\n.log-select {\n    width: 130px;\n    display: inline-block;\n    top: 1px;\n}\n\n.item-divider {\n    height: 24px;\n    display: inline-block;\n    width: 1px;\n    background-color: #ccc;\n    opacity: 0.55;\n    margin-left: 12px;\n    top: 8px;\n    position: relative;\n}\n.rightPos {\n    position: absolute;\n    z-index: 100;\n    right: 35px;\n    margin-top: 4px;\n}\n";

// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//    http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var RecentLogComponent = (function () {
    function RecentLogComponent(logService, errorHandler) {
        this.logService = logService;
        this.errorHandler = errorHandler;
        this.recentLogs = [];
        this.loading = true;
        this.withTitle = false;
        this.pageSize = DEFAULT_PAGE_SIZE;
        this.currentPage = 1; //Double bound to pagination component
        this.currentPagePvt = 0; //Used to confirm whether page is changed
        this.opTimeComparator = new CustomComparator('op_time', 'date');
    }
    RecentLogComponent.prototype.ngOnInit = function () {
    };
    Object.defineProperty(RecentLogComponent.prototype, "totalCount", {
        get: function () {
            return this.logsCache && this.logsCache.metadata ? this.logsCache.metadata.xTotalCount : 0;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RecentLogComponent.prototype, "inProgress", {
        get: function () {
            return this.loading;
        },
        enumerable: true,
        configurable: true
    });
    RecentLogComponent.prototype.doFilter = function (terms) {
        this.currentTerm = terms.trim();
        //Trigger data loading and start from first page
        this.loading = true;
        this.currentPage = 1;
        if (this.currentPagePvt === 1) {
            //Force reloading
            var st = this.currentState;
            if (!st) {
                st = {
                    page: {}
                };
            }
            st.page.from = 0;
            st.page.to = this.pageSize - 1;
            st.page.size = this.pageSize;
            this.currentPagePvt = 0; //Reset pvt
            this.load(st);
        }
    };
    RecentLogComponent.prototype.refresh = function () {
        this.doFilter("");
    };
    RecentLogComponent.prototype.load = function (state) {
        var _this = this;
        //Keep it for future filter
        this.currentState = state;
        var pageNumber = calculatePage(state);
        if (pageNumber !== this.currentPagePvt) {
            //load data
            var params = new RequestQueryParams();
            params.set("page", '' + pageNumber);
            params.set("page_size", '' + this.pageSize);
            if (this.currentTerm && this.currentTerm !== "") {
                params.set('repository', this.currentTerm);
            }
            this.loading = true;
            toPromise(this.logService.getRecentLogs(params))
                .then(function (response) {
                _this.logsCache = response; //Keep the data
                _this.recentLogs = _this.logsCache.data.filter(function (log) { return log.username != ""; }); //To display
                //Do customized filter
                _this.recentLogs = doFiltering(_this.recentLogs, state);
                //Do customized sorting
                _this.recentLogs = doSorting(_this.recentLogs, state);
                _this.currentPagePvt = pageNumber;
                _this.loading = false;
            })
                .catch(function (error) {
                _this.loading = false;
                _this.errorHandler.error(error);
            });
        }
        else {
            //Column sorting and filtering
            this.recentLogs = this.logsCache.data.filter(function (log) { return log.username != ""; }); //Reset data
            //Do customized filter
            this.recentLogs = doFiltering(this.recentLogs, state);
            //Do customized sorting
            this.recentLogs = doSorting(this.recentLogs, state);
        }
    };
    RecentLogComponent.prototype.isMatched = function (terms, log) {
        var reg = new RegExp('.*' + terms + '.*', 'i');
        return reg.test(log.username) ||
            reg.test(log.repo_name) ||
            reg.test(log.operation) ||
            reg.test(log.repo_tag);
    };
    return RecentLogComponent;
}());
RecentLogComponent.decorators = [
    { type: _angular_core.Component, args: [{
                selector: 'hbr-log',
                styles: [LOG_STYLES],
                template: LOG_TEMPLATE
            },] },
];
/** @nocollapse */
RecentLogComponent.ctorParameters = function () { return [
    { type: AccessLogService, },
    { type: ErrorHandler, },
]; };
RecentLogComponent.propDecorators = {
    'withTitle': [{ type: _angular_core.Input },],
};

var LOG_DIRECTIVES = [
    RecentLogComponent
];

/**
 * Define template resources for filter component
 */
/**
 * Define template resources for filter component
 */ var FILTER_TEMPLATE = "\n<span>\n    <clr-icon shape=\"search\" size=\"20\" class=\"search-btn\" [class.filter-icon]=\"isShowSearchBox\" (click)=\"onClick()\"></clr-icon>\n    <input [hidden]=\"!isShowSearchBox\" type=\"text\" style=\"padding-left: 15px;\" (keyup)=\"valueChange()\" placeholder=\"{{placeHolder}}\" [(ngModel)]=\"currentValue\"/>\n    <span class=\"filter-divider\" *ngIf=\"withDivider\"></span>\n</span>\n";
var FILTER_STYLES = "\n.filter-icon {\n    position: relative;\n    right: -12px;\n}\n\n.filter-divider {\n    display: inline-block;\n    height: 16px;\n    width: 2px;\n    background-color: #cccccc;\n    padding-top: 12px;\n    padding-bottom: 12px;\n    position: relative;\n    top: 9px;\n    margin-right: 6px;\n    margin-left: 6px;\n}\n\n.search-btn {\n    cursor: pointer;\n}\n\n.search-btn:hover {\n    color: #007CBB;\n}\n";

// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//    http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var FilterComponent = (function () {
    function FilterComponent() {
        this.placeHolder = "";
        this.filterTerms = new rxjs_Subject.Subject();
        this.isExpanded = false;
        this.filterEvt = new _angular_core.EventEmitter();
        this.expandMode = false;
        this.withDivider = false;
    }
    Object.defineProperty(FilterComponent.prototype, "flPlaceholder", {
        set: function (placeHolder) {
            this.placeHolder = placeHolder;
        },
        enumerable: true,
        configurable: true
    });
    FilterComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.filterTerms
            .debounceTime(500)
            .subscribe(function (terms) {
            _this.filterEvt.emit(terms);
        });
    };
    FilterComponent.prototype.valueChange = function () {
        //Send out filter terms
        this.filterTerms.next(this.currentValue.trim());
    };
    FilterComponent.prototype.onClick = function () {
        //Only enabled when expandMode is set to false
        if (this.expandMode) {
            return;
        }
        this.isExpanded = !this.isExpanded;
    };
    Object.defineProperty(FilterComponent.prototype, "isShowSearchBox", {
        get: function () {
            return this.expandMode || (!this.expandMode && this.isExpanded);
        },
        enumerable: true,
        configurable: true
    });
    return FilterComponent;
}());
FilterComponent.decorators = [
    { type: _angular_core.Component, args: [{
                selector: 'hbr-filter',
                styles: [FILTER_STYLES],
                template: FILTER_TEMPLATE
            },] },
];
/** @nocollapse */
FilterComponent.ctorParameters = function () { return []; };
FilterComponent.propDecorators = {
    'filterEvt': [{ type: _angular_core.Output, args: ["filter",] },],
    'currentValue': [{ type: _angular_core.Input },],
    'flPlaceholder': [{ type: _angular_core.Input, args: ["filterPlaceholder",] },],
    'expandMode': [{ type: _angular_core.Input },],
    'withDivider': [{ type: _angular_core.Input },],
};

var FILTER_DIRECTIVES = [
    FilterComponent
];

var ConfirmationMessage = (function () {
    function ConfirmationMessage(title, message, param, data, targetId, buttons) {
        this.data = {}; //default is empty
        this.targetId = 0 /* EMPTY */;
        this.title = title;
        this.message = message;
        this.data = data;
        this.targetId = targetId;
        this.param = param;
        this.buttons = buttons ? buttons : 0 /* CONFIRM_CANCEL */;
    }
    return ConfirmationMessage;
}());

/**
 * To handle the error message body
 *
 * @export
 * @returns {string}
 */
var errorHandler = function (error) {
    if (!error) {
        return "UNKNOWN_ERROR";
    }
    if (!(error.statusCode || error.status)) {
        // treat as string message
        return '' + error;
    }
    else {
        switch (error.statusCode || error.status) {
            case 400:
                return "BAD_REQUEST_ERROR";
            case 401:
                return "UNAUTHORIZED_ERROR";
            case 403:
                return "FORBIDDEN_ERROR";
            case 404:
                return "NOT_FOUND_ERROR";
            case 412:
                return "PRECONDITION_FAILED";
            case 409:
                return "CONFLICT_ERROR";
            case 500:
                return "SERVER_ERROR";
            default:
                return "UNKNOWN_ERROR";
        }
    }
};

var INLINE_ALERT_STYLE = "\n  .alert-text-blink {\n    color: red;\n    font-weight: bolder;\n  }\n  .alert-btn-link {\n    padding: 0px !important;\n    min-width: 30px !important;\n  }\n  .alert-item {\n    text-align: center;\n}\n:host >>> .alert-icon-wrapper{\n    display: inline;\n}\n";

var INLINE_ALERT_TEMPLATE = "\n<clr-alert [clrAlertType]=\"inlineAlertType\" [clrAlertClosable]=\"inlineAlertClosable\" [(clrAlertClosed)]=\"alertClose\" [clrAlertAppLevel]=\"useAppLevelStyle\">\n    <div class=\"alert-item\">\n        <span class=\"alert-text\" [class.alert-text-blink]=\"blinking\">\n            {{errorMessage}}\n        </span>\n        <div class=\"alert-actions\" *ngIf=\"showCancelAction\">\n            <button class=\"btn btn-sm btn-link alert-btn-link\" (click)=\"close()\">{{'BUTTON.NO' | translate}}</button>\n            <button class=\"btn btn-sm btn-link alert-btn-link\" (click)=\"confirmCancel()\">{{'BUTTON.YES' | translate}}</button>\n        </div>\n    </div>\n</clr-alert>\n";

// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//    http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var InlineAlertComponent = (function () {
    function InlineAlertComponent(translate) {
        this.translate = translate;
        this.inlineAlertType = 'alert-danger';
        this.inlineAlertClosable = false;
        this.alertClose = true;
        this.displayedText = "";
        this.showCancelAction = false;
        this.useAppLevelStyle = false;
        this.timer = null;
        this.count = 0;
        this.blinking = false;
        this.confirmEvt = new _angular_core.EventEmitter();
    }
    Object.defineProperty(InlineAlertComponent.prototype, "errorMessage", {
        get: function () {
            return this.displayedText;
        },
        enumerable: true,
        configurable: true
    });
    //Show error message inline
    InlineAlertComponent.prototype.showInlineError = function (error) {
        var _this = this;
        this.displayedText = errorHandler(error);
        if (this.displayedText) {
            this.translate.get(this.displayedText).subscribe(function (res) { return _this.displayedText = res; });
        }
        this.inlineAlertType = 'alert-danger';
        this.showCancelAction = false;
        this.inlineAlertClosable = true;
        this.alertClose = false;
        this.useAppLevelStyle = false;
    };
    //Show confirmation info with action button
    InlineAlertComponent.prototype.showInlineConfirmation = function (warning) {
        var _this = this;
        this.displayedText = "";
        if (warning && warning.message) {
            this.translate.get(warning.message).subscribe(function (res) { return _this.displayedText = res; });
        }
        this.inlineAlertType = 'alert-warning';
        this.showCancelAction = true;
        this.inlineAlertClosable = false;
        this.alertClose = false;
        this.useAppLevelStyle = false;
    };
    //Show inline sccess info
    InlineAlertComponent.prototype.showInlineSuccess = function (info) {
        var _this = this;
        this.displayedText = "";
        if (info && info.message) {
            this.translate.get(info.message).subscribe(function (res) { return _this.displayedText = res; });
        }
        this.inlineAlertType = 'alert-success';
        this.showCancelAction = false;
        this.inlineAlertClosable = true;
        this.alertClose = false;
        this.useAppLevelStyle = false;
    };
    //Close alert
    InlineAlertComponent.prototype.close = function () {
        this.alertClose = true;
    };
    InlineAlertComponent.prototype.blink = function () {
    };
    InlineAlertComponent.prototype.confirmCancel = function () {
        this.confirmEvt.emit(true);
    };
    return InlineAlertComponent;
}());
InlineAlertComponent.decorators = [
    { type: _angular_core.Component, args: [{
                selector: 'hbr-inline-alert',
                template: INLINE_ALERT_TEMPLATE,
                styles: [INLINE_ALERT_STYLE]
            },] },
];
/** @nocollapse */
InlineAlertComponent.ctorParameters = function () { return [
    { type: _ngxTranslate_core.TranslateService, },
]; };
InlineAlertComponent.propDecorators = {
    'confirmEvt': [{ type: _angular_core.Output },],
};

var CREATE_EDIT_ENDPOINT_STYLE = "\n  .form-group-label-override {\n    font-size: 14px;\n    font-weight: 400;\n  }\n\n  clr-tooltip {\n    top: 3px;\n    position: relative;\n  }\n";

var CREATE_EDIT_ENDPOINT_TEMPLATE = "\n<clr-modal [(clrModalOpen)]=\"createEditDestinationOpened\" [clrModalStaticBackdrop]=\"staticBackdrop\" [clrModalClosable]=\"closable\">\n  <h3 class=\"modal-title\">{{modalTitle}}</h3>\n  <hbr-inline-alert class=\"modal-title\" (confirmEvt)=\"confirmCancel($event)\"></hbr-inline-alert>\n  <div class=\"modal-body\">\n    <div class=\"alert alert-warning\" *ngIf=\"!editable\">\n      <div class=\"alert-item static\">\n        <span class=\"alert-text\">\n          {{'DESTINATION.CANNOT_EDIT' | translate}}\n        </span>\n      </div>\n    </div>\n    <form #targetForm=\"ngForm\">\n      <section class=\"form-block\">\n        <div class=\"form-group\">\n          <label for=\"destination_name\" class=\"col-md-4 form-group-label-override required\">{{ 'DESTINATION.NAME' | translate }}</label>\n          <label class=\"col-md-8\" for=\"destination_name\" aria-haspopup=\"true\" role=\"tooltip\" [class.invalid]=\"targetName.errors && (targetName.dirty || targetName.touched)\" [class.valid]=\"targetName.valid\" class=\"tooltip tooltip-validation tooltip-sm tooltip-bottom-left\">\n            <input type=\"text\" id=\"destination_name\" [disabled]=\"testOngoing\" [readonly]=\"!editable\" [(ngModel)]=\"target.name\" name=\"targetName\" size=\"20\" #targetName=\"ngModel\" required> \n            <span class=\"tooltip-content\" *ngIf=\"targetName.errors && targetName.errors.required && (targetName.dirty || targetName.touched)\">\n              {{ 'DESTINATION.NAME_IS_REQUIRED' | translate }}\n            </span>\n          </label>\n        </div>\n        <div class=\"form-group\">\n          <label for=\"destination_url\" class=\"col-md-4 form-group-label-override required\">{{ 'DESTINATION.URL' | translate }}</label>\n          <label class=\"col-md-8\" for=\"destination_url\" aria-haspopup=\"true\" role=\"tooltip\" [class.invalid]=\"targetEndpoint.errors && (targetEndpoint.dirty || targetEndpoint.touched)\" [class.valid]=\"targetEndpoint.valid\" class=\"tooltip tooltip-validation tooltip-sm tooltip-bottom-left\">\n            <input type=\"text\" id=\"destination_url\" [disabled]=\"testOngoing\" [readonly]=\"!editable\" [(ngModel)]=\"target.endpoint\" size=\"20\" name=\"endpointUrl\" #targetEndpoint=\"ngModel\" required placeholder=\"http(s)://192.168.1.1\">\n            <span class=\"tooltip-content\" *ngIf=\"targetEndpoint.errors && targetEndpoint.errors.required && (targetEndpoint.dirty || targetEndpoint.touched)\">\n              {{ 'DESTINATION.URL_IS_REQUIRED' | translate }}\n            </span>\n          </label>\n        </div>\n        <div class=\"form-group\">\n          <label for=\"destination_username\" class=\"col-md-4 form-group-label-override\">{{ 'DESTINATION.USERNAME' | translate }}</label>\n          <input type=\"text\" class=\"col-md-8\" id=\"destination_username\" [disabled]=\"testOngoing\" [readonly]=\"!editable\" [(ngModel)]=\"target.username\" size=\"20\" name=\"username\" #username=\"ngModel\">\n        </div>\n        <div class=\"form-group\">\n          <label for=\"destination_password\" class=\"col-md-4 form-group-label-override\">{{ 'DESTINATION.PASSWORD' | translate }}</label>\n          <input type=\"password\" class=\"col-md-8\" id=\"destination_password\" [disabled]=\"testOngoing\" [readonly]=\"!editable\" [(ngModel)]=\"target.password\" size=\"20\" name=\"password\" #password=\"ngModel\">\n        </div>\n        <div class=\"form-group\">\n          <label for=\"destination_insecure\" class=\"col-md-4 form-group-label-override\">{{'CONFIG.VERIFY_REMOTE_CERT' | translate }}</label>\n          <clr-checkbox #insecure name=\"insecure\" id=\"destination_insecure\" [clrDisabled]=\"testOngoing || !editable\" [clrChecked]=\"!target.insecure\" [clrInline]=\"true\" (clrCheckedChange)=\"setInsecureValue($event)\">\n          </clr-checkbox>\n          <clr-tooltip>\n            <clr-icon clrTooltipTrigger shape=\"info-circle\" size=\"24\"></clr-icon>\n            <clr-tooltip-content clrPosition=\"top-right\" clrSize=\"md\" *clrIfOpen>\n              {{'CONFIG.TOOLTIP.VERIFY_REMOTE_CERT' | translate}}\n            </clr-tooltip-content>\n          </clr-tooltip>\n        </div>\n        <div class=\"form-group\">\n          <label for=\"spin\" class=\"col-md-4\"></label>\n          <span class=\"col-md-8 spinner spinner-inline\" [hidden]=\"!inProgress\"></span>\n        </div>\n      </section>\n    </form>\n  </div>\n  <div class=\"modal-footer\">\n      <button type=\"button\" class=\"btn btn-outline\" (click)=\"testConnection()\" [disabled]=\"inProgress || targetEndpoint.errors\">{{ 'DESTINATION.TEST_CONNECTION' | translate }}</button>\n      <button type=\"button\" class=\"btn btn-outline\" (click)=\"onCancel()\"  [disabled]=\"inProgress\">{{ 'BUTTON.CANCEL' | translate }}</button>\n      <button type=\"submit\" class=\"btn btn-primary\" (click)=\"onSubmit()\"  [disabled]=\"!isValid\">{{ 'BUTTON.OK' | translate }}</button>\n  </div>\n</clr-modal>";

// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//    http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var FAKE_PASSWORD = 'rjGcfuRu';
var CreateEditEndpointComponent = (function () {
    function CreateEditEndpointComponent(endpointService, errorHandler, translateService, ref) {
        this.endpointService = endpointService;
        this.errorHandler = errorHandler;
        this.translateService = translateService;
        this.ref = ref;
        this.staticBackdrop = true;
        this.closable = false;
        this.target = this.initEndpoint();
        this.reload = new _angular_core.EventEmitter();
    }
    Object.defineProperty(CreateEditEndpointComponent.prototype, "isValid", {
        get: function () {
            return !this.testOngoing &&
                !this.onGoing &&
                this.targetForm &&
                this.targetForm.valid &&
                this.editable &&
                !compareValue(this.target, this.initVal);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CreateEditEndpointComponent.prototype, "inProgress", {
        get: function () {
            return this.onGoing || this.testOngoing;
        },
        enumerable: true,
        configurable: true
    });
    CreateEditEndpointComponent.prototype.setInsecureValue = function ($event) {
        this.target.insecure = !$event;
    };
    CreateEditEndpointComponent.prototype.ngOnDestroy = function () {
        if (this.valueChangesSub) {
            this.valueChangesSub.unsubscribe();
        }
    };
    CreateEditEndpointComponent.prototype.initEndpoint = function () {
        return {
            endpoint: "",
            name: "",
            username: "",
            password: "",
            insecure: false,
            type: 0
        };
    };
    CreateEditEndpointComponent.prototype.open = function () {
        this.createEditDestinationOpened = true;
    };
    CreateEditEndpointComponent.prototype.close = function () {
        this.createEditDestinationOpened = false;
    };
    CreateEditEndpointComponent.prototype.reset = function () {
        //Reset status variables
        this.testOngoing = false;
        this.onGoing = false;
        //Reset data
        this.target = this.initEndpoint();
        this.initVal = this.initEndpoint();
        this.formValues = null;
        this.endpointId = '';
        this.inlineAlert.close();
    };
    //Forcely refresh the view
    CreateEditEndpointComponent.prototype.forceRefreshView = function (duration) {
        var _this = this;
        //Reset timer
        if (this.timerHandler) {
            clearInterval(this.timerHandler);
        }
        this.timerHandler = setInterval(function () { return _this.ref.markForCheck(); }, 100);
        setTimeout(function () {
            if (_this.timerHandler) {
                clearInterval(_this.timerHandler);
                _this.timerHandler = null;
            }
        }, duration);
    };
    CreateEditEndpointComponent.prototype.openCreateEditTarget = function (editable, targetId) {
        var _this = this;
        this.editable = editable;
        //reset
        this.reset();
        if (targetId) {
            this.endpointId = targetId;
            this.translateService.get('DESTINATION.TITLE_EDIT').subscribe(function (res) { return _this.modalTitle = res; });
            toPromise(this.endpointService
                .getEndpoint(targetId))
                .then(function (target) {
                _this.target = target;
                //Keep data cache
                _this.initVal = clone(target);
                _this.initVal.password = FAKE_PASSWORD;
                _this.target.password = FAKE_PASSWORD;
                //Open the modal now
                _this.open();
                _this.forceRefreshView(2000);
            })
                .catch(function (error) { return _this.errorHandler.error(error); });
        }
        else {
            this.endpointId = '';
            this.translateService.get('DESTINATION.TITLE_ADD').subscribe(function (res) { return _this.modalTitle = res; });
            //Directly open the modal
            this.open();
        }
    };
    CreateEditEndpointComponent.prototype.testConnection = function () {
        var _this = this;
        var payload = this.initEndpoint();
        if (!this.endpointId) {
            payload.endpoint = this.target.endpoint;
            payload.username = this.target.username;
            payload.password = this.target.password;
            payload.insecure = this.target.insecure;
        }
        else {
            var changes_1 = this.getChanges();
            for (var prop in payload) {
                delete payload[prop];
            }
            payload.id = this.target.id;
            if (!isEmptyObject(changes_1)) {
                var changekeys = Object.keys(this.getChanges());
                changekeys.forEach(function (key) {
                    payload[key] = changes_1[key];
                });
            }
        }
        this.testOngoing = true;
        toPromise(this.endpointService
            .pingEndpoint(payload))
            .then(function (response) {
            _this.inlineAlert.showInlineSuccess({ message: "DESTINATION.TEST_CONNECTION_SUCCESS" });
            _this.forceRefreshView(2000);
            _this.testOngoing = false;
        }).catch(function (error) {
            _this.inlineAlert.showInlineError('DESTINATION.TEST_CONNECTION_FAILURE');
            _this.forceRefreshView(2000);
            _this.testOngoing = false;
        });
    };
    CreateEditEndpointComponent.prototype.onSubmit = function () {
        if (this.endpointId) {
            this.updateEndpoint();
        }
        else {
            this.addEndpoint();
        }
    };
    CreateEditEndpointComponent.prototype.addEndpoint = function () {
        var _this = this;
        if (this.onGoing) {
            return; //Avoid duplicated submitting
        }
        this.onGoing = true;
        toPromise(this.endpointService
            .createEndpoint(this.target))
            .then(function (response) {
            _this.translateService.get('DESTINATION.CREATED_SUCCESS')
                .subscribe(function (res) { return _this.errorHandler.info(res); });
            _this.reload.emit(true);
            _this.onGoing = false;
            _this.close();
            _this.forceRefreshView(2000);
        }).catch(function (error) {
            _this.onGoing = false;
            var errorMessageKey = _this.handleErrorMessageKey(error.status);
            _this.translateService
                .get(errorMessageKey)
                .subscribe(function (res) {
                _this.inlineAlert.showInlineError(res);
            });
            _this.forceRefreshView(2000);
        });
    };
    CreateEditEndpointComponent.prototype.updateEndpoint = function () {
        var _this = this;
        if (this.onGoing) {
            return; //Avoid duplicated submitting
        }
        var payload = this.initEndpoint();
        for (var prop in payload) {
            delete payload[prop];
        }
        var changes = this.getChanges();
        if (isEmptyObject(changes)) {
            return;
        }
        var changekeys = Object.keys(changes);
        changekeys.forEach(function (key) {
            payload[key] = changes[key];
        });
        if (!this.target.id) {
            return;
        }
        this.onGoing = true;
        toPromise(this.endpointService
            .updateEndpoint(this.target.id, payload))
            .then(function (response) {
            _this.translateService.get('DESTINATION.UPDATED_SUCCESS')
                .subscribe(function (res) { return _this.errorHandler.info(res); });
            _this.reload.emit(true);
            _this.close();
            _this.onGoing = false;
            _this.forceRefreshView(2000);
        })
            .catch(function (error) {
            var errorMessageKey = _this.handleErrorMessageKey(error.status);
            _this.translateService
                .get(errorMessageKey)
                .subscribe(function (res) {
                _this.inlineAlert.showInlineError(res);
            });
            _this.onGoing = false;
            _this.forceRefreshView(2000);
        });
    };
    CreateEditEndpointComponent.prototype.handleErrorMessageKey = function (status) {
        switch (status) {
            case 409:
                return 'DESTINATION.CONFLICT_NAME';
            case 400:
                return 'DESTINATION.INVALID_NAME';
            default:
                return 'UNKNOWN_ERROR';
        }
    };
    CreateEditEndpointComponent.prototype.onCancel = function () {
        var changes = this.getChanges();
        if (!isEmptyObject(changes)) {
            this.inlineAlert.showInlineConfirmation({ message: 'ALERT.FORM_CHANGE_CONFIRMATION' });
        }
        else {
            this.close();
            if (this.targetForm) {
                this.targetForm.reset();
            }
        }
    };
    CreateEditEndpointComponent.prototype.confirmCancel = function (confirmed) {
        this.inlineAlert.close();
        this.close();
    };
    CreateEditEndpointComponent.prototype.ngAfterViewChecked = function () {
        var _this = this;
        if (this.targetForm != this.currentForm) {
            this.targetForm = this.currentForm;
            if (this.targetForm) {
                this.valueChangesSub = this.targetForm.valueChanges.subscribe(function (data) {
                    if (data) {
                        //To avoid invalid change publish events
                        var keyNumber = 0;
                        for (var key in data) {
                            //Empty string "" is accepted
                            if (data[key] !== null) {
                                keyNumber++;
                            }
                        }
                        if (keyNumber !== 5) {
                            return;
                        }
                        if (!compareValue(_this.formValues, data)) {
                            _this.formValues = data;
                            _this.inlineAlert.close();
                        }
                    }
                });
            }
        }
    };
    CreateEditEndpointComponent.prototype.getChanges = function () {
        var changes = {};
        if (!this.target || !this.initVal) {
            return changes;
        }
        for (var prop in this.target) {
            var field = this.initVal[prop];
            if (!compareValue(field, this.target[prop])) {
                changes[prop] = this.target[prop];
                //Number
                if (typeof field === "number") {
                    changes[prop] = +changes[prop];
                }
                //Trim string value
                if (typeof field === "string") {
                    changes[prop] = ('' + changes[prop]).trim();
                }
            }
        }
        return changes;
    };
    return CreateEditEndpointComponent;
}());
CreateEditEndpointComponent.decorators = [
    { type: _angular_core.Component, args: [{
                selector: 'hbr-create-edit-endpoint',
                template: CREATE_EDIT_ENDPOINT_TEMPLATE,
                styles: [CREATE_EDIT_ENDPOINT_STYLE]
            },] },
];
/** @nocollapse */
CreateEditEndpointComponent.ctorParameters = function () { return [
    { type: EndpointService, },
    { type: ErrorHandler, },
    { type: _ngxTranslate_core.TranslateService, },
    { type: _angular_core.ChangeDetectorRef, },
]; };
CreateEditEndpointComponent.propDecorators = {
    'currentForm': [{ type: _angular_core.ViewChild, args: ['targetForm',] },],
    'inlineAlert': [{ type: _angular_core.ViewChild, args: [InlineAlertComponent,] },],
    'reload': [{ type: _angular_core.Output },],
};

var ENDPOINT_STYLE = "\n  .option-left {\n    padding-left: 16px;\n    margin-top: -6px;\n  }\n  .option-right {\n    padding-right: 16px;\n  }\n  .refresh-btn {\n    cursor: pointer;\n  }\n  .refresh-btn:hover {\n    color: #007CBB;\n  }\n  .rightPos{  \n    position: absolute;\n    z-index: 100;\n    right: 35px;\n    margin-top: 4px;\n    height: 24px;}\n";

var ENDPOINT_TEMPLATE = "\n<div>\n    <div class=\"row\"  style=\"position:relative;\">\n        <div>\n            <div class=\"row flex-items-xs-between rightPos\">\n                <div class=\"flex-items-xs-middle option-right\">\n                    <hbr-filter [withDivider]=\"true\" filterPlaceholder='{{\"REPLICATION.FILTER_TARGETS_PLACEHOLDER\" | translate}}' (filter)=\"doSearchTargets($event)\" [currentValue]=\"targetName\"></hbr-filter>\n                    <span class=\"refresh-btn\" (click)=\"refreshTargets()\">\n                        <clr-icon shape=\"refresh\"></clr-icon>\n                    </span>\n                </div>\n            </div>\n        </div>\n        <div class=\"col-lg-12 col-md-12 col-sm-12 col-xs-12\">\n            <clr-datagrid [clrDgLoading]=\"loading\"  [(clrDgSelected)]=\"selectedRow\" (clrDgSelectedChange)=\"selectedChange()\">\n                <clr-dg-action-bar>\n                    <button type=\"button\" class=\"btn btn-sm btn-secondary\" (click)=\"openModal()\"><clr-icon shape=\"plus\" size=\"16\"></clr-icon>&nbsp;{{'DESTINATION.NEW_ENDPOINT' | translate}}</button>\n                    <button type=\"button\" class=\"btn btn-sm btn-secondary\" [disabled]=\"!(selectedRow.length ===1)\"  (click)=\"editTargets(selectedRow)\" ><clr-icon shape=\"pencil\" size=\"16\"></clr-icon>&nbsp;{{'DESTINATION.EDIT' | translate}}</button>\n                    <button type=\"button\" class=\"btn btn-sm btn-secondary\" [disabled]=\"!selectedRow.length\" (click)=\"deleteTargets(selectedRow)\"><clr-icon shape=\"times\" size=\"16\"></clr-icon>&nbsp;{{'DESTINATION.DELETE' | translate}}</button>\n                </clr-dg-action-bar>\n                <clr-dg-column [clrDgField]=\"'name'\">{{'DESTINATION.NAME' | translate}}</clr-dg-column>\n                <clr-dg-column [clrDgField]=\"'endpoint'\">{{'DESTINATION.URL' | translate}}</clr-dg-column>\n                <clr-dg-column [clrDgField]=\"'insecure'\">{{'CONFIG.VERIFY_REMOTE_CERT' | translate }}</clr-dg-column>\n                <clr-dg-column [clrDgSortBy]=\"creationTimeComparator\">{{'DESTINATION.CREATION_TIME' | translate}}</clr-dg-column>\n                <clr-dg-placeholder>{{'DESTINATION.PLACEHOLDER' | translate }}</clr-dg-placeholder>\n                <clr-dg-row *clrDgItems=\"let t of targets\" [clrDgItem]='t'>\n                    <clr-dg-cell>{{t.name}}</clr-dg-cell>\n                    <clr-dg-cell>{{t.endpoint}}</clr-dg-cell>\n                    <clr-dg-cell>\n                        {{!t.insecure}}\n                    </clr-dg-cell>\n                    <clr-dg-cell>{{t.creation_time | date: 'short'}}</clr-dg-cell>\n                </clr-dg-row>\n                <clr-dg-footer>\n                    <span *ngIf=\"pagination.totalItems\">{{pagination.firstItem + 1}} - {{pagination.lastItem + 1}} {{'DESTINATION.OF' | translate}}</span>\n                    {{pagination.totalItems}} {{'DESTINATION.ITEMS' | translate}}\n                    <clr-dg-pagination #pagination [clrDgPageSize]=\"15\"></clr-dg-pagination>\n                </clr-dg-footer>\n            </clr-datagrid>\n        </div>\n    </div>\n    <confirmation-dialog #confirmationDialog [batchInfors]=\"batchDelectionInfos\" (confirmAction)=\"confirmDeletion($event)\"></confirmation-dialog>\n    <hbr-create-edit-endpoint (reload)=\"reload($event)\"></hbr-create-edit-endpoint>\n</div>\n";

/**
 * Created by pengf on 11/22/2017.
 */
var BatchInfo = (function () {
    function BatchInfo() {
        this.status = 'pending';
        this.loading = false;
        this.errorState = false;
        this.errorInfo = '';
    }
    return BatchInfo;
}());
function BathInfoChanges(list, status, loading, errStatus, errorInfo) {
    if (loading === void 0) { loading = false; }
    if (errStatus === void 0) { errStatus = false; }
    if (errorInfo === void 0) { errorInfo = ''; }
    list.status = status;
    list.loading = loading;
    list.errorState = errStatus;
    list.errorInfo = errorInfo;
    return list;
}

// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//    http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var EndpointComponent = (function () {
    function EndpointComponent(endpointService, errorHandler, translateService, ref) {
        this.endpointService = endpointService;
        this.errorHandler = errorHandler;
        this.translateService = translateService;
        this.ref = ref;
        this.loading = false;
        this.creationTimeComparator = new CustomComparator('creation_time', 'date');
        this.selectedRow = [];
        this.batchDelectionInfos = [];
        this.forceRefreshView(1000);
    }
    Object.defineProperty(EndpointComponent.prototype, "initEndpoint", {
        get: function () {
            return {
                endpoint: "",
                name: "",
                username: "",
                password: "",
                insecure: false,
                type: 0
            };
        },
        enumerable: true,
        configurable: true
    });
    EndpointComponent.prototype.ngOnInit = function () {
        this.targetName = '';
        this.retrieve();
    };
    EndpointComponent.prototype.ngOnDestroy = function () {
        if (this.subscription) {
            this.subscription.unsubscribe();
        }
    };
    EndpointComponent.prototype.selectedChange = function () {
        this.forceRefreshView(5000);
    };
    EndpointComponent.prototype.retrieve = function () {
        var _this = this;
        this.loading = true;
        this.selectedRow = [];
        toPromise(this.endpointService
            .getEndpoints(this.targetName))
            .then(function (targets) {
            _this.targets = targets || [];
            _this.forceRefreshView(1000);
            _this.loading = false;
        }).catch(function (error) {
            _this.errorHandler.error(error);
            _this.loading = false;
        });
    };
    EndpointComponent.prototype.doSearchTargets = function (targetName) {
        this.targetName = targetName;
        this.retrieve();
    };
    EndpointComponent.prototype.refreshTargets = function () {
        this.retrieve();
    };
    EndpointComponent.prototype.reload = function ($event) {
        this.targetName = '';
        this.retrieve();
    };
    EndpointComponent.prototype.openModal = function () {
        this.createEditEndpointComponent.openCreateEditTarget(true);
        this.target = this.initEndpoint;
    };
    EndpointComponent.prototype.editTargets = function (targets) {
        if (targets && targets.length === 1) {
            var target = targets[0];
            var editable = true;
            if (!target.id) {
                return;
            }
            var id = target.id;
            this.createEditEndpointComponent.openCreateEditTarget(editable, id);
        }
    };
    EndpointComponent.prototype.deleteTargets = function (targets) {
        var _this = this;
        if (targets && targets.length) {
            var targetNames_1 = [];
            this.batchDelectionInfos = [];
            targets.forEach(function (target) {
                targetNames_1.push(target.name);
                var initBatchMessage = new BatchInfo();
                initBatchMessage.name = target.name;
                _this.batchDelectionInfos.push(initBatchMessage);
            });
            var deletionMessage = new ConfirmationMessage('REPLICATION.DELETION_TITLE_TARGET', 'REPLICATION.DELETION_SUMMARY_TARGET', targetNames_1.join(', ') || '', targets, 6 /* TARGET */, 2 /* DELETE_CANCEL */);
            this.confirmationDialogComponent.open(deletionMessage);
        }
    };
    EndpointComponent.prototype.confirmDeletion = function (message) {
        var _this = this;
        if (message &&
            message.source === 6 /* TARGET */ &&
            message.state === 1 /* CONFIRMED */) {
            var targetLists = message.data;
            if (targetLists && targetLists.length) {
                var promiseLists_1 = [];
                targetLists.forEach(function (target) {
                    promiseLists_1.push(_this.delOperate(target.id, target.name));
                });
                Promise.all(promiseLists_1).then(function (item) {
                    _this.selectedRow = [];
                    _this.reload(true);
                    _this.forceRefreshView(2000);
                });
            }
        }
    };
    EndpointComponent.prototype.delOperate = function (id, name) {
        var _this = this;
        var findedList = this.batchDelectionInfos.find(function (data) { return data.name === name; });
        return toPromise(this.endpointService
            .deleteEndpoint(id))
            .then(function (response) {
            _this.translateService.get('BATCH.DELETED_SUCCESS')
                .subscribe(function (res) {
                findedList = BathInfoChanges(findedList, res);
            });
        }).catch(function (error) {
            if (error && error.status === 412) {
                rxjs_Observable.Observable.forkJoin(_this.translateService.get('BATCH.DELETED_FAILURE'), _this.translateService.get('DESTINATION.FAILED_TO_DELETE_TARGET_IN_USED')).subscribe(function (res) {
                    findedList = BathInfoChanges(findedList, res[0], false, true, res[1]);
                });
            }
            else {
                _this.translateService.get('BATCH.DELETED_FAILURE').subscribe(function (res) {
                    findedList = BathInfoChanges(findedList, res, false, true);
                });
            }
        });
    };
    //Forcely refresh the view
    EndpointComponent.prototype.forceRefreshView = function (duration) {
        var _this = this;
        //Reset timer
        if (this.timerHandler) {
            clearInterval(this.timerHandler);
        }
        this.timerHandler = setInterval(function () { return _this.ref.markForCheck(); }, 100);
        setTimeout(function () {
            if (_this.timerHandler) {
                clearInterval(_this.timerHandler);
                _this.timerHandler = null;
            }
        }, duration);
    };
    return EndpointComponent;
}());
EndpointComponent.decorators = [
    { type: _angular_core.Component, args: [{
                selector: 'hbr-endpoint',
                template: ENDPOINT_TEMPLATE,
                styles: [ENDPOINT_STYLE],
                changeDetection: _angular_core.ChangeDetectionStrategy.OnPush
            },] },
];
/** @nocollapse */
EndpointComponent.ctorParameters = function () { return [
    { type: EndpointService, },
    { type: ErrorHandler, },
    { type: _ngxTranslate_core.TranslateService, },
    { type: _angular_core.ChangeDetectorRef, },
]; };
EndpointComponent.propDecorators = {
    'createEditEndpointComponent': [{ type: _angular_core.ViewChild, args: [CreateEditEndpointComponent,] },],
    'confirmationDialogComponent': [{ type: _angular_core.ViewChild, args: ['confirmationDialog',] },],
};

var ENDPOINT_DIRECTIVES = [
    EndpointComponent
];

var REPOSITORY_TEMPLATE = "\n<section class=\"overview-section\">\n  <div class=\"title-wrapper\">\n    <div class=\"title-block arrow-block\" *ngIf=\"withAdmiral\">\t\n       <clr-icon class=\"rotate-90 arrow-back\" shape=\"arrow\" size=\"36\" (click)=\"goBack()\"></clr-icon>\n    </div>\n    <div class=\"title-block\">\n      <h2 sub-header-title class=\"custom-h2\">{{repoName}}</h2>\n    </div>\n  </div>\n</section>\n\n<section class=\"detail-section\">\n  <div class=\"col-lg-12 col-md-12 col-sm-12 col-xs-12\">\n    <span class=\"spinner spinner-inline\" [hidden]=\"inProgress === false\"></span>\n    <ul id=\"configTabs\" class=\"nav\" role=\"tablist\">\n      <li role=\"presentation\" class=\"nav-item\">\n          <button id=\"repo-info\" class=\"btn btn-link nav-link\" aria-controls=\"info\" [class.active]='isCurrentTabLink(\"repo-info\")' type=\"button\" (click)='tabLinkClick(\"repo-info\")'>{{'REPOSITORY.INFO' | translate}}</button>\n      </li>\n      <li role=\"presentation\" class=\"nav-item\">\n          <button id=\"repo-image\" class=\"btn btn-link nav-link active\" aria-controls=\"image\" [class.active]='isCurrentTabLink(\"repo-image\")' type=\"button\" (click)='tabLinkClick(\"repo-image\")'>{{'REPOSITORY.IMAGE' | translate}}</button>\n      </li>\n    </ul>\n    <section id=\"info\" role=\"tabpanel\" aria-labelledby=\"repo-info\" [hidden]='!isCurrentTabContent(\"info\")'>\n      <form #repoInfoForm=\"ngForm\">\n        <div id=\"info-edit-button\">\n          <button class=\"btn btn-sm\" [disabled]=\"editing || !hasProjectAdminRole \" (click)=\"editInfo()\" ><clr-icon shape=\"pencil\" size=\"16\"></clr-icon>&nbsp;{{'BUTTON.EDIT' | translate}}</button>\n        </div>\n        <div *ngIf=\"!editing\">\n          <div *ngIf=\"!hasInfo()\" class=\"no-info-div\">\n            <p>{{'REPOSITORY.NO_INFO' | translate }}<p>\n          </div>\n          <div *ngIf=\"hasInfo()\" class=\"info-div\">\n            <pre class=\"info-pre\">{{ imageInfo }}</pre>\n          </div>\n        </div>\n        <div *ngIf=\"editing\">\n            <textarea rows=\"5\"  name=\"info-edit-textarea\" [(ngModel)]=\"imageInfo\"></textarea>\n        </div>\n        <div class=\"btn-sm\" *ngIf=\"editing\">\n          <button class=\"btn btn-primary\" [disabled]=\"!hasChanges()\" (click)=\"saveInfo()\" >{{'BUTTON.SAVE' | translate}}</button>\n          <button class=\"btn\" (click)=\"cancelInfo()\" >{{'BUTTON.CANCEL' | translate}}</button>\n        </div>\n        <confirmation-dialog #confirmationDialog (confirmAction)=\"confirmCancel($event)\"></confirmation-dialog>\n      </form>\n    </section>\n    <section id=\"image\" role=\"tabpanel\" aria-labelledby=\"repo-image\" [hidden]='!isCurrentTabContent(\"image\")'>\n      <div id=images-container>\n        <hbr-tag ngProjectAs=\"clr-dg-row-detail\" (tagClickEvent)=\"watchTagClickEvt($event)\" (signatureOutput)=\"saveSignatures($event)\" class=\"sub-grid-custom\" [repoName]=\"repoName\" [registryUrl]=\"registryUrl\" [withNotary]=\"withNotary\" [withClair]=\"withClair\" [withAdmiral]=\"withAdmiral\" [hasSignedIn]=\"hasSignedIn\" [hasProjectAdminRole]=\"hasProjectAdminRole\" [isGuest]=\"isGuest\" [projectId]=\"projectId\"></hbr-tag>\n      </div>\n    </section>\n  </div>\n</section>\n";

var REPOSITORY_STYLE = ".option-right {\n  padding-right: 16px;\n  margin-bottom: 12px;\n}\n\n.arrow-back {\n  cursor: pointer;\n}\n\n.arrow-block {\t\n  border-right: 2px solid #cccccc;\t\n  margin-right: 6px;\t\n  display: inline-flex;\t\n  padding: 6px 6px 6px 12px;\t\n}\t\n\t\n.title-block {\t\n  display: inline-block;\t\n}\t\n\n.tag-name {\n  font-weight: 300;\n  font-size: 32px;\n}\n\n.no-info-div {\n  background: white;\n  border: 1px;\n  border-style: solid;\n  border-color: #CCCCCC;\n  padding: 12px 12px 12px 12px;\n}\n\n.info-div {\n  background: white;\n  border: 1px;\n  border-style: solid;\n  border-color: #CCCCCC;\n  padding: 0px 12px 24px 12px;\n}\n\n.info-pre {\n  border: 0px;\n  max-height: fit-content;\n}\n\n#info-edit-button {\n  margin-top: 0px;\n  margin-bottom: 12px;\n}\n\n#images-container {\n  margin-top: 12px;\n}\n\nharbor-tag {\n  position: relative;\n  top: 24px;\n}\n";

// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//    http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var TabLinkContentMap = {
    'repo-info': 'info',
    'repo-image': 'image'
};
var RepositoryComponent = (function () {
    function RepositoryComponent(errorHandler, repositoryService, systemInfoService, tagService, translate) {
        this.errorHandler = errorHandler;
        this.repositoryService = repositoryService;
        this.systemInfoService = systemInfoService;
        this.tagService = tagService;
        this.translate = translate;
        this.signedCon = {};
        this.tagClickEvent = new _angular_core.EventEmitter();
        this.backEvt = new _angular_core.EventEmitter();
        this.onGoing = false;
        this.editing = false;
        this.inProgress = true;
        this.currentTabID = 'repo-image';
    }
    Object.defineProperty(RepositoryComponent.prototype, "registryUrl", {
        get: function () {
            return this.systemInfo ? this.systemInfo.registry_url : '';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RepositoryComponent.prototype, "withNotary", {
        get: function () {
            return this.systemInfo ? this.systemInfo.with_notary : false;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RepositoryComponent.prototype, "withClair", {
        get: function () {
            return this.systemInfo ? this.systemInfo.with_clair : false;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RepositoryComponent.prototype, "withAdmiral", {
        get: function () {
            return this.systemInfo ? this.systemInfo.with_admiral : false;
        },
        enumerable: true,
        configurable: true
    });
    RepositoryComponent.prototype.ngOnInit = function () {
        if (!this.projectId) {
            this.errorHandler.error('Project ID cannot be unset.');
            return;
        }
        this.retrieve();
        this.inProgress = false;
    };
    RepositoryComponent.prototype.retrieve = function (state) {
        var _this = this;
        toPromise(this.repositoryService.getRepositories(this.projectId, this.repoName))
            .then(function (response) {
            if (response.metadata.xTotalCount > 0) {
                _this.orgImageInfo = response.data[0].description;
                _this.imageInfo = response.data[0].description;
            }
        })
            .catch(function (error) { return _this.errorHandler.error(error); });
        toPromise(this.systemInfoService.getSystemInfo())
            .then(function (systemInfo) { return _this.systemInfo = systemInfo; })
            .catch(function (error) { return _this.errorHandler.error(error); });
    };
    RepositoryComponent.prototype.saveSignatures = function (event) {
        Object.assign(this.signedCon, event);
    };
    RepositoryComponent.prototype.refresh = function () {
        this.retrieve();
    };
    RepositoryComponent.prototype.watchTagClickEvt = function (tagClickEvt) {
        this.tagClickEvent.emit(tagClickEvt);
    };
    RepositoryComponent.prototype.isCurrentTabLink = function (tabID) {
        return this.currentTabID === tabID;
    };
    RepositoryComponent.prototype.isCurrentTabContent = function (ContentID) {
        return TabLinkContentMap[this.currentTabID] === ContentID;
    };
    RepositoryComponent.prototype.tabLinkClick = function (tabID) {
        this.currentTabID = tabID;
    };
    RepositoryComponent.prototype.getTagInfo = function (repoName) {
        var _this = this;
        // this.signedNameArr = [];
        this.signedCon[repoName] = [];
        return toPromise(this.tagService
            .getTags(repoName))
            .then(function (items) {
            items.forEach(function (t) {
                if (t.signature !== null) {
                    _this.signedCon[repoName].push(t.name);
                }
            });
        })
            .catch(function (error) { return _this.errorHandler.error(error); });
    };
    RepositoryComponent.prototype.goBack = function () {
        this.backEvt.emit(this.projectId);
    };
    RepositoryComponent.prototype.hasChanges = function () {
        return this.imageInfo !== this.orgImageInfo;
    };
    RepositoryComponent.prototype.reset = function () {
        this.imageInfo = this.orgImageInfo;
    };
    RepositoryComponent.prototype.hasInfo = function () {
        return this.imageInfo && this.imageInfo.length > 0;
    };
    RepositoryComponent.prototype.editInfo = function () {
        this.editing = true;
    };
    RepositoryComponent.prototype.saveInfo = function () {
        var _this = this;
        if (!this.hasChanges()) {
            return;
        }
        this.onGoing = true;
        toPromise(this.repositoryService.updateRepositoryDescription(this.repoName, this.imageInfo))
            .then(function () {
            _this.onGoing = false;
            _this.translate.get('CONFIG.SAVE_SUCCESS').subscribe(function (res) {
                _this.errorHandler.info(res);
            });
            _this.editing = false;
            _this.refresh();
        })
            .catch(function (error) {
            _this.onGoing = false;
            _this.errorHandler.error(error);
        });
    };
    RepositoryComponent.prototype.cancelInfo = function () {
        var msg = new ConfirmationMessage('CONFIG.CONFIRM_TITLE', 'CONFIG.CONFIRM_SUMMARY', '', {}, 9 /* CONFIG */);
        this.confirmationDlg.open(msg);
    };
    RepositoryComponent.prototype.confirmCancel = function (ack) {
        this.editing = false;
        if (ack && ack.source === 9 /* CONFIG */ &&
            ack.state === 1 /* CONFIRMED */) {
            this.reset();
        }
    };
    return RepositoryComponent;
}());
RepositoryComponent.decorators = [
    { type: _angular_core.Component, args: [{
                selector: 'hbr-repository',
                template: REPOSITORY_TEMPLATE,
                styles: [REPOSITORY_STYLE]
            },] },
];
/** @nocollapse */
RepositoryComponent.ctorParameters = function () { return [
    { type: ErrorHandler, },
    { type: RepositoryService, },
    { type: SystemInfoService, },
    { type: TagService, },
    { type: _ngxTranslate_core.TranslateService, },
]; };
RepositoryComponent.propDecorators = {
    'projectId': [{ type: _angular_core.Input },],
    'repoName': [{ type: _angular_core.Input },],
    'hasSignedIn': [{ type: _angular_core.Input },],
    'hasProjectAdminRole': [{ type: _angular_core.Input },],
    'isGuest': [{ type: _angular_core.Input },],
    'tagClickEvent': [{ type: _angular_core.Output },],
    'backEvt': [{ type: _angular_core.Output },],
    'confirmationDlg': [{ type: _angular_core.ViewChild, args: ['confirmationDialog',] },],
};

var REPOSITORY_DIRECTIVES = [
    RepositoryComponent
];

var REPOSITORY_STACKVIEW_TEMPLATE = "\n<div>\n<div class=\"row\" style=\"margin-top: 20px; position: relative;\">\n  <div>  \n    <div class=\"row flex-items-xs-right rightPos\">\n      <div class=\"flex-xs-middle\">\n        <hbr-push-image-button style=\"display: inline-block;\" [registryUrl]=\"registryUrl\" [projectName]=\"projectName\"></hbr-push-image-button>\n        <hbr-filter [withDivider]=\"true\" filterPlaceholder=\"{{'REPOSITORY.FILTER_FOR_REPOSITORIES' | translate}}\" (filter)=\"doSearchRepoNames($event)\" [currentValue]=\"lastFilteredRepoName\"></hbr-filter>  \n        <span class=\"refresh-btn\" (click)=\"refresh()\"><clr-icon shape=\"refresh\"></clr-icon></span>\n      </div>\n    </div>\n  </div>\n  <div class=\"col-lg-12 col-md-12 col-sm-12 col-xs-12\">  \n    <clr-datagrid (clrDgRefresh)=\"clrLoad($event)\" [clrDgLoading]=\"loading\">\n      <clr-dg-column [clrDgField]=\"'name'\">{{'REPOSITORY.NAME' | translate}}</clr-dg-column>\n      <clr-dg-column [clrDgSortBy]=\"tagsCountComparator\">{{'REPOSITORY.TAGS_COUNT' | translate}}</clr-dg-column>\n      <clr-dg-column [clrDgSortBy]=\"pullCountComparator\">{{'REPOSITORY.PULL_COUNT' | translate}}</clr-dg-column>\n      <clr-dg-placeholder>{{'REPOSITORY.PLACEHOLDER' | translate}}</clr-dg-placeholder>\n      <clr-dg-row *ngFor=\"let r of repositories\">\n        <clr-dg-action-overflow [hidden]=\"!hasProjectAdminRole\">\n          <button class=\"action-item\" (click)=\"deleteRepo(r.name)\">{{'REPOSITORY.DELETE' | translate}}</button>\n        </clr-dg-action-overflow>\n        <clr-dg-cell>{{r.name}}</clr-dg-cell>\n        <clr-dg-cell>{{r.tags_count}}</clr-dg-cell>\n        <clr-dg-cell>{{r.pull_count}}</clr-dg-cell>        \n        <hbr-tag *clrIfExpanded ngProjectAs=\"clr-dg-row-detail\" (tagClickEvent)=\"watchTagClickEvt($event)\" (signatureOutput)=\"saveSignatures($event)\" class=\"sub-grid-custom\" [repoName]=\"r.name\" [registryUrl]=\"registryUrl\" [withNotary]=\"withNotary\" [withClair]=\"withClair\" [hasSignedIn]=\"hasSignedIn\" [hasProjectAdminRole]=\"hasProjectAdminRole\" [projectId]=\"projectId\" [isEmbedded]=\"true\"></hbr-tag>\n      </clr-dg-row>\n      <clr-dg-footer>\n        <span *ngIf=\"showDBStatusWarning\" class=\"db-status-warning\">\n          <clr-icon shape=\"warning\" class=\"is-warning\" size=\"24\"></clr-icon>\n          {{'CONFIG.SCANNING.DB_NOT_READY' | translate }}\n        </span>\n        <span *ngIf=\"pagination.totalItems\">{{pagination.firstItem + 1}} - {{pagination.lastItem + 1}} {{'REPOSITORY.OF' | translate}}</span>\n        {{pagination.totalItems}} {{'REPOSITORY.ITEMS' | translate}}\n        <clr-dg-pagination #pagination [(clrDgPage)]=\"currentPage\" [clrDgPageSize]=\"pageSize\" [clrDgTotalItems]=\"totalCount\"></clr-dg-pagination>\n      </clr-dg-footer>\n    </clr-datagrid>\n  </div>\n</div>\n<confirmation-dialog #confirmationDialog (confirmAction)=\"confirmDeletion($event)\"></confirmation-dialog>\n</div>\n";

var REPOSITORY_STACKVIEW_STYLES = "\n.option-right {\n  padding-right: 16px;\n}\n.sub-grid-custom {\n  left: 40px;\n}\n.refresh-btn {\n    cursor: pointer;\n}\n.refresh-btn:hover {\n    color: #007CBB;\n}\n\n:host >>> .datagrid .datagrid-body {\n  overflow-x: hidden;\n}\n\n:host >>> .datagrid .datagrid-foot {\n  border-top: 1px solid #ccc;\n}\n\n:host >>> .datagrid .datagrid-body .datagrid-row {\n  background-color: #ccc;\n}\n\n:host >>> .datagrid-body .datagrid-row .datagrid-row-master{\n  background-color: #FFFFFF;\n}\n\n:host >>> .datagrid .datagrid-placeholder-container {\n  display: none;\n}\n:host >>> .datagrid-overlay-wrapper{margin-top:24px;}\n\n.db-status-warning {\n  position: absolute;\n  left: 24px;\n  display: inline-block;\n}\n.rightPos{\n    position: absolute;\n    z-index: 100;\n    right: 35px;\n    margin-top: 4px;\n}\n";

var RepositoryStackviewComponent = (function () {
    function RepositoryStackviewComponent(errorHandler, translateService, repositoryService, systemInfoService, translate, tagService, ref) {
        this.errorHandler = errorHandler;
        this.translateService = translateService;
        this.repositoryService = repositoryService;
        this.systemInfoService = systemInfoService;
        this.translate = translate;
        this.tagService = tagService;
        this.ref = ref;
        this.signedCon = {};
        this.projectName = "unknown";
        this.tagClickEvent = new _angular_core.EventEmitter();
        this.loading = true;
        this.pullCountComparator = new CustomComparator('pull_count', 'number');
        this.tagsCountComparator = new CustomComparator('tags_count', 'number');
        this.pageSize = DEFAULT_PAGE_SIZE;
        this.currentPage = 1;
        this.totalCount = 0;
    }
    Object.defineProperty(RepositoryStackviewComponent.prototype, "registryUrl", {
        get: function () {
            return this.systemInfo ? this.systemInfo.registry_url : "";
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RepositoryStackviewComponent.prototype, "withNotary", {
        get: function () {
            return this.systemInfo ? this.systemInfo.with_notary : false;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RepositoryStackviewComponent.prototype, "withClair", {
        get: function () {
            return this.systemInfo ? this.systemInfo.with_clair : false;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RepositoryStackviewComponent.prototype, "isClairDBReady", {
        get: function () {
            return this.systemInfo &&
                this.systemInfo.clair_vulnerability_status &&
                this.systemInfo.clair_vulnerability_status.overall_last_update > 0;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RepositoryStackviewComponent.prototype, "showDBStatusWarning", {
        get: function () {
            return this.withClair && !this.isClairDBReady;
        },
        enumerable: true,
        configurable: true
    });
    RepositoryStackviewComponent.prototype.confirmDeletion = function (message) {
        var _this = this;
        if (message &&
            message.source === 7 /* REPOSITORY */ &&
            message.state === 1 /* CONFIRMED */) {
            var repoName = message.data;
            toPromise(this.repositoryService
                .deleteRepository(repoName))
                .then(function (response) {
                _this.refresh();
                var st = _this.getStateAfterDeletion();
                if (!st) {
                    _this.refresh();
                }
                else {
                    _this.clrLoad(st);
                }
                _this.translateService.get('REPOSITORY.DELETED_REPO_SUCCESS')
                    .subscribe(function (res) { return _this.errorHandler.info(res); });
            }).catch(function (error) {
                if (error.status === "412") {
                    _this.translateService.get('REPOSITORY.TAGS_SIGNED')
                        .subscribe(function (res) { return _this.errorHandler.info(res); });
                    return;
                }
                _this.errorHandler.error(error);
            });
        }
    };
    RepositoryStackviewComponent.prototype.ngOnChanges = function (changes) {
        if (changes['projectId'] && changes['projectId'].currentValue) {
            this.refresh();
        }
    };
    RepositoryStackviewComponent.prototype.ngOnInit = function () {
        var _this = this;
        //Get system info for tag views
        toPromise(this.systemInfoService.getSystemInfo())
            .then(function (systemInfo) { return _this.systemInfo = systemInfo; })
            .catch(function (error) { return _this.errorHandler.error(error); });
        this.lastFilteredRepoName = '';
    };
    RepositoryStackviewComponent.prototype.doSearchRepoNames = function (repoName) {
        this.lastFilteredRepoName = repoName;
        this.currentPage = 1;
        var st = this.currentState;
        if (!st) {
            st = { page: {} };
        }
        st.page.size = this.pageSize;
        st.page.from = 0;
        st.page.to = this.pageSize - 1;
        this.clrLoad(st);
    };
    RepositoryStackviewComponent.prototype.saveSignatures = function (event) {
        Object.assign(this.signedCon, event);
    };
    RepositoryStackviewComponent.prototype.deleteRepo = function (repoName) {
        var _this = this;
        if (this.signedCon[repoName]) {
            this.signedDataSet(repoName);
        }
        else {
            this.getTagInfo(repoName).then(function () {
                _this.signedDataSet(repoName);
            });
        }
    };
    RepositoryStackviewComponent.prototype.getTagInfo = function (repoName) {
        var _this = this;
        // this.signedNameArr = [];
        this.signedCon[repoName] = [];
        return toPromise(this.tagService
            .getTags(repoName))
            .then(function (items) {
            items.forEach(function (t) {
                if (t.signature !== null) {
                    _this.signedCon[repoName].push(t.name);
                }
            });
        })
            .catch(function (error) { return _this.errorHandler.error(error); });
    };
    RepositoryStackviewComponent.prototype.signedDataSet = function (repoName) {
        var signature = '';
        if (this.signedCon[repoName].length === 0) {
            this.confirmationDialogSet('REPOSITORY.DELETION_TITLE_REPO', signature, repoName, 'REPOSITORY.DELETION_SUMMARY_REPO', 2 /* DELETE_CANCEL */);
            return;
        }
        signature = this.signedCon[repoName].join(',');
        this.confirmationDialogSet('REPOSITORY.DELETION_TITLE_REPO_SIGNED', signature, repoName, 'REPOSITORY.DELETION_SUMMARY_REPO_SIGNED', 3 /* CLOSE */);
    };
    RepositoryStackviewComponent.prototype.confirmationDialogSet = function (summaryTitle, signature, repoName, summaryKey, button) {
        var _this = this;
        this.translate.get(summaryKey, {
            repoName: repoName,
            signedImages: signature,
        })
            .subscribe(function (res) {
            summaryKey = res;
            var message = new ConfirmationMessage(summaryTitle, summaryKey, repoName, repoName, 7 /* REPOSITORY */, button);
            _this.confirmationDialog.open(message);
            var hnd = setInterval(function () { return _this.ref.markForCheck(); }, 100);
            setTimeout(function () { return clearInterval(hnd); }, 5000);
        });
    };
    RepositoryStackviewComponent.prototype.refresh = function () {
        this.doSearchRepoNames("");
    };
    RepositoryStackviewComponent.prototype.watchTagClickEvt = function (tagClickEvt) {
        this.tagClickEvent.emit(tagClickEvt);
    };
    RepositoryStackviewComponent.prototype.clrLoad = function (state) {
        var _this = this;
        //Keep it for future filtering and sorting
        this.currentState = state;
        var pageNumber = calculatePage(state);
        if (pageNumber <= 0) {
            pageNumber = 1;
        }
        //Pagination
        var params = new RequestQueryParams();
        params.set("page", '' + pageNumber);
        params.set("page_size", '' + this.pageSize);
        this.loading = true;
        toPromise(this.repositoryService.getRepositories(this.projectId, this.lastFilteredRepoName, params))
            .then(function (repo) {
            _this.totalCount = repo.metadata.xTotalCount;
            _this.repositories = repo.data;
            _this.signedCon = {};
            //Do filtering and sorting
            _this.repositories = doFiltering(_this.repositories, state);
            _this.repositories = doSorting(_this.repositories, state);
            _this.loading = false;
        })
            .catch(function (error) {
            _this.loading = false;
            _this.errorHandler.error(error);
        });
        //Force refresh view
        var hnd = setInterval(function () { return _this.ref.markForCheck(); }, 100);
        setTimeout(function () { return clearInterval(hnd); }, 5000);
    };
    RepositoryStackviewComponent.prototype.getStateAfterDeletion = function () {
        var total = this.totalCount - 1;
        if (total <= 0) {
            return null;
        }
        var totalPages = Math.ceil(total / this.pageSize);
        var targetPageNumber = this.currentPage;
        if (this.currentPage > totalPages) {
            targetPageNumber = totalPages; //Should == currentPage -1
        }
        var st = this.currentState;
        if (!st) {
            st = { page: {} };
        }
        st.page.size = this.pageSize;
        st.page.from = (targetPageNumber - 1) * this.pageSize;
        st.page.to = targetPageNumber * this.pageSize - 1;
        return st;
    };
    return RepositoryStackviewComponent;
}());
RepositoryStackviewComponent.decorators = [
    { type: _angular_core.Component, args: [{
                selector: 'hbr-repository-stackview',
                template: REPOSITORY_STACKVIEW_TEMPLATE,
                styles: [REPOSITORY_STACKVIEW_STYLES],
                changeDetection: _angular_core.ChangeDetectionStrategy.OnPush
            },] },
];
/** @nocollapse */
RepositoryStackviewComponent.ctorParameters = function () { return [
    { type: ErrorHandler, },
    { type: _ngxTranslate_core.TranslateService, },
    { type: RepositoryService, },
    { type: SystemInfoService, },
    { type: _ngxTranslate_core.TranslateService, },
    { type: TagService, },
    { type: _angular_core.ChangeDetectorRef, },
]; };
RepositoryStackviewComponent.propDecorators = {
    'projectId': [{ type: _angular_core.Input },],
    'projectName': [{ type: _angular_core.Input },],
    'hasSignedIn': [{ type: _angular_core.Input },],
    'hasProjectAdminRole': [{ type: _angular_core.Input },],
    'tagClickEvent': [{ type: _angular_core.Output },],
    'confirmationDialog': [{ type: _angular_core.ViewChild, args: ['confirmationDialog',] },],
};

var REPOSITORY_STACKVIEW_DIRECTIVES = [
    RepositoryStackviewComponent
];

var REPOSITORY_LISTVIEW_TEMPLATE = "\n<div>\n  <div class=\"row\" style=\"position:relative;\">\n    <div>\n      <div class=\"row flex-items-xs-right option-right rightPos\">\n        <div class=\"flex-xs-middle\">\n          <hbr-push-image-button style=\"display: inline-block;\" [registryUrl]=\"registryUrl\" [projectName]=\"projectName\"></hbr-push-image-button>\n          <hbr-filter [withDivider]=\"true\" filterPlaceholder=\"{{'REPOSITORY.FILTER_FOR_REPOSITORIES' | translate}}\" (filter)=\"doSearchRepoNames($event)\" [currentValue]=\"lastFilteredRepoName\"></hbr-filter>\n          <span class=\"refresh-btn\" (click)=\"refresh()\"><clr-icon shape=\"refresh\"></clr-icon></span>\n        </div>\n      </div>\n    </div>\n    <div class=\"col-lg-12 col-md-12 col-sm-12 col-xs-12\">\n      <clr-datagrid (clrDgRefresh)=\"clrLoad($event)\" [clrDgLoading]=\"loading\"  [(clrDgSelected)]=\"selectedRow\" (clrDgSelectedChange)=\"selectedChange()\">\n        <clr-dg-action-bar>\n          <button type=\"button\" class=\"btn btn-sm btn-secondary\" (click)=\"deleteRepos(selectedRow)\" [disabled]=\"!(selectedRow.length && hasProjectAdminRole)\"><clr-icon shape=\"times\" size=\"16\"></clr-icon>&nbsp;{{'REPOSITORY.DELETE' | translate}}</button>\n        </clr-dg-action-bar>\n        <clr-dg-column [clrDgField]=\"'name'\">{{'REPOSITORY.NAME' | translate}}</clr-dg-column>\n        <clr-dg-column [clrDgSortBy]=\"tagsCountComparator\">{{'REPOSITORY.TAGS_COUNT' | translate}}</clr-dg-column>\n        <clr-dg-column [clrDgSortBy]=\"pullCountComparator\">{{'REPOSITORY.PULL_COUNT' | translate}}</clr-dg-column>\n        <clr-dg-placeholder>{{'REPOSITORY.PLACEHOLDER' | translate }}</clr-dg-placeholder>\n        <clr-dg-row *ngFor=\"let r of repositories\"  [clrDgItem]=\"r\">\n          <clr-dg-cell><a href=\"javascript:void(0)\" (click)=\"watchRepoClickEvt(r)\">{{r.name}}</a></clr-dg-cell>\n          <clr-dg-cell>{{r.tags_count}}</clr-dg-cell>\n          <clr-dg-cell>{{r.pull_count}}</clr-dg-cell>\n        </clr-dg-row>\n        <clr-dg-footer>\n          <span *ngIf=\"showDBStatusWarning\" class=\"db-status-warning\">\n            <clr-icon shape=\"warning\" class=\"is-warning\" size=\"24\"></clr-icon>\n            {{'CONFIG.SCANNING.DB_NOT_READY' | translate }}\n          </span>\n          <span *ngIf=\"pagination.totalItems\">{{pagination.firstItem + 1}} - {{pagination.lastItem + 1}} {{'REPOSITORY.OF' | translate}}</span>\n          {{pagination.totalItems}} {{'REPOSITORY.ITEMS' | translate}}\n          <clr-dg-pagination #pagination [(clrDgPage)]=\"currentPage\" [clrDgPageSize]=\"pageSize\" [clrDgTotalItems]=\"totalCount\"></clr-dg-pagination>\n        </clr-dg-footer>\n      </clr-datagrid>\n    </div>\n  </div>\n  <confirmation-dialog #confirmationDialog [batchInfors]=\"batchDelectionInfos\" (confirmAction)=\"confirmDeletion($event)\"></confirmation-dialog>  \n</div>\n";

var REPOSITORY_LISTVIEW_STYLE = "\n.rightPos{\n    position: absolute;\n    z-index: 100;\n    right: 35px;\n    margin-top: 4px;\n}\n";

var RepositoryListviewComponent = (function () {
    function RepositoryListviewComponent(errorHandler, translateService, repositoryService, systemInfoService, tagService, ref, router) {
        this.errorHandler = errorHandler;
        this.translateService = translateService;
        this.repositoryService = repositoryService;
        this.systemInfoService = systemInfoService;
        this.tagService = tagService;
        this.ref = ref;
        this.router = router;
        this.signedCon = {};
        this.projectName = 'unknown';
        this.repoClickEvent = new _angular_core.EventEmitter();
        this.selectedRow = [];
        this.loading = true;
        this.batchDelectionInfos = [];
        this.pullCountComparator = new CustomComparator('pull_count', 'number');
        this.tagsCountComparator = new CustomComparator('tags_count', 'number');
        this.pageSize = DEFAULT_PAGE_SIZE;
        this.currentPage = 1;
        this.totalCount = 0;
    }
    Object.defineProperty(RepositoryListviewComponent.prototype, "registryUrl", {
        get: function () {
            return this.systemInfo ? this.systemInfo.registry_url : '';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RepositoryListviewComponent.prototype, "withNotary", {
        get: function () {
            return this.systemInfo ? this.systemInfo.with_notary : false;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RepositoryListviewComponent.prototype, "withClair", {
        get: function () {
            return this.systemInfo ? this.systemInfo.with_clair : false;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RepositoryListviewComponent.prototype, "isClairDBReady", {
        get: function () {
            return this.systemInfo &&
                this.systemInfo.clair_vulnerability_status &&
                this.systemInfo.clair_vulnerability_status.overall_last_update > 0;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RepositoryListviewComponent.prototype, "showDBStatusWarning", {
        get: function () {
            return this.withClair && !this.isClairDBReady;
        },
        enumerable: true,
        configurable: true
    });
    RepositoryListviewComponent.prototype.ngOnChanges = function (changes) {
        if (changes['projectId'] && changes['projectId'].currentValue) {
            this.refresh();
        }
    };
    RepositoryListviewComponent.prototype.ngOnInit = function () {
        var _this = this;
        // Get system info for tag views
        toPromise(this.systemInfoService.getSystemInfo())
            .then(function (systemInfo) { return _this.systemInfo = systemInfo; })
            .catch(function (error) { return _this.errorHandler.error(error); });
        this.lastFilteredRepoName = '';
    };
    RepositoryListviewComponent.prototype.confirmDeletion = function (message) {
        var _this = this;
        if (message &&
            message.source === 7 /* REPOSITORY */ &&
            message.state === 1 /* CONFIRMED */) {
            var promiseLists_1 = [];
            var repoNames = message.data.split(',');
            repoNames.forEach(function (repoName) {
                promiseLists_1.push(_this.delOperate(repoName));
            });
            Promise.all(promiseLists_1).then(function (item) {
                _this.selectedRow = [];
                _this.refresh();
                var st = _this.getStateAfterDeletion();
                if (!st) {
                    _this.refresh();
                }
                else {
                    _this.clrLoad(st);
                }
            });
        }
    };
    RepositoryListviewComponent.prototype.delOperate = function (repoName) {
        var _this = this;
        var findedList = this.batchDelectionInfos.find(function (data) { return data.name === repoName; });
        if (this.signedCon[repoName].length !== 0) {
            rxjs_Observable.Observable.forkJoin(this.translateService.get('BATCH.DELETED_FAILURE'), this.translateService.get('REPOSITORY.DELETION_TITLE_REPO_SIGNED')).subscribe(function (res) {
                findedList = BathInfoChanges(findedList, res[0], false, true, res[1]);
            });
        }
        else {
            return toPromise(this.repositoryService
                .deleteRepository(repoName))
                .then(function (response) {
                _this.translateService.get('BATCH.DELETED_SUCCESS').subscribe(function (res) {
                    findedList = BathInfoChanges(findedList, res);
                });
            }).catch(function (error) {
                if (error.status === "412") {
                    rxjs_Observable.Observable.forkJoin(_this.translateService.get('BATCH.DELETED_FAILURE'), _this.translateService.get('REPOSITORY.TAGS_SIGNED')).subscribe(function (res) {
                        findedList = BathInfoChanges(findedList, res[0], false, true, res[1]);
                    });
                    return;
                }
                if (error.status === 503) {
                    rxjs_Observable.Observable.forkJoin(_this.translateService.get('BATCH.DELETED_FAILURE'), _this.translateService.get('REPOSITORY.TAGS_NO_DELETE')).subscribe(function (res) {
                        findedList = BathInfoChanges(findedList, res[0], false, true, res[1]);
                    });
                    return;
                }
                _this.translateService.get('BATCH.DELETED_FAILURE').subscribe(function (res) {
                    findedList = BathInfoChanges(findedList, res, false, true);
                });
            });
        }
    };
    RepositoryListviewComponent.prototype.doSearchRepoNames = function (repoName) {
        this.lastFilteredRepoName = repoName;
        this.currentPage = 1;
        var st = this.currentState;
        if (!st) {
            st = { page: {} };
        }
        st.page.size = this.pageSize;
        st.page.from = 0;
        st.page.to = this.pageSize - 1;
        this.clrLoad(st);
    };
    RepositoryListviewComponent.prototype.saveSignatures = function (event) {
        Object.assign(this.signedCon, event);
    };
    RepositoryListviewComponent.prototype.deleteRepos = function (repoLists) {
        var _this = this;
        if (repoLists && repoLists.length) {
            var repoNames_1 = [];
            this.batchDelectionInfos = [];
            var repArr_1 = [];
            repoLists.forEach(function (repo) {
                repoNames_1.push(repo.name);
                var initBatchMessage = new BatchInfo();
                initBatchMessage.name = repo.name;
                _this.batchDelectionInfos.push(initBatchMessage);
                if (!_this.signedCon[repo.name]) {
                    repArr_1.push(_this.getTagInfo(repo.name));
                }
            });
            Promise.all(repArr_1).then(function () {
                _this.confirmationDialogSet('REPOSITORY.DELETION_TITLE_REPO', '', repoNames_1.join(','), 'REPOSITORY.DELETION_SUMMARY_REPO', 2 /* DELETE_CANCEL */);
            });
        }
    };
    RepositoryListviewComponent.prototype.getTagInfo = function (repoName) {
        var _this = this;
        // this.signedNameArr = [];
        this.signedCon[repoName] = [];
        return toPromise(this.tagService
            .getTags(repoName))
            .then(function (items) {
            items.forEach(function (t) {
                if (t.signature !== null) {
                    _this.signedCon[repoName].push(t.name);
                }
            });
        })
            .catch(function (error) { return _this.errorHandler.error(error); });
    };
    RepositoryListviewComponent.prototype.signedDataSet = function (repoName) {
        var signature = '';
        if (this.signedCon[repoName].length === 0) {
            this.confirmationDialogSet('REPOSITORY.DELETION_TITLE_REPO', signature, repoName, 'REPOSITORY.DELETION_SUMMARY_REPO', 2 /* DELETE_CANCEL */);
            return;
        }
        signature = this.signedCon[repoName].join(',');
        this.confirmationDialogSet('REPOSITORY.DELETION_TITLE_REPO_SIGNED', signature, repoName, 'REPOSITORY.DELETION_SUMMARY_REPO_SIGNED', 3 /* CLOSE */);
    };
    RepositoryListviewComponent.prototype.confirmationDialogSet = function (summaryTitle, signature, repoName, summaryKey, button) {
        var _this = this;
        this.translateService.get(summaryKey, {
            repoName: repoName,
            signedImages: signature,
        })
            .subscribe(function (res) {
            summaryKey = res;
            var message = new ConfirmationMessage(summaryTitle, summaryKey, repoName, repoName, 7 /* REPOSITORY */, button);
            _this.confirmationDialog.open(message);
            var hnd = setInterval(function () { return _this.ref.markForCheck(); }, 100);
            setTimeout(function () { return clearInterval(hnd); }, 5000);
        });
    };
    RepositoryListviewComponent.prototype.selectedChange = function () {
        var _this = this;
        var hnd = setInterval(function () { return _this.ref.markForCheck(); }, 100);
        setTimeout(function () { return clearInterval(hnd); }, 2000);
    };
    RepositoryListviewComponent.prototype.refresh = function () {
        this.doSearchRepoNames('');
    };
    RepositoryListviewComponent.prototype.clrLoad = function (state) {
        var _this = this;
        this.selectedRow = [];
        // Keep it for future filtering and sorting
        this.currentState = state;
        var pageNumber = calculatePage(state);
        if (pageNumber <= 0) {
            pageNumber = 1;
        }
        // Pagination
        var params = new RequestQueryParams();
        params.set("page", '' + pageNumber);
        params.set("page_size", '' + this.pageSize);
        this.loading = true;
        toPromise(this.repositoryService.getRepositories(this.projectId, this.lastFilteredRepoName, params))
            .then(function (repo) {
            _this.totalCount = repo.metadata.xTotalCount;
            _this.repositories = repo.data;
            _this.signedCon = {};
            // Do filtering and sorting
            _this.repositories = doFiltering(_this.repositories, state);
            _this.repositories = doSorting(_this.repositories, state);
            _this.loading = false;
        })
            .catch(function (error) {
            _this.loading = false;
            _this.errorHandler.error(error);
        });
        // Force refresh view
        var hnd = setInterval(function () { return _this.ref.markForCheck(); }, 100);
        setTimeout(function () { return clearInterval(hnd); }, 5000);
    };
    RepositoryListviewComponent.prototype.getStateAfterDeletion = function () {
        var total = this.totalCount - 1;
        if (total <= 0) {
            return null;
        }
        var totalPages = Math.ceil(total / this.pageSize);
        var targetPageNumber = this.currentPage;
        if (this.currentPage > totalPages) {
            targetPageNumber = totalPages; // Should == currentPage -1
        }
        var st = this.currentState;
        if (!st) {
            st = { page: {} };
        }
        st.page.size = this.pageSize;
        st.page.from = (targetPageNumber - 1) * this.pageSize;
        st.page.to = targetPageNumber * this.pageSize - 1;
        return st;
    };
    RepositoryListviewComponent.prototype.watchRepoClickEvt = function (repo) {
        this.repoClickEvent.emit(repo);
    };
    return RepositoryListviewComponent;
}());
RepositoryListviewComponent.decorators = [
    { type: _angular_core.Component, args: [{
                selector: 'hbr-repository-listview',
                template: REPOSITORY_LISTVIEW_TEMPLATE,
                styles: [REPOSITORY_LISTVIEW_STYLE],
                changeDetection: _angular_core.ChangeDetectionStrategy.OnPush
            },] },
];
/** @nocollapse */
RepositoryListviewComponent.ctorParameters = function () { return [
    { type: ErrorHandler, },
    { type: _ngxTranslate_core.TranslateService, },
    { type: RepositoryService, },
    { type: SystemInfoService, },
    { type: TagService, },
    { type: _angular_core.ChangeDetectorRef, },
    { type: _angular_router.Router, },
]; };
RepositoryListviewComponent.propDecorators = {
    'projectId': [{ type: _angular_core.Input },],
    'projectName': [{ type: _angular_core.Input },],
    'urlPrefix': [{ type: _angular_core.Input },],
    'hasSignedIn': [{ type: _angular_core.Input },],
    'hasProjectAdminRole': [{ type: _angular_core.Input },],
    'repoClickEvent': [{ type: _angular_core.Output },],
    'confirmationDialog': [{ type: _angular_core.ViewChild, args: ['confirmationDialog',] },],
};

var REPOSITORY_LISTVIEW_DIRECTIVES = [
    RepositoryListviewComponent
];

// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//    http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var ChannelService = (function () {
    function ChannelService() {
        //Declare for publishing scan event
        this.scanCommandSource = new rxjs_Subject.Subject();
        this.scanCommand$ = this.scanCommandSource.asObservable();
    }
    ChannelService.prototype.publishScanEvent = function (tagId) {
        this.scanCommandSource.next(tagId);
    };
    return ChannelService;
}());
ChannelService.decorators = [
    { type: _angular_core.Injectable },
];
/** @nocollapse */
ChannelService.ctorParameters = function () { return []; };

var TAG_TEMPLATE = "\n<confirmation-dialog class=\"hidden-tag\" #confirmationDialog  [batchInfors]=\"batchDelectionInfos\" (confirmAction)=\"confirmDeletion($event)\"></confirmation-dialog>\n<clr-modal class=\"hidden-tag\" [(clrModalOpen)]=\"showTagManifestOpened\" [clrModalStaticBackdrop]=\"staticBackdrop\" [clrModalClosable]=\"closable\">\n  <h3 class=\"modal-title\">{{ manifestInfoTitle | translate }}</h3>\n  <div class=\"modal-body\">\n    <div class=\"row col-md-12\">\n        <textarea rows=\"2\" #digestTarget>{{digestId}}</textarea>\n    </div>\n  </div>\n  <div class=\"modal-footer\">\n    <span class=\"copy-failed\" [hidden]=\"!copyFailed\">{{'TAG.COPY_ERROR' | translate}}</span>\n    <button type=\"button\" class=\"btn btn-primary\" [ngxClipboard]=\"digestTarget\" (cbOnSuccess)=\"onSuccess($event)\" (cbOnError)=\"onError($event)\">{{'BUTTON.COPY' | translate}}</button>\n  </div>\n</clr-modal>\n<div class=\"row\" style=\"position:relative;\">\n  <div>\n    <div class=\"row flex-items-xs-right rightPos\">\n      <div class='filterLabelPiece' [style.left.px]='filterLabelPieceWidth' ><hbr-label-piece [hidden]='!filterOneLabel' [label]=\"filterOneLabel\"  [labelWidth]=\"130\"></hbr-label-piece></div>\n      <div class=\"flex-xs-middle\">\n      <hbr-filter *ngIf=\"withAdmiral\" [withDivider]=\"true\" filterPlaceholder=\"{{'TAG.FILTER_FOR_TAGS' | translate}}\" (filter)=\"doSearchTagNames($event)\" [currentValue]=\"lastFilteredTagName\"></hbr-filter>\n        <clr-dropdown *ngIf=\"!withAdmiral\">\n            <hbr-filter [withDivider]=\"true\" filterPlaceholder=\"{{'TAG.FILTER_FOR_TAGS' | translate}}\" (filter)=\"doSearchTagNames($event)\" [currentValue]=\"lastFilteredTagName\" clrDropdownTrigger></hbr-filter>\n            <clr-dropdown-menu clrPosition=\"bottom-left\" *clrIfOpen>\n                <div style='display:grid'>\n                    <label class=\"dropdown-header\">{{'REPOSITORY.FILTER_BY_LABEL' | translate}}</label>\n                    <div class=\"form-group\"><input type=\"text\" placeholder=\"Filter labels\" [(ngModel)]= \"filterName\" (keyup)=\"handleInputFilter()\"></div>\n                    <div [hidden]='imageFilterLabels.length' style=\"padding-left:10px;\">{{'LABEL.NO_LABELS' | translate }}</div>\n                    <div [hidden]='!imageFilterLabels.length' style='max-height:300px;overflow-y: auto;'>\n                        <button type=\"button\" class=\"dropdown-item\" *ngFor='let label of imageFilterLabels' [hidden]=\"!label.show\" (click)=\"rightFilterLabel(label)\">\n                            <clr-icon shape=\"check\" class='pull-left' [hidden]='!label.iconsShow'></clr-icon>\n                            <div class='labelDiv'><hbr-label-piece [label]=\"label.label\"  [labelWidth]=\"130\"></hbr-label-piece></div>\n                        </button>\n                    </div>\n                </div>\n            </clr-dropdown-menu>\n        </clr-dropdown>\n        <span class=\"refresh-btn\" (click)=\"refresh()\"><clr-icon shape=\"refresh\"></clr-icon></span> \n      </div>\n    </div>\n  </div>\n  <div class=\"col-lg-12 col-md-12 col-sm-12 col-xs-12\">\n    <clr-datagrid [clrDgLoading]=\"loading\" [class.embeded-datagrid]=\"isEmbedded\"  [(clrDgSelected)]=\"selectedRow\">\n        <clr-dg-action-bar>\n          <button type=\"button\" class=\"btn btn-sm btn-secondary\" [disabled]=\"!(canScanNow(selectedRow) && selectedRow.length==1)\" (click)=\"scanNow(selectedRow)\"><clr-icon shape=\"shield-check\" size=\"16\"></clr-icon>&nbsp;{{'VULNERABILITY.SCAN_NOW' | translate}}</button>\n          <button type=\"button\" class=\"btn btn-sm btn-secondary\" [disabled]=\"!(selectedRow.length==1)\" (click)=\"showDigestId(selectedRow)\" ><clr-icon shape=\"copy\" size=\"16\"></clr-icon>&nbsp;{{'REPOSITORY.COPY_DIGEST_ID' | translate}}</button>\n                <clr-dropdown *ngIf=\"!withAdmiral\">\n                    <button type=\"button\" class=\"btn btn-sm btn-secondary\" clrDropdownTrigger [disabled]=\"!(selectedRow.length==1) || isGuest\" (click)=\"addLabels(selectedRow)\" ><clr-icon shape=\"plus\" size=\"16\"></clr-icon>{{'REPOSITORY.ADD_LABELS' | translate}}</button>\n                    <clr-dropdown-menu clrPosition=\"bottom-left\" *clrIfOpen>\n                    <div style='display:grid'>\n                        <label class=\"dropdown-header\">{{'REPOSITORY.ADD_TO_IMAGE' | translate}}</label>\n                        <div class=\"form-group\"><input type=\"text\" placeholder=\"Filter labels\" [(ngModel)]=\"stickName\" (keyup)=\"handleStickInputFilter()\"></div>\n                        <div [hidden]='imageStickLabels.length' style=\"padding-left:10px;\">{{'LABEL.NO_LABELS' | translate }}</div>\n                        <div [hidden]='!imageStickLabels.length' style='max-height:300px;overflow-y: auto;'>\n                            <button type=\"button\" class=\"dropdown-item\" *ngFor='let label of imageStickLabels' [hidden]='!label.show' (click)=\"stickLabel(label)\">\n                                <clr-icon shape=\"check\" class='pull-left' [hidden]='!label.iconsShow'></clr-icon>\n                                <div class='labelDiv'><hbr-label-piece [label]=\"label.label\"  [labelWidth]=\"130\"></hbr-label-piece></div>\n                            </button>\n                        </div>\n                      </div>\n                    </clr-dropdown-menu>\n                </clr-dropdown>\n          <button type=\"button\" class=\"btn btn-sm btn-secondary\" *ngIf=\"hasProjectAdminRole\" (click)=\"deleteTags(selectedRow)\" [disabled]=\"!selectedRow.length\"><clr-icon shape=\"times\" size=\"16\"></clr-icon>&nbsp;{{'REPOSITORY.DELETE' | translate}}</button>\n        </clr-dg-action-bar>\n        <clr-dg-column style=\"width: 120px;\" [clrDgField]=\"'name'\">{{'REPOSITORY.TAG' | translate}}</clr-dg-column>\n        <clr-dg-column style=\"width: 90px;\" [clrDgField]=\"'size'\">{{'REPOSITORY.SIZE' | translate}}</clr-dg-column>\n        <clr-dg-column style=\"min-width: 100px; max-width:220px;\">{{'REPOSITORY.PULL_COMMAND' | translate}}</clr-dg-column>\n        <clr-dg-column style=\"width: 140px;\" *ngIf=\"withClair\">{{'REPOSITORY.VULNERABILITY' | translate}}</clr-dg-column>\n        <clr-dg-column style=\"width: 80px;\" *ngIf=\"withNotary\">{{'REPOSITORY.SIGNED' | translate}}</clr-dg-column>\n        <clr-dg-column style=\"min-width: 130px;\">{{'REPOSITORY.AUTHOR' | translate}}</clr-dg-column>\n        <clr-dg-column style=\"width: 160px;\"[clrDgSortBy]=\"createdComparator\">{{'REPOSITORY.CREATED' | translate}}</clr-dg-column>\n        <clr-dg-column style=\"width: 80px;\" [clrDgField]=\"'docker_version'\" *ngIf=\"!withClair\">{{'REPOSITORY.DOCKER_VERSION' | translate}}</clr-dg-column>\n        <clr-dg-column *ngIf=\"!withAdmiral\" style=\"width: 140px;\">{{'REPOSITORY.LABELS' | translate}}</clr-dg-column>\n        <clr-dg-placeholder>{{'TAG.PLACEHOLDER' | translate }}</clr-dg-placeholder>\n        <clr-dg-row *clrDgItems=\"let t of tags\" [clrDgItem]='t'>\n          <clr-dg-cell  class=\"truncated\"  style=\"width: 120px;\">\n            <a href=\"javascript:void(0)\" (click)=\"onTagClick(t)\" title=\"{{t.name}}\">{{t.name}}</a>\n          </clr-dg-cell>\n          <clr-dg-cell style=\"width: 90px;\">{{sizeTransform(t.size)}}</clr-dg-cell>\n          <clr-dg-cell style=\"min-width: 100px; max-width:220px;\" class=\"truncated\" title=\"docker pull {{registryUrl}}/{{repoName}}:{{t.name}}\">\n              <hbr-copy-input #copyInput  (onCopyError)=\"onCpError($event)\"  iconMode=\"true\" defaultValue=\"docker pull {{registryUrl}}/{{repoName}}:{{t.name}}\"></hbr-copy-input>\n          </clr-dg-cell>\n          <clr-dg-cell style=\"width: 140px;\" *ngIf=\"withClair\">\n            <hbr-vulnerability-bar [repoName]=\"repoName\" [tagId]=\"t.name\" [summary]=\"t.scan_overview\"></hbr-vulnerability-bar>\n          </clr-dg-cell>\n          <clr-dg-cell style=\"width: 80px;\" *ngIf=\"withNotary\"  [ngSwitch]=\"t.signature !== null\">\n            <clr-icon shape=\"check-circle\" *ngSwitchCase=\"true\"  size=\"20\" style=\"color: #1D5100;\"></clr-icon>\n            <clr-icon shape=\"times-circle\" *ngSwitchCase=\"false\"  size=\"16\" style=\"color: #C92100;\"></clr-icon>\n            <a href=\"javascript:void(0)\" *ngSwitchDefault role=\"tooltip\" aria-haspopup=\"true\" class=\"tooltip tooltip-top-right\">\n              <clr-icon shape=\"help\" style=\"color: #565656;\" size=\"16\"></clr-icon>\n              <span class=\"tooltip-content\">{{'REPOSITORY.NOTARY_IS_UNDETERMINED' | translate}}</span>\n            </a>\n          </clr-dg-cell>\n          <clr-dg-cell  class=\"truncated\"  style=\"min-width: 130px;\" title=\"{{t.author}}\">{{t.author}}</clr-dg-cell>\n          <clr-dg-cell style=\"width: 160px;\">{{t.created | date: 'short'}}</clr-dg-cell>\n          <clr-dg-cell style=\"width: 80px;\" *ngIf=\"!withClair\">{{t.docker_version}}</clr-dg-cell>\n          <clr-dg-cell *ngIf=\"!withAdmiral\" style=\"width: 140px;\">\n            <hbr-label-piece *ngIf=\"t.labels?.length\" [label]=\"t.labels[0]\" [labelWidth]=\"90\"> </hbr-label-piece>\n            <div class=\"signpost-item\" [hidden]=\"t.labels?.length<=1\">\n                <div class=\"trigger-item\">\n                    <clr-signpost>\n                     <button class=\"btn btn-link\" clrSignpostTrigger>...</button>\n                        <clr-signpost-content [clrPosition]=\"'left-top'\" *clrIfOpen>\n                            <div>\n                               <hbr-label-piece *ngFor=\"let label of t.labels\" [label]=\"label\"></hbr-label-piece>\n                            </div>\n                        </clr-signpost-content>\n                    </clr-signpost>\n                </div>\n            </div>\n          </clr-dg-cell>\n        </clr-dg-row>\n        <clr-dg-footer>\n          <span *ngIf=\"pagination.totalItems\">{{pagination.firstItem + 1}} - {{pagination.lastItem + 1}} {{'REPOSITORY.OF' | translate}}</span>\n          {{pagination.totalItems}} {{'REPOSITORY.ITEMS' | translate}}&nbsp;&nbsp;&nbsp;&nbsp;\n          <clr-dg-pagination #pagination [clrDgPageSize]=\"10\"></clr-dg-pagination>\n        </clr-dg-footer>\n    </clr-datagrid>\n  </div>\n</div>";

var TAG_STYLE = "\n.option-right {\n  padding-right: 18px;\n  padding-bottom: 6px;\n}\n\n.refresh-btn {\n  cursor: pointer;\n}\n\n.refresh-btn:hover {\n  color: #007CBB;\n}\n\n.sub-header-title {\n  margin: 12px 0;\n}\n\n.embeded-datagrid {\n  width: 98%;\n  float:right; /*add for issue #2688*/\n}\n\n.hidden-tag {\n  display: block; height: 0;\n}\n\n:host >>> .datagrid-placeholder {\n  display: none;\n}\n\n.truncated {\n  display: inline-block;\n  overflow: hidden;\n  white-space: nowrap;\n  text-overflow:ellipsis;\n}\n\n.copy-failed {\n  color: red;\n  margin-right: 6px;\n}\n\n:host >>> .datagrid clr-dg-column {\n    min-width: 80px;\n}\n.rightPos{\n    position: absolute;\n    z-index: 100;\n    right: 35px;\n    margin-top: 4px;\n}\n\n.btn-group .dropdown-menu clr-icon{display: block;}\n.dropdown-menu .dropdown-item{position: relative;padding-left:.5rem; padding-right:.5rem;line-height:1.0}\n.dropdown-menu input{position: relative;margin-left:.5rem; margin-right:.5rem;}\n.pull-left{display:inline-block;float:left;}\n.pull-right{display:inline-block; float:right;}\n.btn-link{display:inline-flex;width: 15px;min-width:15px; color:black; vertical-align: super; }\n.trigger-item, .signpost-item{display: inline;}\n.signpost-content-body .label{margin:.3rem;}\n.labelDiv{position: absolute; left:34px;top:5px;}\n.datagrid-action-bar{z-index:10;}\n.trigger-item hbr-label-piece{display: flex !important;margin: 6px 0;}\n:host >>> .signpost-content{min-width:4rem;}\n:host >>> .signpost-content-body{padding:0 .4rem;}\n:host >>> .signpost-content-header{display:none;}\n.filterLabelPiece{position: absolute; bottom :0px;z-index:1;}\n.dropdown .dropdown-toggle.btn {\n    margin: .25rem .5rem .25rem 0;\n}\n";

// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//    http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var TagComponent = (function () {
    function TagComponent(errorHandler, tagService, labelService, translateService, ref, channel) {
        this.errorHandler = errorHandler;
        this.tagService = tagService;
        this.labelService = labelService;
        this.translateService = translateService;
        this.ref = ref;
        this.channel = channel;
        this.signedCon = {};
        this.refreshRepo = new _angular_core.EventEmitter();
        this.tagClickEvent = new _angular_core.EventEmitter();
        this.signatureOutput = new _angular_core.EventEmitter();
        this.staticBackdrop = true;
        this.closable = false;
        this.batchDelectionInfos = [];
        this.createdComparator = new CustomComparator("created", "date");
        this.loading = false;
        this.copyFailed = false;
        this.selectedRow = [];
        this.imageLabels = [];
        this.imageStickLabels = [];
        this.imageFilterLabels = [];
        this.labelListOpen = false;
        this.labelNameFilter = new rxjs_Subject.Subject();
        this.stickLabelNameFilter = new rxjs_Subject.Subject();
        this.stickName = '';
        this.filterName = '';
        this.initFilter = {
            name: '',
            description: '',
            color: '',
            scope: '',
            project_id: 0,
        };
        this.filterOneLabel = this.initFilter;
        this.pageSize = DEFAULT_PAGE_SIZE;
        this.currentPage = 1;
        this.totalCount = 0;
    }
    TagComponent.prototype.ngOnInit = function () {
        var _this = this;
        if (!this.projectId) {
            this.errorHandler.error("Project ID cannot be unset.");
            return;
        }
        if (!this.repoName) {
            this.errorHandler.error("Repo name cannot be unset.");
            return;
        }
        this.retrieve();
        this.lastFilteredTagName = '';
        this.labelNameFilter
            .debounceTime(500)
            .distinctUntilChanged()
            .subscribe(function (name) {
            if (_this.filterName.length) {
                _this.filterOnGoing = true;
                _this.imageFilterLabels.forEach(function (data) {
                    if (data.label.name.indexOf(_this.filterName) !== -1) {
                        data.show = true;
                    }
                    else {
                        data.show = false;
                    }
                });
                setTimeout(function () {
                    setInterval(function () { return _this.ref.markForCheck(); }, 200);
                }, 1000);
            }
        });
        this.stickLabelNameFilter
            .debounceTime(500)
            .distinctUntilChanged()
            .subscribe(function (name) {
            if (_this.stickName.length) {
                _this.filterOnGoing = true;
                _this.imageStickLabels.forEach(function (data) {
                    if (data.label.name.indexOf(_this.stickName) !== -1) {
                        data.show = true;
                    }
                    else {
                        data.show = false;
                    }
                });
                setTimeout(function () {
                    setInterval(function () { return _this.ref.markForCheck(); }, 200);
                }, 1000);
            }
        });
    };
    TagComponent.prototype.ngAfterViewInit = function () {
        if (!this.withAdmiral) {
            this.getAllLabels();
        }
    };
    Object.defineProperty(TagComponent.prototype, "filterLabelPieceWidth", {
        get: function () {
            var len = this.lastFilteredTagName.length ? this.lastFilteredTagName.length * 6 + 60 : 115;
            return len > 210 ? 210 : len;
        },
        enumerable: true,
        configurable: true
    });
    TagComponent.prototype.doSearchTagNames = function (tagName) {
        this.lastFilteredTagName = tagName;
        this.currentPage = 1;
        var st = this.currentState;
        if (!st) {
            st = { page: {} };
        }
        st.page.size = this.pageSize;
        st.page.from = 0;
        st.page.to = this.pageSize - 1;
        var selectedLab = this.imageFilterLabels.find(function (label) { return label.iconsShow === true; });
        if (selectedLab) {
            st.filters = [{ property: 'name', value: this.lastFilteredTagName }, { property: 'labels.id', value: selectedLab.label.id }];
        }
        else {
            st.filters = [{ property: 'name', value: this.lastFilteredTagName }];
        }
        this.clrLoad(st);
    };
    TagComponent.prototype.clrLoad = function (state) {
        var _this = this;
        this.selectedRow = [];
        // Keep it for future filtering and sorting
        this.currentState = state;
        var pageNumber = calculatePage(state);
        if (pageNumber <= 0) {
            pageNumber = 1;
        }
        // Pagination
        var params = new RequestQueryParams();
        params.set("page", "" + pageNumber);
        params.set("page_size", "" + this.pageSize);
        this.loading = true;
        toPromise(this.tagService.getTags(this.repoName, params))
            .then(function (tags) {
            _this.signedCon = {};
            // Do filtering and sorting
            _this.tags = doFiltering(tags, state);
            _this.tags = doSorting(_this.tags, state);
            _this.loading = false;
        })
            .catch(function (error) {
            _this.loading = false;
            _this.errorHandler.error(error);
        });
        // Force refresh view
        var hnd = setInterval(function () { return _this.ref.markForCheck(); }, 100);
        setTimeout(function () { return clearInterval(hnd); }, 5000);
    };
    TagComponent.prototype.refresh = function () {
        this.doSearchTagNames("");
    };
    TagComponent.prototype.getAllLabels = function () {
        var _this = this;
        toPromise(this.labelService.getGLabels()).then(function (res) {
            if (res.length) {
                res.forEach(function (data) {
                    _this.imageLabels.push({ 'iconsShow': false, 'label': data, 'show': true });
                });
            }
            toPromise(_this.labelService.getPLabels(_this.projectId)).then(function (res1) {
                if (res1.length) {
                    res1.forEach(function (data) {
                        _this.imageLabels.push({ 'iconsShow': false, 'label': data, 'show': true });
                    });
                }
                _this.imageFilterLabels = clone(_this.imageLabels);
                _this.imageStickLabels = clone(_this.imageLabels);
            }).catch(function (error) {
                _this.errorHandler.error(error);
            });
        }).catch(function (error) {
            _this.errorHandler.error(error);
        });
    };
    TagComponent.prototype.labelSelectedChange = function (tag) {
        var _this = this;
        if (tag && tag[0].labels) {
            this.imageStickLabels.forEach(function (data) {
                data.iconsShow = false;
                data.show = true;
            });
            if (tag[0].labels.length) {
                tag[0].labels.forEach(function (labelInfo) {
                    var findedLabel = _this.imageStickLabels.find(function (data) { return labelInfo.id === data['label'].id; });
                    _this.imageStickLabels.splice(_this.imageStickLabels.indexOf(findedLabel), 1);
                    _this.imageStickLabels.unshift(findedLabel);
                    findedLabel.iconsShow = true;
                });
            }
        }
    };
    TagComponent.prototype.addLabels = function (tag) {
        this.labelListOpen = true;
        this.selectedTag = tag;
        this.stickName = '';
        this.labelSelectedChange(tag);
    };
    TagComponent.prototype.stickLabel = function (labelInfo) {
        if (labelInfo && !labelInfo.iconsShow) {
            this.selectLabel(labelInfo);
        }
        if (labelInfo && labelInfo.iconsShow) {
            this.unSelectLabel(labelInfo);
        }
    };
    TagComponent.prototype.selectLabel = function (labelInfo) {
        var _this = this;
        if (!this.inprogress) {
            this.inprogress = true;
            var labelId = labelInfo.label.id;
            this.selectedRow = this.selectedTag;
            toPromise(this.tagService.addLabelToImages(this.repoName, this.selectedRow[0].name, labelId)).then(function (res) {
                _this.refresh();
                // set the selected label in front
                _this.imageStickLabels.splice(_this.imageStickLabels.indexOf(labelInfo), 1);
                _this.imageStickLabels.unshift(labelInfo);
                labelInfo.iconsShow = true;
                _this.inprogress = false;
            }).catch(function (err) {
                _this.inprogress = false;
                _this.errorHandler.error(err);
            });
        }
    };
    TagComponent.prototype.unSelectLabel = function (labelInfo) {
        var _this = this;
        if (!this.inprogress) {
            this.inprogress = true;
            var labelId = labelInfo.label.id;
            this.selectedRow = this.selectedTag;
            toPromise(this.tagService.deleteLabelToImages(this.repoName, this.selectedRow[0].name, labelId)).then(function (res) {
                _this.refresh();
                // insert the unselected label to groups with the same icons
                _this.sortOperation(_this.imageStickLabels, labelInfo);
                labelInfo.iconsShow = false;
                _this.inprogress = false;
            }).catch(function (err) {
                _this.inprogress = false;
                _this.errorHandler.error(err);
            });
        }
    };
    TagComponent.prototype.rightFilterLabel = function (labelInfo) {
        if (labelInfo) {
            if (!labelInfo.iconsShow) {
                this.filterLabel(labelInfo);
            }
            else {
                this.unFilterLabel(labelInfo);
            }
        }
    };
    TagComponent.prototype.filterLabel = function (labelInfo) {
        var _this = this;
        var labelName = labelInfo.label.name;
        var labelId = labelInfo.label.id;
        // insert the unselected label to groups with the same icons
        var preLabelInfo = this.imageFilterLabels.find(function (data) { return data.label.id === _this.filterOneLabel.id; });
        if (preLabelInfo) {
            this.sortOperation(this.imageFilterLabels, preLabelInfo);
        }
        this.imageFilterLabels.filter(function (data) {
            if (data.label.id !== labelId) {
                data.iconsShow = false;
            }
            else {
                data.iconsShow = true;
            }
        });
        this.imageFilterLabels.splice(this.imageFilterLabels.indexOf(labelInfo), 1);
        this.imageFilterLabels.unshift(labelInfo);
        this.filterOneLabel = labelInfo.label;
        // reload data
        this.currentPage = 1;
        var st = this.currentState;
        if (!st) {
            st = { page: {} };
        }
        st.page.size = this.pageSize;
        st.page.from = 0;
        st.page.to = this.pageSize - 1;
        if (this.lastFilteredTagName) {
            st.filters = [{ property: 'name', value: this.lastFilteredTagName }, { property: 'labels.id', value: labelId }];
        }
        else {
            st.filters = [{ property: 'labels.id', value: labelId }];
        }
        this.clrLoad(st);
    };
    TagComponent.prototype.unFilterLabel = function (labelInfo) {
        // insert the unselected label to groups with the same icons
        this.sortOperation(this.imageFilterLabels, labelInfo);
        this.filterOneLabel = this.initFilter;
        labelInfo.iconsShow = false;
        // reload data
        this.currentPage = 1;
        var st = this.currentState;
        if (!st) {
            st = { page: {} };
        }
        st.page.size = this.pageSize;
        st.page.from = 0;
        st.page.to = this.pageSize - 1;
        if (this.lastFilteredTagName) {
            st.filters = [{ property: 'name', value: this.lastFilteredTagName }];
        }
        else {
            st.filters = [];
        }
        this.clrLoad(st);
    };
    TagComponent.prototype.handleInputFilter = function () {
        if (this.filterName.length) {
            this.labelNameFilter.next(this.filterName);
        }
        else {
            this.imageFilterLabels.every(function (data) { return data.show = true; });
        }
    };
    TagComponent.prototype.handleStickInputFilter = function () {
        if (this.stickName.length) {
            this.stickLabelNameFilter.next(this.stickName);
        }
        else {
            this.imageStickLabels.every(function (data) { return data.show = true; });
        }
    };
    // insert the unselected label to groups with the same icons
    TagComponent.prototype.sortOperation = function (labelList, labelInfo) {
        labelList.some(function (data, i) {
            if (!data.iconsShow) {
                if (data.label.scope === labelInfo.label.scope) {
                    labelList.splice(i, 0, labelInfo);
                    labelList.splice(labelList.indexOf(labelInfo, 0), 1);
                    return true;
                }
                if (data.label.scope !== labelInfo.label.scope && i === labelList.length - 1) {
                    labelList.push(labelInfo);
                    labelList.splice(labelList.indexOf(labelInfo), 1);
                    return true;
                }
            }
        });
    };
    TagComponent.prototype.retrieve = function () {
        var _this = this;
        this.tags = [];
        var signatures = [];
        this.loading = true;
        toPromise(this.tagService
            .getTags(this.repoName))
            .then(function (items) {
            // To keep easy use for vulnerability bar
            items.forEach(function (t) {
                if (!t.scan_overview) {
                    t.scan_overview = {
                        scan_status: VULNERABILITY_SCAN_STATUS.stopped,
                        severity: exports.VulnerabilitySeverity.UNKNOWN,
                        update_time: new Date(),
                        components: {
                            total: 0,
                            summary: []
                        }
                    };
                }
                if (t.signature !== null) {
                    signatures.push(t.name);
                }
            });
            _this.tags = items;
            var signedName = {};
            signedName[_this.repoName] = signatures;
            _this.signatureOutput.emit(signedName);
            _this.loading = false;
            if (_this.tags && _this.tags.length === 0) {
                _this.refreshRepo.emit(true);
            }
        })
            .catch(function (error) {
            _this.errorHandler.error(error);
            _this.loading = false;
        });
        var hnd = setInterval(function () { return _this.ref.markForCheck(); }, 100);
        setTimeout(function () { return clearInterval(hnd); }, 5000);
    };
    TagComponent.prototype.sizeTransform = function (tagSize) {
        var size = Number.parseInt(tagSize);
        if (Math.pow(1024, 1) <= size && size < Math.pow(1024, 2)) {
            return (size / Math.pow(1024, 1)).toFixed(2) + "KB";
        }
        else if (Math.pow(1024, 2) <= size && size < Math.pow(1024, 3)) {
            return (size / Math.pow(1024, 2)).toFixed(2) + "MB";
        }
        else if (Math.pow(1024, 3) <= size && size < Math.pow(1024, 4)) {
            return (size / Math.pow(1024, 3)).toFixed(2) + "GB";
        }
        else {
            return size + "B";
        }
    };
    TagComponent.prototype.deleteTags = function (tags) {
        var _this = this;
        if (tags && tags.length) {
            var tagNames_1 = [];
            this.batchDelectionInfos = [];
            tags.forEach(function (tag) {
                tagNames_1.push(tag.name);
                var initBatchMessage = new BatchInfo();
                initBatchMessage.name = tag.name;
                _this.batchDelectionInfos.push(initBatchMessage);
            });
            var titleKey = void 0, summaryKey = void 0, content = void 0, buttons = void 0;
            titleKey = "REPOSITORY.DELETION_TITLE_TAG";
            summaryKey = "REPOSITORY.DELETION_SUMMARY_TAG";
            buttons = 2 /* DELETE_CANCEL */;
            content = tagNames_1.join(" , ");
            var message = new ConfirmationMessage(titleKey, summaryKey, content, tags, 8 /* TAG */, buttons);
            this.confirmationDialog.open(message);
        }
    };
    TagComponent.prototype.confirmDeletion = function (message) {
        var _this = this;
        if (message &&
            message.source === 8 /* TAG */
            && message.state === 1 /* CONFIRMED */) {
            var tags = message.data;
            if (tags && tags.length) {
                var promiseLists_1 = [];
                tags.forEach(function (tag) {
                    promiseLists_1.push(_this.delOperate(tag.signature, tag.name));
                });
                Promise.all(promiseLists_1).then(function (item) {
                    _this.selectedRow = [];
                    _this.retrieve();
                });
            }
        }
    };
    TagComponent.prototype.delOperate = function (signature, name) {
        var _this = this;
        var findedList = this.batchDelectionInfos.find(function (data) { return data.name === name; });
        if (signature) {
            rxjs_Observable.Observable.forkJoin(this.translateService.get("BATCH.DELETED_FAILURE"), this.translateService.get("REPOSITORY.DELETION_SUMMARY_TAG_DENIED")).subscribe(function (res) {
                var wrongInfo = res[1] + "notary -s https://" + _this.registryUrl + ":4443 -d ~/.docker/trust remove -p " + _this.registryUrl + "/" + _this.repoName + " " + name;
                findedList = BathInfoChanges(findedList, res[0], false, true, wrongInfo);
            });
        }
        else {
            return toPromise(this.tagService
                .deleteTag(this.repoName, name))
                .then(function (response) {
                _this.translateService.get("BATCH.DELETED_SUCCESS")
                    .subscribe(function (res) {
                    findedList = BathInfoChanges(findedList, res);
                });
            }).catch(function (error) {
                if (error.status === 503) {
                    rxjs_Observable.Observable.forkJoin(_this.translateService.get('BATCH.DELETED_FAILURE'), _this.translateService.get('REPOSITORY.TAGS_NO_DELETE')).subscribe(function (res) {
                        findedList = BathInfoChanges(findedList, res[0], false, true, res[1]);
                    });
                    return;
                }
                _this.translateService.get("BATCH.DELETED_FAILURE").subscribe(function (res) {
                    findedList = BathInfoChanges(findedList, res, false, true);
                });
            });
        }
    };
    TagComponent.prototype.showDigestId = function (tag) {
        if (tag && (tag.length === 1)) {
            this.manifestInfoTitle = "REPOSITORY.COPY_DIGEST_ID";
            this.digestId = tag[0].digest;
            this.showTagManifestOpened = true;
            this.copyFailed = false;
        }
    };
    TagComponent.prototype.onTagClick = function (tag) {
        if (tag) {
            var evt = {
                project_id: this.projectId,
                repository_name: this.repoName,
                tag_name: tag.name
            };
            this.tagClickEvent.emit(evt);
        }
    };
    TagComponent.prototype.onSuccess = function ($event) {
        this.copyFailed = false;
        // Directly close dialog
        this.showTagManifestOpened = false;
    };
    TagComponent.prototype.onError = function ($event) {
        // Show error
        this.copyFailed = true;
        // Select all text
        if (this.textInput) {
            this.textInput.nativeElement.select();
        }
    };
    // Get vulnerability scanning status
    TagComponent.prototype.scanStatus = function (t) {
        if (t && t.scan_overview && t.scan_overview.scan_status) {
            return t.scan_overview.scan_status;
        }
        return VULNERABILITY_SCAN_STATUS.unknown;
    };
    TagComponent.prototype.existObservablePackage = function (t) {
        return t.scan_overview &&
            t.scan_overview.components &&
            t.scan_overview.components.total &&
            t.scan_overview.components.total > 0 ? true : false;
    };
    // Whether show the 'scan now' menu
    TagComponent.prototype.canScanNow = function (t) {
        if (!this.withClair) {
            return false;
        }
        if (!this.hasProjectAdminRole) {
            return false;
        }
        var st = this.scanStatus(t[0]);
        return st !== VULNERABILITY_SCAN_STATUS.pending &&
            st !== VULNERABILITY_SCAN_STATUS.running;
    };
    // Trigger scan
    TagComponent.prototype.scanNow = function (t) {
        var _this = this;
        if (t && t.length) {
            t.forEach(function (data) {
                var tagId = data.name;
                _this.channel.publishScanEvent(_this.repoName + "/" + tagId);
            });
        }
    };
    // pull command
    TagComponent.prototype.onCpError = function ($event) {
        this.copyInput.setPullCommendShow();
    };
    return TagComponent;
}());
TagComponent.decorators = [
    { type: _angular_core.Component, args: [{
                selector: "hbr-tag",
                template: TAG_TEMPLATE,
                styles: [TAG_STYLE],
            },] },
];
/** @nocollapse */
TagComponent.ctorParameters = function () { return [
    { type: ErrorHandler, },
    { type: TagService, },
    { type: LabelService, },
    { type: _ngxTranslate_core.TranslateService, },
    { type: _angular_core.ChangeDetectorRef, },
    { type: ChannelService, },
]; };
TagComponent.propDecorators = {
    'projectId': [{ type: _angular_core.Input },],
    'repoName': [{ type: _angular_core.Input },],
    'isEmbedded': [{ type: _angular_core.Input },],
    'hasSignedIn': [{ type: _angular_core.Input },],
    'hasProjectAdminRole': [{ type: _angular_core.Input },],
    'isGuest': [{ type: _angular_core.Input },],
    'registryUrl': [{ type: _angular_core.Input },],
    'withNotary': [{ type: _angular_core.Input },],
    'withClair': [{ type: _angular_core.Input },],
    'withAdmiral': [{ type: _angular_core.Input },],
    'refreshRepo': [{ type: _angular_core.Output },],
    'tagClickEvent': [{ type: _angular_core.Output },],
    'signatureOutput': [{ type: _angular_core.Output },],
    'confirmationDialog': [{ type: _angular_core.ViewChild, args: ['confirmationDialog',] },],
    'textInput': [{ type: _angular_core.ViewChild, args: ["digestTarget",] },],
    'copyInput': [{ type: _angular_core.ViewChild, args: ["copyInput",] },],
};

var TAG_DETAIL_STYLES = "\n.overview-section {\n    padding-bottom: 36px;\n}\n\n.detail-section {\n    background-color: #fafafa;\n    padding-left: 12px;\n    padding-right: 24px;\n}\n\n.title-block {\n    display: inline-block;\n}\n\n.tag-name {\n    font-weight: 300;\n    font-size: 32px;\n}\n.tag-name h2{margin-top:0;}\n\n.tag-timestamp {\n    font-weight: 400;\n    font-size: 12px;\n    margin-top: 6px;\n}\n\n.rotate-90 {\n    -webkit-transform: rotate(-90deg);\n    /*Firefox*/\n    -moz-transform: rotate(-90deg);\n    /*Chrome*/\n    -ms-transform: rotate(-90deg);\n    /*IE9 \u3001IE10*/\n    -o-transform: rotate(-90deg);\n    /*Opera*/\n    transform: rotate(-90deg);\n}\n\n.arrow-back {\n    cursor: pointer;\n}\n\n.arrow-block {\t\n    border-right: 2px solid #cccccc;\t\n    margin-right: 6px;\t\n    display: inline-flex;\t\n    padding: 6px 6px 6px 12px;\t\n}\t\n\t\n.title-block {\t\n    display: inline-block;\t\n}\n\n\n.vulnerability-block {\n    margin-bottom: 12px;\n}\n\n.summary-block {\n    margin-top: 24px;\n    display: flex;\n    flex-wrap: row wrap;\n}\n\n.image-summary {\n    margin-right: 36px;\n    margin-left: 18px;\n}\n\n.flex-block {\n    display: inline-flex;\n    flex-wrap: row wrap;\n    justify-content: space-around;\n}\n\n.vulnerabilities-info {\n    padding-left: 24px;\n}\n\n .third-column {\n    margin-left: 36px;\n}\n.vulnerability{\nmargin-left: 50px;\n    margin-top: -12px;\n    margin-bottom: 20px;}\n\n.vulnerabilities-info .second-column {\n    text-align: left;\n    margin-left: 6px;\n}\n\n.fourth-column{\nfloat: left;\nmargin-left:20px;}\n\n.vulnerabilities-info .second-row {\n    margin-top: 6px;\n}\n\n.detail-title {\n    float:left;\n    font-weight: 600;\n    font-size: 14px;\n}\n\n.image-detail-label {\n    margin-right: 10px;\n    text-align: left;\n    font-weight: 600;\n}\n\n.image-detail-value {\n    text-align: left;\n    margin-left: 6px;\n    font-weight: 500;\n}\n.tip-icon-medium {\n    color: orange;\n}\n.tip-icon-low{\n    color:yellow;\n}\n.second-column div, .fourth-column div, .image-detail-value div{\nheight: 24px;\n}\n\n";

var TAG_DETAIL_HTML = "\n<div>\n    <section class=\"overview-section\">\n        <div class=\"title-wrapper\">\n            <div class=\"title-block arrow-block\" *ngIf=\"withAdmiral\">\n                <clr-icon class=\"rotate-90 arrow-back\" shape=\"arrow\" size=\"36\" (click)=\"onBack()\"></clr-icon>\n            </div>\n            <div class=\"title-block\">\n                <h2 class=\"custom-h2\">{{repositoryId}}:{{tagDetails.name}}</h2>\n            </div>\n        </div>\n        <div class=\"summary-block row\">\n            <div class=\"image-summary col-md-4 col-lg-3\">\n                <div class=\"flex-block\">\n                    <div class=\"image-detail-label\">\n                        <div>{{'TAG.AUTHOR' | translate }}</div>\n                        <div>{{'TAG.ARCHITECTURE' | translate }}</div>\n                        <div>{{'TAG.OS' | translate }}</div>\n                        <div>{{'TAG.DOCKER_VERSION' | translate }}</div>\n                        <div>{{'TAG.SCAN_COMPLETION_TIME' | translate }}</div>\n                    </div>\n                    <div class=\"image-detail-value\">\n                        <div>{{author | translate}}</div>\n                        <div>{{tagDetails.architecture}}</div>\n                        <div>{{tagDetails.os}}</div>\n                        <div>{{tagDetails.docker_version}}</div>\n                        <div>{{scanCompletedDatetime | date}}</div>\n                    </div>\n                </div>\n            </div>\n            <div *ngIf=\"withClair\" class=\"col-md-4 col-lg-3\">\n                <div class=\"vulnerability\">\n                    <hbr-vulnerability-bar [repoName]=\"repositoryId\" [tagId]=\"tagDetails.name\" [summary]=\"tagDetails.scan_overview\"></hbr-vulnerability-bar>\n                </div>\n                <div class=\"flex-block vulnerabilities-info\">\n                    <div>\n                        <div>\n                            <clr-icon shape=\"error\" size=\"24\" class=\"is-error\"></clr-icon>\n                        </div>\n                        <div class=\"second-row\">\n                            <clr-icon shape=\"exclamation-triangle\" size=\"24\" class=\"tip-icon-medium\"></clr-icon>\n                        </div>\n                        <div>\n                            <clr-icon shape=\"play\" size=\"20\" class=\"tip-icon-low rotate-90\"></clr-icon>\n                        </div>\n                        <div class=\"second-row\">\n                            <clr-icon shape=\"help\" size=\"18\" style=\"margin-left: 2px;\"></clr-icon>\n                        </div>\n                    </div>\n                    <div class=\"second-column\">\n                        <div>{{highCount}} {{'VULNERABILITY.SEVERITY.HIGH' | translate }}{{'TAG.LEVEL_VULNERABILITIES' | translate }}</div>\n                        <div class=\"second-row\">{{mediumCount}} {{'VULNERABILITY.SEVERITY.MEDIUM' | translate }}{{'TAG.LEVEL_VULNERABILITIES' | translate }}</div>\n                        <div>{{lowCount}} {{'VULNERABILITY.SEVERITY.LOW' | translate }}{{'TAG.LEVEL_VULNERABILITIES' | translate }}</div>\n                        <div class=\"second-row\">{{unknownCount}} {{'VULNERABILITY.SEVERITY.UNKNOWN' | translate }}{{'TAG.LEVEL_VULNERABILITIES' | translate }}</div>\n                    </div>\n                </div>\n\n            </div>\n            <div *ngIf=\"!withAdmiral && tagDetails?.labels?.length\" >\n                <div class=\"third-column detail-title\">{{'TAG.LABELS' | translate }}</div>\n                <div class=\"fourth-column\">\n                  <div *ngFor=\"let label of tagDetails.labels\" style=\"margin-bottom: 2px;\"><hbr-label-piece [label]=\"label\"></hbr-label-piece></div>\n                </div>\n            </div>\n        </div>\n    </section>\n    <section class=\"detail-section\">\n        <div class=\"vulnerability-block\">\n            <hbr-vulnerabilities-grid [repositoryId]=\"repositoryId\" [tagId]=\"tagId\"></hbr-vulnerabilities-grid>\n        </div>\n        <div>\n            <ng-content></ng-content>\n        </div>\n    </section>\n</div>\n";

var TagDetailComponent = (function () {
    function TagDetailComponent(tagService, errorHandler) {
        this.tagService = tagService;
        this.errorHandler = errorHandler;
        this._highCount = 0;
        this._mediumCount = 0;
        this._lowCount = 0;
        this._unknownCount = 0;
        this.tagDetails = {
            name: "--",
            size: "--",
            author: "--",
            created: new Date(),
            architecture: "--",
            os: "--",
            docker_version: "--",
            digest: "--",
            labels: [],
        };
        this.backEvt = new _angular_core.EventEmitter();
    }
    TagDetailComponent.prototype.ngOnInit = function () {
        var _this = this;
        if (this.repositoryId && this.tagId) {
            toPromise(this.tagService.getTag(this.repositoryId, this.tagId))
                .then(function (response) {
                _this.tagDetails = response;
                if (_this.tagDetails &&
                    _this.tagDetails.scan_overview &&
                    _this.tagDetails.scan_overview.components &&
                    _this.tagDetails.scan_overview.components.summary) {
                    _this.tagDetails.scan_overview.components.summary.forEach(function (item) {
                        switch (item.severity) {
                            case exports.VulnerabilitySeverity.UNKNOWN:
                                _this._unknownCount += item.count;
                                break;
                            case exports.VulnerabilitySeverity.LOW:
                                _this._lowCount += item.count;
                                break;
                            case exports.VulnerabilitySeverity.MEDIUM:
                                _this._mediumCount += item.count;
                                break;
                            case exports.VulnerabilitySeverity.HIGH:
                                _this._highCount += item.count;
                                break;
                            default:
                                break;
                        }
                    });
                }
            })
                .catch(function (error) { return _this.errorHandler.error(error); });
        }
    };
    TagDetailComponent.prototype.onBack = function () {
        this.backEvt.emit(this.repositoryId);
    };
    TagDetailComponent.prototype.getPackageText = function (count) {
        return count > 1 ? "VULNERABILITY.PACKAGES" : "VULNERABILITY.PACKAGE";
    };
    Object.defineProperty(TagDetailComponent.prototype, "author", {
        get: function () {
            return this.tagDetails && this.tagDetails.author ? this.tagDetails.author : 'TAG.ANONYMITY';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TagDetailComponent.prototype, "highCount", {
        get: function () {
            return this._highCount;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TagDetailComponent.prototype, "mediumCount", {
        get: function () {
            return this._mediumCount;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TagDetailComponent.prototype, "lowCount", {
        get: function () {
            return this._lowCount;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TagDetailComponent.prototype, "unknownCount", {
        get: function () {
            return this._unknownCount;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TagDetailComponent.prototype, "scanCompletedDatetime", {
        get: function () {
            return this.tagDetails && this.tagDetails.scan_overview ?
                this.tagDetails.scan_overview.update_time : null;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TagDetailComponent.prototype, "suffixForHigh", {
        get: function () {
            return this.highCount > 1 ? "VULNERABILITY.PLURAL" : "VULNERABILITY.SINGULAR";
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TagDetailComponent.prototype, "suffixForMedium", {
        get: function () {
            return this.mediumCount > 1 ? "VULNERABILITY.PLURAL" : "VULNERABILITY.SINGULAR";
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TagDetailComponent.prototype, "suffixForLow", {
        get: function () {
            return this.lowCount > 1 ? "VULNERABILITY.PLURAL" : "VULNERABILITY.SINGULAR";
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TagDetailComponent.prototype, "suffixForUnknown", {
        get: function () {
            return this.unknownCount > 1 ? "VULNERABILITY.PLURAL" : "VULNERABILITY.SINGULAR";
        },
        enumerable: true,
        configurable: true
    });
    return TagDetailComponent;
}());
TagDetailComponent.decorators = [
    { type: _angular_core.Component, args: [{
                selector: 'hbr-tag-detail',
                styles: [TAG_DETAIL_STYLES],
                template: TAG_DETAIL_HTML,
                providers: []
            },] },
];
/** @nocollapse */
TagDetailComponent.ctorParameters = function () { return [
    { type: TagService, },
    { type: ErrorHandler, },
]; };
TagDetailComponent.propDecorators = {
    'tagId': [{ type: _angular_core.Input },],
    'repositoryId': [{ type: _angular_core.Input },],
    'withAdmiral': [{ type: _angular_core.Input },],
    'withClair': [{ type: _angular_core.Input },],
    'backEvt': [{ type: _angular_core.Output },],
};

var TAG_DIRECTIVES = [
    TagComponent,
    TagDetailComponent
];

var LIST_REPLICATION_RULE_TEMPLATE = "\n<div style=\"padding-bottom: 15px;\">\n<clr-datagrid [clrDgLoading]=\"loading\"  [(clrDgSingleSelected)]=\"selectedRow\" [clDgRowSelection]=\"true\">\n    <clr-dg-action-bar style=\"height: 24px;\">\n        <button type=\"button\" class=\"btn btn-sm btn-secondary\" *ngIf=\"isSystemAdmin\" (click)=\"openModal()\"><clr-icon shape=\"plus\" size=\"16\"></clr-icon>&nbsp;{{'REPLICATION.NEW_REPLICATION_RULE' | translate}}</button>\n        <button type=\"button\" class=\"btn btn-sm btn-secondary\" *ngIf=\"isSystemAdmin\" [disabled]=\"!selectedRow\" (click)=\"editRule(selectedRow)\"><clr-icon shape=\"pencil\" size=\"16\"></clr-icon>&nbsp;{{'REPLICATION.EDIT_POLICY' | translate}}</button>\n        <button type=\"button\" class=\"btn btn-sm btn-secondary\" *ngIf=\"isSystemAdmin\" [disabled]=\"!selectedRow\" (click)=\"deleteRule(selectedRow)\"><clr-icon shape=\"times\" size=\"16\"></clr-icon>&nbsp;{{'REPLICATION.DELETE_POLICY' | translate}}</button>\n        <button type=\"button\" class=\"btn btn-sm btn-secondary\" *ngIf=\"isSystemAdmin\" [disabled]=\"!selectedRow\" (click)=\"replicateRule(selectedRow)\"><clr-icon shape=\"export\" size=\"16\"></clr-icon>&nbsp;{{'REPLICATION.REPLICATE' | translate}}</button>\n    </clr-dg-action-bar>\n    <clr-dg-column [clrDgField]=\"'name'\">{{'REPLICATION.NAME' | translate}}</clr-dg-column>\n    <clr-dg-column [clrDgField]=\"'projects'\" *ngIf=\"!projectScope\">{{'REPLICATION.PROJECT' | translate}}</clr-dg-column>\n    <clr-dg-column [clrDgField]=\"'description'\">{{'REPLICATION.DESCRIPTION' | translate}}</clr-dg-column>\n    <clr-dg-column [clrDgField]=\"'targets'\">{{'REPLICATION.DESTINATION_NAME' | translate}}</clr-dg-column>\n    <clr-dg-column [clrDgField]=\"'trigger'\">{{'REPLICATION.TRIGGER_MODE' | translate}}</clr-dg-column>\n    <clr-dg-placeholder>{{'REPLICATION.PLACEHOLDER' | translate }}</clr-dg-placeholder>\n    <clr-dg-row *clrDgItems=\"let p of changedRules\" [clrDgItem]=\"p\"  (click)=\"selectRule(p)\" [style.backgroundColor]=\"(projectScope && withReplicationJob && selectedId === p.id) ? '#eee' : ''\">\n        <clr-dg-cell>{{p.name}}</clr-dg-cell>\n        <clr-dg-cell *ngIf=\"!projectScope\">\n            <a href=\"javascript:void(0)\" (click)=\"$event.stopPropagation(); redirectTo(p)\">{{p.projects?.length>0  ? p.projects[0].name : ''}}</a>\n        </clr-dg-cell>\n        <clr-dg-cell>\n            {{p.description ? trancatedDescription(p.description) : '-'}}\n            <clr-tooltip>\n                <clr-icon *ngIf=\"p.description && p.description.length > 35\" clrTooltipTrigger shape=\"ellipsis-horizontal\" size=\"18\"></clr-icon>\n                <clr-tooltip-content clrPosition=\"bottom-right\" clrSize=\"md\" *clrIfOpen>\n                    <span>{{p.description}}</span>\n                </clr-tooltip-content>\n            </clr-tooltip>\n        </clr-dg-cell>\n        <clr-dg-cell>{{p.targets?.length>0 ? p.targets[0].name : ''}}</clr-dg-cell>\n        <clr-dg-cell>{{p.trigger ? p.trigger.kind : ''}}</clr-dg-cell>\n    </clr-dg-row>\n    <clr-dg-footer>\n      <span *ngIf=\"pagination.totalItems\">{{pagination.firstItem + 1}} - {{pagination.lastItem +1 }} {{'REPLICATION.OF' | translate}} </span>{{pagination.totalItems }} {{'REPLICATION.ITEMS' | translate}}\n      <clr-dg-pagination #pagination [clrDgPageSize]=\"5\"></clr-dg-pagination>\n    </clr-dg-footer>\n</clr-datagrid>\n<confirmation-dialog #deletionConfirmDialog [batchInfors]=\"batchDelectionInfos\" (confirmAction)=\"deletionConfirm($event)\"></confirmation-dialog>\n</div>\n";

var LIST_REPLICATION_RULE_CSS = "\n";

// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//    http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var ListReplicationRuleComponent = (function () {
    function ListReplicationRuleComponent(replicationService, translateService, errorHandler, ref) {
        this.replicationService = replicationService;
        this.translateService = translateService;
        this.errorHandler = errorHandler;
        this.ref = ref;
        this.nullTime = '0001-01-01T00:00:00Z';
        this.loading = false;
        this.reload = new _angular_core.EventEmitter();
        this.selectOne = new _angular_core.EventEmitter();
        this.editOne = new _angular_core.EventEmitter();
        this.toggleOne = new _angular_core.EventEmitter();
        this.hideJobs = new _angular_core.EventEmitter();
        this.redirect = new _angular_core.EventEmitter();
        this.openNewRule = new _angular_core.EventEmitter();
        this.replicateManual = new _angular_core.EventEmitter();
        this.projectScope = false;
        this.batchDelectionInfos = [];
        this.startTimeComparator = new CustomComparator('start_time', 'date');
        this.enabledComparator = new CustomComparator('enabled', 'number');
        setInterval(function () { return ref.markForCheck(); }, 500);
    }
    ListReplicationRuleComponent.prototype.trancatedDescription = function (desc) {
        if (desc.length > 35) {
            return desc.substr(0, 35);
        }
        else {
            return desc;
        }
    };
    ListReplicationRuleComponent.prototype.ngOnInit = function () {
        // Global scope
        if (!this.projectScope) {
            this.retrieveRules();
        }
    };
    ListReplicationRuleComponent.prototype.ngOnChanges = function (changes) {
        var proIdChange = changes["projectId"];
        if (proIdChange) {
            if (proIdChange.currentValue !== proIdChange.previousValue) {
                if (proIdChange.currentValue) {
                    this.projectId = proIdChange.currentValue;
                    this.projectScope = true; // Scope is project, not global list
                    // Initially load the replication rule data
                    this.retrieveRules();
                }
            }
        }
    };
    ListReplicationRuleComponent.prototype.retrieveRules = function (ruleName) {
        var _this = this;
        if (ruleName === void 0) { ruleName = ''; }
        this.loading = true;
        /*this.selectedRow = null;*/
        toPromise(this.replicationService
            .getReplicationRules(this.projectId, ruleName))
            .then(function (rules) {
            _this.rules = rules || [];
            // job list hidden
            _this.hideJobs.emit();
            _this.changedRules = _this.rules;
            _this.loading = false;
        }).catch(function (error) {
            _this.errorHandler.error(error);
            _this.loading = false;
        });
    };
    ListReplicationRuleComponent.prototype.replicateRule = function (rules) {
        this.replicateManual.emit(rules);
    };
    ListReplicationRuleComponent.prototype.deletionConfirm = function (message) {
        if (message &&
            message.source === 4 /* POLICY */ &&
            message.state === 1 /* CONFIRMED */) {
            this.deleteOpe(message.data);
        }
    };
    ListReplicationRuleComponent.prototype.selectRule = function (rule) {
        this.selectedId = rule.id || '';
        this.selectOne.emit(rule);
    };
    ListReplicationRuleComponent.prototype.redirectTo = function (rule) {
        this.redirect.emit(rule);
    };
    ListReplicationRuleComponent.prototype.openModal = function () {
        this.openNewRule.emit();
    };
    ListReplicationRuleComponent.prototype.editRule = function (rule) {
        this.editOne.emit(rule);
    };
    ListReplicationRuleComponent.prototype.jobList = function (id) {
        var _this = this;
        var ruleData;
        this.canDeleteRule = true;
        var count = 0;
        return toPromise(this.replicationService
            .getJobs(id))
            .then(function (response) {
            ruleData = response.data;
            if (ruleData.length) {
                ruleData.forEach(function (job) {
                    if ((job.status === 'pending') || (job.status === 'running') || (job.status === 'retrying')) {
                        count++;
                    }
                });
            }
            _this.canDeleteRule = count > 0 ? false : true;
        })
            .catch(function (error) { return _this.errorHandler.error(error); });
    };
    ListReplicationRuleComponent.prototype.deleteRule = function (rule) {
        if (rule) {
            this.batchDelectionInfos = [];
            var initBatchMessage = new BatchInfo();
            initBatchMessage.name = rule.name;
            this.batchDelectionInfos.push(initBatchMessage);
            var deletionMessage = new ConfirmationMessage('REPLICATION.DELETION_TITLE', 'REPLICATION.DELETION_SUMMARY', rule.name, rule, 4 /* POLICY */, 2 /* DELETE_CANCEL */);
            this.deletionConfirmDialog.open(deletionMessage);
        }
    };
    ListReplicationRuleComponent.prototype.deleteOpe = function (rule) {
        var _this = this;
        if (rule) {
            var promiseLists_1 = [];
            Promise.all([this.jobList(rule.id)]).then(function (items) {
                if (!_this.canDeleteRule) {
                    var findedList_1 = _this.batchDelectionInfos.find(function (data) { return data.name === rule.name; });
                    rxjs_Observable.Observable.forkJoin(_this.translateService.get('BATCH.DELETED_FAILURE'), _this.translateService.get('REPLICATION.DELETION_SUMMARY_FAILURE')).subscribe(function (res) {
                        findedList_1 = BathInfoChanges(findedList_1, res[0], false, true, res[1]);
                    });
                }
                else {
                    promiseLists_1.push(_this.delOperate(+rule.id, rule.name));
                }
                Promise.all(promiseLists_1).then(function (item) {
                    _this.selectedRow = null;
                    _this.reload.emit(true);
                    var hnd = setInterval(function () { return _this.ref.markForCheck(); }, 200);
                    setTimeout(function () { return clearInterval(hnd); }, 2000);
                });
            });
        }
    };
    ListReplicationRuleComponent.prototype.delOperate = function (ruleId, name) {
        var _this = this;
        var findedList = this.batchDelectionInfos.find(function (data) { return data.name === name; });
        return toPromise(this.replicationService
            .deleteReplicationRule(ruleId))
            .then(function () {
            _this.translateService.get('BATCH.DELETED_SUCCESS')
                .subscribe(function (res) { return findedList = BathInfoChanges(findedList, res); });
        })
            .catch(function (error) {
            if (error && error.status === 412) {
                rxjs_Observable.Observable.forkJoin(_this.translateService.get('BATCH.DELETED_FAILURE'), _this.translateService.get('REPLICATION.FAILED_TO_DELETE_POLICY_ENABLED')).subscribe(function (res) {
                    findedList = BathInfoChanges(findedList, res[0], false, true, res[1]);
                });
            }
            else {
                _this.translateService.get('BATCH.DELETED_FAILURE').subscribe(function (res) {
                    findedList = BathInfoChanges(findedList, res, false, true);
                });
            }
        });
    };
    return ListReplicationRuleComponent;
}());
ListReplicationRuleComponent.decorators = [
    { type: _angular_core.Component, args: [{
                selector: 'hbr-list-replication-rule',
                template: LIST_REPLICATION_RULE_TEMPLATE,
                styles: [LIST_REPLICATION_RULE_CSS],
                changeDetection: _angular_core.ChangeDetectionStrategy.OnPush
            },] },
];
/** @nocollapse */
ListReplicationRuleComponent.ctorParameters = function () { return [
    { type: ReplicationService, },
    { type: _ngxTranslate_core.TranslateService, },
    { type: ErrorHandler, },
    { type: _angular_core.ChangeDetectorRef, },
]; };
ListReplicationRuleComponent.propDecorators = {
    'projectId': [{ type: _angular_core.Input },],
    'isSystemAdmin': [{ type: _angular_core.Input },],
    'selectedId': [{ type: _angular_core.Input },],
    'withReplicationJob': [{ type: _angular_core.Input },],
    'loading': [{ type: _angular_core.Input },],
    'reload': [{ type: _angular_core.Output },],
    'selectOne': [{ type: _angular_core.Output },],
    'editOne': [{ type: _angular_core.Output },],
    'toggleOne': [{ type: _angular_core.Output },],
    'hideJobs': [{ type: _angular_core.Output },],
    'redirect': [{ type: _angular_core.Output },],
    'openNewRule': [{ type: _angular_core.Output },],
    'replicateManual': [{ type: _angular_core.Output },],
    'toggleConfirmDialog': [{ type: _angular_core.ViewChild, args: ['toggleConfirmDialog',] },],
    'deletionConfirmDialog': [{ type: _angular_core.ViewChild, args: ['deletionConfirmDialog',] },],
};

var CREATE_EDIT_RULE_TEMPLATE = "\n<clr-modal [(clrModalOpen)]=\"createEditRuleOpened\" [clrModalStaticBackdrop]=\"true\" [clrModalClosable]=\"false\">\n  <h3 class=\"modal-title\">{{headerTitle | translate}}</h3>\n  <hbr-inline-alert class=\"modal-title\" (confirmEvt)=\"confirmCancel($event)\"></hbr-inline-alert>\n  <div class=\"modal-body\" style=\"max-height: 85vh;\">\n    <form [formGroup]=\"ruleForm\"  novalidate>\n     <section class=\"form-block\">\n      <div class=\"form-group form-group-override\">\n       <label class=\"form-group-label-override required\">{{'REPLICATION.NAME' | translate}}</label>\n       <label aria-haspopup=\"true\" role=\"tooltip\" class=\"tooltip tooltip-validation tooltip-md tooltip-bottom-left\"\n              [class.invalid]='(ruleForm.controls.name.touched && ruleForm.controls.name.invalid) || isRuleNameExist'>\n        <input type=\"text\" id=\"ruleName\" pattern=\"^[a-z0-9]+(?:[._-][a-z0-9]+)*$\" class=\"inputWidth\" required maxlength=\"255\" formControlName=\"name\" #ruleName (keyup)='checkRuleName()' autocomplete=\"off\">\n        <span class=\"tooltip-content\">{{ruleNameTooltip | translate}}</span>\n       </label><span class=\"spinner spinner-inline spinner-pos\" [hidden]=\"!inNameChecking\"></span>\n      </div>\n      <!--Description-->\n      <div class=\"form-group form-group-override\">\n       <label class=\"form-group-label-override\">{{'REPLICATION.DESCRIPTION' | translate}}</label>\n       <textarea type=\"text\" id=\"ruleDescription\" class=\"inputWidth\" row= 3; formControlName=\"description\"></textarea>\n      </div>\n      <!--Projects-->\n      <div class=\"form-group form-group-override\">\n       <label class=\"form-group-label-override required\">{{'REPLICATION.SOURCE_PROJECT' | translate}}</label>\n       <div formArrayName=\"projects\">\n        <div class=\"projectInput inputWidth\" *ngFor=\"let project of projects.controls; let i= index\" [formGroupName]=\"i\" (mouseleave)=\"leaveInput()\">\n         <input *ngIf=\"!projectId\" formControlName=\"name\" type=\"text\" class=\"inputWidth\"  value=\"name\" required\n                pattern=\"^[a-z0-9]+(?:[._-][a-z0-9]+)*$\" (keyup)='handleValidation()' (focus)=\"focusClear($event)\" autocomplete=\"off\">\n         <input *ngIf=\"projectId\" formControlName=\"name\" type=\"text\"  class=\"inputWidth\"  value=\"name\" readonly>\n         <div class=\"selectBox inputWidth\"  [style.display]=\"selectedProjectList.length ? 'block' : 'none'\" >\n          <ul>\n           <li *ngFor=\"let project of selectedProjectList\" (click)=\"selectedProjectName(project?.name)\">{{project?.name}}</li>\n          </ul>\n         </div>\n        </div>\n       </div>\n       <label *ngIf=\"noProjectInfo.length != 0\" class=\"colorRed alertLabel\">{{noProjectInfo | translate}}</label>\n      </div>\n    \n    <!--images/Filter-->\n      <div class=\"form-group form-group-override\">\n       <label class=\"form-group-label-override\">{{'REPLICATION.SOURCE_IMAGES_FILTER' | translate}}</label>\n       <div formArrayName=\"filters\">\n        <div class=\"filterSelect\" *ngFor=\"let filter of filters.controls; let i=index\"  [formGroupName]=\"i\">\n         <div>\n          <div class=\"select floatSetPar\">\n           <select formControlName=\"kind\" (change)=\"filterChange($event)\"  id=\"{{i}}\" name=\"{{filterListData[i]?.name}}\">\n            <option *ngFor=\"let filter of filterListData[i]?.options;\" value=\"{{filter}}\">{{filter}}</option>\n           </select>\n          </div>\n          <label aria-haspopup=\"true\" role=\"tooltip\" class=\"tooltip tooltip-validation tooltip-md tooltip-bottom-left\"\n                 [class.invalid]='ruleForm.controls.filters.controls[i].controls.pattern.touched && ruleForm.controls.filters.controls[i].controls.pattern.invalid'>\n           <input type=\"text\" #filterValue required size=\"14\" formControlName=\"pattern\">\n           <span class=\"tooltip-content\">{{'TOOLTIP.EMPTY' | translate}}</span>\n          </label>\n          <clr-icon shape=\"times-circle\" class=\"is-solid\"  (click)=\"deleteFilter(i)\"></clr-icon>\n         </div>\n        </div>\n       </div>\n        <clr-icon shape=\"plus-circle\" class=\"is-solid\" [hidden]=\"isFilterHide\" (click)=\"addNewFilter()\" style=\"margin-top: 11px;\"></clr-icon>\n      </div>\n      <!--Targets-->\n      <div class=\"form-group form-group-override\">\n       <label class=\"form-group-label-override  required\">{{'DESTINATION.ENDPOINT' | translate}}</label>\n       <div formArrayName=\"targets\">\n        <div class=\"select endpointSelect pull-left\" *ngFor=\"let target of targets.controls; let i= index\" [formGroupName]=\"i\">\n          <select id=\"ruleTarget\" (change)=\"targetChange($event)\"  formControlName=\"id\">\n           <option *ngFor=\"let target of targetList\" value=\"{{target.id}}\">{{target.name}}-{{target.endpoint}}</option>\n          </select>\n         </div>\n       </div>\n       <label *ngIf=\"noEndpointInfo.length != 0\" class=\"colorRed alertLabel\">{{noEndpointInfo | translate}}</label>\n       <span class=\"alertLabel goLink\" *ngIf=\"noEndpointInfo.length != 0\" (click)=\"goRegistry()\">{{'REPLICATION.ENDPOINTS' | translate}}</span>\n       </div>\n\n      <!--Trigger-->\n      <div class=\"form-group form-group-override\">\n       <label class=\"form-group-label-override\">{{'REPLICATION.TRIGGER_MODE' | translate}}</label>\n       <div  formGroupName=\"trigger\">\n        <!--on trigger-->\n        <div class=\"select floatSetPar\">\n         <select id=\"ruleTrigger\" formControlName=\"kind\"  (change)=\"selectTrigger($event)\">\n          <option value=\"Manual\">{{'REPLICATION.MANUAL' | translate}}</option>\n          <option value=\"Immediate\">{{'REPLICATION.IMMEDIATE' | translate}}</option>\n          <option value=\"Scheduled\">{{'REPLICATION.SCHEDULE' | translate}}</option>\n         </select>\n        </div>\n        <!--on push-->\n        <div formGroupName=\"schedule_param\">\n          <div class=\"select floatSet\" [hidden]=\"!isScheduleOpt\">\n           <select name=\"scheduleType\" formControlName=\"type\" (change)=\"selectSchedule($event)\">\n            <option value=\"Daily\">{{'REPLICATION.DAILY' | translate}}</option>\n            <option value=\"Weekly\">{{'REPLICATION.WEEKLY' | translate}}</option>\n           </select>\n          </div>\n          <!--weekly-->\n          <span [hidden]=\"!weeklySchedule || !isScheduleOpt\">on &nbsp;</span>\n          <div  [hidden]=\"!weeklySchedule || !isScheduleOpt\" class=\"select floatSet\" style=\"width:104px\">\n           <select name=\"scheduleDay\" formControlName=\"weekday\">\n            <option value=\"1\">{{'WEEKLY.MONDAY' | translate}}</option>\n            <option value=\"2\">{{'WEEKLY.TUESDAY' | translate}}</option>\n            <option value=\"3\">{{'WEEKLY.WEDNESDAY' | translate}}</option>\n            <option value=\"4\">{{'WEEKLY.THURSDAY' | translate}}</option>\n            <option value=\"5\">{{'WEEKLY.FRIDAY' | translate}}</option>\n            <option value=\"6\">{{'WEEKLY.SATURDAY' | translate}}</option>\n            <option value=\"7\">{{'WEEKLY.SUNDAY' | translate}}</option>\n           </select>\n          </div>\n          <!--daily/time-->\n          <span [hidden]=\"!isScheduleOpt\">at &nbsp;</span>\n          <input [hidden]=\"!isScheduleOpt\" type=\"time\" formControlName=\"offtime\"  required value=\"08:00\" />\n        </div>\n       </div>\n       <div style=\"width: 100%;\" [hidden]=\"!isImmediate\">\n        <clr-checkbox [clrChecked]=\"false\" id=\"ruleDeletion\" formControlName=\"replicate_deletion\">\n         {{'REPLICATION.DELETE_REMOTE_IMAGES' | translate}}\n        </clr-checkbox>\n       </div>\n       <div  style=\"width: 100%;\" >\n        <clr-checkbox [clrChecked]=\"true\" id=\"ruleExit\" formControlName=\"replicate_existing_image_now\">\n         {{'REPLICATION.REPLICATE_IMMEDIATE' | translate}}\n        </clr-checkbox>\n       </div>\n      </div>\n      <div style=\"display:block;text-align:center\">\n       <span class=\"spinner spinner-inline\" [hidden]=\"inProgress === false\"></span>\n     </div>\n     </section>\n    </form>\n  </div>\n  <div class=\"modal-footer\">\n    <button type=\"button\" id=\"ruleBtnCancel\" class=\"btn btn-outline\" [disabled]=\"this.inProgress\" (click)=\"onCancel()\">{{ 'BUTTON.CANCEL' | translate }}</button>\n    <button type=\"submit\" id=\"ruleBtnOk\" class=\"btn btn-primary\"  (click)=\"onSubmit()\" [disabled]=\"!ruleForm.valid || !isValid || !hasFormChange()\">{{ 'BUTTON.SAVE' | translate }}</button>\n  </div>\n</clr-modal>";

var CREATE_EDIT_RULE_STYLE = "\n/**\n * Created by pengf on 9/28/2017.\n */\n\n.select{\n    width: 186px;\n}\n.select .optionMore{\n    background-color: #bfbaba;\n    height: 1.6em;\n    font-size: 1.2em;\n    cursor: pointer;\n    text-align: center;\n}\n.hideFilter{ display: none;}\nh4{\n    color: #666;\n}\n.colorRed{color: red;}\n.colorRed a{text-decoration: underline;color: #007CBB;}\n.alertLabel{display:block; margin-top:2px; line-height:1em; font-size:12px;}\n\n.inputWidth{width: 270px;}\n.endpointSelect{ width: 270px; margin-right: 20px;}\n.filterSelect{width: 315px;}\n.filterSelect clr-icon{margin-left: 15px;}\n.filterSelect label{width: 136px;}\n.filterSelect label input{width: 100%;}\n.pull-left{float: left;}\n.padLeft0{padding-left: 0;}\n.floatSetPar{display: inline-block; width: 120px;margin-right: 10px;}\n.floatSet {display: inline-block; width: 82px;margin-right: 4px;}\n.form-group{ min-height: 36px;}\n\n.projectInput{float: left;position: relative;}\n.switchIcon{width:20px;height:20px; margin-top: 10px;margin-left: 10px; cursor: pointer;}\n.addEndpoint{  margin-top: .25em !important;padding-left:2px;padding-right:2px;min-width:58px;margin-right:0}\n.shadow{position: absolute;top: 8px;}\n.is-solid{cursor: pointer;}\n.selectBox{\n    position: absolute;\n    width: 100%;\n    height: auto;\n    margin-top:-0.25rem;\n    border: 1px solid #ccc;\n    background-color: white;\n    border: 1px solid rgba(0,0,0,.15);\n    border-right-width: 2px;\n    border-bottom-width: 2px;\n    border-radius: 6px;\n    box-shadow: 0 5px 10px rgba(0,0,0,.2);\n    z-index: 100;\n}\n.selectBox ul li{\n    list-style: none;\n    padding: 3px 20px\n    cursor: pointer;\n}\n.selectBox ul li:hover{\n    color: #262626;\n    background-image: linear-gradient(180deg,#f5f5f5 0,#e8e8e8);\n    background-repeat: repeat-x;\n}\n.form-group-override{\n    padding-left: 170px !important;\n}\n.form-group>label:first-child{font-size:14px; width:6.5rem;}\n.goLink{color:blue; border-bottom:1px solid blue; line-height:14px; cursor:pointer;}\n";

// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//    http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var ONE_HOUR_SECONDS = 3600;
var ONE_DAY_SECONDS = 24 * ONE_HOUR_SECONDS;
var CreateEditRuleComponent = (function () {
    function CreateEditRuleComponent(fb, repService, endpointService, errorHandler, proService, translateService, ref) {
        this.fb = fb;
        this.repService = repService;
        this.endpointService = endpointService;
        this.errorHandler = errorHandler;
        this.proService = proService;
        this.translateService = translateService;
        this.ref = ref;
        this._localTime = new Date();
        this.targetList = [];
        this.projectList = [];
        this.selectedProjectList = [];
        this.isFilterHide = false;
        this.isImmediate = false;
        this.noProjectInfo = "";
        this.noEndpointInfo = "";
        this.noSelectedProject = true;
        this.noSelectedEndpoint = true;
        this.filterCount = 0;
        this.triggerNames = ['Manual', 'Immediate', 'Scheduled'];
        this.scheduleNames = ['Daily', 'Weekly'];
        this.weekly = ['Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday', 'Sunday'];
        this.filterSelect = ['repository', 'tag'];
        this.ruleNameTooltip = 'TOOLTIP.EMPTY';
        this.headerTitle = 'REPLICATION.ADD_POLICY';
        this.filterListData = [];
        this.inProgress = false;
        this.inNameChecking = false;
        this.isRuleNameExist = false;
        this.nameChecker = new rxjs_Subject.Subject();
        this.proNameChecker = new rxjs_Subject.Subject();
        this.firstClick = 0;
        this.goToRegistry = new _angular_core.EventEmitter();
        this.reload = new _angular_core.EventEmitter();
        this.emptyProject = {
            project_id: -1,
            name: '',
        };
        this.emptyEndpoint = {
            id: -1,
            endpoint: '',
            name: '',
            username: '',
            password: '',
            insecure: true,
            type: 0,
        };
        this.createForm();
    }
    CreateEditRuleComponent.prototype.baseFilterData = function (name, option, state) {
        return {
            name: name,
            options: option,
            state: state,
            isValid: true
        };
    };
    CreateEditRuleComponent.prototype.ngOnInit = function () {
        var _this = this;
        toPromise(this.endpointService
            .getEndpoints())
            .then(function (targets) {
            _this.targetList = targets || [];
        }).catch(function (error) { return _this.errorHandler.error(error); });
        if (!this.projectId) {
            toPromise(this.proService.listProjects("", undefined))
                .then(function (targets) {
                _this.projectList = targets || [];
            }).catch(function (error) { return _this.errorHandler.error(error); });
        }
        this.nameChecker.debounceTime(500).distinctUntilChanged().subscribe(function (ruleName) {
            _this.isRuleNameExist = false;
            _this.inNameChecking = true;
            toPromise(_this.repService.getReplicationRules(0, ruleName))
                .then(function (response) {
                if (response.some(function (rule) { return rule.name === ruleName; })) {
                    _this.ruleNameTooltip = 'TOOLTIP.RULE_USER_EXISTING';
                    _this.isRuleNameExist = true;
                }
                _this.inNameChecking = false;
            }).catch(function () {
                _this.inNameChecking = false;
            });
        });
        this.proNameChecker
            .debounceTime(500)
            .distinctUntilChanged()
            .subscribe(function (name) {
            _this.noProjectInfo = '';
            _this.selectedProjectList = [];
            toPromise(_this.proService.listProjects(name, undefined)).then(function (res) {
                if (res) {
                    _this.selectedProjectList = res.slice(0, 10);
                    // if input value exit in project list
                    var pro = res.find(function (data) { return data.name === name; });
                    if (!pro) {
                        _this.noProjectInfo = 'REPLICATION.NO_PROJECT_INFO';
                        _this.noSelectedProject = true;
                    }
                    else {
                        _this.noProjectInfo = '';
                        _this.noSelectedProject = false;
                        _this.setProject([pro]);
                    }
                }
                else {
                    _this.noProjectInfo = 'REPLICATION.NO_PROJECT_INFO';
                    _this.noSelectedProject = true;
                }
            }).catch(function (error) {
                _this.errorHandler.error(error);
                _this.noProjectInfo = 'REPLICATION.NO_PROJECT_INFO';
                _this.noSelectedProject = true;
            });
        });
    };
    CreateEditRuleComponent.prototype.ngOnDestroy = function () {
        if (this.confirmSub) {
            this.confirmSub.unsubscribe();
        }
        if (this.nameChecker) {
            this.nameChecker.unsubscribe();
        }
        if (this.proNameChecker) {
            this.proNameChecker.unsubscribe();
        }
    };
    Object.defineProperty(CreateEditRuleComponent.prototype, "isValid", {
        get: function () {
            return !(this.isRuleNameExist || this.noSelectedProject || this.noSelectedEndpoint || this.inProgress);
        },
        enumerable: true,
        configurable: true
    });
    CreateEditRuleComponent.prototype.createForm = function () {
        this.ruleForm = this.fb.group({
            name: ['', _angular_forms.Validators.required],
            description: '',
            projects: this.fb.array([]),
            targets: this.fb.array([]),
            trigger: this.fb.group({
                kind: this.triggerNames[0],
                schedule_param: this.fb.group({
                    type: this.scheduleNames[0],
                    weekday: 1,
                    offtime: '08:00'
                }),
            }),
            filters: this.fb.array([]),
            replicate_existing_image_now: true,
            replicate_deletion: false
        });
    };
    CreateEditRuleComponent.prototype.initForm = function () {
        this.ruleForm.reset({
            name: '',
            description: '',
            trigger: { kind: this.triggerNames[0], schedule_param: {
                    type: this.scheduleNames[0],
                    weekday: 1,
                    offtime: '08:00'
                } },
            replicate_existing_image_now: true,
            replicate_deletion: false
        });
        this.setProject([this.emptyProject]);
        this.setTarget([this.emptyEndpoint]);
        this.setFilter([]);
        this.copyUpdateForm = Object.assign({}, this.ruleForm.value);
    };
    CreateEditRuleComponent.prototype.updateForm = function (rule) {
        var _this = this;
        rule.trigger = this.updateTrigger(rule.trigger);
        this.ruleForm.reset({
            name: rule.name,
            description: rule.description,
            trigger: rule.trigger,
            replicate_existing_image_now: rule.replicate_existing_image_now,
            replicate_deletion: rule.replicate_deletion
        });
        this.setProject(rule.projects);
        this.noSelectedProject = false;
        this.setTarget(rule.targets);
        this.noSelectedEndpoint = false;
        if (rule.filters) {
            this.setFilter(rule.filters);
            this.updateFilter(rule.filters);
        }
        // Force refresh view
        var hnd = setInterval(function () { return _this.ref.markForCheck(); }, 100);
        setTimeout(function () { return clearInterval(hnd); }, 2000);
    };
    Object.defineProperty(CreateEditRuleComponent.prototype, "projects", {
        get: function () {
            return this.ruleForm.get('projects');
        },
        enumerable: true,
        configurable: true
    });
    CreateEditRuleComponent.prototype.setProject = function (projects) {
        var _this = this;
        var projectFGs = projects.map(function (project) { return _this.fb.group(project); });
        var projectFormArray = this.fb.array(projectFGs);
        this.ruleForm.setControl('projects', projectFormArray);
    };
    Object.defineProperty(CreateEditRuleComponent.prototype, "filters", {
        get: function () {
            return this.ruleForm.get('filters');
        },
        enumerable: true,
        configurable: true
    });
    CreateEditRuleComponent.prototype.setFilter = function (filters) {
        var _this = this;
        var filterFGs = filters.map(function (filter) { return _this.fb.group(filter); });
        var filterFormArray = this.fb.array(filterFGs);
        this.ruleForm.setControl('filters', filterFormArray);
    };
    Object.defineProperty(CreateEditRuleComponent.prototype, "targets", {
        get: function () {
            return this.ruleForm.get('targets');
        },
        enumerable: true,
        configurable: true
    });
    CreateEditRuleComponent.prototype.setTarget = function (targets) {
        var _this = this;
        var targetFGs = targets.map(function (target) { return _this.fb.group(target); });
        var targetFormArray = this.fb.array(targetFGs);
        this.ruleForm.setControl('targets', targetFormArray);
    };
    CreateEditRuleComponent.prototype.initFilter = function (name) {
        return this.fb.group({
            kind: name,
            pattern: ['', _angular_forms.Validators.required]
        });
    };
    CreateEditRuleComponent.prototype.filterChange = function ($event) {
        if ($event && $event.target['value']) {
            var id_1 = $event.target.id;
            var name_1 = $event.target.name;
            var value_1 = $event.target['value'];
            this.filterListData.forEach(function (data, index) {
                if (index === +id_1) {
                    data.name = $event.target.name = value_1;
                }
                else {
                    data.options.splice(data.options.indexOf(value_1), 1);
                }
                if (data.options.indexOf(name_1) === -1) {
                    data.options.push(name_1);
                }
            });
        }
    };
    CreateEditRuleComponent.prototype.targetChange = function ($event) {
        if ($event && $event.target) {
            if ($event.target['value'] === '-1') {
                this.noSelectedEndpoint = true;
                return;
            }
            var selecedTarget = this.targetList.find(function (target) { return target.id === +$event.target['value']; });
            this.setTarget([selecedTarget]);
            this.noSelectedEndpoint = false;
        }
    };
    // Handle the form validation
    CreateEditRuleComponent.prototype.handleValidation = function () {
        var cont = this.ruleForm.controls["projects"];
        if (cont && cont.valid) {
            this.proNameChecker.next(cont.value[0].name);
        }
    };
    CreateEditRuleComponent.prototype.focusClear = function ($event) {
        if (this.policyId < 0 && this.firstClick === 0) {
            if ($event && $event.target && $event.target['value']) {
                $event.target['value'] = '';
            }
            this.firstClick++;
        }
    };
    CreateEditRuleComponent.prototype.leaveInput = function () {
        this.selectedProjectList = [];
    };
    CreateEditRuleComponent.prototype.selectedProjectName = function (projectName) {
        this.noSelectedProject = false;
        var pro = this.selectedProjectList.find(function (data) { return data.name === projectName; });
        this.setProject([pro]);
        this.selectedProjectList = [];
        this.noProjectInfo = "";
    };
    CreateEditRuleComponent.prototype.selectedProject = function (project) {
        if (!project) {
            this.noSelectedProject = true;
        }
        else {
            this.noSelectedProject = false;
            this.setProject([project]);
        }
    };
    CreateEditRuleComponent.prototype.addNewFilter = function () {
        if (this.filterCount === 0) {
            this.filterListData.push(this.baseFilterData(this.filterSelect[0], this.filterSelect.slice(), true));
            this.filters.push(this.initFilter(this.filterSelect[0]));
        }
        else {
            var nameArr_1 = this.filterSelect.slice();
            this.filterListData.forEach(function (data) {
                nameArr_1.splice(nameArr_1.indexOf(data.name), 1);
            });
            // when add a new filter,the filterListData should change the options
            this.filterListData.filter(function (data) {
                data.options.splice(data.options.indexOf(nameArr_1[0]), 1);
            });
            this.filterListData.push(this.baseFilterData(nameArr_1[0], nameArr_1, true));
            this.filters.push(this.initFilter(nameArr_1[0]));
        }
        this.filterCount += 1;
        if (this.filterCount >= this.filterSelect.length) {
            this.isFilterHide = true;
        }
    };
    // delete a filter
    CreateEditRuleComponent.prototype.deleteFilter = function (i) {
        if (i || i === 0) {
            var delfilter = this.filterListData.splice(i, 1)[0];
            if (this.filterCount === this.filterSelect.length) {
                this.isFilterHide = false;
            }
            this.filterCount -= 1;
            if (this.filterListData.length) {
                var optionVal_1 = delfilter.name;
                this.filterListData.filter(function (data) {
                    if (data.options.indexOf(optionVal_1) === -1) {
                        data.options.push(optionVal_1);
                    }
                });
            }
            var control = this.ruleForm.controls['filters'];
            control.removeAt(i);
        }
    };
    CreateEditRuleComponent.prototype.selectTrigger = function ($event) {
        if ($event && $event.target && $event.target['value']) {
            var val = $event.target['value'];
            if (val === this.triggerNames[2]) {
                this.isScheduleOpt = true;
                this.isImmediate = false;
            }
            if (val === this.triggerNames[1]) {
                this.isScheduleOpt = false;
                this.isImmediate = true;
            }
            if (val === this.triggerNames[0]) {
                this.isScheduleOpt = false;
                this.isImmediate = false;
            }
        }
    };
    // Replication Schedule select value exchange
    CreateEditRuleComponent.prototype.selectSchedule = function ($event) {
        if ($event && $event.target && $event.target['value']) {
            switch ($event.target['value']) {
                case this.scheduleNames[1]:
                    this.weeklySchedule = true;
                    this.ruleForm.patchValue({
                        trigger: {
                            schedule_param: {
                                weekday: 1,
                            }
                        }
                    });
                    break;
                case this.scheduleNames[0]:
                    this.weeklySchedule = false;
                    break;
            }
        }
    };
    CreateEditRuleComponent.prototype.checkRuleName = function () {
        var ruleName = this.ruleForm.controls['name'].value;
        if (ruleName) {
            this.nameChecker.next(ruleName);
        }
        else {
            this.ruleNameTooltip = 'TOOLTIP.EMPTY';
        }
    };
    CreateEditRuleComponent.prototype.updateFilter = function (filters) {
        var _this = this;
        var opt = this.filterSelect.slice();
        filters.forEach(function (filter) {
            opt.splice(opt.indexOf(filter.kind), 1);
        });
        filters.forEach(function (filter) {
            var option = opt.slice();
            option.unshift(filter.kind);
            _this.filterListData.push(_this.baseFilterData(filter.kind, option, true));
        });
        this.filterCount = filters.length;
        if (filters.length === this.filterSelect.length) {
            this.isFilterHide = true;
        }
    };
    CreateEditRuleComponent.prototype.updateTrigger = function (trigger) {
        if (trigger['schedule_param']) {
            this.isScheduleOpt = true;
            this.isImmediate = false;
            trigger['schedule_param']['offtime'] = this.getOfftime(trigger['schedule_param']['offtime']);
            if (trigger['schedule_param']['weekday']) {
                this.weeklySchedule = true;
            }
            else {
                // set default
                trigger['schedule_param']['weekday'] = 1;
            }
        }
        else {
            if (trigger['kind'] === this.triggerNames[0]) {
                this.isImmediate = false;
            }
            if (trigger['kind'] === this.triggerNames[1]) {
                this.isImmediate = true;
            }
            trigger['schedule_param'] = { type: this.scheduleNames[0],
                weekday: this.weekly[0],
                offtime: '08:00' };
        }
        return trigger;
    };
    CreateEditRuleComponent.prototype.setTriggerVaule = function (trigger) {
        if (!this.isScheduleOpt) {
            delete trigger['schedule_param'];
            return trigger;
        }
        else {
            if (!this.weeklySchedule) {
                delete trigger['schedule_param']['weekday'];
            }
            else {
                trigger['schedule_param']['weekday'] = +trigger['schedule_param']['weekday'];
            }
            trigger['schedule_param']['offtime'] = this.setOfftime(trigger['schedule_param']['offtime']);
            return trigger;
        }
    };
    CreateEditRuleComponent.prototype.hasFormChange = function () {
        return !isEmptyObject(this.getChanges());
    };
    CreateEditRuleComponent.prototype.onSubmit = function () {
        var _this = this;
        // add new Replication rule
        this.inProgress = true;
        var copyRuleForm = this.ruleForm.value;
        copyRuleForm.trigger = this.setTriggerVaule(copyRuleForm.trigger);
        if (this.policyId < 0) {
            this.repService.createReplicationRule(copyRuleForm)
                .then(function () {
                _this.translateService.get('REPLICATION.CREATED_SUCCESS')
                    .subscribe(function (res) { return _this.errorHandler.info(res); });
                _this.inProgress = false;
                _this.reload.emit(true);
                _this.close();
            }).catch(function (error) {
                _this.inProgress = false;
                _this.inlineAlert.showInlineError(error);
            });
        }
        else {
            this.repService.updateReplicationRule(this.policyId, this.ruleForm.value)
                .then(function () {
                _this.translateService.get('REPLICATION.UPDATED_SUCCESS')
                    .subscribe(function (res) { return _this.errorHandler.info(res); });
                _this.inProgress = false;
                _this.reload.emit(true);
                _this.close();
            }).catch(function (error) {
                _this.inProgress = false;
                _this.inlineAlert.showInlineError(error);
            });
        }
    };
    CreateEditRuleComponent.prototype.openCreateEditRule = function (ruleId) {
        var _this = this;
        this.initForm();
        this.selectedProjectList = [];
        this.filterCount = 0;
        this.filterListData = [];
        this.firstClick = 0;
        this.noSelectedProject = true;
        this.noSelectedEndpoint = true;
        this.isRuleNameExist = false;
        this.weeklySchedule = false;
        this.isScheduleOpt = false;
        this.isImmediate = false;
        this.policyId = -1;
        this.createEditRuleOpened = true;
        this.noProjectInfo = "";
        this.noEndpointInfo = "";
        if (this.targetList.length === 0) {
            this.noEndpointInfo = 'REPLICATION.NO_ENDPOINT_INFO';
        }
        if (this.projectList.length === 0 && !this.projectName) {
            this.noProjectInfo = 'REPLICATION.NO_PROJECT_INFO';
        }
        if (ruleId) {
            this.policyId = +ruleId;
            this.headerTitle = 'REPLICATION.EDIT_POLICY_TITLE';
            toPromise(this.repService.getReplicationRule(ruleId))
                .then(function (response) {
                _this.copyUpdateForm = Object.assign({}, response);
                // set filter value is [] if callback fiter value is null.
                _this.copyUpdateForm.filters = response.filters ? response.filters : [];
                _this.updateForm(response);
            }).catch(function (error) {
                _this.inlineAlert.showInlineError(error);
            });
        }
        else {
            this.headerTitle = 'REPLICATION.ADD_POLICY';
            if (this.projectId) {
                this.setProject([{ project_id: this.projectId, name: this.projectName }]);
                this.noSelectedProject = false;
            }
            this.copyUpdateForm = Object.assign({}, this.ruleForm.value);
        }
    };
    CreateEditRuleComponent.prototype.close = function () {
        this.createEditRuleOpened = false;
    };
    CreateEditRuleComponent.prototype.confirmCancel = function (confirmed) {
        this.inlineAlert.close();
        this.close();
    };
    CreateEditRuleComponent.prototype.onCancel = function () {
        if (this.hasFormChange()) {
            this.inlineAlert.showInlineConfirmation({ message: 'ALERT.FORM_CHANGE_CONFIRMATION' });
        }
        else {
            this.close();
        }
    };
    CreateEditRuleComponent.prototype.goRegistry = function () {
        this.goToRegistry.emit();
    };
    // UTC time
    CreateEditRuleComponent.prototype.getOfftime = function (daily_time) {
        var timeOffset = 0; // seconds
        if (daily_time && typeof daily_time === 'number') {
            timeOffset = +daily_time;
        }
        // Convert to current time
        var timezoneOffset = this._localTime.getTimezoneOffset();
        // Local time
        timeOffset = timeOffset - timezoneOffset * 60;
        if (timeOffset < 0) {
            timeOffset = timeOffset + ONE_DAY_SECONDS;
        }
        if (timeOffset >= ONE_DAY_SECONDS) {
            timeOffset -= ONE_DAY_SECONDS;
        }
        // To time string
        var hours = Math.floor(timeOffset / ONE_HOUR_SECONDS);
        var minutes = Math.floor((timeOffset - hours * ONE_HOUR_SECONDS) / 60);
        var timeStr = '' + hours;
        if (hours < 10) {
            timeStr = '0' + timeStr;
        }
        if (minutes < 10) {
            timeStr += ':0';
        }
        else {
            timeStr += ':';
        }
        timeStr += minutes;
        return timeStr;
    };
    CreateEditRuleComponent.prototype.setOfftime = function (v) {
        if (!v || v === '') {
            return;
        }
        var values = v.split(':');
        if (!values || values.length !== 2) {
            return;
        }
        var hours = +values[0];
        var minutes = +values[1];
        // Convert to UTC time
        var timezoneOffset = this._localTime.getTimezoneOffset();
        var utcTimes = hours * ONE_HOUR_SECONDS + minutes * 60;
        utcTimes += timezoneOffset * 60;
        if (utcTimes < 0) {
            utcTimes += ONE_DAY_SECONDS;
        }
        if (utcTimes >= ONE_DAY_SECONDS) {
            utcTimes -= ONE_DAY_SECONDS;
        }
        return utcTimes;
    };
    CreateEditRuleComponent.prototype.getChanges = function () {
        var changes = {};
        var ruleValue = this.ruleForm.value;
        if (!ruleValue || !this.copyUpdateForm) {
            return changes;
        }
        for (var prop in ruleValue) {
            var field = this.copyUpdateForm[prop];
            if (!compareValue(field, ruleValue[prop])) {
                if (ruleValue[prop][0] && ruleValue[prop][0].project_id && (ruleValue[prop][0].project_id === field[0].project_id)) {
                    break;
                }
                if (ruleValue[prop][0] && ruleValue[prop][0].id && (ruleValue[prop][0].id === field[0].id)) {
                    break;
                }
                changes[prop] = ruleValue[prop];
                // Number
                if (typeof field === "number") {
                    changes[prop] = +changes[prop];
                }
                // Trim string value
                if (typeof field === "string") {
                    changes[prop] = ('' + changes[prop]).trim();
                }
            }
        }
        return changes;
    };
    return CreateEditRuleComponent;
}());
CreateEditRuleComponent.decorators = [
    { type: _angular_core.Component, args: [{
                selector: 'hbr-create-edit-rule',
                template: CREATE_EDIT_RULE_TEMPLATE,
                styles: [CREATE_EDIT_RULE_STYLE]
            },] },
];
/** @nocollapse */
CreateEditRuleComponent.ctorParameters = function () { return [
    { type: _angular_forms.FormBuilder, },
    { type: ReplicationService, },
    { type: EndpointService, },
    { type: ErrorHandler, },
    { type: ProjectService, },
    { type: _ngxTranslate_core.TranslateService, },
    { type: _angular_core.ChangeDetectorRef, },
]; };
CreateEditRuleComponent.propDecorators = {
    'projectId': [{ type: _angular_core.Input },],
    'projectName': [{ type: _angular_core.Input },],
    'goToRegistry': [{ type: _angular_core.Output },],
    'reload': [{ type: _angular_core.Output },],
    'inlineAlert': [{ type: _angular_core.ViewChild, args: [InlineAlertComponent,] },],
};

var REPLICATION_TEMPLATE = "\n<div class=\"row\" style=\"position:relative;\">\n  <div>\n    <div class=\"row flex-items-xs-between rightPos\">\n      <div class=\"flex-xs-middle option-right\">\n        <hbr-filter [withDivider]=\"true\" filterPlaceholder='{{\"REPLICATION.FILTER_POLICIES_PLACEHOLDER\" | translate}}' (filter)=\"doSearchRules($event)\" [currentValue]=\"search.ruleName\"></hbr-filter>\n        <span class=\"refresh-btn\" (click)=\"refreshRules()\">\n          <clr-icon shape=\"refresh\"></clr-icon>\n        </span>\n      </div>\n    </div>\n    </div>\n    <div class=\"col-lg-12 col-md-12 col-sm-12 col-xs-12\">\n      <hbr-list-replication-rule #listReplicationRule [projectId]=\"projectId\" [isSystemAdmin]=\"isSystemAdmin\"  (replicateManual)=replicateManualRule($event) (selectOne)=\"selectOneRule($event)\" (hideJobs)=\"hideJobs()\"  (openNewRule)=\"openModal()\" (editOne)=\"openEditRule($event)\" (reload)=\"reloadRules($event)\" [loading]=\"loading\" [withReplicationJob]=\"withReplicationJob\" (redirect)=\"customRedirect($event)\"></hbr-list-replication-rule>\n    </div>\n    <div class=\"col-lg-12 col-md-12 col-sm-12 col-xs-12\" style=\"padding-left:0px;\" [hidden]='hiddenJobList'>\n    <div *ngIf=\"withReplicationJob\" class=\"col-lg-12 col-md-12 col-sm-12 col-xs-12\">\n      <div class=\"row flex-items-xs-between\" style=\"height:60px;\">\n        <h5 class=\"flex-items-xs-bottom option-left-down\" style=\"margin-left: 14px;\">{{'REPLICATION.REPLICATION_JOBS' | translate}}</h5>\n        <div class=\"flex-items-xs-bottom option-right-down\">\n          <button class=\"btn btn-link\" (click)=\"toggleSearchJobOptionalName(currentJobSearchOption)\">{{toggleJobSearchOption[currentJobSearchOption] | translate}}</button>\n          <hbr-filter [withDivider]=\"true\" filterPlaceholder='{{\"REPLICATION.FILTER_JOBS_PLACEHOLDER\" | translate}}' (filter)=\"doSearchJobs($event)\" [currentValue]=\"search.repoName\" ></hbr-filter>\n          <span class=\"refresh-btn\" (click)=\"refreshJobs()\">\n            <clr-icon shape=\"refresh\"></clr-icon>\n          </span>\n        </div>\n      </div>\n      <div class=\"row flex-items-xs-right option-right\" [hidden]=\"currentJobSearchOption === 0\">\n        <div class=\"select\" style=\"float: left;\">\n          <select (change)=\"doFilterJobStatus($event)\">\n          <option *ngFor=\"let j of jobStatus\" value=\"{{j.key}}\" [selected]=\"currentJobStatus.key === j.key\">{{j.description | translate}}</option>\n          </select>\n        </div>\n        <div class=\"flex-items-xs-middle\">    \n          <hbr-datetime [dateInput]=\"search.startTime\" (search)=\"doJobSearchByStartTime($event)\"></hbr-datetime>\n          <hbr-datetime [dateInput]=\"search.endTime\" [oneDayOffset]=\"true\" (search)=\"doJobSearchByEndTime($event)\"></hbr-datetime>\n        </div>\n      </div>\n    </div>\n    <div *ngIf=\"withReplicationJob\" class=\"col-lg-12 col-md-12 col-sm-12 col-xs-12\">\n      <clr-datagrid [clrDgLoading]=\"jobsLoading\" (clrDgRefresh)=\"clrLoadJobs($event)\"><clr-dg-action-bar>\n            <div class=\"btn-group\">\n                <button type=\"button\" class=\"btn btn-sm btn-secondary\" *ngIf=\"isSystemAdmin\" [disabled]=\"!(jobs && jobs.length>0) || isStopOnGoing\" (click)=\"stopJobs()\">{{'REPLICATION.STOPJOB' | translate}}</button>\n            </div>\n        </clr-dg-action-bar>\n        <clr-dg-column [clrDgField]=\"'repository'\">{{'REPLICATION.NAME' | translate}}</clr-dg-column>\n        <clr-dg-column [clrDgField]=\"'status'\">{{'REPLICATION.STATUS' | translate}}</clr-dg-column>\n        <clr-dg-column [clrDgField]=\"'operation'\">{{'REPLICATION.OPERATION' | translate}}</clr-dg-column>\n        <clr-dg-column [clrDgSortBy]=\"creationTimeComparator\">{{'REPLICATION.CREATION_TIME' | translate}}</clr-dg-column>\n        <clr-dg-column [clrDgSortBy]=\"updateTimeComparator\">{{'REPLICATION.UPDATE_TIME' | translate}}</clr-dg-column>\n        <clr-dg-column>{{'REPLICATION.LOGS' | translate}}</clr-dg-column>\n        <clr-dg-placeholder>{{'REPLICATION.JOB_PLACEHOLDER' | translate }}</clr-dg-placeholder>\n        <clr-dg-row *ngFor=\"let j of jobs\">\n            <clr-dg-cell>{{j.repository}}</clr-dg-cell>\n            <clr-dg-cell>{{j.status}}</clr-dg-cell>\n            <clr-dg-cell>{{j.operation}}</clr-dg-cell>\n            <clr-dg-cell>{{j.creation_time | date: 'short'}}</clr-dg-cell>\n            <clr-dg-cell>{{j.update_time | date: 'short'}}</clr-dg-cell>\n            <clr-dg-cell>\n             <span *ngIf=\"j.status=='pending'; else elseBlock\" class=\"label\">{{'REPLICATION.NO_LOGS' | translate}}</span>\n                <ng-template #elseBlock>\n                    <a href=\"javascript:void(0);\" (click)=\"viewLog(j.id)\">\n                <clr-icon shape=\"clipboard\"></clr-icon>\n              </a></ng-template>\n            </clr-dg-cell>\n        </clr-dg-row>\n        <clr-dg-footer>\n            <span *ngIf=\"showPaginationIndex\">{{pagination.firstItem + 1}} - {{pagination.lastItem + 1}} {{'REPLICATION.OF' | translate}}</span>\n            {{pagination.totalItems}} {{'REPLICATION.ITEMS' | translate}}\n            <clr-dg-pagination #pagination [(clrDgPage)]=\"currentPage\" [clrDgPageSize]=\"pageSize\" [clrDgTotalItems]=\"totalCount\"></clr-dg-pagination>\n        </clr-dg-footer>\n      </clr-datagrid>\n    </div>\n    </div>\n    <job-log-viewer #replicationLogViewer></job-log-viewer>\n    <hbr-create-edit-rule  *ngIf=\"isSystemAdmin\" [projectId]=\"projectId\" [projectName]=\"projectName\" (goToRegistry)=\"goRegistry()\" (reload)=\"reloadRules($event)\"></hbr-create-edit-rule>\n    <confirmation-dialog #replicationConfirmDialog [batchInfors]=\"batchDelectionInfos\" (confirmAction)=\"confirmReplication($event)\"></confirmation-dialog>\n</div>";

var REPLICATION_STYLE = "\n.refresh-btn {\n    cursor: pointer;\n}\n\n.refresh-btn:hover {\n    color: #007CBB;\n}\n\n.option-left {\n  padding-left: 16px;\n}\n.option-right {\n  padding-right: 16px;\n}\n\n.option-left-down {\n  margin-top: 36px;\n}\n\n.option-right-down {\n  padding-right: 16px;\n  margin-top: 24px;\n}\n .rightPos{\n    position: absolute;\n    right: 35px;\n    margin-top: 5px;\n    z-index: 100;\n    height: 32px;\n}";

// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//    http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var ruleStatus = [
    { 'key': 'all', 'description': 'REPLICATION.ALL_STATUS' },
    { 'key': '1', 'description': 'REPLICATION.ENABLED' },
    { 'key': '0', 'description': 'REPLICATION.DISABLED' }
];
var jobStatus = [
    { 'key': 'all', 'description': 'REPLICATION.ALL' },
    { 'key': 'pending', 'description': 'REPLICATION.PENDING' },
    { 'key': 'running', 'description': 'REPLICATION.RUNNING' },
    { 'key': 'error', 'description': 'REPLICATION.ERROR' },
    { 'key': 'retrying', 'description': 'REPLICATION.RETRYING' },
    { 'key': 'stopped', 'description': 'REPLICATION.STOPPED' },
    { 'key': 'finished', 'description': 'REPLICATION.FINISHED' },
    { 'key': 'canceled', 'description': 'REPLICATION.CANCELED' }
];
var optionalSearch = { 0: 'REPLICATION.ADVANCED', 1: 'REPLICATION.SIMPLE' };
var SearchOption = (function () {
    function SearchOption() {
        this.ruleName = '';
        this.repoName = '';
        this.status = '';
        this.startTime = '';
        this.startTimestamp = '';
        this.endTime = '';
        this.endTimestamp = '';
        this.page = 1;
        this.pageSize = DEFAULT_PAGE_SIZE;
    }
    return SearchOption;
}());
var ReplicationComponent = (function () {
    function ReplicationComponent(errorHandler, replicationService, translateService) {
        this.errorHandler = errorHandler;
        this.replicationService = replicationService;
        this.translateService = translateService;
        this.redirect = new _angular_core.EventEmitter();
        this.openCreateRule = new _angular_core.EventEmitter();
        this.openEdit = new _angular_core.EventEmitter();
        this.goToRegistry = new _angular_core.EventEmitter();
        this.search = new SearchOption();
        this.ruleStatus = ruleStatus;
        this.jobStatus = jobStatus;
        this.hiddenJobList = true;
        this.batchDelectionInfos = [];
        this.toggleJobSearchOption = optionalSearch;
        this.creationTimeComparator = new CustomComparator('creation_time', 'date');
        this.updateTimeComparator = new CustomComparator('update_time', 'date');
        //Server driven pagination
        this.currentPage = 1;
        this.totalCount = 0;
        this.pageSize = DEFAULT_PAGE_SIZE;
        this.jobsLoading = false;
    }
    Object.defineProperty(ReplicationComponent.prototype, "showPaginationIndex", {
        get: function () {
            return this.totalCount > 0;
        },
        enumerable: true,
        configurable: true
    });
    ReplicationComponent.prototype.ngOnInit = function () {
        this.currentRuleStatus = this.ruleStatus[0];
        this.currentJobStatus = this.jobStatus[0];
        this.currentJobSearchOption = 0;
    };
    ReplicationComponent.prototype.ngOnDestroy = function () {
        if (this.timerDelay) {
            this.timerDelay.unsubscribe();
        }
    };
    // open replication rule
    ReplicationComponent.prototype.openModal = function () {
        this.createEditPolicyComponent.openCreateEditRule();
    };
    // edit replication rule
    ReplicationComponent.prototype.openEditRule = function (rule) {
        if (rule) {
            this.createEditPolicyComponent.openCreateEditRule(rule.id);
        }
    };
    ReplicationComponent.prototype.goRegistry = function () {
        this.goToRegistry.emit();
    };
    //Server driven data loading
    ReplicationComponent.prototype.clrLoadJobs = function (state) {
        var _this = this;
        if (!state || !state.page || !this.search.ruleId) {
            return;
        }
        this.currentState = state;
        var pageNumber = calculatePage(state);
        if (pageNumber <= 0) {
            pageNumber = 1;
        }
        var params = new RequestQueryParams();
        //Pagination
        params.set("page", '' + pageNumber);
        params.set("page_size", '' + this.pageSize);
        //Search by status
        if (this.search.status.trim()) {
            params.set('status', this.search.status);
        }
        //Search by repository
        if (this.search.repoName.trim()) {
            params.set('repository', this.search.repoName);
        }
        //Search by timestamps
        if (this.search.startTimestamp.trim()) {
            params.set('start_time', this.search.startTimestamp);
        }
        if (this.search.endTimestamp.trim()) {
            params.set('end_time', this.search.endTimestamp);
        }
        this.jobsLoading = true;
        //Do filtering and sorting
        this.jobs = doFiltering(this.jobs, state);
        this.jobs = doSorting(this.jobs, state);
        this.jobsLoading = false;
        toPromise(this.replicationService
            .getJobs(this.search.ruleId, params))
            .then(function (response) {
            _this.totalCount = response.metadata.xTotalCount;
            _this.jobs = response.data;
            if (!_this.timerDelay) {
                _this.timerDelay = rxjs_Observable.Observable.timer(10000, 10000).subscribe(function () {
                    var count = 0;
                    _this.jobs.forEach(function (job) {
                        if ((job.status === 'pending') || (job.status === 'running') || (job.status === 'retrying')) {
                            count++;
                        }
                    });
                    if (count > 0) {
                        _this.clrLoadJobs(_this.currentState);
                    }
                    else {
                        _this.timerDelay.unsubscribe();
                        _this.timerDelay = null;
                    }
                });
            }
            //Do filtering and sorting
            _this.jobs = doFiltering(_this.jobs, state);
            _this.jobs = doSorting(_this.jobs, state);
            _this.jobsLoading = false;
        }).catch(function (error) {
            _this.jobsLoading = false;
            _this.errorHandler.error(error);
        });
    };
    ReplicationComponent.prototype.loadFirstPage = function () {
        var st = this.currentState;
        if (!st) {
            st = {
                page: {}
            };
        }
        st.page.size = this.pageSize;
        st.page.from = 0;
        st.page.to = this.pageSize - 1;
        this.clrLoadJobs(st);
    };
    ReplicationComponent.prototype.selectOneRule = function (rule) {
        if (rule && rule.id) {
            this.hiddenJobList = false;
            this.search.ruleId = rule.id || '';
            this.search.repoName = '';
            this.search.status = '';
            this.currentJobSearchOption = 0;
            this.currentJobStatus = { 'key': 'all', 'description': 'REPLICATION.ALL' };
            this.loadFirstPage();
        }
    };
    ReplicationComponent.prototype.replicateManualRule = function (rule) {
        if (rule) {
            this.batchDelectionInfos = [];
            var initBatchMessage = new BatchInfo();
            initBatchMessage.name = rule.name;
            this.batchDelectionInfos.push(initBatchMessage);
            var replicationMessage = new ConfirmationMessage('REPLICATION.REPLICATION_TITLE', 'REPLICATION.REPLICATION_SUMMARY', rule.name, rule, 6 /* TARGET */, 4 /* REPLICATE_CANCEL */);
            this.replicationConfirmDialog.open(replicationMessage);
        }
    };
    ReplicationComponent.prototype.confirmReplication = function (message) {
        var _this = this;
        if (message &&
            message.source === 6 /* TARGET */ &&
            message.state === 1 /* CONFIRMED */) {
            var rule_1 = message.data;
            if (rule_1) {
                Promise.all([this.replicationOperate(+rule_1.id, rule_1.name)]).then(function (item) {
                    _this.selectOneRule(rule_1);
                });
            }
        }
    };
    ReplicationComponent.prototype.replicationOperate = function (ruleId, name) {
        var _this = this;
        var findedList = this.batchDelectionInfos.find(function (data) { return data.name === name; });
        return toPromise(this.replicationService.replicateRule(ruleId))
            .then(function (response) {
            _this.translateService.get('BATCH.REPLICATE_SUCCESS')
                .subscribe(function (res) { return findedList = BathInfoChanges(findedList, res); });
        })
            .catch(function (error) {
            if (error && error.status === 412) {
                rxjs_Observable.Observable.forkJoin(_this.translateService.get('BATCH.REPLICATE_FAILURE'), _this.translateService.get('REPLICATION.REPLICATE_SUMMARY_FAILURE'))
                    .subscribe(function (res) {
                    findedList = BathInfoChanges(findedList, res[0], false, true, res[1]);
                });
            }
            else {
                _this.translateService.get('BATCH.REPLICATE_FAILURE').subscribe(function (res) {
                    findedList = BathInfoChanges(findedList, res, false, true);
                });
            }
        });
    };
    ReplicationComponent.prototype.customRedirect = function (rule) {
        this.redirect.emit(rule);
    };
    ReplicationComponent.prototype.doSearchRules = function (ruleName) {
        this.search.ruleName = ruleName;
        this.listReplicationRule.retrieveRules(ruleName);
    };
    ReplicationComponent.prototype.doFilterJobStatus = function ($event) {
        if ($event && $event.target && $event.target["value"]) {
            var status_1 = $event.target["value"];
            this.currentJobStatus = this.jobStatus.find(function (r) { return r.key === status_1; });
            if (this.currentJobStatus.key === 'all') {
                status_1 = '';
            }
            this.search.status = status_1;
            this.doSearchJobs(this.search.repoName);
        }
    };
    ReplicationComponent.prototype.doSearchJobs = function (repoName) {
        this.search.repoName = repoName;
        this.loadFirstPage();
    };
    ReplicationComponent.prototype.hideJobs = function () {
        this.search.ruleId = 0;
        this.jobs = [];
        this.hiddenJobList = true;
    };
    ReplicationComponent.prototype.stopJobs = function () {
        var _this = this;
        if (this.jobs && this.jobs.length) {
            this.isStopOnGoing = true;
            toPromise(this.replicationService.stopJobs(this.jobs[0].policy_id))
                .then(function (res) {
                _this.refreshJobs();
                _this.isStopOnGoing = false;
            })
                .catch(function (error) { return _this.errorHandler.error(error); });
        }
    };
    ReplicationComponent.prototype.reloadRules = function (isReady) {
        if (isReady) {
            this.search.ruleName = '';
            this.listReplicationRule.retrieveRules(this.search.ruleName);
        }
    };
    ReplicationComponent.prototype.refreshRules = function () {
        this.listReplicationRule.retrieveRules();
    };
    ReplicationComponent.prototype.refreshJobs = function () {
        this.currentJobStatus = this.jobStatus[0];
        this.search.startTime = ' ';
        this.search.endTime = ' ';
        this.search.repoName = "";
        this.search.startTimestamp = "";
        this.search.endTimestamp = "";
        this.search.status = "";
        this.currentPage = 1;
        var st = {
            page: {
                from: 0,
                to: this.pageSize - 1,
                size: this.pageSize
            }
        };
        this.clrLoadJobs(st);
    };
    ReplicationComponent.prototype.toggleSearchJobOptionalName = function (option) {
        (option === 1) ? this.currentJobSearchOption = 0 : this.currentJobSearchOption = 1;
    };
    ReplicationComponent.prototype.doJobSearchByStartTime = function (fromTimestamp) {
        this.search.startTimestamp = fromTimestamp;
        this.loadFirstPage();
    };
    ReplicationComponent.prototype.doJobSearchByEndTime = function (toTimestamp) {
        this.search.endTimestamp = toTimestamp;
        this.loadFirstPage();
    };
    ReplicationComponent.prototype.viewLog = function (jobId) {
        if (this.replicationLogViewer) {
            this.replicationLogViewer.open(jobId);
        }
    };
    return ReplicationComponent;
}());
ReplicationComponent.decorators = [
    { type: _angular_core.Component, args: [{
                selector: 'hbr-replication',
                template: REPLICATION_TEMPLATE,
                styles: [REPLICATION_STYLE]
            },] },
];
/** @nocollapse */
ReplicationComponent.ctorParameters = function () { return [
    { type: ErrorHandler, },
    { type: ReplicationService, },
    { type: _ngxTranslate_core.TranslateService, },
]; };
ReplicationComponent.propDecorators = {
    'projectId': [{ type: _angular_core.Input },],
    'projectName': [{ type: _angular_core.Input },],
    'isSystemAdmin': [{ type: _angular_core.Input },],
    'withReplicationJob': [{ type: _angular_core.Input },],
    'redirect': [{ type: _angular_core.Output },],
    'openCreateRule': [{ type: _angular_core.Output },],
    'openEdit': [{ type: _angular_core.Output },],
    'goToRegistry': [{ type: _angular_core.Output },],
    'listReplicationRule': [{ type: _angular_core.ViewChild, args: [ListReplicationRuleComponent,] },],
    'createEditPolicyComponent': [{ type: _angular_core.ViewChild, args: [CreateEditRuleComponent,] },],
    'replicationLogViewer': [{ type: _angular_core.ViewChild, args: ["replicationLogViewer",] },],
    'replicationConfirmDialog': [{ type: _angular_core.ViewChild, args: ['replicationConfirmDialog',] },],
};

var REPLICATION_DIRECTIVES = [
    ReplicationComponent
];

var CREATE_EDIT_RULE_DIRECTIVES = [
    CreateEditRuleComponent
];

var LIST_REPLICATION_RULE_DIRECTIVES = [
    ListReplicationRuleComponent
];

var CREATE_EDIT_ENDPOINT_DIRECTIVES = [
    CreateEditEndpointComponent
];

var ConfirmationAcknowledgement = (function () {
    function ConfirmationAcknowledgement(state, data, source) {
        this.state = 0 /* NA */;
        this.data = {};
        this.source = 0 /* EMPTY */;
        this.state = state;
        this.data = data;
        this.source = source;
    }
    return ConfirmationAcknowledgement;
}());

var CONFIRMATION_DIALOG_TEMPLATE = "\n<clr-modal [(clrModalOpen)]=\"opened\" [clrModalClosable]=\"false\" [clrModalStaticBackdrop]=\"true\">\n    <h3 class=\"modal-title\" class=\"confirmation-title\" style=\"margin-top: 0px;\">{{dialogTitle}}</h3>\n    <div class=\"modal-body\">\n        <div class=\"confirmation-icon-inline\">\n            <clr-icon shape=\"warning\" class=\"is-warning\" size=\"64\"></clr-icon>\n        </div>\n        <div class=\"confirmation-content\">{{dialogContent}}</div>\n       <div>\n            <ul class=\"batchInfoUl\">\n                <li *ngFor=\"let info of batchInfors\">\n                   <span> <i class=\"spinner spinner-inline spinner-pos\" [hidden]='!info.loading'></i>&nbsp;&nbsp;{{info.name}}</span>\n                    <span *ngIf=\"!info.errorInfo.length\" [style.color]=\"colorChange(info)\">{{info.status}}</span>\n                    <span *ngIf=\"info.errorInfo.length\" [style.color]=\"colorChange(info)\">\n                        <a (click)=\"toggleErrorTitle(errorInfo)\" >{{info.status}}</a><br>\n                        <i #errorInfo style=\"display: none;\">{{info.errorInfo}}</i>\n                    </span>\n                </li>\n            </ul>\n        </div>\n    </div>\n    <div class=\"modal-footer\" [ngSwitch]=\"buttons\">\n       <ng-template [ngSwitchCase]=\"0\">\n        <button type=\"button\" class=\"btn btn-outline\" (click)=\"cancel()\">{{'BUTTON.CANCEL' | translate}}</button>\n        <button type=\"button\" class=\"btn btn-primary\" (click)=\"confirm()\">{{'BUTTON.CONFIRM' | translate}}</button>\n       </ng-template>\n       <ng-template [ngSwitchCase]=\"1\">\n        <button type=\"button\" class=\"btn btn-outline\" (click)=\"cancel()\">{{'BUTTON.NO' | translate}}</button>\n        <button type=\"button\" class=\"btn btn-primary\" (click)=\"confirm()\">{{ 'BUTTON.YES' | translate}}</button>\n       </ng-template>\n       <ng-template [ngSwitchCase]=\"2\">\n        <button type=\"button\" class=\"btn btn-outline\" (click)=\"cancel()\" [hidden]=\"isDelete\">{{'BUTTON.CANCEL' | translate}}</button>\n         <button type=\"button\" class=\"btn btn-danger\" (click)=\"operate()\" [hidden]=\"isDelete\">{{'BUTTON.DELETE' | translate}}</button>\n        <button type=\"button\" class=\"btn btn-primary\" (click)=\"cancel()\" [disabled]=\"!batchOverStatus\"  [hidden]=\"!isDelete\">{{'BUTTON.CLOSE' | translate}}</button>\n       </ng-template>\n       <ng-template [ngSwitchCase]=\"3\">\n        <button type=\"button\" class=\"btn btn-primary\" (click)=\"cancel()\">{{'BUTTON.CLOSE' | translate}}</button>\n       </ng-template>\n       <ng-template [ngSwitchCase]=\"4\">\n        <button type=\"button\" class=\"btn btn-outline\" (click)=\"cancel()\" [hidden]=\"isDelete\">{{'BUTTON.CANCEL' | translate}}</button>\n         <button type=\"button\" class=\"btn btn-primary\" (click)=\"operate()\" [hidden]=\"isDelete\">{{'BUTTON.REPLICATE' | translate}}</button>\n        <button type=\"button\" class=\"btn btn-primary\" (click)=\"cancel()\" [disabled]=\"!batchOverStatus\"  [hidden]=\"!isDelete\">{{'BUTTON.CLOSE' | translate}}</button>\n       </ng-template>\n    </div>\n</clr-modal>\n";

var CONFIRMATION_DIALOG_STYLE = "\n.confirmation-icon-inline {\n    display: inline-block;\n}\n\n.confirmation-title {\n    line-height: 24px;\n    color: #000000;\n    font-size: 22px;\n}\n\n.confirmation-content {\n    font-size: 14px;\n    color: #565656;\n    line-height: 24px;\n    display: inline-block;\n    vertical-align: middle;\n    width: 80%;\n    white-space: pre-wrap;\n}\n.batchInfoUl{\n    padding: 20px; list-style-type: none;\n}\n.batchInfoUl li {line-height: 24px;border-bottom: 1px solid #e8e8e8;}\n.batchInfoUl li span:first-child {padding-right: 20px; width: 240px; display: inline-block; color:#666;  \n  text-overflow: ellipsis; overflow: hidden; vertical-align: middle;}\n.batchInfoUl li span:last-child {width: 220px; display: inline-block;  color:#666;}\n.batchInfoUl li span i {display: inline-block; line-height: 1.2em; font-size: 0.8em; color: #999;}\n.batchInfoUl li span a{cursor: pointer; text-decoration: underline;}\n";

// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//    http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var ConfirmationDialogComponent = (function () {
    function ConfirmationDialogComponent(translate) {
        this.translate = translate;
        this.opened = false;
        this.dialogTitle = '';
        this.dialogContent = '';
        this.confirmAction = new _angular_core.EventEmitter();
        this.cancelAction = new _angular_core.EventEmitter();
        this.batchInfors = [];
        this.isDelete = false;
    }
    ConfirmationDialogComponent.prototype.open = function (msg) {
        var _this = this;
        this.dialogTitle = msg.title;
        this.dialogContent = msg.message;
        this.message = msg;
        this.translate.get(this.dialogTitle).subscribe(function (res) { return _this.dialogTitle = res; });
        this.translate.get(this.dialogContent, { 'param': msg.param }).subscribe(function (res) { return _this.dialogContent = res; });
        // Open dialog
        this.buttons = msg.buttons;
        this.opened = true;
    };
    Object.defineProperty(ConfirmationDialogComponent.prototype, "batchOverStatus", {
        get: function () {
            if (this.batchInfors.length) {
                return this.batchInfors.every(function (item) { return item.loading === false; });
            }
            return false;
        },
        enumerable: true,
        configurable: true
    });
    ConfirmationDialogComponent.prototype.colorChange = function (list) {
        if (!list.loading && !list.errorState) {
            return 'green';
        }
        else if (!list.loading && list.errorState) {
            return 'red';
        }
        else {
            return '#666';
        }
    };
    ConfirmationDialogComponent.prototype.toggleErrorTitle = function (errorSpan) {
        errorSpan.style.display = (errorSpan.style.display === 'none') ? 'block' : 'none';
    };
    ConfirmationDialogComponent.prototype.close = function () {
        this.batchInfors = [];
        this.opened = false;
    };
    ConfirmationDialogComponent.prototype.cancel = function () {
        if (!this.message) {
            // Inproper condition
            this.close();
            return;
        }
        var data = this.message.data ? this.message.data : {};
        var target = this.message.targetId ? this.message.targetId : 0;
        this.cancelAction.emit(new ConfirmationAcknowledgement(2 /* CANCEL */, data, target));
        this.isDelete = false;
        this.close();
    };
    ConfirmationDialogComponent.prototype.operate = function () {
        if (!this.message) {
            this.close();
            return;
        }
        if (this.batchInfors.length) {
            this.batchInfors.every(function (item) { return item.loading = true; });
            this.isDelete = true;
        }
        var data = this.message.data ? this.message.data : {};
        var target = this.message.targetId ? this.message.targetId : 0;
        var message = new ConfirmationAcknowledgement(1 /* CONFIRMED */, data, target);
        this.confirmAction.emit(message);
    };
    ConfirmationDialogComponent.prototype.confirm = function () {
        if (!this.message) {
            this.close();
            return;
        }
        var data = this.message.data ? this.message.data : {};
        var target = this.message.targetId ? this.message.targetId : 0;
        var message = new ConfirmationAcknowledgement(1 /* CONFIRMED */, data, target);
        this.confirmAction.emit(message);
        this.close();
    };
    return ConfirmationDialogComponent;
}());
ConfirmationDialogComponent.decorators = [
    { type: _angular_core.Component, args: [{
                selector: 'confirmation-dialog',
                template: CONFIRMATION_DIALOG_TEMPLATE,
                styles: [CONFIRMATION_DIALOG_STYLE]
            },] },
];
/** @nocollapse */
ConfirmationDialogComponent.ctorParameters = function () { return [
    { type: _ngxTranslate_core.TranslateService, },
]; };
ConfirmationDialogComponent.propDecorators = {
    'confirmAction': [{ type: _angular_core.Output },],
    'cancelAction': [{ type: _angular_core.Output },],
    'batchInfors': [{ type: _angular_core.Input },],
};

var CONFIRMATION_DIALOG_DIRECTIVES = [
    ConfirmationDialogComponent
];

var INLINE_ALERT_DIRECTIVES = [
    InlineAlertComponent
];

var DATETIME_PICKER_TEMPLATE = "\n<clr-icon shape=\"date\"></clr-icon>\n<label aria-haspopup=\"true\" role=\"tooltip\" [class.invalid]=\"dateInvalid\" class=\"tooltip tooltip-validation tooltip-sm\">\n  <input type=\"date\" #searchTime=\"ngModel\" [(ngModel)]=\"dateInput\" name=\"searchTime\" placeholder=\"dd/mm/yyyy\" dateValidator (change)=\"doSearch()\">\n  <span *ngIf=\"dateInvalid\" class=\"tooltip-content\">\n    {{'AUDIT_LOG.INVALID_DATE' | translate }}\n  </span>\n</label>\n";

var DatePickerComponent = (function () {
    function DatePickerComponent() {
        this.search = new _angular_core.EventEmitter();
    }
    DatePickerComponent.prototype.ngOnChanges = function () {
        this.dateInput = this.dateInput.trim();
    };
    Object.defineProperty(DatePickerComponent.prototype, "dateInvalid", {
        get: function () {
            return (this.searchTime.errors && this.searchTime.errors.dateValidator && (this.searchTime.dirty || this.searchTime.touched)) || false;
        },
        enumerable: true,
        configurable: true
    });
    DatePickerComponent.prototype.convertDate = function (strDate) {
        if (/^(0[1-9]|[12][0-9]|3[01])[- /.](0[1-9]|1[012])[- /.](19|20)\d\d$/.test(strDate)) {
            var parts = strDate.split(/[-\/]/);
            strDate = parts[2] /*Year*/ + '-' + parts[1] /*Month*/ + '-' + parts[0] /*Date*/;
        }
        return strDate;
    };
    DatePickerComponent.prototype.doSearch = function () {
        var searchTerm = '';
        if (this.searchTime.valid && this.dateInput) {
            var timestamp = new Date(this.convertDate(this.searchTime.value)).getTime() / 1000;
            if (this.oneDayOffset) {
                timestamp += 3600 * 24;
            }
            searchTerm = timestamp.toString();
        }
        this.search.emit(searchTerm);
    };
    return DatePickerComponent;
}());
DatePickerComponent.decorators = [
    { type: _angular_core.Component, args: [{
                selector: 'hbr-datetime',
                template: DATETIME_PICKER_TEMPLATE
            },] },
];
/** @nocollapse */
DatePickerComponent.ctorParameters = function () { return []; };
DatePickerComponent.propDecorators = {
    'dateInput': [{ type: _angular_core.Input },],
    'oneDayOffset': [{ type: _angular_core.Input },],
    'searchTime': [{ type: _angular_core.ViewChild, args: ['searchTime',] },],
    'search': [{ type: _angular_core.Output },],
};

// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//    http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var DateValidatorDirective = (function () {
    function DateValidatorDirective() {
        this.valFn = _angular_forms.Validators.nullValidator;
    }
    DateValidatorDirective.prototype.ngOnChanges = function (changes) {
        var change = changes['dateValidator'];
        if (change) {
            this.valFn = dateValidator();
        }
        else {
            this.valFn = _angular_forms.Validators.nullValidator;
        }
    };
    DateValidatorDirective.prototype.validate = function (control) {
        return this.valFn(control) || _angular_forms.Validators.nullValidator;
    };
    return DateValidatorDirective;
}());
DateValidatorDirective.decorators = [
    { type: _angular_core.Directive, args: [{
                selector: '[dateValidator]',
                providers: [{ provide: _angular_forms.NG_VALIDATORS, useExisting: DateValidatorDirective, multi: true }]
            },] },
];
/** @nocollapse */
DateValidatorDirective.ctorParameters = function () { return []; };
DateValidatorDirective.propDecorators = {
    'dateValidator': [{ type: _angular_core.Input },],
};
function dateValidator() {
    return function (control) {
        var controlValue = control.value;
        var valid = true;
        if (controlValue) {
            var regYMD = /^(19|20)\d\d([- /.])(0[1-9]|1[012])\2(0[1-9]|[12][0-9]|3[01])$/g;
            var regDMY = /^(0[1-9]|[12][0-9]|3[01])[- /.](0[1-9]|1[012])[- /.](19|20)\d\d$/g;
            valid = (regYMD.test(controlValue) || regDMY.test(controlValue));
        }
        return valid ? _angular_forms.Validators.nullValidator : { 'dateValidator': { value: controlValue } };
    };
}

var DATETIME_PICKER_DIRECTIVES = [
    DatePickerComponent,
    DateValidatorDirective
];

var TIP_COMPONENT_HTML = "\n<div class=\"tip-wrapper tip-position\" [style.width]='maxWidth'>\n    <clr-tooltip>\n        <div clrTooltipTrigger>\n        <div class=\"tip-wrapper tip-block bar-block-high\" [style.width]='tipWidth(5)'></div>\n        <div class=\"tip-wrapper tip-block bar-block-medium\" [style.width]='tipWidth(4)'></div>\n        <div class=\"tip-wrapper tip-block bar-block-low\" [style.width]='tipWidth(3)'></div>\n        <div class=\"tip-wrapper tip-block bar-block-unknown\" [style.width]='tipWidth(2)'></div>\n        <div class=\"tip-wrapper tip-block bar-block-none\" [style.width]='tipWidth(1)'></div>\n        </div>\n        <clr-tooltip-content [clrPosition]=\"'top-right'\" [clrSize]=\"'lg'\" *clrIfOpen>\n            <div [ngSwitch]=\"scanLevel\" class=\"bar-tooltip-font-larger\">\n                <ng-template [ngSwitchCase]=\"5\">\n                    <clr-icon shape=\"exclamation-circle\" class=\"is-error\" size=\"32\"></clr-icon>\n                    <span>{{'VULNERABILITY.OVERALL_SEVERITY' | translate }} <span class=\"font-weight-600\">{{'VULNERABILITY.SEVERITY.HIGH' | translate | titlecase }}</span></span>\n                </ng-template>\n                <ng-template [ngSwitchCase]=\"4\">\n                    <clr-icon *ngIf=\"hasMedium\" shape=\"exclamation-triangle\" class=\"tip-icon-medium\" size=\"30\"></clr-icon>\n                    <span>{{'VULNERABILITY.OVERALL_SEVERITY' | translate }} <span class=\"font-weight-600\">{{'VULNERABILITY.SEVERITY.MEDIUM' | translate | titlecase}}</span></span>\n                </ng-template>\n                <ng-template [ngSwitchCase]=\"3\">\n                    <clr-icon shape=\"play\" class=\"tip-icon-low rotate-90\" size=\"28\"></clr-icon>\n                    <span>{{'VULNERABILITY.OVERALL_SEVERITY' | translate }} <span class=\"font-weight-600\">{{'VULNERABILITY.SEVERITY.LOW' | translate | titlecase }}</span></span>\n                </ng-template>\n                <ng-template [ngSwitchCase]=\"2\">\n                    <clr-icon shape=\"help\" size=\"24\" style=\"margin-left: 3px;\"></clr-icon>\n                    <span>{{'VULNERABILITY.OVERALL_SEVERITY' | translate }} <span class=\"font-weight-600\">{{'VULNERABILITY.SEVERITY.UNKNOWN' | translate | titlecase }}</span></span>\n                </ng-template>\n                <ng-template [ngSwitchCase]=\"1\">\n                    <clr-icon shape=\"check-circle\"  class=\"is-success\" size=\"32\"></clr-icon>\n                    <span>{{'VULNERABILITY.NO_VULNERABILITY' | translate }}</span>\n                </ng-template>\n            </div>\n            <hr>\n            <div>\n                <span class=\"bar-tooltip-font bar-tooltip-font-title\">{{tipTitle}}</span>\n            </div>\n            <div class=\"bar-summary bar-tooltip-fon\">\n                <div *ngIf=\"hasHigh\" class=\"bar-summary-item\">\n                    <span><clr-icon shape=\"exclamation-circle\" class=\"is-error\" size=\"24\"></clr-icon></span>\n                    <span>{{highCount}}</span><span>{{'VULNERABILITY.SEVERITY.HIGH' | translate }}</span>\n                </div>\n                <div *ngIf=\"hasMedium\" class=\"bar-summary-item\">\n                    <span><clr-icon *ngIf=\"hasMedium\" shape=\"exclamation-triangle\" class=\"tip-icon-medium\" size=\"22\"></clr-icon></span>\n                    <span>{{mediumCount}}</span><span>{{'VULNERABILITY.SEVERITY.MEDIUM' | translate }}</span>\n                </div>\n                <div *ngIf=\"hasLow\" class=\"bar-summary-item\">\n                    <span><clr-icon shape=\"play\" class=\"tip-icon-low rotate-90\" size=\"20\"></clr-icon></span>\n                    <span>{{lowCount}}</span><span>{{'VULNERABILITY.SEVERITY.LOW' | translate }}</span>\n                </div>\n                <div *ngIf=\"hasUnknown\" class=\"bar-summary-item\">\n                    <span><clr-icon shape=\"help\" size=\"18\"></clr-icon></span>\n                    <span>{{unknownCount}}</span><span>{{'VULNERABILITY.SEVERITY.UNKNOWN' | translate }}</span>\n                </div>\n                <div *ngIf=\"hasNone\" class=\"bar-summary-item\">\n                    <span><clr-icon shape=\"check-circle\" class=\"is-success\" size=\"24\"></clr-icon></span>\n                    <span>{{noneCount}}</span><span>{{'VULNERABILITY.SEVERITY.NONE' | translate }}</span>\n                </div>\n            </div>\n            <div>\n                <span class=\"bar-scanning-time\">{{'VULNERABILITY.CHART.SCANNING_TIME' | translate}} </span>\n                <span>{{completeTimestamp | date:'MM/dd/y HH:mm:ss'}}</span>\n            </div>\n        </clr-tooltip-content>\n    </clr-tooltip>\n</div>\n";
var GRID_COMPONENT_HTML = "\n<div class=\"row\"  style=\"position:relative;\">\n  <div>  \n    <div class=\"row flex-items-xs-right rightPos\">\n      <div class=\"flex-xs-middle option-right\">\n        <hbr-filter [withDivider]=\"true\" filterPlaceholder=\"{{'VULNERABILITY.PLACEHOLDER' | translate}}\" (filter)=\"filterVulnerabilities($event)\"></hbr-filter>  \n        <span class=\"refresh-btn\" (click)=\"refresh()\"><clr-icon shape=\"refresh\"></clr-icon></span>\n      </div>\n    </div>\n  </div>\n  <div class=\"col-lg-12 col-md-12 col-sm-12 col-xs-12\">\n    <clr-datagrid>\n        <clr-dg-action-bar>\n          <button type=\"button\" class=\"btn btn-sm btn-secondary\" (click)=\"scanNow()\"><clr-icon shape=\"shield-check\" size=\"16\"></clr-icon>&nbsp;{{'VULNERABILITY.SCAN_NOW' | translate}}</button>\n        </clr-dg-action-bar>\n        <clr-dg-column [clrDgField]=\"'id'\">{{'VULNERABILITY.GRID.COLUMN_ID' | translate}}</clr-dg-column>\n        <clr-dg-column [clrDgField]=\"'severity'\">{{'VULNERABILITY.GRID.COLUMN_SEVERITY' | translate}}</clr-dg-column>\n        <clr-dg-column [clrDgField]=\"'package'\">{{'VULNERABILITY.GRID.COLUMN_PACKAGE' | translate}}</clr-dg-column>\n        <clr-dg-column [clrDgField]=\"'version'\">{{'VULNERABILITY.GRID.COLUMN_VERSION' | translate}}</clr-dg-column>\n        <clr-dg-column [clrDgField]=\"'fixedVersion'\">{{'VULNERABILITY.GRID.COLUMN_FIXED' | translate}}</clr-dg-column>\n\n        <clr-dg-placeholder>{{'VULNERABILITY.GRID.PLACEHOLDER' | translate}}</clr-dg-placeholder>\n        <clr-dg-row *clrDgItems=\"let res of scanningResults\">\n            <clr-dg-cell><a href=\"{{res.link}}\" target=\"_blank\">{{res.id}}</a></clr-dg-cell>\n            <clr-dg-cell [ngSwitch]=\"res.severity\">\n              <span *ngSwitchCase=\"5\" class=\"label label-danger\">{{severityText(res.severity) | translate}}</span>\n              <span *ngSwitchCase=\"4\" class=\"label label-medium\">{{severityText(res.severity) | translate}}</span>\n              <span *ngSwitchCase=\"3\" class=\"label label-low\">{{severityText(res.severity) | translate}}</span>\n              <span *ngSwitchCase=\"1\" class=\"label\">{{severityText(res.severity) | translate}}</span>\n              <span *ngSwitchDefault>{{severityText(res.severity) | translate}}</span>\n            </clr-dg-cell>\n            <clr-dg-cell>{{res.package}}</clr-dg-cell>\n            <clr-dg-cell>{{res.version}}</clr-dg-cell>\n            <clr-dg-cell>\n                 <div *ngIf=\"res.fixedVersion; else elseBlock\">\n                    <clr-icon shape=\"wrench\" class=\"is-success\" size=\"20\"></clr-icon>&nbsp;<span class=\"font-color-green\">{{res.fixedVersion}}</span>\n                 </div>\n                <ng-template #elseBlock>{{res.fixedVersion}}</ng-template>\n            </clr-dg-cell>\n            <clr-dg-row-detail *clrIfExpanded>\n            {{'VULNERABILITY.GRID.COLUMN_DESCRIPTION' | translate}}: {{res.description}}\n            </clr-dg-row-detail>\n        </clr-dg-row>\n\n        <clr-dg-footer>\n            <span *ngIf=\"pagination.totalItems\">{{pagination.firstItem + 1}} - {{pagination.lastItem + 1}} {{'VULNERABILITY.GRID.FOOT_OF' | translate}}</span>\n             {{pagination.totalItems}} {{'VULNERABILITY.GRID.FOOT_ITEMS' | translate}}\n            <clr-dg-pagination #pagination [clrDgPageSize]=\"25\" [clrDgTotalItems]=\"scanningResults.length\"></clr-dg-pagination>\n        </clr-dg-footer>\n    </clr-datagrid>\n  </div>\n</div>\n";
var BAR_CHART_COMPONENT_HTML = "\n<div class=\"bar-wrapper\">\n    <div *ngIf=\"stopped\" class=\"bar-state\">\n       <span class=\"label\">{{'VULNERABILITY.STATE.STOPPED' | translate}}</span>\n    </div>\n    <div *ngIf=\"queued\" class=\"bar-state\">\n        <span class=\"label label-orange\">{{'VULNERABILITY.STATE.QUEUED' | translate}}</span>\n    </div>\n    <div *ngIf=\"error\" class=\"bar-state bar-state-error\">\n        <a href=\"javascript:void(0);\" class=\"error-text\" (click)=\"viewLog()\">\n            <clr-icon shape=\"error\" class=\"is-error\" size=\"24\"></clr-icon>\n            {{'VULNERABILITY.STATE.ERROR' | translate}}\n        </a>\n    </div>\n    <div *ngIf=\"scanning\" class=\"bar-state bar-state-chart\">\n        <div>{{'VULNERABILITY.STATE.SCANNING' | translate}}</div>\n        <div class=\"progress loop\" style=\"height:2px;\"><progress></progress></div>\n    </div>\n    <div *ngIf=\"completed\" class=\"bar-state bar-state-chart\">\n        <hbr-vulnerability-summary-chart [summary]=\"summary\"></hbr-vulnerability-summary-chart>\n    </div>\n    <div *ngIf=\"unknown\" class=\"bar-state\">\n        <clr-icon shape=\"warning\" class=\"is-warning\" size=\"24\"></clr-icon>\n        <span style=\"margin-left:-5px;\">{{'VULNERABILITY.STATE.UNKNOWN' | translate}}</span>\n    </div>\n    <job-log-viewer #scanningLogViewer [jobType]=\"'scan'\"></job-log-viewer>\n</div>\n";

var SCANNING_STYLES = "\n.bar-wrapper {\n    width: 120px;\n    height: 12px;\n}\n.bar-state {\n    text-align: center !important;\n}\n\n.bar-state-chart {\n    margin-top: 2px;\n}\n\n.bar-state-error {\n    position: relative;\n    top: -4px;\n}\n\n.error-text {\n    position: relative;\n    top: 1px;\n    margin-left: -5px;\n    cursor: pointer;\n}\n\n.scanning-button {\n    height: 24px;\n    margin-top: 0px;\n    margin-bottom: 0px;\n    vertical-align: middle;\n    top: -12px;\n    position: relative;\n}\n.tip-wrapper {\n    display: inline-block;\n    height: 10px;\n    max-width: 120px;\n}\n.tip-position {\n    margin-left: -4px;\n}\n.tip-block {\n    margin-left: -3px;\n}\n.bar-block-high {\n    background-color: #e62700;\n}\n.bar-block-medium {\n    background-color: orange;\n}\n.bar-block-low {\n    background-color: yellow;\n}\n.bar-block-none {\n    background-color: green;\n}\n.bar-block-unknown {\n    background-color: grey;\n}\n.bar-tooltip-font {\n    font-size: 13px;\n    color: #ffffff;\n}\n.bar-tooltip-font-title {\n    font-weight: 600;\n}\n.bar-summary {\n    margin-top: 12px;\n    text-align: left;\n}\n.bar-scanning-time {\n    margin-top: 12px;\n}\n.bar-summary-item {\n    margin-top: 3px;\n    margin-bottom: 3px;\n}\n.bar-summary-item span:nth-child(1){\n    width: 30px;\n    text-align: center;\n    display: inline-block;\n}\n.bar-summary-item span:nth-child(2){\n    width: 28px;\n    display: inline-block;\n}\n\n.option-right {\n  padding-right: 16px;\n}\n.refresh-btn {\n    cursor: pointer;\n}\n.refresh-btn:hover {\n    color: #007CBB;\n}\n\n.label.label-medium{\n      background-color: #ffe4a9;\n    border: 1px solid orange;\n    color: orange;\n}\n.tip-icon-medium {\n    color: orange;\n}\n.label.label-low{\n    background: rgba(251, 255, 0, 0.38);\n    color: #c5c50b;\n    border: 1px solid #e6e63f;\n}\n.tip-icon-low {\n    color: yellow;\n}\n.font-color-green{\n    color:green;\n}\n.bar-tooltip-font-larger span{\n    font-size:16px;\n    vertical-align:middle\n}\nhr{\n    border-bottom: 0;\n    border-color: #aaa;\n    margin: 6px -10px;\n}\n.font-weight-600{\n    font-weight:600;\n}\n.rightPos{\n    position: absolute;\n    z-index: 100;\n    right: 35px;\n    margin-top: 4px;\n}\n";

var ResultGridComponent = (function () {
    function ResultGridComponent(scanningService, channel, errorHandler) {
        this.scanningService = scanningService;
        this.channel = channel;
        this.errorHandler = errorHandler;
        this.scanningResults = [];
        this.dataCache = [];
    }
    ResultGridComponent.prototype.ngOnInit = function () {
        this.loadResults(this.repositoryId, this.tagId);
    };
    ResultGridComponent.prototype.loadResults = function (repositoryId, tagId) {
        var _this = this;
        toPromise(this.scanningService.getVulnerabilityScanningResults(repositoryId, tagId))
            .then(function (results) {
            _this.dataCache = results;
            _this.scanningResults = _this.dataCache.filter(function (item) { return item.id !== ''; });
        })
            .catch(function (error) { _this.errorHandler.error(error); });
    };
    //TODO: Should query from back-end service
    ResultGridComponent.prototype.filterVulnerabilities = function (terms) {
        var _this = this;
        if (terms.trim() === '') {
            this.scanningResults = this.dataCache.filter(function (item) { return item.id !== ''; });
        }
        else {
            this.scanningResults = this.dataCache.filter(function (item) { return _this._regexpFilter(terms, item.package); });
        }
    };
    ResultGridComponent.prototype.refresh = function () {
        this.loadResults(this.repositoryId, this.tagId);
    };
    ResultGridComponent.prototype.severityText = function (severity) {
        switch (severity) {
            case exports.VulnerabilitySeverity.HIGH:
                return 'VULNERABILITY.SEVERITY.HIGH';
            case exports.VulnerabilitySeverity.MEDIUM:
                return 'VULNERABILITY.SEVERITY.MEDIUM';
            case exports.VulnerabilitySeverity.LOW:
                return 'VULNERABILITY.SEVERITY.LOW';
            case exports.VulnerabilitySeverity.NONE:
                return 'VULNERABILITY.SEVERITY.NEGLIGIBLE';
            case exports.VulnerabilitySeverity.UNKNOWN:
                return 'VULNERABILITY.SEVERITY.UNKNOWN';
            default:
                return 'UNKNOWN';
        }
    };
    ResultGridComponent.prototype._regexpFilter = function (terms, testedValue) {
        var reg = new RegExp('.*' + terms + '.*', 'i');
        return reg.test(testedValue);
    };
    ResultGridComponent.prototype.scanNow = function () {
        this.channel.publishScanEvent(this.repositoryId + "/" + this.tagId);
    };
    return ResultGridComponent;
}());
ResultGridComponent.decorators = [
    { type: _angular_core.Component, args: [{
                selector: 'hbr-vulnerabilities-grid',
                styles: [SCANNING_STYLES],
                template: GRID_COMPONENT_HTML
            },] },
];
/** @nocollapse */
ResultGridComponent.ctorParameters = function () { return [
    { type: ScanningResultService, },
    { type: ChannelService, },
    { type: ErrorHandler, },
]; };
ResultGridComponent.propDecorators = {
    'tagId': [{ type: _angular_core.Input },],
    'repositoryId': [{ type: _angular_core.Input },],
};

var STATE_CHECK_INTERVAL = 2000; //2s
var RETRY_TIMES = 3;
var ResultBarChartComponent = (function () {
    function ResultBarChartComponent(tagService, scanningService, errorHandler, channel, ref) {
        this.tagService = tagService;
        this.scanningService = scanningService;
        this.errorHandler = errorHandler;
        this.channel = channel;
        this.ref = ref;
        this.repoName = "";
        this.tagId = "";
        this.onSubmitting = false;
        this.retryCounter = 0;
    }
    ResultBarChartComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.scanSubscription = this.channel.scanCommand$.subscribe(function (tagId) {
            var myFullTag = _this.repoName + "/" + _this.tagId;
            if (myFullTag === tagId) {
                _this.scanNow();
            }
        });
    };
    ResultBarChartComponent.prototype.ngOnDestroy = function () {
        if (this.stateCheckTimer) {
            this.stateCheckTimer.unsubscribe();
            this.stateCheckTimer = null;
        }
        if (this.scanSubscription) {
            this.scanSubscription.unsubscribe();
        }
        
    };
    Object.defineProperty(ResultBarChartComponent.prototype, "status", {
        //Get vulnerability scanning status 
        get: function () {
            if (this.summary && this.summary.scan_status) {
                return this.summary.scan_status;
            }
            return VULNERABILITY_SCAN_STATUS.stopped;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ResultBarChartComponent.prototype, "completed", {
        get: function () {
            return this.status === VULNERABILITY_SCAN_STATUS.finished;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ResultBarChartComponent.prototype, "error", {
        get: function () {
            return this.status === VULNERABILITY_SCAN_STATUS.error;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ResultBarChartComponent.prototype, "queued", {
        get: function () {
            return this.status === VULNERABILITY_SCAN_STATUS.pending;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ResultBarChartComponent.prototype, "scanning", {
        get: function () {
            return this.status === VULNERABILITY_SCAN_STATUS.running;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ResultBarChartComponent.prototype, "stopped", {
        get: function () {
            return this.status === VULNERABILITY_SCAN_STATUS.stopped;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ResultBarChartComponent.prototype, "unknown", {
        get: function () {
            return this.status === VULNERABILITY_SCAN_STATUS.unknown;
        },
        enumerable: true,
        configurable: true
    });
    ResultBarChartComponent.prototype.scanNow = function () {
        var _this = this;
        if (this.onSubmitting) {
            //Avoid duplicated submitting
            return;
        }
        if (!this.repoName || !this.tagId) {
            return;
        }
        this.onSubmitting = true;
        toPromise(this.scanningService.startVulnerabilityScanning(this.repoName, this.tagId))
            .then(function () {
            _this.onSubmitting = false;
            //Forcely change status to queued after successful submitting
            _this.summary.scan_status = VULNERABILITY_SCAN_STATUS.pending;
            //Forcely refresh view 
            _this.forceRefreshView(1000);
            //Start check status util the job is done
            if (!_this.stateCheckTimer) {
                //Avoid duplicated subscribing
                _this.stateCheckTimer = rxjs_Rx.Observable.timer(STATE_CHECK_INTERVAL, STATE_CHECK_INTERVAL).subscribe(function () {
                    _this.getSummary();
                });
            }
        })
            .catch(function (error) {
            _this.onSubmitting = false;
            _this.errorHandler.error(error);
        });
    };
    ResultBarChartComponent.prototype.getSummary = function () {
        var _this = this;
        if (!this.repoName || !this.tagId) {
            return;
        }
        toPromise(this.tagService.getTag(this.repoName, this.tagId))
            .then(function (t) {
            //To keep the same summary reference, use value copy.
            _this.copyValue(t.scan_overview);
            //Forcely refresh view 
            _this.forceRefreshView(1000);
            if (!_this.queued && !_this.scanning) {
                //Scanning should be done
                if (_this.stateCheckTimer) {
                    _this.stateCheckTimer.unsubscribe();
                    _this.stateCheckTimer = null;
                }
            }
        })
            .catch(function (error) {
            _this.errorHandler.error(error);
            _this.retryCounter++;
            if (_this.retryCounter >= RETRY_TIMES) {
                //Stop timer
                if (_this.stateCheckTimer) {
                    _this.stateCheckTimer.unsubscribe();
                    _this.stateCheckTimer = null;
                }
                _this.retryCounter = 0;
            }
        });
    };
    ResultBarChartComponent.prototype.copyValue = function (newVal) {
        if (!newVal || !newVal.scan_status) {
            return;
        }
        this.summary.scan_status = newVal.scan_status;
        this.summary.job_id = newVal.job_id;
        this.summary.severity = newVal.severity;
        this.summary.components = newVal.components;
        this.summary.update_time = newVal.update_time;
    };
    ResultBarChartComponent.prototype.forceRefreshView = function (duration) {
        var _this = this;
        //Reset timer
        if (this.timerHandler) {
            clearInterval(this.timerHandler);
        }
        this.timerHandler = setInterval(function () { return _this.ref.markForCheck(); }, 100);
        setTimeout(function () {
            if (_this.timerHandler) {
                clearInterval(_this.timerHandler);
                _this.timerHandler = null;
            }
        }, duration);
    };
    //Check error log
    ResultBarChartComponent.prototype.viewLog = function () {
        if (this.summary && this.summary.job_id) {
            this.scanningJobLogViewer.open(this.summary.job_id);
        }
    };
    return ResultBarChartComponent;
}());
ResultBarChartComponent.decorators = [
    { type: _angular_core.Component, args: [{
                selector: 'hbr-vulnerability-bar',
                styles: [SCANNING_STYLES],
                template: BAR_CHART_COMPONENT_HTML
            },] },
];
/** @nocollapse */
ResultBarChartComponent.ctorParameters = function () { return [
    { type: TagService, },
    { type: ScanningResultService, },
    { type: ErrorHandler, },
    { type: ChannelService, },
    { type: _angular_core.ChangeDetectorRef, },
]; };
ResultBarChartComponent.propDecorators = {
    'repoName': [{ type: _angular_core.Input },],
    'tagId': [{ type: _angular_core.Input },],
    'summary': [{ type: _angular_core.Input },],
    'scanningJobLogViewer': [{ type: _angular_core.ViewChild, args: ["scanningLogViewer",] },],
};

var MIN_TIP_WIDTH = 5;
var MAX_TIP_WIDTH = 100;
var ResultTipComponent = (function () {
    function ResultTipComponent(translate) {
        this.translate = translate;
        this._tipTitle = "";
        this._highCount = 0;
        this._mediumCount = 0;
        this._lowCount = 0;
        this._unknownCount = 0;
        this._noneCount = 0;
        this.totalPackages = 0;
        this.packagesWithVul = 0;
        this.summary = {
            scan_status: VULNERABILITY_SCAN_STATUS.unknown,
            severity: exports.VulnerabilitySeverity.UNKNOWN,
            update_time: new Date(),
            components: {
                total: 0,
                summary: []
            }
        };
    }
    Object.defineProperty(ResultTipComponent.prototype, "scanLevel", {
        get: function () {
            var level;
            if (this._highCount && this._highCount >= 1) {
                level = exports.VulnerabilitySeverity.HIGH;
            }
            else if (this._mediumCount && this._mediumCount >= 1) {
                level = exports.VulnerabilitySeverity.MEDIUM;
            }
            else if (this._lowCount && this._lowCount >= 1) {
                level = exports.VulnerabilitySeverity.LOW;
            }
            else if (this._unknownCount && this._unknownCount >= 1) {
                level = exports.VulnerabilitySeverity.UNKNOWN;
            }
            else if (this.totalPackages == 0) {
                level = exports.VulnerabilitySeverity.UNKNOWN;
            }
            else {
                level = exports.VulnerabilitySeverity.NONE;
            }
            return level;
        },
        enumerable: true,
        configurable: true
    });
    ResultTipComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.totalPackages = this.summary && this.summary.components ? this.summary.components.total : 0;
        if (this.summary && this.summary.components && this.summary.components.summary) {
            this.summary.components.summary.forEach(function (item) {
                if (item.severity != exports.VulnerabilitySeverity.NONE) {
                    _this.packagesWithVul += item.count;
                }
                switch (item.severity) {
                    case exports.VulnerabilitySeverity.UNKNOWN:
                        _this._unknownCount += item.count;
                        break;
                    case exports.VulnerabilitySeverity.NONE:
                        _this._noneCount += item.count;
                        break;
                    case exports.VulnerabilitySeverity.LOW:
                        _this._lowCount += item.count;
                        break;
                    case exports.VulnerabilitySeverity.MEDIUM:
                        _this._mediumCount += item.count;
                        break;
                    case exports.VulnerabilitySeverity.HIGH:
                        _this._highCount += item.count;
                        break;
                    default:
                        break;
                }
            });
        }
        this.translate.get(this.packageText(this.totalPackages)).subscribe(function (p1) {
            _this.translate.get(_this.unitText(_this.packagesWithVul)).subscribe(function (vul) {
                if (_this.totalPackages === 0) {
                    _this.translate.get('VULNERABILITY.CHART.TOOLTIPS_TITLE_ZERO').subscribe(function (res) {
                        _this._tipTitle = res;
                    });
                }
                else {
                    var messageKey = 'VULNERABILITY.CHART.TOOLTIPS_TITLE_SINGULAR';
                    if (_this.packagesWithVul > 1) {
                        messageKey = 'VULNERABILITY.CHART.TOOLTIPS_TITLE';
                    }
                    _this.translate.get(messageKey, {
                        totalVulnerability: _this.packagesWithVul,
                        totalPackages: _this.totalPackages,
                        package: p1,
                        vulnerability: vul
                    }).subscribe(function (res) { return _this._tipTitle = res; });
                }
            });
        });
    };
    ResultTipComponent.prototype.tipWidth = function (severity) {
        var n = 0;
        var m = this.totalPackages;
        if (m === 0) {
            //If no packages recognized, then show grey
            if (severity === exports.VulnerabilitySeverity.UNKNOWN) {
                return MAX_TIP_WIDTH + 'px';
            }
            else {
                return 0 + 'px';
            }
        }
        switch (severity) {
            case exports.VulnerabilitySeverity.HIGH:
                n = this.highCount;
                break;
            case exports.VulnerabilitySeverity.MEDIUM:
                n = this.mediumCount;
                break;
            case exports.VulnerabilitySeverity.LOW:
                n = this.lowCount;
                break;
            case exports.VulnerabilitySeverity.UNKNOWN:
                n = this.unknownCount;
                break;
            case exports.VulnerabilitySeverity.NONE:
                //Show all the left as green bar
                n = m - (this.highCount + this.mediumCount + this.lowCount + this.unknownCount);
                if (n < 0) {
                    n = 0;
                }
                break;
            default:
                n = 0;
                break;
        }
        var width = Math.round((n / m) * MAX_TIP_WIDTH);
        if (width > 0 && width < MIN_TIP_WIDTH) {
            width = MIN_TIP_WIDTH;
        }
        return width + 'px';
    };
    ResultTipComponent.prototype.unitText = function (count) {
        if (count > 1) {
            return "VULNERABILITY.PLURAL";
        }
        return "VULNERABILITY.SINGULAR";
    };
    ResultTipComponent.prototype.packageText = function (count) {
        return count > 1 ? "VULNERABILITY.PACKAGES" : "VULNERABILITY.PACKAGE";
    };
    Object.defineProperty(ResultTipComponent.prototype, "completeTimestamp", {
        get: function () {
            return this.summary && this.summary.update_time ? this.summary.update_time : new Date();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ResultTipComponent.prototype, "hasHigh", {
        get: function () {
            return this.highCount > 0;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ResultTipComponent.prototype, "hasMedium", {
        get: function () {
            return this.mediumCount > 0;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ResultTipComponent.prototype, "hasLow", {
        get: function () {
            return this.lowCount > 0;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ResultTipComponent.prototype, "hasUnknown", {
        get: function () {
            return this.unknownCount > 0;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ResultTipComponent.prototype, "hasNone", {
        get: function () {
            return this.noneCount > 0;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ResultTipComponent.prototype, "tipTitle", {
        get: function () {
            return this._tipTitle;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ResultTipComponent.prototype, "highCount", {
        get: function () {
            return this._highCount;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ResultTipComponent.prototype, "mediumCount", {
        get: function () {
            return this._mediumCount;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ResultTipComponent.prototype, "lowCount", {
        get: function () {
            return this._lowCount;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ResultTipComponent.prototype, "unknownCount", {
        get: function () {
            return this._unknownCount;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ResultTipComponent.prototype, "noneCount", {
        get: function () {
            return this._noneCount;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ResultTipComponent.prototype, "highSuffix", {
        get: function () {
            return this.unitText(this.highCount);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ResultTipComponent.prototype, "mediumSuffix", {
        get: function () {
            return this.unitText(this.mediumCount);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ResultTipComponent.prototype, "lowSuffix", {
        get: function () {
            return this.unitText(this.lowCount);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ResultTipComponent.prototype, "unknownSuffix", {
        get: function () {
            return this.unitText(this.unknownCount);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ResultTipComponent.prototype, "noneSuffix", {
        get: function () {
            return this.unitText(this.noneCount);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ResultTipComponent.prototype, "maxWidth", {
        get: function () {
            return (MAX_TIP_WIDTH + 20) + "px";
        },
        enumerable: true,
        configurable: true
    });
    return ResultTipComponent;
}());
ResultTipComponent.decorators = [
    { type: _angular_core.Component, args: [{
                selector: 'hbr-vulnerability-summary-chart',
                template: TIP_COMPONENT_HTML,
                styles: [SCANNING_STYLES]
            },] },
];
/** @nocollapse */
ResultTipComponent.ctorParameters = function () { return [
    { type: _ngxTranslate_core.TranslateService, },
]; };
ResultTipComponent.propDecorators = {
    'summary': [{ type: _angular_core.Input },],
};

var VULNERABILITY_DIRECTIVES = [
    ResultGridComponent,
    ResultTipComponent,
    ResultBarChartComponent
];

var PUSH_IMAGE_STYLE = "\n.commands-container {\n    min-width: 360px;\n    max-width: 720px;\n    padding-left: 24px;\n}\n\n.h5-override {\n    display: inline-block !important;\n    margin-top: 0px !important;\n    margin-bottom: 12px;\n}\n\n.commands-section {\n    margin-top: 12px;\n    margin-bottom: 24px;\n}\n\n.info-tips-icon {\n    color: grey;\n}\n\n.info-tips-icon:hover {\n    color: #007CBB;\n    cursor: pointer;\n}\n\n.command-title {\n    font-size: 14px;\n    padding-left: 6px;\n}\n\n.command-input {\n    font-size: 14px;\n    font-weight: 500;\n}\n\n:host>>>.dropdown-menu {\n    min-width: 360px;\n    max-width: 720px;\n}\n\n.btn-font {\n    font-size: 14px !important;\n}\n.hide{\n    display:none;\n}\n";

var PUSH_IMAGE_HTML = "\n<div>\n    <clr-dropdown>\n        <button class=\"btn btn-link btn-font\" clrDropdownToggle (click)=\"onclick()\">\n            {{ 'PUSH_IMAGE.TITLE' | translate | uppercase}}\n            <clr-icon shape=\"caret down\"></clr-icon>\n        </button>\n        <clr-dropdown-menu *clrIfOpen [clrPosition]=\"'bottom-right'\" style=\"min-width:500px;\">\n            <div class=\"commands-container\">\n                <section>\n                    <span><h5 class=\"h5-override\">{{ 'PUSH_IMAGE.TITLE' | translate }}</h5></span>\n                    <span>\n                      <clr-tooltip>\n                        <clr-icon  clrTooltipTrigger shape=\"info-circle\" class=\"info-tips-icon\" size=\"24\"></clr-icon>\n                        <clr-tooltip-content [clrPosition]=\"'top-right'\" [clrSize]=\"'md'\" *clrIfOpen>\n                            {{ 'PUSH_IMAGE.TOOLTIP' | translate }}\n                        </clr-tooltip-content>\n                      </clr-tooltip>\n                    </span>\n                </section>\n                <section>\n                  <hbr-inline-alert #copyAlert></hbr-inline-alert>\n                </section>\n                <section>\n                    <article class=\"commands-section\">\n                        <hbr-copy-input #tagCopy (onCopyError)=\"onCpError($event)\" inputSize=\"50\" headerTitle=\"{{ 'PUSH_IMAGE.TAG_COMMAND' | translate }}\" defaultValue=\"{{tagCommand}}\"></hbr-copy-input>\n                    </article>\n                    <article class=\"commands-section\">\n                        <hbr-copy-input #pushCopy (onCopyError)=\"onCpError($event)\" inputSize=\"50\" headerTitle=\"{{ 'PUSH_IMAGE.PUSH_COMMAND' | translate }}\" defaultValue=\"{{pushCommand}}\"></hbr-copy-input>\n                    </article>\n                </section>\n            </div>\n        </clr-dropdown-menu>\n    </clr-dropdown>\n</div>\n";

var PushImageButtonComponent = (function () {
    function PushImageButtonComponent() {
        this.registryUrl = "unknown";
        this.projectName = "unknown";
    }
    Object.defineProperty(PushImageButtonComponent.prototype, "tagCommand", {
        get: function () {
            return "docker tag SOURCE_IMAGE[:TAG] " + this.registryUrl + "/" + this.projectName + "/IMAGE[:TAG]";
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PushImageButtonComponent.prototype, "pushCommand", {
        get: function () {
            return "docker push " + this.registryUrl + "/" + this.projectName + "/IMAGE[:TAG]";
        },
        enumerable: true,
        configurable: true
    });
    PushImageButtonComponent.prototype.onclick = function () {
        if (this.tagCopyInput) {
            this.tagCopyInput.reset();
        }
        if (this.pushCopyInput) {
            this.pushCopyInput.reset();
        }
        if (this.copyAlert) {
            this.copyAlert.close();
        }
    };
    PushImageButtonComponent.prototype.onCpError = function ($event) {
        if (this.copyAlert) {
            this.copyAlert.showInlineError("PUSH_IMAGE.COPY_ERROR");
        }
    };
    return PushImageButtonComponent;
}());
PushImageButtonComponent.decorators = [
    { type: _angular_core.Component, args: [{
                selector: 'hbr-push-image-button',
                template: PUSH_IMAGE_HTML,
                styles: [PUSH_IMAGE_STYLE],
                providers: []
            },] },
];
/** @nocollapse */
PushImageButtonComponent.ctorParameters = function () { return []; };
PushImageButtonComponent.propDecorators = {
    'registryUrl': [{ type: _angular_core.Input },],
    'projectName': [{ type: _angular_core.Input },],
    'tagCopyInput': [{ type: _angular_core.ViewChild, args: ["tagCopy",] },],
    'pushCopyInput': [{ type: _angular_core.ViewChild, args: ["pushCopy",] },],
    'copyAlert': [{ type: _angular_core.ViewChild, args: ["copyAlert",] },],
};

var COPY_INPUT_HTML = "\n<div>\n    <div class=\"command-title\" *ngIf=\"!iconMode\">\n        {{headerTitle}}\n    </div>\n    <div>\n        <span  [class.hide]=\"iconMode\">\n            <input type=\"text\" class=\"command-input\" size=\"{{inputSize}}\" [(ngModel)]=\"defaultValue\" #inputTarget readonly/>\n        </span>\n        <span>\n            <input type=\"text\" size=\"{{inputSize}}\" [(ngModel)]=\"defaultValue\" #inputTarget1 style=\"width: 1px; min-width: 0px; padding: 0; opacity: .1;\">\n        </span>\n        <span>\n            <clr-icon shape=\"copy\" [class.is-success]=\"isCopied\" [class.is-error]=\"hasCopyError\" class=\"info-tips-icon\" size=\"24\" [ngxClipboard]=\"inputTarget1\" (cbOnSuccess)=\"onSuccess($event)\" (cbOnError)=\"onError($event)\"></clr-icon>\n        </span>\n    </div>\n</div>\n";

var CopyInputComponent = (function () {
    function CopyInputComponent() {
        this.inputSize = 40;
        this.headerTitle = "Copy Input";
        this.defaultValue = "N/A";
        this.iconMode = false;
        this.state = 0 /* NORMAL */;
        this.onCopySuccess = new _angular_core.EventEmitter();
        this.onCopyError = new _angular_core.EventEmitter();
    }
    CopyInputComponent.prototype.ngOnInit = function () { };
    CopyInputComponent.prototype.onSuccess = function ($event) {
        this.state = 1 /* SUCCESS */;
        this.onCopySuccess.emit($event);
    };
    CopyInputComponent.prototype.onError = function (error) {
        this.state = 2 /* ERROR */;
        this.onCopyError.emit(error);
    };
    CopyInputComponent.prototype.reset = function () {
        this.state = 0 /* NORMAL */;
    };
    CopyInputComponent.prototype.setPullCommendShow = function () {
        this.iconMode = false;
    };
    Object.defineProperty(CopyInputComponent.prototype, "isCopied", {
        get: function () {
            return this.state === 1 /* SUCCESS */;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CopyInputComponent.prototype, "hasCopyError", {
        get: function () {
            return this.state === 2 /* ERROR */;
        },
        enumerable: true,
        configurable: true
    });
    return CopyInputComponent;
}());
CopyInputComponent.decorators = [
    { type: _angular_core.Component, args: [{
                selector: 'hbr-copy-input',
                styles: [PUSH_IMAGE_STYLE],
                template: COPY_INPUT_HTML,
                providers: []
            },] },
];
/** @nocollapse */
CopyInputComponent.ctorParameters = function () { return []; };
CopyInputComponent.propDecorators = {
    'inputSize': [{ type: _angular_core.Input },],
    'headerTitle': [{ type: _angular_core.Input },],
    'defaultValue': [{ type: _angular_core.Input },],
    'iconMode': [{ type: _angular_core.Input },],
    'onCopySuccess': [{ type: _angular_core.Output },],
    'onCopyError': [{ type: _angular_core.Output },],
};

var PUSH_IMAGE_BUTTON_DIRECTIVES = [
    CopyInputComponent,
    PushImageButtonComponent
];

var REPLICATION_CONFIG_HTML = "\n<form #replicationConfigFrom=\"ngForm\" class=\"compact\">\n<section class=\"form-block\" style=\"margin-top:0px;margin-bottom:0px;\">\n<label style=\"font-size:14px;font-weight:600;\" *ngIf=\"showSubTitle\">{{'CONFIG.REPLICATION' | translate}}</label>\n<div class=\"form-group\">\n  <label for=\"verifyRemoteCert\">{{'CONFIG.VERIFY_REMOTE_CERT' | translate }}</label>\n    <clr-checkbox name=\"verifyRemoteCert\" id=\"verifyRemoteCert\" [(ngModel)]=\"replicationConfig.verify_remote_cert.value\" [disabled]=\"!editable\">\n      <a href=\"javascript:void(0)\" role=\"tooltip\" aria-haspopup=\"true\" class=\"tooltip tooltip-lg tooltip-top-right\" style=\"top:-8px;\">\n        <clr-icon shape=\"info-circle\" class=\"info-tips-icon\" size=\"24\"></clr-icon>\n        <span class=\"tooltip-content\">{{'CONFIG.TOOLTIP.VERIFY_REMOTE_CERT' | translate }}</span>\n      </a>\n     </clr-checkbox>\n</div>\n</section>\n</form>\n";

var REGISTRY_CONFIG_STYLES = "\n.info-tips-icon {\n    color: grey;\n}\n\n.info-tips-icon:hover {\n    color: #007CBB;\n}\n";

var ReplicationConfigComponent = (function () {
    function ReplicationConfigComponent() {
        this.configChange = new _angular_core.EventEmitter();
        this.showSubTitle = false;
    }
    Object.defineProperty(ReplicationConfigComponent.prototype, "replicationConfig", {
        get: function () {
            return this.config;
        },
        set: function (cfg) {
            this.config = cfg;
            this.configChange.emit(this.config);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ReplicationConfigComponent.prototype, "editable", {
        get: function () {
            return this.replicationConfig &&
                this.replicationConfig.verify_remote_cert &&
                this.replicationConfig.verify_remote_cert.editable;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ReplicationConfigComponent.prototype, "isValid", {
        get: function () {
            return this.replicationConfigForm && this.replicationConfigForm.valid;
        },
        enumerable: true,
        configurable: true
    });
    return ReplicationConfigComponent;
}());
ReplicationConfigComponent.decorators = [
    { type: _angular_core.Component, args: [{
                selector: 'replication-config',
                template: REPLICATION_CONFIG_HTML,
                styles: [REGISTRY_CONFIG_STYLES]
            },] },
];
/** @nocollapse */
ReplicationConfigComponent.ctorParameters = function () { return []; };
ReplicationConfigComponent.propDecorators = {
    'configChange': [{ type: _angular_core.Output },],
    'replicationConfig': [{ type: _angular_core.Input },],
    'showSubTitle': [{ type: _angular_core.Input },],
    'replicationConfigForm': [{ type: _angular_core.ViewChild, args: ["replicationConfigFrom",] },],
};

var SYSTEM_SETTINGS_HTML = "\n<form #systemConfigFrom=\"ngForm\" class=\"compact\">\n<section class=\"form-block\" style=\"margin-top:0px;margin-bottom:0px;\">\n  <label style=\"font-size:14px;font-weight:600;\" *ngIf=\"showSubTitle\">{{'CONFIG.SYSTEM' | translate}}</label>\n  <div class=\"form-group\">\n      <label for=\"tokenExpiration\" class=\"required\">{{'CONFIG.TOKEN_EXPIRATION' | translate}}</label>\n      <label for=\"tokenExpiration\" aria-haspopup=\"true\" role=\"tooltip\" class=\"tooltip tooltip-validation tooltip-md tooltip-top-right\" [class.invalid]=\"tokenExpirationInput.invalid && (tokenExpirationInput.dirty || tokenExpirationInput.touched)\">\n        <input name=\"tokenExpiration\" type=\"text\" #tokenExpirationInput=\"ngModel\" [(ngModel)]=\"systemSettings.token_expiration.value\" \n         required \n         pattern=\"^[1-9]{1}[0-9]*$\"\n         id=\"tokenExpiration\" \n         size=\"20\" [disabled]=\"!editable\">\n         <span class=\"tooltip-content\">\n               {{'TOOLTIP.NUMBER_REQUIRED' | translate}}\n          </span>\n       </label>\n       <a href=\"javascript:void(0)\" role=\"tooltip\" aria-haspopup=\"true\" class=\"tooltip tooltip-top-right\">\n         <clr-icon shape=\"info-circle\" class=\"info-tips-icon\" size=\"24\"></clr-icon>\n         <span class=\"tooltip-content\">{{'CONFIG.TOOLTIP.TOKEN_EXPIRATION' | translate}}</span>\n       </a>\n   </div>\n   <div class=\"form-group\" *ngIf=\"canDownloadCert\">\n      <label for=\"certDownloadLink\" class=\"required\">{{'CONFIG.ROOT_CERT' | translate}}</label>\n      <a #certDownloadLink [href]=\"downloadLink\" target=\"_blank\">{{'CONFIG.ROOT_CERT_LINK' | translate}}</a>\n       <a href=\"javascript:void(0)\" role=\"tooltip\" aria-haspopup=\"true\" class=\"tooltip tooltip-top-right\">\n         <clr-icon shape=\"info-circle\" class=\"info-tips-icon\" size=\"24\"></clr-icon>\n         <span class=\"tooltip-content\">{{'CONFIG.TOOLTIP.ROOT_CERT_DOWNLOAD' | translate}}</span>\n       </a>\n   </div>\n   <div *ngIf=\"!withAdmiral\" class=\"form-group\">\n            <label for=\"repoReadOnly\">{{'CONFIG.REPO_READ_ONLY' | translate}}</label>\n            <clr-checkbox name=\"repoReadOnly\" id=\"repoReadOnly\" [clrChecked]=\"systemSettings.read_only.value\"  (clrCheckedChange)=\"setRepoReadOnlyValue($event)\">\n                <a href=\"javascript:void(0)\" role=\"tooltip\" aria-haspopup=\"true\" class=\"tooltip tooltip-top-right\" style=\"top:-7px;\">\n                    <clr-icon shape=\"info-circle\" class=\"info-tips-icon\" size=\"24\"></clr-icon>\n                    <span class=\"tooltip-content\">{{'CONFIG.TOOLTIP.READONLY_TOOLTIP' | translate}}</span>\n                </a>\n            </clr-checkbox>\n        </div>\n</section>\n</form>\n";

var SystemSettingsComponent = (function () {
    function SystemSettingsComponent(configInfo) {
        this.configInfo = configInfo;
        this.downloadLink = "/api/systeminfo/getcert";
        this.configChange = new _angular_core.EventEmitter();
        this.showSubTitle = false;
        this.hasAdminRole = false;
        this.hasCAFile = false;
        this.withAdmiral = false;
        if (this.configInfo && this.configInfo.systemInfoEndpoint) {
            this.downloadLink = this.configInfo.systemInfoEndpoint + "/getcert";
        }
    }
    Object.defineProperty(SystemSettingsComponent.prototype, "systemSettings", {
        get: function () {
            return this.config;
        },
        set: function (cfg) {
            this.config = cfg;
            this.configChange.emit(this.config);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SystemSettingsComponent.prototype, "editable", {
        get: function () {
            return this.systemSettings &&
                this.systemSettings.token_expiration &&
                this.systemSettings.token_expiration.editable;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SystemSettingsComponent.prototype, "isValid", {
        get: function () {
            return this.systemSettingsForm && this.systemSettingsForm.valid;
        },
        enumerable: true,
        configurable: true
    });
    SystemSettingsComponent.prototype.setRepoReadOnlyValue = function ($event) {
        this.systemSettings.read_only.value = $event;
    };
    Object.defineProperty(SystemSettingsComponent.prototype, "canDownloadCert", {
        get: function () {
            return this.hasAdminRole && this.hasCAFile;
        },
        enumerable: true,
        configurable: true
    });
    return SystemSettingsComponent;
}());
SystemSettingsComponent.decorators = [
    { type: _angular_core.Component, args: [{
                selector: 'system-settings',
                template: SYSTEM_SETTINGS_HTML,
                styles: [REGISTRY_CONFIG_STYLES]
            },] },
];
/** @nocollapse */
SystemSettingsComponent.ctorParameters = function () { return [
    { type: undefined, decorators: [{ type: _angular_core.Inject, args: [SERVICE_CONFIG,] },] },
]; };
SystemSettingsComponent.propDecorators = {
    'configChange': [{ type: _angular_core.Output },],
    'systemSettings': [{ type: _angular_core.Input },],
    'showSubTitle': [{ type: _angular_core.Input },],
    'hasAdminRole': [{ type: _angular_core.Input },],
    'hasCAFile': [{ type: _angular_core.Input },],
    'withAdmiral': [{ type: _angular_core.Input },],
    'systemSettingsForm': [{ type: _angular_core.ViewChild, args: ["systemConfigFrom",] },],
};

var VULNERABILITY_CONFIG_HTML = "\n<form #systemConfigFrom=\"ngForm\" class=\"compact\">\n    <section class=\"form-block\" style=\"margin-top:0px;margin-bottom:0px;\">\n        <label class=\"section-title\" *ngIf=\"showSubTitle\">{{ 'CONFIG.SCANNING.TITLE' | translate }}</label>\n        <div class=\"form-group\">\n            <label>{{ 'CONFIG.SCANNING.DB_REFRESH_TIME' | translate }}</label>\n            <clr-tooltip *ngIf=\"!isClairDBFullyReady\">\n              <clr-icon shape=\"warning\" class=\"is-warning\" size=\"22\"></clr-icon>\n              <clr-tooltip-content [clrPosition]=\"'top-right'\" [clrSize]=\"'md'\" *clrIfOpen>\n                <span>{{'CONFIG.SCANNING.DB_NOT_READY' | translate }}</span>\n              </clr-tooltip-content>\n            </clr-tooltip>\n            <clr-dropdown *ngIf=\"isClairDBFullyReady && showScanningNamespaces\" style=\"margin-top:-8px;\" class=\"clr-dropdown-override\">\n                <button class=\"btn btn-link btn-font\" clrDropdownToggle>\n                  {{ updatedTimestamp | date:'MM/dd/y HH:mm:ss' }}\n                  <clr-icon shape=\"caret down\"></clr-icon>\n                </button>\n                <clr-dropdown-menu [clrPosition]=\"'bottom-right'\" style=\"min-width:300px;\">\n                    <div *ngFor=\"let nt of namespaceTimestamps\" class=\"namespace\">\n                      <span class=\"label label-info\">{{nt.namespace}}</span>\n                      <span>{{ convertToLocalTime(nt.last_update) | date:'MM/dd/y HH:mm:ss'}}</span>\n                    </div>\n                </clr-dropdown-menu>\n            </clr-dropdown>\n            <span class=\"label label-blue\" *ngIf=\"isClairDBFullyReady && !showScanningNamespaces\">{{ updatedTimestamp | date:'MM/dd/y HH:mm:ss' }}</span>\n        </div>\n        <div class=\"form-group\">\n            <label for=\"scanAllPolicy\">{{ 'CONFIG.SCANNING.SCAN_ALL' | translate }}</label>\n            <div class=\"select\">\n                <select id=\"scanAllPolicy\" name=\"scanAllPolicy\" [disabled]=\"!editable\" [(ngModel)]=\"scanningType\">\n                    <option value=\"none\">{{ 'CONFIG.SCANNING.NONE_POLICY' | translate }}</option>\n                    <option value=\"daily\">{{ 'CONFIG.SCANNING.DAILY_POLICY' | translate }}</option>\n                </select>\n            </div>\n            <input type=\"time\" name=\"dailyTimePicker\" required [disabled]=\"!editable\" [hidden]=\"!showTimePicker\" [(ngModel)]=\"dailyTime\" />\n            <a href=\"javascript:void(0)\" role=\"tooltip\" aria-haspopup=\"true\" class=\"tooltip tooltip-top-right\">\n                <clr-icon shape=\"info-circle\" class=\"info-tips-icon\" size=\"24\"></clr-icon>\n                <span class=\"tooltip-content\">{{'CONFIG.TOOLTIP.SCANNING_POLICY' | translate}}</span>\n            </a>\n            <div class=\"btn-scan-right\">\n                 <button class=\"btn btn-primary btn-sm\" (click)=\"scanNow()\" [disabled]=\"!scanAvailable\">{{ 'CONFIG.SCANNING.SCAN_NOW' | translate }}</button><br>\n                 <span *ngIf=\"!scanAvailable\">{{ 'CONFIG.SCANNING.NEXT_SCAN' | translate }} {{ nextScanTimestamp | date:'y/MM/dd HH:mm' }}</span>\n            </div>\n        </div>\n    </section>\n</form>\n";
var VULNERABILITY_CONFIG_STYLES = "\n.form-group-override {\n    padding-left: 0px !important;\n}\n\n.section-title {\n    font-size: 14px !important;\n    font-weight: 600 !important;\n}\n\n.btn-font {\n    font-size: 12px !important;\n}\n\n.namespace {\n    margin-left: 24px;\n}\n\n.clr-dropdown-override {\n    margin-top: -8px;\n}\n.btn-scan-right{\n    margin-left: 10px;\n}\n.btn-scan-right button{\n    width: 160px;\n    margin-bottom: 0px;\n    margin-top: 5px;\n}\n.btn-scan-right span{\n    margin-top: 4px;\n}\n";

var ONE_HOUR_SECONDS$1 = 3600;
var ONE_DAY_SECONDS$1 = 24 * ONE_HOUR_SECONDS$1;
var VulnerabilityConfigComponent = (function () {
    function VulnerabilityConfigComponent(scanningService, errorHandler, translate, systemInfoService) {
        this.scanningService = scanningService;
        this.errorHandler = errorHandler;
        this.translate = translate;
        this.systemInfoService = systemInfoService;
        this._localTime = new Date();
        this.onSubmitting = false;
        this.openState = false;
        this.configChange = new _angular_core.EventEmitter();
        this.showSubTitle = false;
        this.showScanningNamespaces = false;
    }
    Object.defineProperty(VulnerabilityConfigComponent.prototype, "vulnerabilityConfig", {
        get: function () {
            return this.config;
        },
        set: function (cfg) {
            this.config = cfg;
            if (this.config.scan_all_policy &&
                this.config.scan_all_policy.value) {
                if (this.config.scan_all_policy.value.type === "daily") {
                    if (!this.config.scan_all_policy.value.parameter) {
                        this.config.scan_all_policy.value.parameter = {
                            daily_time: 0
                        };
                    }
                }
            }
            this.configChange.emit(this.config);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(VulnerabilityConfigComponent.prototype, "scanAvailable", {
        get: function () {
            var dt = new Date();
            return !this.onSubmitting && (this.nextScanTime <= 0 || dt.getTime() > ((this.nextScanTime + 300) * 1000));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(VulnerabilityConfigComponent.prototype, "nextScanTimestamp", {
        get: function () {
            return this.nextScanTime > 0 ? this.convertToLocalTime(this.nextScanTime) : null;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(VulnerabilityConfigComponent.prototype, "nextScanTime", {
        get: function () {
            return this.systemInfo && this.systemInfo.next_scan_all ? this.systemInfo.next_scan_all : 0;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(VulnerabilityConfigComponent.prototype, "updatedTimestamp", {
        get: function () {
            if (this.systemInfo &&
                this.systemInfo.clair_vulnerability_status &&
                this.systemInfo.clair_vulnerability_status.overall_last_update > 0) {
                return this.convertToLocalTime(this.systemInfo.clair_vulnerability_status.overall_last_update);
            }
            return null;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(VulnerabilityConfigComponent.prototype, "namespaceTimestamps", {
        get: function () {
            if (this.systemInfo &&
                this.systemInfo.clair_vulnerability_status &&
                this.systemInfo.clair_vulnerability_status.details &&
                this.systemInfo.clair_vulnerability_status.details.length > 0) {
                return this.systemInfo.clair_vulnerability_status.details;
            }
            return [];
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(VulnerabilityConfigComponent.prototype, "dailyTime", {
        //UTC time
        get: function () {
            if (!(this.config &&
                this.config.scan_all_policy &&
                this.config.scan_all_policy.value &&
                this.config.scan_all_policy.value.type === "daily")) {
                return "00:00";
            }
            var timeOffset = 0; //seconds
            if (this.config.scan_all_policy.value.parameter) {
                var daily_time = this.config.scan_all_policy.value.parameter.daily_time;
                if (daily_time && typeof daily_time === "number") {
                    timeOffset = +daily_time;
                }
            }
            //Convert to current time
            var timezoneOffset = this._localTime.getTimezoneOffset();
            //Local time
            timeOffset = timeOffset - timezoneOffset * 60;
            if (timeOffset < 0) {
                timeOffset = timeOffset + ONE_DAY_SECONDS$1;
            }
            if (timeOffset >= ONE_DAY_SECONDS$1) {
                timeOffset -= ONE_DAY_SECONDS$1;
            }
            //To time string
            var hours = Math.floor(timeOffset / ONE_HOUR_SECONDS$1);
            var minutes = Math.floor((timeOffset - hours * ONE_HOUR_SECONDS$1) / 60);
            var timeStr = "" + hours;
            if (hours < 10) {
                timeStr = "0" + timeStr;
            }
            if (minutes < 10) {
                timeStr += ":0";
            }
            else {
                timeStr += ":";
            }
            timeStr += minutes;
            return timeStr;
        },
        set: function (v) {
            if (!v || v === "") {
                return;
            }
            if (!(this.config &&
                this.config.scan_all_policy &&
                this.config.scan_all_policy.value &&
                this.config.scan_all_policy.value.type === "daily")) {
                return;
            }
            //Double confirm inner parameter existing.
            if (!this.config.scan_all_policy.value.parameter) {
                this.config.scan_all_policy.value.parameter = {
                    daily_time: 0
                };
            }
            var values = v.split(":");
            if (!values || values.length !== 2) {
                return;
            }
            var hours = +values[0];
            var minutes = +values[1];
            //Convert to UTC time
            var timezoneOffset = this._localTime.getTimezoneOffset();
            var utcTimes = hours * ONE_HOUR_SECONDS$1 + minutes * 60;
            utcTimes += timezoneOffset * 60;
            if (utcTimes < 0) {
                utcTimes += ONE_DAY_SECONDS$1;
            }
            if (utcTimes >= ONE_DAY_SECONDS$1) {
                utcTimes -= ONE_DAY_SECONDS$1;
            }
            this.config.scan_all_policy.value.parameter.daily_time = utcTimes;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(VulnerabilityConfigComponent.prototype, "scanningType", {
        //Scanning type
        get: function () {
            if (this.config &&
                this.config.scan_all_policy &&
                this.config.scan_all_policy.value) {
                return this.config.scan_all_policy.value.type;
            }
            else {
                //default
                return "none";
            }
        },
        set: function (v) {
            if (this.config &&
                this.config.scan_all_policy &&
                this.config.scan_all_policy.value) {
                var type = (v && v.trim() !== "") ? v : "none";
                this.config.scan_all_policy.value.type = type;
                if (type !== "daily") {
                    //No parameter
                    if (this.config.scan_all_policy.value.parameter) {
                        delete (this.config.scan_all_policy.value.parameter);
                    }
                }
                else {
                    //Has parameter
                    if (!this.config.scan_all_policy.value.parameter) {
                        this.config.scan_all_policy.value.parameter = {
                            daily_time: 0
                        };
                    }
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(VulnerabilityConfigComponent.prototype, "editable", {
        get: function () {
            return this.vulnerabilityConfig &&
                this.vulnerabilityConfig.scan_all_policy &&
                this.vulnerabilityConfig.scan_all_policy.editable;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(VulnerabilityConfigComponent.prototype, "isValid", {
        get: function () {
            return this.systemSettingsForm && this.systemSettingsForm.valid;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(VulnerabilityConfigComponent.prototype, "showTimePicker", {
        get: function () {
            return this.vulnerabilityConfig &&
                this.vulnerabilityConfig.scan_all_policy &&
                this.vulnerabilityConfig.scan_all_policy.value &&
                this.vulnerabilityConfig.scan_all_policy.value.type === "daily";
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(VulnerabilityConfigComponent.prototype, "isClairDBFullyReady", {
        get: function () {
            return this.systemInfo &&
                this.systemInfo.clair_vulnerability_status &&
                this.systemInfo.clair_vulnerability_status.overall_last_update > 0;
        },
        enumerable: true,
        configurable: true
    });
    VulnerabilityConfigComponent.prototype.ngOnInit = function () {
        this.getSystemInfo();
    };
    VulnerabilityConfigComponent.prototype.convertToLocalTime = function (utcTime) {
        var dt = new Date();
        dt.setTime(utcTime * 1000);
        return dt;
    };
    VulnerabilityConfigComponent.prototype.scanNow = function () {
        var _this = this;
        if (this.onSubmitting) {
            return; //Aoid duplicated submitting
        }
        if (!this.scanAvailable) {
            return; //Aoid page hacking
        }
        this.onSubmitting = true;
        toPromise(this.scanningService.startScanningAll())
            .then(function () {
            _this.translate.get("CONFIG.SCANNING.TRIGGER_SCAN_ALL_SUCCESS").subscribe(function (res) {
                _this.errorHandler.info(res);
            });
            //Update system info
            _this.getSystemInfo().then(function () {
                _this.onSubmitting = false;
            }).catch(function () {
                _this.onSubmitting = false;
            });
        })
            .catch(function (error) {
            if (error && error.status && error.status === 412) {
                _this.translate.get("CONFIG.SCANNING.TRIGGER_SCAN_ALL_FAIL", { error: '' + error }).subscribe(function (res) {
                    _this.errorHandler.error(res);
                });
            }
            else {
                _this.errorHandler.error(error);
            }
            _this.onSubmitting = false;
        });
    };
    VulnerabilityConfigComponent.prototype.getSystemInfo = function () {
        var _this = this;
        return toPromise(this.systemInfoService.getSystemInfo())
            .then(function (info) { return _this.systemInfo = info; })
            .catch(function (error) { return _this.errorHandler.error(error); });
    };
    return VulnerabilityConfigComponent;
}());
VulnerabilityConfigComponent.decorators = [
    { type: _angular_core.Component, args: [{
                selector: 'vulnerability-config',
                template: VULNERABILITY_CONFIG_HTML,
                styles: [VULNERABILITY_CONFIG_STYLES, REGISTRY_CONFIG_STYLES]
            },] },
];
/** @nocollapse */
VulnerabilityConfigComponent.ctorParameters = function () { return [
    { type: ScanningResultService, },
    { type: ErrorHandler, },
    { type: _ngxTranslate_core.TranslateService, },
    { type: SystemInfoService, },
]; };
VulnerabilityConfigComponent.propDecorators = {
    'configChange': [{ type: _angular_core.Output },],
    'vulnerabilityConfig': [{ type: _angular_core.Input },],
    'showSubTitle': [{ type: _angular_core.Input },],
    'showScanningNamespaces': [{ type: _angular_core.Input },],
    'systemSettingsForm': [{ type: _angular_core.ViewChild, args: ["systemConfigFrom",] },],
};

// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//    http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var StringValueItem = (function () {
    function StringValueItem(v, e) {
        this.value = v;
        this.editable = e;
    }
    return StringValueItem;
}());
var NumberValueItem = (function () {
    function NumberValueItem(v, e) {
        this.value = v;
        this.editable = e;
    }
    return NumberValueItem;
}());
var BoolValueItem = (function () {
    function BoolValueItem(v, e) {
        this.value = v;
        this.editable = e;
    }
    return BoolValueItem;
}());
var ComplexValueItem = (function () {
    function ComplexValueItem(v, e) {
        this.value = v;
        this.editable = e;
    }
    return ComplexValueItem;
}());
var Configuration = (function () {
    function Configuration() {
        this.auth_mode = new StringValueItem("db_auth", true);
        this.project_creation_restriction = new StringValueItem("everyone", true);
        this.self_registration = new BoolValueItem(false, true);
        this.ldap_base_dn = new StringValueItem("", true);
        this.ldap_filter = new StringValueItem("", true);
        this.ldap_scope = new NumberValueItem(0, true);
        this.ldap_search_dn = new StringValueItem("", true);
        this.ldap_search_password = new StringValueItem("", true);
        this.ldap_timeout = new NumberValueItem(5, true);
        this.ldap_uid = new StringValueItem("", true);
        this.ldap_url = new StringValueItem("", true);
        this.ldap_verify_cert = new BoolValueItem(true, true);
        this.uaa_client_id = new StringValueItem("", true);
        this.uaa_client_secret = new StringValueItem("", true);
        this.uaa_endpoint = new StringValueItem("", true);
        this.uaa_verify_cert = new BoolValueItem(false, true);
        this.email_host = new StringValueItem("", true);
        this.email_identity = new StringValueItem("", true);
        this.email_from = new StringValueItem("", true);
        this.email_port = new NumberValueItem(25, true);
        this.email_ssl = new BoolValueItem(false, true);
        this.email_username = new StringValueItem("", true);
        this.email_password = new StringValueItem("", true);
        this.email_insecure = new BoolValueItem(false, true);
        this.token_expiration = new NumberValueItem(30, true);
        this.cfg_expiration = new NumberValueItem(30, true);
        this.verify_remote_cert = new BoolValueItem(false, true);
        this.scan_all_policy = new ComplexValueItem({
            type: "daily",
            parameter: {
                daily_time: 0
            }
        }, true);
        this.read_only = new BoolValueItem(false, true);
    }
    return Configuration;
}());

var REGISTRY_CONFIG_HTML = "\n<div>\n    <system-settings #systemSettings [(systemSettings)]=\"config\" [showSubTitle]=\"true\" [hasAdminRole]=\"hasAdminRole\" [hasCAFile]=\"hasCAFile\" [withAdmiral]=\"withAdmiral\"></system-settings>\n    <vulnerability-config *ngIf=\"withClair\" #vulnerabilityConfig [(vulnerabilityConfig)]=\"config\" [showSubTitle]=\"true\"></vulnerability-config>\n    <div>\n        <button type=\"button\" class=\"btn btn-primary\" (click)=\"save()\" [disabled]=\"shouldDisable\">{{'BUTTON.SAVE' | translate}}</button>\n        <button type=\"button\" class=\"btn btn-outline\" (click)=\"cancel()\" [disabled]=\"shouldDisable\">{{'BUTTON.CANCEL' | translate}}</button>\n    </div>\n    <confirmation-dialog #cfgConfirmationDialog (confirmAction)=\"confirmCancel($event)\"></confirmation-dialog>\n</div>\n";

var RegistryConfigComponent = (function () {
    function RegistryConfigComponent(configService, errorHandler, translate, systemInfoService) {
        this.configService = configService;
        this.errorHandler = errorHandler;
        this.translate = translate;
        this.systemInfoService = systemInfoService;
        this.config = new Configuration();
        this.onGoing = false;
        this.hasAdminRole = false;
    }
    Object.defineProperty(RegistryConfigComponent.prototype, "shouldDisable", {
        get: function () {
            return !this.isValid() || !this.hasChanges() || this.onGoing;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RegistryConfigComponent.prototype, "hasCAFile", {
        get: function () {
            return this.systemInfo && this.systemInfo.has_ca_root;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RegistryConfigComponent.prototype, "withClair", {
        get: function () {
            return this.systemInfo && this.systemInfo.with_clair;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RegistryConfigComponent.prototype, "withAdmiral", {
        get: function () {
            return this.systemInfo && this.systemInfo.with_admiral;
        },
        enumerable: true,
        configurable: true
    });
    RegistryConfigComponent.prototype.ngOnInit = function () {
        this.loadSystemInfo();
        //Initialize
        this.load();
    };
    RegistryConfigComponent.prototype.isValid = function () {
        return this.systemSettings &&
            this.systemSettings.isValid &&
            this.vulnerabilityCfg &&
            this.vulnerabilityCfg.isValid;
    };
    RegistryConfigComponent.prototype.hasChanges = function () {
        return !isEmptyObject(this.getChanges());
    };
    //Get system info
    RegistryConfigComponent.prototype.loadSystemInfo = function () {
        var _this = this;
        toPromise(this.systemInfoService.getSystemInfo())
            .then(function (info) { return _this.systemInfo = info; })
            .catch(function (error) { return _this.errorHandler.error(error); });
    };
    //Load configurations
    RegistryConfigComponent.prototype.load = function () {
        var _this = this;
        this.onGoing = true;
        toPromise(this.configService.getConfigurations())
            .then(function (config) {
            _this.configCopy = clone(config);
            _this.config = config;
            _this.onGoing = false;
        })
            .catch(function (error) {
            _this.errorHandler.error(error);
            _this.onGoing = false;
        });
    };
    //Save configuration changes
    RegistryConfigComponent.prototype.save = function () {
        var _this = this;
        var changes = this.getChanges();
        if (isEmptyObject(changes)) {
            //Guard code, do nothing
            return;
        }
        this.onGoing = true;
        toPromise(this.configService.saveConfigurations(changes))
            .then(function () {
            _this.onGoing = false;
            _this.translate.get("CONFIG.SAVE_SUCCESS").subscribe(function (res) {
                _this.errorHandler.info(res);
            });
            //Reload to fetch all the updates
            _this.load();
            //Reload all system info 
            //this.loadSystemInfo();
        })
            .catch(function (error) {
            _this.onGoing = false;
            _this.errorHandler.error(error);
        });
    };
    //Cancel the changes if have
    RegistryConfigComponent.prototype.cancel = function () {
        var msg = new ConfirmationMessage("CONFIG.CONFIRM_TITLE", "CONFIG.CONFIRM_SUMMARY", "", {}, 9 /* CONFIG */);
        this.confirmationDlg.open(msg);
    };
    //Confirm cancel
    RegistryConfigComponent.prototype.confirmCancel = function (ack) {
        if (ack && ack.source === 9 /* CONFIG */ &&
            ack.state === 1 /* CONFIRMED */) {
            this.reset();
        }
    };
    RegistryConfigComponent.prototype.reset = function () {
        //Reset to the values of copy
        var changes = this.getChanges();
        for (var prop in changes) {
            this.config[prop] = clone(this.configCopy[prop]);
        }
    };
    RegistryConfigComponent.prototype.getChanges = function () {
        var changes = {};
        if (!this.config || !this.configCopy) {
            return changes;
        }
        for (var prop in this.config) {
            var field = this.configCopy[prop];
            if (field && field.editable) {
                if (!compareValue(field.value, this.config[prop].value)) {
                    changes[prop] = this.config[prop].value;
                    //Number 
                    if (typeof field.value === "number") {
                        changes[prop] = +changes[prop];
                    }
                    //Trim string value
                    if (typeof field.value === "string") {
                        changes[prop] = ('' + changes[prop]).trim();
                    }
                }
            }
        }
        return changes;
    };
    return RegistryConfigComponent;
}());
RegistryConfigComponent.decorators = [
    { type: _angular_core.Component, args: [{
                selector: 'hbr-registry-config',
                template: REGISTRY_CONFIG_HTML
            },] },
];
/** @nocollapse */
RegistryConfigComponent.ctorParameters = function () { return [
    { type: ConfigurationService, },
    { type: ErrorHandler, },
    { type: _ngxTranslate_core.TranslateService, },
    { type: SystemInfoService, },
]; };
RegistryConfigComponent.propDecorators = {
    'hasAdminRole': [{ type: _angular_core.Input },],
    'systemSettings': [{ type: _angular_core.ViewChild, args: ["systemSettings",] },],
    'vulnerabilityCfg': [{ type: _angular_core.ViewChild, args: ["vulnerabilityConfig",] },],
    'confirmationDlg': [{ type: _angular_core.ViewChild, args: ["cfgConfirmationDialog",] },],
};

var CONFIGURATION_DIRECTIVES = [
    ReplicationConfigComponent,
    SystemSettingsComponent,
    VulnerabilityConfigComponent,
    RegistryConfigComponent
];

var JOB_LOG_VIEWER_TEMPLATE = "\n<clr-modal [(clrModalOpen)]=\"opened\" [clrModalStaticBackdrop]=\"true\" [clrModalSize]=\"'xl'\">\n    <h3 class=\"modal-title\" class=\"log-viewer-title\" style=\"margin-top: 0px;\">{{title | translate }}</h3>\n    <div class=\"modal-body\">\n      <div class=\"loading-back\" [hidden]=\"!onGoing\">\n        <span class=\"spinner spinner-md\"></span>\n      </div>\n      <pre [hidden]=\"onGoing\">\n<code>{{log}}</code>\n      </pre>\n    </div>\n    <div class=\"modal-footer\">\n      <button type=\"button\" class=\"btn btn-primary\" (click)=\"close()\">{{ 'BUTTON.CLOSE' | translate}}</button>\n    </div>\n</clr-modal>\n";
var JOB_LOG_VIEWER_STYLES = "\n.log-viewer-title {\n    line-height: 24px;\n    color: #000000;\n    font-size: 22px;\n}\n\n.loading-back {\n  height: 358px;\n  display: flex;\n  align-items: center;\n  justify-content: center; \n}\n";

// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//    http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var supportSet = ["replication", "scan"];
var JobLogViewerComponent = (function () {
    function JobLogViewerComponent(jobLogService, errorHandler, ref) {
        this.jobLogService = jobLogService;
        this.errorHandler = errorHandler;
        this.ref = ref;
        this._jobType = "replication";
        this.opened = false;
        this.log = '';
        this.onGoing = true;
    }
    Object.defineProperty(JobLogViewerComponent.prototype, "jobType", {
        get: function () {
            return this._jobType;
        },
        set: function (v) {
            if (supportSet.find(function (t) { return t === v; })) {
                this._jobType = v;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(JobLogViewerComponent.prototype, "title", {
        get: function () {
            if (this.jobType === "scan") {
                return "VULNERABILITY.JOB_LOG_VIEWER";
            }
            return "REPLICATION.JOB_LOG_VIEWER";
        },
        enumerable: true,
        configurable: true
    });
    JobLogViewerComponent.prototype.open = function (jobId) {
        this.opened = true;
        this.load(jobId);
    };
    JobLogViewerComponent.prototype.close = function () {
        this.opened = false;
        this.log = "";
    };
    JobLogViewerComponent.prototype.load = function (jobId) {
        var _this = this;
        this.onGoing = true;
        toPromise(this.jobLogService.getJobLog(this.jobType, jobId))
            .then(function (log) {
            _this.onGoing = false;
            _this.log = log;
        })
            .catch(function (error) {
            _this.onGoing = false;
            _this.errorHandler.error(error);
        });
        var hnd = setInterval(function () { return _this.ref.markForCheck(); }, 100);
        setTimeout(function () { return clearInterval(hnd); }, 2000);
    };
    return JobLogViewerComponent;
}());
JobLogViewerComponent.decorators = [
    { type: _angular_core.Component, args: [{
                selector: 'job-log-viewer',
                template: JOB_LOG_VIEWER_TEMPLATE,
                styles: [JOB_LOG_VIEWER_STYLES],
                changeDetection: _angular_core.ChangeDetectionStrategy.OnPush
            },] },
];
/** @nocollapse */
JobLogViewerComponent.ctorParameters = function () { return [
    { type: JobLogService, },
    { type: ErrorHandler, },
    { type: _angular_core.ChangeDetectorRef, },
]; };
JobLogViewerComponent.propDecorators = {
    'jobType': [{ type: _angular_core.Input },],
};

var JOB_LOG_VIEWER_DIRECTIVES = [
    JobLogViewerComponent
];

var PROJECT_POLICY_CONFIG_TEMPLATE = "\n<form #projectPolicyForm=\"ngForm\">\n    <section class=\"form-block\">\n        <div class=\"form-group\">\n          <label for=\"projectPolicyForm\">{{ 'PROJECT_CONFIG.REGISTRY' | translate }}</label>\n          <div class=\"form-content\">\n            <clr-checkbox [(ngModel)]=\"projectPolicy.Public\" name=\"public\"\n              [clrDisabled]=\"!hasProjectAdminRole\">{{ 'PROJECT_CONFIG.PUBLIC_TOGGLE' | translate }}</clr-checkbox>\n            <div>\n              <label> {{ 'PROJECT_CONFIG.PUBLIC_POLICY' | translate }} </label>\n            </div>\n          </div>\n        </div>\n        <div class=\"form-group\" *ngIf=\"withNotary || withClair\">\n          <label for=\"projectPolicyForm\">{{ 'PROJECT_CONFIG.SECURITY' | translate }}</label>\n          <div class=\"form-content\">\n            <div *ngIf=\"withNotary\">\n              <clr-checkbox [(ngModel)]=\"projectPolicy.ContentTrust\" name=\"content-trust\" \n                [clrDisabled]=\"!hasProjectAdminRole\">{{ 'PROJECT_CONFIG.CONTENT_TRUST_TOGGLE' | translate }}</clr-checkbox>\n              <div class=\"chk-explain\"><label> {{ 'PROJECT_CONFIG.CONTENT_TRUST_POLCIY' | translate }} </label></div>\n            </div>\n            <div *ngIf=\"withClair\">\n              <clr-checkbox [(ngModel)]=\"projectPolicy.PreventVulImg\" name=\"prevent-vulenrability-image\" [clrDisabled]=\"!hasProjectAdminRole\">{{ 'PROJECT_CONFIG.PREVENT_VULNERABLE_TOGGLE' | translate }}</clr-checkbox>\n              <div class=\"chk-explain\">\n                <label>\n                  <div id=\"severity-blk\">\n                    <div>{{ 'PROJECT_CONFIG.PREVENT_VULNERABLE_1' | translate }}</div>\n                    <div class=\"select\">\n                      <select id=\"severity\" name=\"severity\" [(ngModel)]=\"projectPolicy.PreventVulImgSeverity\" [disabled]=\"!projectPolicy.PreventVulImg\">\n                        <option *ngFor='let s of severityOptions' [ngValue]=\"s.severity\">{{ s.severityLevel | translate | uppercase }}</option>                      \n                      </select>\n                    </div> \n                    <div> {{ 'PROJECT_CONFIG.PREVENT_VULNERABLE_2' | translate }} </div>\n                  </div>\n                </label>\n              </div>\n            </div>\n          </div>\n        </div>\n        <div class=\"form-group\" *ngIf=\"withClair\">\n          <label for=\"projectPolicyForm\">{{ 'PROJECT_CONFIG.SCAN' | translate }}</label>\n          <div class=\"form-content\">\n            <clr-checkbox [(ngModel)]=\"projectPolicy.ScanImgOnPush\" name=\"scan-image-on-push\" [clrDisabled]=\"!hasProjectAdminRole\">{{ 'PROJECT_CONFIG.AUTOSCAN_TOGGLE' | translate }}</clr-checkbox>\n            <div class=\"chk-explain\"><label> {{ 'PROJECT_CONFIG.AUTOSCAN_POLICY' | translate }}</label></div>\n          </div>\n        </div>\n       <button type=\"button\" class=\"btn btn-primary\" (click)=\"save()\" [disabled]=\"!isValid() || !hasChanges() || !hasProjectAdminRole\">{{'BUTTON.SAVE' | translate}}</button>\n       <button type=\"button\" class=\"btn btn-outline\" (click)=\"cancel()\" [disabled]=\"!isValid() || !hasChanges() || !hasProjectAdminRole\">{{'BUTTON.CANCEL' | translate}}</button>\n       <confirmation-dialog #cfgConfirmationDialog (confirmAction)=\"confirmCancel($event)\"></confirmation-dialog>       \n    </section>\n</form>";

var PROJECT_POLICY_CONFIG_STYLE = "#severity-blk div\n{\n    display: inline-block;\n}\n\n.select {\n    width: 120px;\n}\n";

var ProjectPolicy = (function () {
    function ProjectPolicy() {
        this.Public = false;
        this.ContentTrust = false;
        this.PreventVulImg = false;
        this.PreventVulImgSeverity = 'low';
        this.ScanImgOnPush = false;
    }
    ProjectPolicy.prototype.initByProject = function (pro) {
        this.Public = pro.metadata.public === 'true' ? true : false;
        this.ContentTrust = pro.metadata.enable_content_trust === 'true' ? true : false;
        this.PreventVulImg = pro.metadata.prevent_vul === 'true' ? true : false;
        if (pro.metadata.severity) {
            this.PreventVulImgSeverity = pro.metadata.severity;
        }
        
        this.ScanImgOnPush = pro.metadata.auto_scan === 'true' ? true : false;
    };
    
    return ProjectPolicy;
}());
var ProjectPolicyConfigComponent = (function () {
    function ProjectPolicyConfigComponent(errorHandler, translate, projectService, systemInfoService) {
        this.errorHandler = errorHandler;
        this.translate = translate;
        this.projectService = projectService;
        this.systemInfoService = systemInfoService;
        this.onGoing = false;
        this.projectName = 'unknown';
        this.orgProjectPolicy = new ProjectPolicy();
        this.projectPolicy = new ProjectPolicy();
        this.severityOptions = [
            { severity: 'high', severityLevel: 'VULNERABILITY.SEVERITY.HIGH' },
            { severity: 'medium', severityLevel: 'VULNERABILITY.SEVERITY.MEDIUM' },
            { severity: 'low', severityLevel: 'VULNERABILITY.SEVERITY.LOW' },
            { severity: 'negligible', severityLevel: 'VULNERABILITY.SEVERITY.NEGLIGIBLE' },
        ];
    }
    ProjectPolicyConfigComponent.prototype.ngOnInit = function () {
        var _this = this;
        // assert if project id exist
        if (!this.projectId) {
            this.errorHandler.error('Project ID cannot be unset.');
            return;
        }
        // get system info
        toPromise(this.systemInfoService.getSystemInfo())
            .then(function (systemInfo) { return _this.systemInfo = systemInfo; })
            .catch(function (error) { return _this.errorHandler.error(error); });
        // retrive project level policy data
        this.retrieve();
    };
    Object.defineProperty(ProjectPolicyConfigComponent.prototype, "withNotary", {
        get: function () {
            return this.systemInfo ? this.systemInfo.with_notary : false;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ProjectPolicyConfigComponent.prototype, "withClair", {
        get: function () {
            return this.systemInfo ? this.systemInfo.with_clair : false;
        },
        enumerable: true,
        configurable: true
    });
    ProjectPolicyConfigComponent.prototype.retrieve = function (state) {
        var _this = this;
        toPromise(this.projectService.getProject(this.projectId))
            .then(function (response) {
            _this.orgProjectPolicy.initByProject(response);
            _this.projectPolicy.initByProject(response);
        })
            .catch(function (error) { return _this.errorHandler.error(error); });
    };
    ProjectPolicyConfigComponent.prototype.updateProjectPolicy = function (projectId, pp) {
        this.projectService.updateProjectPolicy(projectId, pp);
    };
    ProjectPolicyConfigComponent.prototype.refresh = function () {
        this.retrieve();
    };
    ProjectPolicyConfigComponent.prototype.isValid = function () {
        var _this = this;
        var flag = false;
        if (!this.projectPolicy.PreventVulImg || this.severityOptions.some(function (x) { return x.severity === _this.projectPolicy.PreventVulImgSeverity; })) {
            flag = true;
        }
        return flag;
    };
    ProjectPolicyConfigComponent.prototype.hasChanges = function () {
        return !compareValue(this.orgProjectPolicy, this.projectPolicy);
    };
    ProjectPolicyConfigComponent.prototype.save = function () {
        var _this = this;
        if (!this.hasChanges()) {
            return;
        }
        this.onGoing = true;
        toPromise(this.projectService.updateProjectPolicy(this.projectId, this.projectPolicy))
            .then(function () {
            _this.onGoing = false;
            _this.translate.get('CONFIG.SAVE_SUCCESS').subscribe(function (res) {
                _this.errorHandler.info(res);
            });
            _this.refresh();
        })
            .catch(function (error) {
            _this.onGoing = false;
            _this.errorHandler.error(error);
        });
    };
    ProjectPolicyConfigComponent.prototype.cancel = function () {
        var msg = new ConfirmationMessage('CONFIG.CONFIRM_TITLE', 'CONFIG.CONFIRM_SUMMARY', '', {}, 9 /* CONFIG */);
        this.confirmationDlg.open(msg);
    };
    ProjectPolicyConfigComponent.prototype.reset = function () {
        this.projectPolicy = clone(this.orgProjectPolicy);
    };
    ProjectPolicyConfigComponent.prototype.confirmCancel = function (ack) {
        if (ack && ack.source === 9 /* CONFIG */ &&
            ack.state === 1 /* CONFIRMED */) {
            this.reset();
        }
    };
    return ProjectPolicyConfigComponent;
}());
ProjectPolicyConfigComponent.decorators = [
    { type: _angular_core.Component, args: [{
                selector: 'hbr-project-policy-config',
                template: PROJECT_POLICY_CONFIG_TEMPLATE,
                styles: [PROJECT_POLICY_CONFIG_STYLE],
            },] },
];
/** @nocollapse */
ProjectPolicyConfigComponent.ctorParameters = function () { return [
    { type: ErrorHandler, },
    { type: _ngxTranslate_core.TranslateService, },
    { type: ProjectService, },
    { type: SystemInfoService, },
]; };
ProjectPolicyConfigComponent.propDecorators = {
    'projectId': [{ type: _angular_core.Input },],
    'projectName': [{ type: _angular_core.Input },],
    'hasSignedIn': [{ type: _angular_core.Input },],
    'hasProjectAdminRole': [{ type: _angular_core.Input },],
    'confirmationDlg': [{ type: _angular_core.ViewChild, args: ['cfgConfirmationDialog',] },],
};

var PROJECT_POLICY_CONFIG_DIRECTIVES = [
    ProjectPolicyConfigComponent
];

var GRIDVIEW_TEMPLATE = "\n<div class=\"grid-content\" (scroll)=\"onScroll($event)\">\n  <div class=\"items\" [ngStyle]=\"itemsHolderStyle\" #itemsHolder >\n    <span *ngFor=\"let item of items;let i = index; trackBy:trackByFn\" class='card-item' [ngStyle]=\"cardStyles[i]\" #cardItem\n          (mouseenter)='onCardEnter(i)' (mouseleave)='onCardLeave(i)'>\n      <ng-template [ngTemplateOutlet]=\"gridItemTmpl\" [ngOutletContext]=\"{item: item}\">\n      </ng-template>\n    </span>\n    <span *ngIf=\"items.length === 0 && !loading\" class=\"content-empty\">\n        {{'REPOSITORY.NO_ITEMS' | translate}}\n    </span>\n  </div>\n  <div *ngIf=\"loading\" [ngClass]=\"{'central-block-loading': isFirstPage, 'central-block-loading-more': !isFirstPage}\">\n    <span class=\"vertical-helper\"></span>\n    <div class=\"spinner\"></div>\n  </div>\n</div>\n";

// Copyright (c) 2017-2018 VMware, Inc. All Rights Reserved.
// This software is released under MIT license.
// The full license information can be found in LICENSE in the root directory of this project.
// @import 'node_modules/admiral-ui-common/css/mixins';
// Copyright (c) 2017-2018 VMware, Inc. All Rights Reserved.
var GRIDVIEW_STYLE = "\n.grid-content {\n  position: relative;\n  top: 36px;\n  left: 0;\n  right: 0;\n  bottom: 0;\n  overflow: auto;\n  max-height: 65vh;\n}\n\n.card-item {\n  display: block;\n  max-width: 400px;\n  min-width: 300px;\n  position: absolute;\n  margin-right: 40px;\n  transition: width 0.4s, transform 0.4s;\n}\n\n.content-empty {\n  text-align: center;\n  display: block;\n  margin-top: 100px;\n}\n\n.central-block-loading {\n  position: absolute;\n  z-index: 10;\n  top: 0;\n  left: 0;\n  right: 0;\n  bottom: 0;\n  @include animation(fadein 0.4s);\n  text-align: center;\n  background-color: rgba(255, 255, 255, 0.5);\n}\n.central-block-loading-more {\n  position: relative;\n  z-index: 10;\n  top: 0;\n  left: 0;\n  right: 0;\n  bottom: 0;\n  @include animation(fadein 0.4s);\n  text-align: center;\n  background-color: rgba(255, 255, 255, 0.5);\n}\n.vertical-helper {\n  display: inline-block;\n  height: 100%;\n  vertical-align: middle;\n}\n\n.spinner {\n  width: 100px;\n  height: 100px;\n  vertical-align: middle;\n}\n\n";

/*
 * Copyright (c) 2017 VMware, Inc. All Rights Reserved.
 *
 * This product is licensed to you under the Apache License, Version 2.0 (the "License").
 * You may not use this product except in compliance with the License.
 *
 * This product may include a number of subcomponents with separate copyright notices
 * and license terms. Your use of these subcomponents is subject to the terms and
 * conditions of the subcomponent's license, as noted in the LICENSE file.
 */
/**
 * Grid view general component.
 */
var GridViewComponent = (function () {
    function GridViewComponent(translate) {
        this.translate = translate;
        this.expectScrollPercent = 70;
        this.loadNextPageEvent = new _angular_core.EventEmitter();
        this._items = [];
        this.cardStyles = [];
        this.itemsHolderStyle = {};
        this.loadedPages = 0;
        this.hidePartialRows = false;
        this.CurrentScrollPosition = {
            sH: 0,
            sT: 0,
            cH: 0
        };
        this.preScrollPosition = null;
    }
    Object.defineProperty(GridViewComponent.prototype, "items", {
        get: function () {
            return this._items;
        },
        set: function (value) {
            var _this = this;
            var newCardStyles = value.map(function (d, index) {
                if (index < _this.cardStyles.length) {
                    return _this.cardStyles[index];
                }
                return {
                    opacity: '0',
                    overflow: 'hidden'
                };
            });
            this.cardStyles = newCardStyles;
            this._items = value;
        },
        enumerable: true,
        configurable: true
    });
    GridViewComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        this.cards.changes.subscribe(function () {
            _this.throttleLayout();
        });
        this.throttleLayout();
    };
    GridViewComponent.prototype.onScroll = function (event) {
        this.preScrollPosition = this.CurrentScrollPosition;
        this.CurrentScrollPosition = {
            sH: event.target.scrollHeight,
            sT: event.target.scrollTop,
            cH: event.target.clientHeight
        };
        if (!this.loading
            && this.isScrollDown()
            && this.isScrollExpectPercent()
            && (this.currentPage * this.pageSize < this.totalCount)) {
            this.loadNextPageEvent.emit();
        }
    };
    GridViewComponent.prototype.isScrollDown = function () {
        return this.preScrollPosition.sT < this.CurrentScrollPosition.sT;
    };
    GridViewComponent.prototype.isScrollExpectPercent = function () {
        return ((this.CurrentScrollPosition.sT + this.CurrentScrollPosition.cH) / this.CurrentScrollPosition.sH) > (this.expectScrollPercent / 100);
    };
    GridViewComponent.prototype.onResize = function (event) {
        this.throttleLayout();
    };
    GridViewComponent.prototype.throttleLayout = function () {
        var _this = this;
        clearTimeout(this.layoutTimeout);
        this.layoutTimeout = setTimeout(function () {
            _this.layout.call(_this);
        }, 40);
    };
    Object.defineProperty(GridViewComponent.prototype, "isFirstPage", {
        get: function () {
            return this.currentPage <= 1;
        },
        enumerable: true,
        configurable: true
    });
    GridViewComponent.prototype.layout = function () {
        var el = this.itemsHolder.nativeElement;
        var width = el.offsetWidth;
        var items = el.querySelectorAll('.card-item');
        var items_count = items.length;
        if (items_count === 0) {
            el.height = 0;
            return;
        }
        var itemsHeight = [];
        for (var i = 0; i < items_count; i++) {
            itemsHeight[i] = items[i].offsetHeight;
        }
        var height = Math.max.apply(null, itemsHeight);
        var itemsStyle = window.getComputedStyle(items[0]);
        var minWidthStyle = itemsStyle.minWidth;
        var maxWidthStyle = itemsStyle.maxWidth;
        var minWidth = parseInt(minWidthStyle, 10);
        var maxWidth = parseInt(maxWidthStyle, 10);
        var marginHeight = parseInt(itemsStyle.marginTop, 10) + parseInt(itemsStyle.marginBottom, 10);
        var marginWidth = parseInt(itemsStyle.marginLeft, 10) + parseInt(itemsStyle.marginRight, 10);
        var columns = Math.floor(width / (minWidth + marginWidth));
        var columnsToUse = Math.max(Math.min(columns, items_count), 1);
        var rows = Math.floor(items_count / columnsToUse);
        var itemWidth = Math.min(Math.floor(width / columnsToUse) - marginWidth, maxWidth);
        var itemSpacing = columnsToUse === 1 || columns > items_count ? marginWidth :
            (width - marginWidth - columnsToUse * itemWidth) / (columnsToUse - 1);
        if (!this.withAdmiral) {
            // Fixed spacing and margin on standalone mode
            itemSpacing = marginWidth;
            itemWidth = minWidth;
        }
        var visible = items_count;
        if (this.hidePartialRows && this.totalItemsCount && items_count !== this.totalItemsCount) {
            visible = rows * columnsToUse;
        }
        var count = 0;
        for (var i = 0; i < visible; i++) {
            var item = items[i];
            var itemStyle = window.getComputedStyle(item);
            var left = (i % columnsToUse) * (itemWidth + itemSpacing);
            var top_1 = Math.floor(count / columnsToUse) * (height + marginHeight);
            // trick to show nice apear animation, where the item is already positioned,
            // but it will pop out
            var oldTransform = itemStyle.transform;
            if (!oldTransform || oldTransform === 'none') {
                this.cardStyles[i] = {
                    transform: 'translate(' + left + 'px,' + top_1 + 'px) scale(0)',
                    width: itemWidth + 'px',
                    transition: 'none',
                    overflow: 'hidden'
                };
                this.throttleLayout();
            }
            else {
                this.cardStyles[i] = {
                    transform: 'translate(' + left + 'px,' + top_1 + 'px) scale(1)',
                    width: itemWidth + 'px',
                    transition: null,
                    overflow: 'hidden'
                };
                this.throttleLayout();
            }
            if (!item.classList.contains('context-selected')) {
                var itemHeight = itemsHeight[i];
                if (itemStyle.display === 'none' && itemHeight !== 0) {
                    this.cardStyles[i].display = null;
                }
                if (itemHeight !== 0) {
                    count++;
                }
            }
        }
        for (var i = visible; i < items_count; i++) {
            this.cardStyles[i] = {
                display: 'none'
            };
        }
        this.itemsHolderStyle = {
            height: Math.ceil(count / columnsToUse) * (height + marginHeight) + 'px'
        };
    };
    GridViewComponent.prototype.onCardEnter = function (i) {
        this.cardStyles[i].overflow = 'visible';
    };
    GridViewComponent.prototype.onCardLeave = function (i) {
        this.cardStyles[i].overflow = 'hidden';
    };
    GridViewComponent.prototype.trackByFn = function (index, item) {
        return index;
    };
    return GridViewComponent;
}());
GridViewComponent.decorators = [
    { type: _angular_core.Component, args: [{
                selector: 'hbr-gridview',
                template: GRIDVIEW_TEMPLATE,
                styles: [GRIDVIEW_STYLE],
                encapsulation: _angular_core.ViewEncapsulation.None
            },] },
];
/** @nocollapse */
GridViewComponent.ctorParameters = function () { return [
    { type: _ngxTranslate_core.TranslateService, },
]; };
GridViewComponent.propDecorators = {
    'loading': [{ type: _angular_core.Input },],
    'totalCount': [{ type: _angular_core.Input },],
    'currentPage': [{ type: _angular_core.Input },],
    'pageSize': [{ type: _angular_core.Input },],
    'expectScrollPercent': [{ type: _angular_core.Input },],
    'withAdmiral': [{ type: _angular_core.Input },],
    'items': [{ type: _angular_core.Input },],
    'loadNextPageEvent': [{ type: _angular_core.Output },],
    'cards': [{ type: _angular_core.ViewChildren, args: ['cardItem',] },],
    'itemsHolder': [{ type: _angular_core.ViewChild, args: ['itemsHolder',] },],
    'gridItemTmpl': [{ type: _angular_core.ContentChild, args: [_angular_core.TemplateRef,] },],
    'onScroll': [{ type: _angular_core.HostListener, args: ['scroll', ['$event'],] },],
    'onResize': [{ type: _angular_core.HostListener, args: ['window:resize',] },],
};

var HBR_GRIDVIEW_DIRECTIVES = [
    GridViewComponent
];

var REPOSITORY_GRIDVIEW_TEMPLATE = "\n<div>\n    <div class=\"row\" style=\"position:relative;\">\n        <div class=\"toolbar\">\n            <div class=\"row flex-items-xs-right option-right rightPos\">\n                <div class=\"flex-xs-middle\">\n                    <hbr-push-image-button style=\"display: inline-block;\" [registryUrl]=\"registryUrl\" [projectName]=\"projectName\"></hbr-push-image-button>\n                    <hbr-filter [withDivider]=\"true\" filterPlaceholder=\"{{'REPOSITORY.FILTER_FOR_REPOSITORIES' | translate}}\" (filter)=\"doSearchRepoNames($event)\" [currentValue]=\"lastFilteredRepoName\"></hbr-filter>\n                    <span class=\"card-btn\" (click)=\"showCard(true)\" (mouseenter) =\"mouseEnter('card') \"  (mouseleave) =\"mouseLeave('card')\">\n                        <clr-icon [ngClass]=\"{'is-highlight': isCardView || isHovering('card') }\" shape=\"view-cards\"></clr-icon>\n                    </span>\n                    <span class=\"list-btn\" (click)=\"showCard(false)\" (mouseenter) =\"mouseEnter('list') \"  (mouseleave) =\"mouseLeave('list')\">\n                        <clr-icon [ngClass]=\"{'is-highlight': !isCardView || isHovering('list') }\"shape=\"view-list\"></clr-icon>\n                    </span>\n                    <span class=\"filter-divider\"></span>\n                    <span class=\"refresh-btn\" (click)=\"refresh()\"><clr-icon shape=\"refresh\"></clr-icon></span>\n                </div>\n            </div>\n        </div>\n    </div>\n    <div *ngIf=\"!isCardView\" class=\"col-lg-12 col-md-12 col-sm-12 col-xs-12\">\n      <clr-datagrid (clrDgRefresh)=\"clrLoad($event)\" [clrDgLoading]=\"loading\"  [(clrDgSelected)]=\"selectedRow\" (clrDgSelectedChange)=\"selectedChange()\">\n        <clr-dg-action-bar>\n          <button *ngIf=\"withAdmiral\" type=\"button\" class=\"btn btn-sm btn-secondary\" (click)=\"provisionItemEvent($event, selectedRow[0])\" [disabled]=\"!(selectedRow.length===1 && hasProjectAdminRole)\"><clr-icon shape=\"times\" size=\"16\"></clr-icon>&nbsp;{{'REPOSITORY.DEPLOY' | translate}}</button>\n          <button *ngIf=\"withAdmiral\" type=\"button\" class=\"btn btn-sm btn-secondary\" (click)=\"itemAddInfoEvent($event, selectedRow[0])\" [disabled]=\"!(selectedRow.length===1 && hasProjectAdminRole)\"><clr-icon shape=\"times\" size=\"16\"></clr-icon>&nbsp;{{'REPOSITORY.ADDITIONAL_INFO' | translate}}</button>\n          <button type=\"button\" class=\"btn btn-sm btn-secondary\" (click)=\"deleteRepos(selectedRow)\" [disabled]=\"!(selectedRow.length && hasProjectAdminRole)\"><clr-icon shape=\"times\" size=\"16\"></clr-icon>&nbsp;{{'REPOSITORY.DELETE' | translate}}</button>\n        </clr-dg-action-bar>\n        <clr-dg-column [clrDgField]=\"'name'\">{{'REPOSITORY.NAME' | translate}}</clr-dg-column>\n        <clr-dg-column [clrDgSortBy]=\"tagsCountComparator\">{{'REPOSITORY.TAGS_COUNT' | translate}}</clr-dg-column>\n        <clr-dg-column [clrDgSortBy]=\"pullCountComparator\">{{'REPOSITORY.PULL_COUNT' | translate}}</clr-dg-column>\n        <clr-dg-placeholder>{{'REPOSITORY.PLACEHOLDER' | translate }}</clr-dg-placeholder>\n        <clr-dg-row *ngFor=\"let r of repositories\"  [clrDgItem]=\"r\">\n          <clr-dg-cell><a href=\"javascript:void(0)\" (click)=\"watchRepoClickEvt(r)\"><span *ngIf=\"withAdmiral\" class=\"list-img\"><img [src]=\"getImgLink(r)\"/></span>{{r.name}}</a></clr-dg-cell>\n          <clr-dg-cell>{{r.tags_count}}</clr-dg-cell>\n          <clr-dg-cell>{{r.pull_count}}</clr-dg-cell>\n        </clr-dg-row>\n        <clr-dg-footer>\n          <span *ngIf=\"showDBStatusWarning\" class=\"db-status-warning\">\n            <clr-icon shape=\"warning\" class=\"is-warning\" size=\"24\"></clr-icon>\n            {{'CONFIG.SCANNING.DB_NOT_READY' | translate }}\n          </span>\n          <span *ngIf=\"pagination.totalItems\">{{pagination.firstItem + 1}} - {{pagination.lastItem + 1}} {{'REPOSITORY.OF' | translate}}</span>\n          {{pagination.totalItems}} {{'REPOSITORY.ITEMS' | translate}}\n          <clr-dg-pagination #pagination [(clrDgPage)]=\"currentPage\" [clrDgPageSize]=\"pageSize\" [clrDgTotalItems]=\"totalCount\"></clr-dg-pagination>\n        </clr-dg-footer>\n      </clr-datagrid>\n    </div>\n    <hbr-gridview *ngIf=\"isCardView\" #gridView style=\"position:relative;\" [items]=\"repositories\" [loading]=\"loading\" [pageSize]=\"pageSize\"\n        [currentPage]=\"currentPage\" [totalCount]=\"totalCount\" [expectScrollPercent]=\"90\" [withAdmiral]=\"withAdmiral\" (loadNextPageEvent)=\"loadNextPage()\">\n        <ng-template let-item=\"item\">\n            <a class=\"card clickable\" (click)=\"watchRepoClickEvt(item)\">\n                <div class=\"card-header\">\n                    <div [ngClass]=\"{'card-media-block': true, 'wrap': !withAdmiral }\">\n                        <img *ngIf=\"withAdmiral\" [src]=\"getImgLink(item)\"/>\n                        <div class=\"card-media-description\">\n                            <span class=\"card-media-title\">{{item.name}}</span>\n                            <p class=\"card-media-text\">{{registryUrl}}</p>\n                        </div>\n                    </div>\n                </div>\n                <div class=\"card-block\">\n                    <div class=\"card-text\">\n                        {{getRepoDescrition(item)}}\n                    </div>\n                    <div class=\"form-group\">\n                        <label>{{'REPOSITORY.TAGS_COUNT' | translate}}</label>\n                        <div>{{item.tags_count}}</div>\n                    </div>\n                    <div class=\"form-group\">\n                        <label>{{'REPOSITORY.PULL_COUNT' | translate}}</label>\n                        <div>{{item.pull_count}}</div>\n                    </div>\n                </div>\n                <div class=\"card-footer\">\n                    <clr-dropdown [clrCloseMenuOnItemClick]=\"false\">\n                        <button *ngIf=\"withAdmiral\" type=\"button\" class=\"btn btn-link\" (click)=\"provisionItemEvent($event, item)\" [disabled]=\"!hasProjectAdminRole\">{{'REPOSITORY.DEPLOY' | translate}}</button>\n                        <button type=\"button\" class=\"btn btn-link\" (click)=\"$event.stopPropagation()\" [disabled]=\"!hasProjectAdminRole\" clrDropdownTrigger>\n                            {{'REPOSITORY.ACTION' | translate}}\n                            <clr-icon shape=\"caret down\"></clr-icon>\n                        </button>\n                        <clr-dropdown-menu clrPosition=\"top-left\" *clrIfOpen>\n                            <button *ngIf=\"withAdmiral\" type=\"button\" class=\"btn btn-link\" clrDropdownItem (click)=\"itemAddInfoEvent($event, item)\" [disabled]=\"!hasProjectAdminRole\">\n                                {{'REPOSITORY.ADDITIONAL_INFO' | translate}}\n                            </button>\n                            <button type=\"button\" class=\"btn btn-link\" clrDropdownItem (click)=\"deleteItemEvent($event, item)\" [disabled]=\"!hasProjectAdminRole\">\n                                {{'REPOSITORY.DELETE' | translate}}\n                            </button>\n                        </clr-dropdown-menu>\n                    </clr-dropdown>\n                </div>\n            </a>\n        </ng-template>\n    </hbr-gridview>\n  <confirmation-dialog #confirmationDialog [batchInfors]=\"batchDelectionInfos\" (confirmAction)=\"confirmDeletion($event)\"></confirmation-dialog>\n</div>\n";

var REPOSITORY_GRIDVIEW_STYLE = "\n.rightPos{\n    position: absolute;\n    z-index: 100;\n    right: 35px;\n    margin-top: 4px;\n}\n\n.toolbar {\n    overflow: hidden;\n}\n\n.filter-divider {\n    display: inline-block;\n    height: 16px;\n    width: 2px;\n    background-color: #cccccc;\n    padding-top: 12px;\n    padding-bottom: 12px;\n    position: relative;\n    top: 9px;\n    margin-right: 6px;\n    margin-left: 6px;\n}\n\n.card-block {\n    margin-top: 24px;\n    min-height: 100px;\n}\n\n.form-group {\n    display: flex;\n}\n\n.form-group > label {\n    width: 100px;\n}\n\n.card-media-block > img {\n    height: 45px;\n    width: 45px;\n}\n\n.card-media-title {\n    overflow: hidden;\n    height: 24px;\n}\n.card-media-text {\n    overflow: hidden;\n    height: 21px\n}\n\n.card-media-description {\n    height: 45px;\n}\n.card-media-description > p {\n    margin-top:  0px;\n}\n\n.card-text {\n    height: 45px;\n    overflow: hidden;\n    margin-bottom: 18px;\n}\n\n.card-block {\n    margin-top: 0px;\n}\n\n.card-footer {\n    padding-top: 6px;\n    padding-bottom: 6px;\n}\n\n.list-img > img {\n    height: 24px;\n    width: 24px;\n    margin-right: 12px;\n}\n";

var RepositoryGridviewComponent = (function () {
    function RepositoryGridviewComponent(errorHandler, translateService, repositoryService, systemInfoService, tagService, ref, router) {
        this.errorHandler = errorHandler;
        this.translateService = translateService;
        this.repositoryService = repositoryService;
        this.systemInfoService = systemInfoService;
        this.tagService = tagService;
        this.ref = ref;
        this.router = router;
        this.signedCon = {};
        this.projectName = 'unknown';
        this.mode = 'admiral';
        this.repoClickEvent = new _angular_core.EventEmitter();
        this.repoProvisionEvent = new _angular_core.EventEmitter();
        this.addInfoEvent = new _angular_core.EventEmitter();
        this.repositories = [];
        this.repositoriesCopy = [];
        this.selectedRow = [];
        this.loading = true;
        this.cardHover = false;
        this.listHover = false;
        this.batchDelectionInfos = [];
        this.pullCountComparator = new CustomComparator('pull_count', 'number');
        this.tagsCountComparator = new CustomComparator('tags_count', 'number');
        this.pageSize = DEFAULT_PAGE_SIZE;
        this.currentPage = 1;
        this.totalCount = 0;
    }
    Object.defineProperty(RepositoryGridviewComponent.prototype, "registryUrl", {
        get: function () {
            return this.systemInfo ? this.systemInfo.registry_url : '';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RepositoryGridviewComponent.prototype, "withClair", {
        get: function () {
            return this.systemInfo ? this.systemInfo.with_clair : false;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RepositoryGridviewComponent.prototype, "isClairDBReady", {
        get: function () {
            return this.systemInfo &&
                this.systemInfo.clair_vulnerability_status &&
                this.systemInfo.clair_vulnerability_status.overall_last_update > 0;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RepositoryGridviewComponent.prototype, "withAdmiral", {
        get: function () {
            return this.mode === 'admiral';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RepositoryGridviewComponent.prototype, "showDBStatusWarning", {
        get: function () {
            return this.withClair && !this.isClairDBReady;
        },
        enumerable: true,
        configurable: true
    });
    RepositoryGridviewComponent.prototype.ngOnChanges = function (changes) {
        if (changes['projectId'] && changes['projectId'].currentValue) {
            this.refresh();
        }
    };
    RepositoryGridviewComponent.prototype.ngOnInit = function () {
        var _this = this;
        // Get system info for tag views
        toPromise(this.systemInfoService.getSystemInfo())
            .then(function (systemInfo) { return _this.systemInfo = systemInfo; })
            .catch(function (error) { return _this.errorHandler.error(error); });
        if (this.mode === 'admiral') {
            this.isCardView = true;
        }
        else {
            this.isCardView = false;
        }
        this.lastFilteredRepoName = '';
    };
    RepositoryGridviewComponent.prototype.confirmDeletion = function (message) {
        var _this = this;
        if (message &&
            message.source === 7 /* REPOSITORY */ &&
            message.state === 1 /* CONFIRMED */) {
            var promiseLists_1 = [];
            var repoNames = message.data.split(',');
            repoNames.forEach(function (repoName) {
                promiseLists_1.push(_this.delOperate(repoName));
            });
            Promise.all(promiseLists_1).then(function (item) {
                _this.selectedRow = [];
                _this.refresh();
                var st = _this.getStateAfterDeletion();
                if (!st) {
                    _this.refresh();
                }
                else {
                    _this.clrLoad(st);
                }
            });
        }
    };
    RepositoryGridviewComponent.prototype.delOperate = function (repoName) {
        var _this = this;
        var findedList = this.batchDelectionInfos.find(function (data) { return data.name === repoName; });
        if (this.signedCon[repoName].length !== 0) {
            rxjs_Observable.Observable.forkJoin(this.translateService.get('BATCH.DELETED_FAILURE'), this.translateService.get('REPOSITORY.DELETION_TITLE_REPO_SIGNED')).subscribe(function (res) {
                findedList = BathInfoChanges(findedList, res[0], false, true, res[1]);
            });
        }
        else {
            return toPromise(this.repositoryService
                .deleteRepository(repoName))
                .then(function (response) {
                _this.translateService.get('BATCH.DELETED_SUCCESS').subscribe(function (res) {
                    findedList = BathInfoChanges(findedList, res);
                });
            }).catch(function (error) {
                if (error.status === "412") {
                    rxjs_Observable.Observable.forkJoin(_this.translateService.get('BATCH.DELETED_FAILURE'), _this.translateService.get('REPOSITORY.TAGS_SIGNED')).subscribe(function (res) {
                        findedList = BathInfoChanges(findedList, res[0], false, true, res[1]);
                    });
                    return;
                }
                if (error.status === 503) {
                    rxjs_Observable.Observable.forkJoin(_this.translateService.get('BATCH.DELETED_FAILURE'), _this.translateService.get('REPOSITORY.TAGS_NO_DELETE')).subscribe(function (res) {
                        findedList = BathInfoChanges(findedList, res[0], false, true, res[1]);
                    });
                    return;
                }
                _this.translateService.get('BATCH.DELETED_FAILURE').subscribe(function (res) {
                    findedList = BathInfoChanges(findedList, res, false, true);
                });
            });
        }
    };
    RepositoryGridviewComponent.prototype.doSearchRepoNames = function (repoName) {
        this.lastFilteredRepoName = repoName;
        this.currentPage = 1;
        var st = this.currentState;
        if (!st) {
            st = { page: {} };
        }
        st.page.size = this.pageSize;
        st.page.from = 0;
        st.page.to = this.pageSize - 1;
        this.clrLoad(st);
    };
    RepositoryGridviewComponent.prototype.saveSignatures = function (event) {
        Object.assign(this.signedCon, event);
    };
    RepositoryGridviewComponent.prototype.deleteRepos = function (repoLists) {
        var _this = this;
        if (repoLists && repoLists.length) {
            var repoNames_1 = [];
            this.batchDelectionInfos = [];
            var repArr_1 = [];
            repoLists.forEach(function (repo) {
                repoNames_1.push(repo.name);
                var initBatchMessage = new BatchInfo();
                initBatchMessage.name = repo.name;
                _this.batchDelectionInfos.push(initBatchMessage);
                if (!_this.signedCon[repo.name]) {
                    repArr_1.push(_this.getTagInfo(repo.name));
                }
            });
            Promise.all(repArr_1).then(function () {
                _this.confirmationDialogSet('REPOSITORY.DELETION_TITLE_REPO', '', repoNames_1.join(','), 'REPOSITORY.DELETION_SUMMARY_REPO', 2 /* DELETE_CANCEL */);
            });
        }
    };
    RepositoryGridviewComponent.prototype.getTagInfo = function (repoName) {
        var _this = this;
        this.signedCon[repoName] = [];
        return toPromise(this.tagService
            .getTags(repoName))
            .then(function (items) {
            items.forEach(function (t) {
                if (t.signature !== null) {
                    _this.signedCon[repoName].push(t.name);
                }
            });
        })
            .catch(function (error) { return _this.errorHandler.error(error); });
    };
    RepositoryGridviewComponent.prototype.signedDataSet = function (repoName) {
        var signature = '';
        if (this.signedCon[repoName].length === 0) {
            this.confirmationDialogSet('REPOSITORY.DELETION_TITLE_REPO', signature, repoName, 'REPOSITORY.DELETION_SUMMARY_REPO', 2 /* DELETE_CANCEL */);
            return;
        }
        signature = this.signedCon[repoName].join(',');
        this.confirmationDialogSet('REPOSITORY.DELETION_TITLE_REPO_SIGNED', signature, repoName, 'REPOSITORY.DELETION_SUMMARY_REPO_SIGNED', 3 /* CLOSE */);
    };
    RepositoryGridviewComponent.prototype.confirmationDialogSet = function (summaryTitle, signature, repoName, summaryKey, button) {
        var _this = this;
        this.translateService.get(summaryKey, {
            repoName: repoName,
            signedImages: signature,
        })
            .subscribe(function (res) {
            summaryKey = res;
            var message = new ConfirmationMessage(summaryTitle, summaryKey, repoName, repoName, 7 /* REPOSITORY */, button);
            _this.confirmationDialog.open(message);
            var hnd = setInterval(function () { return _this.ref.markForCheck(); }, 100);
            setTimeout(function () { return clearInterval(hnd); }, 5000);
        });
    };
    RepositoryGridviewComponent.prototype.containsLatestTag = function (repo) {
        return toPromise(this.tagService.getTags(repo.name))
            .then(function (items) {
            if (items.some(function (t) { return t.name === 'latest'; })) {
                return true;
            }
            else {
                return false;
            }
            
        })
            .catch(function (error) { return Promise.reject(false); });
    };
    RepositoryGridviewComponent.prototype.provisionItemEvent = function (evt, repo) {
        var _this = this;
        evt.stopPropagation();
        var repoCopy = clone(repo);
        repoCopy.name = this.registryUrl + ":443/" + repoCopy.name;
        this.containsLatestTag(repo)
            .then(function (containsLatest) {
            if (containsLatest) {
                _this.repoProvisionEvent.emit(repoCopy);
            }
            else {
                _this.addInfoEvent.emit(repoCopy);
            }
        })
            .catch(function (error) { return _this.errorHandler.error(error); });
    };
    RepositoryGridviewComponent.prototype.itemAddInfoEvent = function (evt, repo) {
        evt.stopPropagation();
        var repoCopy = clone(repo);
        repoCopy.name = this.registryUrl + ':443/' + repoCopy.name;
        this.addInfoEvent.emit(repoCopy);
    };
    RepositoryGridviewComponent.prototype.deleteItemEvent = function (evt, item) {
        evt.stopPropagation();
        this.deleteRepos([item]);
    };
    RepositoryGridviewComponent.prototype.selectedChange = function () {
        var _this = this;
        var hnd = setInterval(function () { return _this.ref.markForCheck(); }, 100);
        setTimeout(function () { return clearInterval(hnd); }, 2000);
    };
    RepositoryGridviewComponent.prototype.refresh = function () {
        this.doSearchRepoNames('');
    };
    RepositoryGridviewComponent.prototype.loadNextPage = function () {
        var _this = this;
        if (this.currentPage * this.pageSize >= this.totalCount) {
            return;
        }
        this.currentPage = this.currentPage + 1;
        // Pagination
        var params = new RequestQueryParams();
        params.set("page", '' + this.currentPage);
        params.set("page_size", '' + this.pageSize);
        this.loading = true;
        toPromise(this.repositoryService.getRepositories(this.projectId, this.lastFilteredRepoName, params))
            .then(function (repo) {
            _this.totalCount = repo.metadata.xTotalCount;
            _this.repositoriesCopy = repo.data;
            _this.signedCon = {};
            // Do filtering and sorting
            _this.repositoriesCopy = doFiltering(_this.repositoriesCopy, _this.currentState);
            _this.repositoriesCopy = doSorting(_this.repositoriesCopy, _this.currentState);
            _this.repositories = _this.repositories.concat(_this.repositoriesCopy);
            _this.loading = false;
        })
            .catch(function (error) {
            _this.loading = false;
            _this.errorHandler.error(error);
        });
        var hnd = setInterval(function () { return _this.ref.markForCheck(); }, 500);
        setTimeout(function () { return clearInterval(hnd); }, 5000);
    };
    RepositoryGridviewComponent.prototype.clrLoad = function (state) {
        var _this = this;
        this.selectedRow = [];
        // Keep it for future filtering and sorting
        this.currentState = state;
        var pageNumber = calculatePage(state);
        if (pageNumber <= 0) {
            pageNumber = 1;
        }
        // Pagination
        var params = new RequestQueryParams();
        params.set("page", '' + pageNumber);
        params.set("page_size", '' + this.pageSize);
        this.loading = true;
        toPromise(this.repositoryService.getRepositories(this.projectId, this.lastFilteredRepoName, params))
            .then(function (repo) {
            _this.totalCount = repo.metadata.xTotalCount;
            _this.repositories = repo.data;
            _this.signedCon = {};
            // Do filtering and sorting
            _this.repositories = doFiltering(_this.repositories, state);
            _this.repositories = doSorting(_this.repositories, state);
            _this.loading = false;
        })
            .catch(function (error) {
            _this.loading = false;
            _this.errorHandler.error(error);
        });
        // Force refresh view
        var hnd = setInterval(function () { return _this.ref.markForCheck(); }, 100);
        setTimeout(function () { return clearInterval(hnd); }, 5000);
    };
    RepositoryGridviewComponent.prototype.getStateAfterDeletion = function () {
        var total = this.totalCount - 1;
        if (total <= 0) {
            return null;
        }
        var totalPages = Math.ceil(total / this.pageSize);
        var targetPageNumber = this.currentPage;
        if (this.currentPage > totalPages) {
            targetPageNumber = totalPages; // Should == currentPage -1
        }
        var st = this.currentState;
        if (!st) {
            st = { page: {} };
        }
        st.page.size = this.pageSize;
        st.page.from = (targetPageNumber - 1) * this.pageSize;
        st.page.to = targetPageNumber * this.pageSize - 1;
        return st;
    };
    RepositoryGridviewComponent.prototype.watchRepoClickEvt = function (repo) {
        this.repoClickEvent.emit(repo);
    };
    RepositoryGridviewComponent.prototype.getImgLink = function (repo) {
        return '/container-image-icons?container-image=' + repo.name;
    };
    RepositoryGridviewComponent.prototype.getRepoDescrition = function (repo) {
        if (repo && repo.description) {
            return repo.description;
        }
        return "No description for this repo. You can add it to this repository.";
    };
    RepositoryGridviewComponent.prototype.showCard = function (cardView) {
        if (this.isCardView === cardView) {
            return;
        }
        this.isCardView = cardView;
        this.refresh();
    };
    RepositoryGridviewComponent.prototype.mouseEnter = function (itemName) {
        if (itemName === 'card') {
            this.cardHover = true;
        }
        else {
            this.listHover = true;
        }
    };
    RepositoryGridviewComponent.prototype.mouseLeave = function (itemName) {
        if (itemName === 'card') {
            this.cardHover = false;
        }
        else {
            this.listHover = false;
        }
    };
    RepositoryGridviewComponent.prototype.isHovering = function (itemName) {
        if (itemName === 'card') {
            return this.cardHover;
        }
        else {
            return this.listHover;
        }
    };
    return RepositoryGridviewComponent;
}());
RepositoryGridviewComponent.decorators = [
    { type: _angular_core.Component, args: [{
                selector: 'hbr-repository-gridview',
                template: REPOSITORY_GRIDVIEW_TEMPLATE,
                styles: [REPOSITORY_GRIDVIEW_STYLE],
                changeDetection: _angular_core.ChangeDetectionStrategy.OnPush
            },] },
];
/** @nocollapse */
RepositoryGridviewComponent.ctorParameters = function () { return [
    { type: ErrorHandler, },
    { type: _ngxTranslate_core.TranslateService, },
    { type: RepositoryService, },
    { type: SystemInfoService, },
    { type: TagService, },
    { type: _angular_core.ChangeDetectorRef, },
    { type: _angular_router.Router, },
]; };
RepositoryGridviewComponent.propDecorators = {
    'projectId': [{ type: _angular_core.Input },],
    'projectName': [{ type: _angular_core.Input },],
    'urlPrefix': [{ type: _angular_core.Input },],
    'hasSignedIn': [{ type: _angular_core.Input },],
    'hasProjectAdminRole': [{ type: _angular_core.Input },],
    'mode': [{ type: _angular_core.Input },],
    'repoClickEvent': [{ type: _angular_core.Output },],
    'repoProvisionEvent': [{ type: _angular_core.Output },],
    'addInfoEvent': [{ type: _angular_core.Output },],
    'confirmationDialog': [{ type: _angular_core.ViewChild, args: ['confirmationDialog',] },],
    'gridView': [{ type: _angular_core.ViewChild, args: ['gridView',] },],
};

var REPOSITORY_GRIDVIEW_DIRECTIVES = [
    RepositoryGridviewComponent
];

var MyMissingTranslationHandler = (function () {
    function MyMissingTranslationHandler() {
    }
    MyMissingTranslationHandler.prototype.handle = function (params) {
        var missingText = "{Harbor}";
        return params.key || missingText;
    };
    return MyMissingTranslationHandler;
}());

var __extends$13 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * Declare a translation loader with local json object
 *
 * @export
 * @class TranslatorJsonLoader
 * @extends {TranslateLoader}
 */
var TranslatorJsonLoader = (function (_super) {
    __extends$13(TranslatorJsonLoader, _super);
    function TranslatorJsonLoader(config) {
        var _this = _super.call(this) || this;
        _this.config = config;
        return _this;
    }
    TranslatorJsonLoader.prototype.getTranslation = function (lang) {
        var dict = this.config &&
            this.config.localI18nMessageVariableMap &&
            this.config.localI18nMessageVariableMap[lang] ?
            this.config.localI18nMessageVariableMap[lang] : {};
        return rxjs_Observable.Observable.of(dict);
    };
    return TranslatorJsonLoader;
}(_ngxTranslate_core.TranslateLoader));

var WINDOW = new _angular_core.InjectionToken('WindowToken');
function _window() {
    return window;
}
var WindowTokenModule = (function () {
    function WindowTokenModule() {
    }
    return WindowTokenModule;
}());
WindowTokenModule.decorators = [
    { type: _angular_core.NgModule, args: [{
                providers: [{
                        provide: WINDOW,
                        useFactory: _window
                    }]
            },] },
];
/** @nocollapse */
WindowTokenModule.ctorParameters = function () { return []; };

var ClipboardService = (function () {
    function ClipboardService(document, window) {
        this.document = document;
        this.window = window;
    }
    Object.defineProperty(ClipboardService.prototype, "isSupported", {
        get: function () {
            return !!this.document.queryCommandSupported && !!this.document.queryCommandSupported('copy');
        },
        enumerable: true,
        configurable: true
    });
    ClipboardService.prototype.isTargetValid = function (element) {
        if (element instanceof HTMLInputElement || element instanceof HTMLTextAreaElement) {
            if (element.hasAttribute('disabled')) {
                // tslint:disable-next-line:max-line-length
                throw new Error('Invalid "target" attribute. Please use "readonly" instead of "disabled" attribute');
            }
            return true;
        }
        throw new Error('Target should be input or textarea');
    };
    /**
     * copyFromInputElement
     */
    ClipboardService.prototype.copyFromInputElement = function (targetElm, renderer) {
        try {
            this.selectTarget(targetElm, renderer);
            var re = this.copyText();
            this.clearSelection(targetElm, this.window);
            return re;
        }
        catch (error) {
            return false;
        }
    };
    /**
     * Creates a fake textarea element, sets its value from `text` property,
     * and makes a selection on it.
     */
    ClipboardService.prototype.copyFromContent = function (content, renderer) {
        if (!this.tempTextArea) {
            this.tempTextArea = this.createTempTextArea(this.document, this.window);
            this.document.body.appendChild(this.tempTextArea);
        }
        this.tempTextArea.value = content;
        return this.copyFromInputElement(this.tempTextArea, renderer);
    };
    // remove temporary textarea if any
    ClipboardService.prototype.destroy = function () {
        if (this.tempTextArea) {
            this.document.body.removeChild(this.tempTextArea);
            this.tempTextArea = undefined;
        }
    };
    // select the target html input element
    ClipboardService.prototype.selectTarget = function (inputElement, renderer) {
        renderer.invokeElementMethod(inputElement, 'select');
        renderer.invokeElementMethod(inputElement, 'setSelectionRange', [0, inputElement.value.length]);
        return inputElement.value.length;
    };
    ClipboardService.prototype.copyText = function () {
        return this.document.execCommand('copy');
    };
    // Removes current selection and focus from `target` element.
    ClipboardService.prototype.clearSelection = function (inputElement, window) {
        // tslint:disable-next-line:no-unused-expression
        inputElement && inputElement.blur();
        window.getSelection().removeAllRanges();
    };
    // create a fake textarea for copy command
    ClipboardService.prototype.createTempTextArea = function (doc, window) {
        var isRTL = doc.documentElement.getAttribute('dir') === 'rtl';
        var ta;
        ta = doc.createElement('textarea');
        // Prevent zooming on iOS
        ta.style.fontSize = '12pt';
        // Reset box model
        ta.style.border = '0';
        ta.style.padding = '0';
        ta.style.margin = '0';
        // Move element out of screen horizontally
        ta.style.position = 'absolute';
        ta.style[isRTL ? 'right' : 'left'] = '-9999px';
        // Move element to the same position vertically
        var yPosition = window.pageYOffset || doc.documentElement.scrollTop;
        ta.style.top = yPosition + 'px';
        ta.setAttribute('readonly', '');
        return ta;
    };
    return ClipboardService;
}());
ClipboardService.decorators = [
    { type: _angular_core.Injectable },
];
/** @nocollapse */
ClipboardService.ctorParameters = function () { return [
    { type: undefined, decorators: [{ type: _angular_core.Inject, args: [_angular_platformBrowser.DOCUMENT,] },] },
    { type: undefined, decorators: [{ type: _angular_core.Inject, args: [WINDOW,] },] },
]; };
// this pattern is mentioned in https://github.com/angular/angular/issues/13854 in #43
function CLIPBOARD_SERVICE_PROVIDER_FACTORY(doc, win, parentDispatcher) {
    return parentDispatcher || new ClipboardService(doc, win);
}

var CLIPBOARD_SERVICE_PROVIDER = {
    provide: ClipboardService,
    deps: [_angular_platformBrowser.DOCUMENT, WINDOW, [new _angular_core.Optional(), new _angular_core.SkipSelf(), ClipboardService]],
    useFactory: CLIPBOARD_SERVICE_PROVIDER_FACTORY
};

var ClipboardDirective = (function () {
    function ClipboardDirective(clipboardSrv, renderer) {
        this.clipboardSrv = clipboardSrv;
        this.renderer = renderer;
        this.cbOnSuccess = new _angular_core.EventEmitter();
        this.cbOnError = new _angular_core.EventEmitter();
    }
    ClipboardDirective.prototype.ngOnInit = function () { };
    ClipboardDirective.prototype.ngOnDestroy = function () {
        this.clipboardSrv.destroy();
    };
    ClipboardDirective.prototype.onClick = function (button) {
        if (!this.clipboardSrv.isSupported) {
            this.handleResult(false, undefined);
        }
        else if (this.targetElm && this.clipboardSrv.isTargetValid(this.targetElm)) {
            this.handleResult(this.clipboardSrv.copyFromInputElement(this.targetElm, this.renderer), this.targetElm.value);
        }
        else if (this.cbContent) {
            this.handleResult(this.clipboardSrv.copyFromContent(this.cbContent, this.renderer), this.cbContent);
        }
    };
    /**
     * Fires an event based on the copy operation result.
     * @param {Boolean} succeeded
     */
    ClipboardDirective.prototype.handleResult = function (succeeded, copiedContent) {
        if (succeeded) {
            this.cbOnSuccess.emit({ isSuccess: true, content: copiedContent });
        }
        else {
            this.cbOnError.emit({ isSuccess: false });
        }
    };
    return ClipboardDirective;
}());
ClipboardDirective.decorators = [
    { type: _angular_core.Directive, args: [{
                selector: '[ngxClipboard]'
            },] },
];
/** @nocollapse */
ClipboardDirective.ctorParameters = function () { return [
    { type: ClipboardService, },
    { type: _angular_core.Renderer, },
]; };
ClipboardDirective.propDecorators = {
    'targetElm': [{ type: _angular_core.Input, args: ['ngxClipboard',] },],
    'cbContent': [{ type: _angular_core.Input },],
    'cbOnSuccess': [{ type: _angular_core.Output },],
    'cbOnError': [{ type: _angular_core.Output },],
    'onClick': [{ type: _angular_core.HostListener, args: ['click', ['$event.target'],] },],
};

var ClipboardModule = (function () {
    function ClipboardModule() {
    }
    return ClipboardModule;
}());
ClipboardModule.decorators = [
    { type: _angular_core.NgModule, args: [{
                imports: [_angular_common.CommonModule, WindowTokenModule],
                declarations: [ClipboardDirective],
                exports: [ClipboardDirective],
                providers: [CLIPBOARD_SERVICE_PROVIDER]
            },] },
];
/** @nocollapse */
ClipboardModule.ctorParameters = function () { return []; };

/*export function HttpLoaderFactory(http: Http) {
    return new TranslateHttpLoader(http, 'i18n/lang/', '-lang.json');
}

export function LocalJsonLoaderFactory() {
    return new TranslatorJsonLoader();
}*/
function GeneralTranslatorLoader(http, config) {
    if (config && config.langMessageLoader === 'http') {
        var prefix = config.langMessagePathForHttpLoader ? config.langMessagePathForHttpLoader : "i18n/lang/";
        var suffix = config.langMessageFileSuffixForHttpLoader ? config.langMessageFileSuffixForHttpLoader : "-lang.json";
        return new _ngxTranslate_httpLoader.TranslateHttpLoader(http, prefix, suffix);
    }
    else {
        return new TranslatorJsonLoader(config);
    }
}
/**
 *
 * Module for sharing common modules
 *
 * @export
 * @class SharedModule
 */
var SharedModule = (function () {
    function SharedModule() {
    }
    return SharedModule;
}());
SharedModule.decorators = [
    { type: _angular_core.NgModule, args: [{
                imports: [
                    _angular_common.CommonModule,
                    _angular_http.HttpModule,
                    _angular_forms.FormsModule,
                    _angular_forms.ReactiveFormsModule,
                    ClipboardModule,
                    ngxCookie.CookieModule.forRoot(),
                    clarityAngular.ClarityModule.forRoot(),
                    _ngxTranslate_core.TranslateModule.forRoot({
                        loader: {
                            provide: _ngxTranslate_core.TranslateLoader,
                            useFactory: (GeneralTranslatorLoader),
                            deps: [_angular_http.Http, SERVICE_CONFIG]
                        },
                        missingTranslationHandler: {
                            provide: _ngxTranslate_core.MissingTranslationHandler,
                            useClass: MyMissingTranslationHandler
                        }
                    }),
                ],
                exports: [
                    _angular_common.CommonModule,
                    _angular_http.HttpModule,
                    _angular_forms.FormsModule,
                    _angular_forms.ReactiveFormsModule,
                    ngxCookie.CookieModule,
                    ClipboardModule,
                    clarityAngular.ClarityModule,
                    _ngxTranslate_core.TranslateModule,
                ],
                providers: [ngxCookie.CookieService]
            },] },
];
/** @nocollapse */
SharedModule.ctorParameters = function () { return []; };

var TranslateServiceInitializer = (function () {
    function TranslateServiceInitializer(translateService, cookie) {
        this.translateService = translateService;
        this.cookie = cookie;
    }
    TranslateServiceInitializer.prototype.init = function (config) {
        if (config === void 0) { config = {}; }
        var selectedLang = config.defaultLang ? config.defaultLang : DEFAULT_LANG;
        var supportedLangs = config.supportedLangs ? config.supportedLangs : DEFAULT_SUPPORTING_LANGS;
        this.translateService.addLangs(supportedLangs);
        this.translateService.setDefaultLang(selectedLang);
        if (config.enablei18Support) {
            //If user has selected lang, then directly use it
            var langSetting_1 = this.cookie.get(config.langCookieKey ? config.langCookieKey : DEFAULT_LANG_COOKIE_KEY);
            if (!langSetting_1 || langSetting_1.trim() === "") {
                //Use browser lang
                langSetting_1 = this.translateService.getBrowserCultureLang().toLowerCase();
            }
            if (langSetting_1 && langSetting_1.trim() !== "") {
                if (supportedLangs && supportedLangs.length > 0) {
                    if (supportedLangs.find(function (lang) { return lang === langSetting_1; })) {
                        selectedLang = langSetting_1;
                    }
                }
            }
        }
        this.translateService.use(selectedLang);
    };
    return TranslateServiceInitializer;
}());
TranslateServiceInitializer.decorators = [
    { type: _angular_core.Injectable },
];
/** @nocollapse */
TranslateServiceInitializer.ctorParameters = function () { return [
    { type: _ngxTranslate_core.TranslateService, },
    { type: ngxCookie.CookieService, },
]; };

var LABEL_TEMPLATE = "\n<div>\n    <div class=\"row\"  style=\"position:relative;\">\n        <div>\n            <div class=\"row flex-items-xs-between rightPos\">\n                <div class=\"flex-items-xs-middle option-right\">\n                    <hbr-filter [withDivider]=\"true\" filterPlaceholder='{{\"LABEL.FILTER_LABEL_PLACEHOLDER\" | translate}}' (filter)=\"doSearchTargets($event)\" [currentValue]=\"targetName\"></hbr-filter>\n                    <span class=\"refresh-btn\" (click)=\"refreshTargets()\">\n                        <clr-icon shape=\"refresh\"></clr-icon>\n                    </span>\n                </div>\n            </div>\n        </div>\n        <div class=\"col-lg-12 col-md-12 col-sm-12 col-xs-12 btnGroup\">\n            <button type=\"button\" class=\"btn btn-sm btn-secondary\" (click)=\"openModal()\"><clr-icon shape=\"plus\" size=\"16\"></clr-icon>&nbsp;{{'LABEL.NEW_LABEL' | translate}}</button>\n            <button type=\"button\" class=\"btn btn-sm btn-secondary\" [disabled]=\"!(selectedRow.length == 1)\" (click)=\"editLabel(selectedRow)\"><clr-icon shape=\"pencil\" size=\"16\"></clr-icon>&nbsp;{{'LABEL.EDIT' | translate}}</button>\n            <button type=\"button\" class=\"btn btn-sm btn-secondary\" [disabled]=\"!selectedRow.length\" (click)=\"deleteLabels(selectedRow)\"><clr-icon shape=\"times\" size=\"16\"></clr-icon>&nbsp;{{'LABEL.DELETE' | translate}}</button>     \n            <hbr-create-edit-label [scope]=\"scope\"  [projectId]=\"projectId\" (reload)=\"reload()\"></hbr-create-edit-label>\n        </div>\n        <div class=\"col-lg-12 col-md-12 col-sm-12 col-xs-12\">\n            <clr-datagrid [clrDgLoading]=\"loading\"  [(clrDgSelected)]=\"selectedRow\" (clrDgSelectedChange)=\"selectedChange()\">\n                <clr-dg-column [clrDgField]=\"'name'\">{{'LABEL.LABEL' | translate}}</clr-dg-column>\n                <clr-dg-column [clrDgField]=\"'endpoint'\">{{'LABEL.DESCRIPTION' | translate}}</clr-dg-column>\n                <clr-dg-column [clrDgField]=\"'insecure'\">{{'LABEL.CREATION_TIME' | translate }}</clr-dg-column>\n                 <clr-dg-placeholder>{{'LABEL.PLACEHOLDER' | translate }}</clr-dg-placeholder>\n                <clr-dg-row *clrDgItems=\"let label of targets\" [clrDgItem]='label'>\n                    <clr-dg-cell>\n                        <hbr-label-piece [label]=\"label\"></hbr-label-piece>\n                    </clr-dg-cell>\n                    <clr-dg-cell>{{label.description}}</clr-dg-cell>\n                    <clr-dg-cell>{{label.creation_time | date: 'short'}}</clr-dg-cell>\n                </clr-dg-row>\n                <clr-dg-footer>\n                    <span *ngIf=\"pagination.totalItems\">{{pagination.firstItem + 1}} - {{pagination.lastItem + 1}} {{'DESTINATION.OF' | translate}}</span>\n                    {{pagination.totalItems}} {{'DESTINATION.ITEMS' | translate}}\n                    <clr-dg-pagination #pagination [clrDgPageSize]=\"15\"></clr-dg-pagination>\n                </clr-dg-footer>\n            </clr-datagrid>\n        </div>\n    </div>\n    <confirmation-dialog #confirmationDialog [batchInfors]=\"batchDelectionInfos\" (confirmAction)=\"confirmDeletion($event)\"></confirmation-dialog>\n</div>\n";

var LABEL_STYLE = "\n  .option-left {\n    padding-left: 16px;\n    margin-top: -6px;\n  }\n  .option-right {\n    padding-right: 16px;\n  }\n  .refresh-btn {\n    cursor: pointer;\n  }\n  .refresh-btn:hover {\n    color: #007CBB;\n  }\n  .rightPos{  \n    position: absolute;\n    z-index: 100;\n    right: 35px;\n    margin-top: 4px;\n    height: 24px;}\n";

var CREATE_EDIT_LABEL_STYLE = "\n  .form-group-label-override {\n    font-size: 14px;\n    font-weight: 400;\n  }\n  \n  form{margin-bottom:-10px;padding-top:0; margin-top: 20px;width: 100%;background-color: #eee; border:1px solid #ccc;}    \n  form .form-group{display:inline-flex;padding-left: 70px;}\n  form .form-group>label:first-child{width: auto;}\n  section{padding:.5rem 0;}\n  section> label{margin-left: 20px;}\n  \n  .colorDrop {display:inline-block;position: relative; width: 132px;}\n  .colorDrop .colorPanel{position:absolute;  width:166px; padding:6px;    background-color: white; border: 1px solid #ccc; z-index:10;}\n  .btnColor{\n    margin: 0 !important;\n    padding: 0 !important;\n    width: 26px;\n    height:22px;\n    min-width: 26px;}\n .dropdown-item{margin: 5px 4px; width:30px;height:24px; text-align: center;line-height: 24px;font-size:12px;}\n .closePanel{ display: block;\n    left: 138px;\n    position: relative;\n    font-size: 18px;\n    width: 10px;\n    line-height: 8px;\n    cursor: pointer;\n    text-decoration: none;}\n";

var CREATE_EDIT_LABEL_TEMPLATE = "\n<div>\n    <form #labelForm=\"ngForm\" [hidden]=\"!formShow\">\n        <section>\n            <label>\n                <label for=\"name\">{{'LABEL.LABEL_NAME' | translate}}</label>\n                    <label  aria-haspopup=\"true\" role=\"tooltip\" [class.invalid]=\"isLabelNameExist\" class=\"tooltip tooltip-validation tooltip-md tooltip-bottom-left\">\n                    <input type=\"text\" id=\"name\" name=\"name\" required size=\"20\" autocomplete=\"off\" [(ngModel)]=\"labelModel.name\" #name=\"ngModel\" (keyup)=\"existValid(labelModel.name)\">\n                    <span class=\"tooltip-content\">\n                      {{'LABEL.NAME_ALREADY_EXISTS' | translate }}\n                    </span>\n                </label>\n            </label>\n            <label>\n                <label for=\"color\">{{'LABEL.COLOR' | translate}}</label>\n                <div class=\"colorDrop\">\n                  <button type=\"button\" class=\"btn btn-outline btnColor btn-sm\" >\n                    <clr-icon shape=\"caret down\" size=\"20\" style='right:2px; width:24px; height:18px;' (click)=\"openColorPanel()\"></clr-icon>\n                  </button>\n                  <div class=\"colorPanel\" [hidden]=\"panelHidden\">\n                    <a class=\"closePanel\" (click)=\"closeColorPanel()\">&times;</a>\n                    <label type=\"button\" class=\"dropdown-item\"  (click)=\"labelModel.color=i.color\" *ngFor=\"let i of labelColor\" [ngStyle]=\"{'background-color': i.color, 'color': i.textColor }\">Aa</label>\n                  </div>\n                  <input type=\"text\" id=\"color\" size=\"8\" name=\"color\" disabled [(ngModel)]=\"labelModel.color\"  #color=\"ngModel\">\n                </div>\n            </label>\n            <label>\n                <label for=\"description\">{{'LABEL.DESCRIPTION' | translate}}</label>\n                <input type=\"text\" id=\"description\" name=\"description\" size=\"30\" [(ngModel)]=\"labelModel.description\" #description=\"ngModel\">\n            </label>\n            <label>\n                <button type=\"button\" class=\"btn btn-sm btn-outline\" (click)=\"onCancel()\"  [disabled]=\"inProgress\">{{ 'BUTTON.CANCEL' | translate }}</button>\n                <button type=\"submit\" class=\"btn btn-sm btn-primary\" (click)=\"onSubmit()\"  [disabled]=\"!isValid\">{{ 'BUTTON.OK' | translate }}</button>\n            </label>\n        </section>\n    </form>\n</div>";

// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//    http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.












var LabelColor = [
    { 'color': '#000000', 'textColor': 'white' }, { 'color': '#61717D', 'textColor': 'white' }, { 'color': '#737373', 'textColor': 'white' }, { 'color': '#80746D', 'textColor': 'white' },
    { 'color': '#FFFFFF', 'textColor': 'black' }, { 'color': '#A9B6BE', 'textColor': 'black' }, { 'color': '#DDDDDD', 'textColor': 'black' }, { 'color': '#BBB3A9', 'textColor': 'black' },
    { 'color': '#0065AB', 'textColor': 'white' }, { 'color': '#343DAC', 'textColor': 'white' }, { 'color': '#781DA0', 'textColor': 'white' }, { 'color': '#9B0D54', 'textColor': 'white' },
    { 'color': '#0095D3', 'textColor': 'black' }, { 'color': '#9DA3DB', 'textColor': 'black' }, { 'color': '#BE90D6', 'textColor': 'black' }, { 'color': '#F1428A', 'textColor': 'black' },
    { 'color': '#1D5100', 'textColor': 'white' }, { 'color': '#006668', 'textColor': 'white' }, { 'color': '#006690', 'textColor': 'white' }, { 'color': '#004A70', 'textColor': 'white' },
    { 'color': '#48960C', 'textColor': 'black' }, { 'color': '#00AB9A', 'textColor': 'black' }, { 'color': '#00B7D6', 'textColor': 'black' }, { 'color': '#0081A7', 'textColor': 'black' },
    { 'color': '#C92100', 'textColor': 'white' }, { 'color': '#CD3517', 'textColor': 'white' }, { 'color': '#C25400', 'textColor': 'white' }, { 'color': '#D28F00', 'textColor': 'white' },
    { 'color': '#F52F52', 'textColor': 'black' }, { 'color': '#FF5501', 'textColor': 'black' }, { 'color': '#F57600', 'textColor': 'black' }, { 'color': '#FFDC0B', 'textColor': 'black' },
];

// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//    http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var CreateEditLabelComponent = (function () {
    function CreateEditLabelComponent(labelService, errorHandler, ref) {
        this.labelService = labelService;
        this.errorHandler = errorHandler;
        this.ref = ref;
        this.labelModel = this.initLabel();
        this.labelId = 0;
        this.isLabelNameExist = false;
        this.panelHidden = true;
        this.nameChecker = new rxjs_Subject.Subject();
        this.reload = new _angular_core.EventEmitter();
    }
    CreateEditLabelComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.nameChecker.debounceTime(500).subscribe(function (name) {
            _this.checkOnGoing = true;
            var labelName = _this.currentForm.controls['name'].value;
            toPromise(_this.labelService.getLabels(_this.scope, _this.projectId, labelName))
                .then(function (targets) {
                if (targets && targets.length) {
                    _this.isLabelNameExist = true;
                }
                else {
                    _this.isLabelNameExist = false;
                }
                _this.checkOnGoing = false;
            }).catch(function (error) {
                _this.checkOnGoing = false;
                _this.errorHandler.error(error);
            });
            setTimeout(function () {
                setInterval(function () { return _this.ref.markForCheck(); }, 100);
            }, 3000);
        });
    };
    CreateEditLabelComponent.prototype.ngOnDestroy = function () {
        this.nameChecker.unsubscribe();
    };
    Object.defineProperty(CreateEditLabelComponent.prototype, "labelColor", {
        get: function () {
            return LabelColor;
        },
        enumerable: true,
        configurable: true
    });
    CreateEditLabelComponent.prototype.initLabel = function () {
        return {
            name: '',
            description: '',
            color: '',
            scope: '',
            project_id: 0
        };
    };
    CreateEditLabelComponent.prototype.openModal = function () {
        this.labelModel = this.initLabel();
        this.formShow = true;
        this.isLabelNameExist = false;
        this.labelId = 0;
        this.copeLabelModel = null;
    };
    CreateEditLabelComponent.prototype.editModel = function (labelId, label) {
        this.labelModel = clone(label[0]);
        this.formShow = true;
        this.labelId = labelId;
        this.copeLabelModel = clone(label[0]);
    };
    CreateEditLabelComponent.prototype.openColorPanel = function () {
        this.panelHidden = false;
    };
    CreateEditLabelComponent.prototype.closeColorPanel = function () {
        this.panelHidden = true;
    };
    Object.defineProperty(CreateEditLabelComponent.prototype, "hasChanged", {
        get: function () {
            return !compareValue(this.copeLabelModel, this.labelModel);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CreateEditLabelComponent.prototype, "isValid", {
        get: function () {
            return !(this.checkOnGoing || this.isLabelNameExist || !(this.currentForm && this.currentForm.valid) || !this.hasChanged || this.inProgress);
        },
        enumerable: true,
        configurable: true
    });
    CreateEditLabelComponent.prototype.existValid = function (text) {
        if (text) {
            this.nameChecker.next(text);
        }
    };
    CreateEditLabelComponent.prototype.onSubmit = function () {
        var _this = this;
        this.inProgress = true;
        if (this.labelId <= 0) {
            this.labelModel.scope = this.scope;
            this.labelModel.project_id = this.projectId;
            toPromise(this.labelService.createLabel(this.labelModel))
                .then(function (res) {
                _this.inProgress = false;
                _this.reload.emit();
                _this.labelModel = _this.initLabel();
            }).catch(function (err) {
                _this.inProgress = false;
                _this.errorHandler.error(err);
            });
        }
        else {
            toPromise(this.labelService.updateLabel(this.labelId, this.labelModel))
                .then(function (res) {
                _this.inProgress = false;
                _this.reload.emit();
                _this.labelModel = _this.initLabel();
            }).catch(function (err) {
                _this.inProgress = false;
                _this.errorHandler.error(err);
            });
        }
    };
    CreateEditLabelComponent.prototype.onCancel = function () {
        this.inProgress = false;
        this.labelModel = this.initLabel();
        this.formShow = false;
    };
    return CreateEditLabelComponent;
}());
CreateEditLabelComponent.decorators = [
    { type: _angular_core.Component, args: [{
                selector: 'hbr-create-edit-label',
                template: CREATE_EDIT_LABEL_TEMPLATE,
                styles: [CREATE_EDIT_LABEL_STYLE],
                changeDetection: _angular_core.ChangeDetectionStrategy.Default
            },] },
];
/** @nocollapse */
CreateEditLabelComponent.ctorParameters = function () { return [
    { type: LabelService, },
    { type: ErrorHandler, },
    { type: _angular_core.ChangeDetectorRef, },
]; };
CreateEditLabelComponent.propDecorators = {
    'currentForm': [{ type: _angular_core.ViewChild, args: ['labelForm',] },],
    'projectId': [{ type: _angular_core.Input },],
    'scope': [{ type: _angular_core.Input },],
    'reload': [{ type: _angular_core.Output },],
};

// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//    http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var LabelComponent = (function () {
    function LabelComponent(labelService, errorHandler, translateService, ref) {
        this.labelService = labelService;
        this.errorHandler = errorHandler;
        this.translateService = translateService;
        this.ref = ref;
        this.selectedRow = [];
        this.batchDelectionInfos = [];
        this.projectId = 0;
    }
    LabelComponent.prototype.ngOnInit = function () {
        this.retrieve(this.scope);
    };
    LabelComponent.prototype.retrieve = function (scope, name) {
        var _this = this;
        if (name === void 0) { name = ''; }
        this.loading = true;
        this.selectedRow = [];
        this.targetName = '';
        toPromise(this.labelService.getLabels(scope, this.projectId, name))
            .then(function (targets) {
            _this.targets = targets || [];
            _this.loading = false;
            _this.forceRefreshView(2000);
        }).catch(function (error) {
            _this.errorHandler.error(error);
            _this.loading = false;
        });
    };
    LabelComponent.prototype.openModal = function () {
        this.createEditLabel.openModal();
    };
    LabelComponent.prototype.reload = function () {
        this.retrieve(this.scope);
    };
    LabelComponent.prototype.doSearchTargets = function (targetName) {
        this.retrieve(this.scope, targetName);
    };
    LabelComponent.prototype.refreshTargets = function () {
        this.retrieve(this.scope);
    };
    LabelComponent.prototype.selectedChange = function () {
        // this.forceRefreshView(5000);
    };
    LabelComponent.prototype.editLabel = function (label) {
        this.createEditLabel.editModel(label[0].id, label);
    };
    LabelComponent.prototype.deleteLabels = function (targets) {
        var _this = this;
        if (targets && targets.length) {
            var targetNames_1 = [];
            this.batchDelectionInfos = [];
            targets.forEach(function (target) {
                targetNames_1.push(target.name);
                var initBatchMessage = new BatchInfo();
                initBatchMessage.name = target.name;
                _this.batchDelectionInfos.push(initBatchMessage);
            });
            var deletionMessage = new ConfirmationMessage('LABEL.DELETION_TITLE_TARGET', 'LABEL.DELETION_SUMMARY_TARGET', targetNames_1.join(', ') || '', targets, 6 /* TARGET */, 2 /* DELETE_CANCEL */);
            this.confirmationDialogComponent.open(deletionMessage);
        }
    };
    LabelComponent.prototype.confirmDeletion = function (message) {
        var _this = this;
        if (message &&
            message.source === 6 /* TARGET */ &&
            message.state === 1 /* CONFIRMED */) {
            var targetLists = message.data;
            if (targetLists && targetLists.length) {
                var promiseLists_1 = [];
                targetLists.forEach(function (target) {
                    promiseLists_1.push(_this.delOperate(target.id, target.name));
                });
                Promise.all(promiseLists_1).then(function (item) {
                    _this.selectedRow = [];
                    _this.retrieve(_this.scope);
                });
            }
        }
    };
    LabelComponent.prototype.delOperate = function (id, name) {
        var _this = this;
        var findedList = this.batchDelectionInfos.find(function (data) { return data.name === name; });
        return toPromise(this.labelService
            .deleteLabel(id))
            .then(function (response) {
            _this.translateService.get('BATCH.DELETED_SUCCESS')
                .subscribe(function (res) {
                findedList = BathInfoChanges(findedList, res);
            });
        }).catch(function (error) {
            _this.translateService.get('BATCH.DELETED_FAILURE').subscribe(function (res) {
                findedList = BathInfoChanges(findedList, res, false, true);
            });
        });
    };
    // Forcely refresh the view
    LabelComponent.prototype.forceRefreshView = function (duration) {
        var _this = this;
        // Reset timer
        if (this.timerHandler) {
            clearInterval(this.timerHandler);
        }
        this.timerHandler = setInterval(function () { return _this.ref.markForCheck(); }, 100);
        setTimeout(function () {
            if (_this.timerHandler) {
                clearInterval(_this.timerHandler);
                _this.timerHandler = null;
            }
        }, duration);
    };
    return LabelComponent;
}());
LabelComponent.decorators = [
    { type: _angular_core.Component, args: [{
                selector: 'hbr-label',
                template: LABEL_TEMPLATE,
                styles: [LABEL_STYLE],
                changeDetection: _angular_core.ChangeDetectionStrategy.OnPush
            },] },
];
/** @nocollapse */
LabelComponent.ctorParameters = function () { return [
    { type: LabelService, },
    { type: ErrorHandler, },
    { type: _ngxTranslate_core.TranslateService, },
    { type: _angular_core.ChangeDetectorRef, },
]; };
LabelComponent.propDecorators = {
    'scope': [{ type: _angular_core.Input },],
    'projectId': [{ type: _angular_core.Input },],
    'hasProjectAdminRole': [{ type: _angular_core.Input },],
    'createEditLabel': [{ type: _angular_core.ViewChild, args: [CreateEditLabelComponent,] },],
    'confirmationDialogComponent': [{ type: _angular_core.ViewChild, args: ['confirmationDialog',] },],
};

var LABEL_DIRECTIVES = [
    LabelComponent
];

var CREATE_EDIT_LABEL_DIRECTIVES = [
    CreateEditLabelComponent
];

/**
 * Define template resources for filter component
 */
/**
 * Define template resources for filter component
 */ var LABEL_PIEICE_TEMPLATE = "\n<label class=\"label\" [ngStyle]=\"{'background-color': labelColor?.color, 'color': labelColor?.textColor, 'border': labelColor?.color == '#FFFFFF'? '1px solid #666': 'none'}\" [style.max-width.px]=\"labelWidth\">\n    <clr-icon *ngIf=\"label.scope=='p'\" shape=\"organization\"></clr-icon>\n    <clr-icon *ngIf=\"label.scope=='g'\" shape=\"administrator\"></clr-icon>\n     {{label.name}}\n</label>\n";
var LABEL_PIEICE_STYLES = "\n   .label{border: none; color:#222;\n      display: inline-block;\n      justify-content: flex-start;\n      overflow: hidden;\n      text-overflow: ellipsis;\n      line-height: .875rem;}\n   .label clr-icon{ margin-right: 3px;}\n   .btn-group .dropdown-menu clr-icon{display:block;}\n";

// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//    http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var LabelPieceComponent = (function () {
    function LabelPieceComponent() {
    }
    LabelPieceComponent.prototype.ngOnChanges = function () {
        if (this.label) {
            var color_1 = this.label.color;
            this.labelColor = LabelColor.find(function (data) { return data.color === color_1; });
        }
    };
    LabelPieceComponent.prototype.ngOnInit = function () { };
    return LabelPieceComponent;
}());
LabelPieceComponent.decorators = [
    { type: _angular_core.Component, args: [{
                selector: 'hbr-label-piece',
                styles: [LABEL_PIEICE_STYLES],
                template: LABEL_PIEICE_TEMPLATE
            },] },
];
/** @nocollapse */
LabelPieceComponent.ctorParameters = function () { return []; };
LabelPieceComponent.propDecorators = {
    'label': [{ type: _angular_core.Input },],
    'labelWidth': [{ type: _angular_core.Input },],
};

/*export * from "./filter.component";*/
var LABEL_PIECE_DIRECTIVES = [
    LabelPieceComponent
];

/**
 * Declare default service configuration; all the endpoints will be defined in
 * this default configuration.
 */
var DefaultServiceConfig = {
    systemInfoEndpoint: "/api/systeminfo",
    repositoryBaseEndpoint: "/api/repositories",
    logBaseEndpoint: "/api/logs",
    targetBaseEndpoint: "/api/targets",
    replicationBaseEndpoint: "/api/replications",
    replicationRuleEndpoint: "/api/policies/replication",
    replicationJobEndpoint: "/api/jobs/replication",
    vulnerabilityScanningBaseEndpoint: "/api/repositories",
    projectPolicyEndpoint: "/api/projects/configs",
    projectBaseEndpoint: "/api/projects",
    enablei18Support: false,
    langCookieKey: DEFAULT_LANG_COOKIE_KEY,
    supportedLangs: DEFAULT_SUPPORTING_LANGS,
    defaultLang: DEFAULT_LANG,
    langMessageLoader: "local",
    langMessagePathForHttpLoader: "i18n/langs/",
    langMessageFileSuffixForHttpLoader: "-lang.json",
    localI18nMessageVariableMap: {},
    configurationEndpoint: "/api/configurations",
    scanJobEndpoint: "/api/jobs/scan",
    labelEndpoint: "/api/labels"
};
/**
 * @export
 * @param {AppConfigService} configService
 * @returns
 */
function initConfig(translateInitializer, config) {
    return (init);
    function init() {
        translateInitializer.init({
            enablei18Support: config.enablei18Support,
            supportedLangs: config.supportedLangs,
            defaultLang: config.defaultLang,
            langCookieKey: config.langCookieKey
        });
    }
    
}
var HarborLibraryModule = (function () {
    function HarborLibraryModule() {
    }
    HarborLibraryModule.forRoot = function (config) {
        if (config === void 0) { config = {}; }
        return {
            ngModule: HarborLibraryModule,
            providers: [
                config.config || { provide: SERVICE_CONFIG, useValue: DefaultServiceConfig },
                config.errorHandler || { provide: ErrorHandler, useClass: DefaultErrorHandler },
                config.systemInfoService || { provide: SystemInfoService, useClass: SystemInfoDefaultService },
                config.logService || { provide: AccessLogService, useClass: AccessLogDefaultService },
                config.endpointService || { provide: EndpointService, useClass: EndpointDefaultService },
                config.replicationService || { provide: ReplicationService, useClass: ReplicationDefaultService },
                config.repositoryService || { provide: RepositoryService, useClass: RepositoryDefaultService },
                config.tagService || { provide: TagService, useClass: TagDefaultService },
                config.scanningService || { provide: ScanningResultService, useClass: ScanningResultDefaultService },
                config.configService || { provide: ConfigurationService, useClass: ConfigurationDefaultService },
                config.jobLogService || { provide: JobLogService, useClass: JobLogDefaultService },
                config.projectPolicyService || { provide: ProjectService, useClass: ProjectDefaultService },
                config.labelService || { provide: LabelService, useClass: LabelDefaultService },
                // Do initializing
                TranslateServiceInitializer,
                {
                    provide: _angular_core.APP_INITIALIZER,
                    useFactory: initConfig,
                    deps: [TranslateServiceInitializer, SERVICE_CONFIG],
                    multi: true
                },
                ChannelService
            ]
        };
    };
    HarborLibraryModule.forChild = function (config) {
        if (config === void 0) { config = {}; }
        return {
            ngModule: HarborLibraryModule,
            providers: [
                config.config || { provide: SERVICE_CONFIG, useValue: DefaultServiceConfig },
                config.errorHandler || { provide: ErrorHandler, useClass: DefaultErrorHandler },
                config.systemInfoService || { provide: SystemInfoService, useClass: SystemInfoDefaultService },
                config.logService || { provide: AccessLogService, useClass: AccessLogDefaultService },
                config.endpointService || { provide: EndpointService, useClass: EndpointDefaultService },
                config.replicationService || { provide: ReplicationService, useClass: ReplicationDefaultService },
                config.repositoryService || { provide: RepositoryService, useClass: RepositoryDefaultService },
                config.tagService || { provide: TagService, useClass: TagDefaultService },
                config.scanningService || { provide: ScanningResultService, useClass: ScanningResultDefaultService },
                config.configService || { provide: ConfigurationService, useClass: ConfigurationDefaultService },
                config.jobLogService || { provide: JobLogService, useClass: JobLogDefaultService },
                config.projectPolicyService || { provide: ProjectService, useClass: ProjectDefaultService },
                config.labelService || { provide: LabelService, useClass: LabelDefaultService },
                ChannelService
            ]
        };
    };
    return HarborLibraryModule;
}());
HarborLibraryModule.decorators = [
    { type: _angular_core.NgModule, args: [{
                imports: [
                    SharedModule
                ],
                declarations: [
                    LOG_DIRECTIVES,
                    FILTER_DIRECTIVES,
                    ENDPOINT_DIRECTIVES,
                    REPOSITORY_DIRECTIVES,
                    REPOSITORY_STACKVIEW_DIRECTIVES,
                    REPOSITORY_LISTVIEW_DIRECTIVES,
                    TAG_DIRECTIVES,
                    CREATE_EDIT_ENDPOINT_DIRECTIVES,
                    CONFIRMATION_DIALOG_DIRECTIVES,
                    INLINE_ALERT_DIRECTIVES,
                    REPLICATION_DIRECTIVES,
                    LIST_REPLICATION_RULE_DIRECTIVES,
                    CREATE_EDIT_RULE_DIRECTIVES,
                    DATETIME_PICKER_DIRECTIVES,
                    VULNERABILITY_DIRECTIVES,
                    PUSH_IMAGE_BUTTON_DIRECTIVES,
                    CONFIGURATION_DIRECTIVES,
                    JOB_LOG_VIEWER_DIRECTIVES,
                    PROJECT_POLICY_CONFIG_DIRECTIVES,
                    LABEL_DIRECTIVES,
                    CREATE_EDIT_LABEL_DIRECTIVES,
                    LABEL_PIECE_DIRECTIVES,
                    HBR_GRIDVIEW_DIRECTIVES,
                    REPOSITORY_GRIDVIEW_DIRECTIVES,
                ],
                exports: [
                    LOG_DIRECTIVES,
                    FILTER_DIRECTIVES,
                    ENDPOINT_DIRECTIVES,
                    REPOSITORY_DIRECTIVES,
                    REPOSITORY_STACKVIEW_DIRECTIVES,
                    REPOSITORY_LISTVIEW_DIRECTIVES,
                    TAG_DIRECTIVES,
                    CREATE_EDIT_ENDPOINT_DIRECTIVES,
                    CONFIRMATION_DIALOG_DIRECTIVES,
                    INLINE_ALERT_DIRECTIVES,
                    REPLICATION_DIRECTIVES,
                    LIST_REPLICATION_RULE_DIRECTIVES,
                    CREATE_EDIT_RULE_DIRECTIVES,
                    DATETIME_PICKER_DIRECTIVES,
                    VULNERABILITY_DIRECTIVES,
                    PUSH_IMAGE_BUTTON_DIRECTIVES,
                    CONFIGURATION_DIRECTIVES,
                    JOB_LOG_VIEWER_DIRECTIVES,
                    _ngxTranslate_core.TranslateModule,
                    PROJECT_POLICY_CONFIG_DIRECTIVES,
                    LABEL_DIRECTIVES,
                    CREATE_EDIT_LABEL_DIRECTIVES,
                    LABEL_PIECE_DIRECTIVES,
                    HBR_GRIDVIEW_DIRECTIVES,
                    REPOSITORY_GRIDVIEW_DIRECTIVES,
                ],
                providers: []
            },] },
];
/** @nocollapse */
HarborLibraryModule.ctorParameters = function () { return []; };

exports.DefaultServiceConfig = DefaultServiceConfig;
exports.initConfig = initConfig;
exports.HarborLibraryModule = HarborLibraryModule;
exports.SERVICE_CONFIG = SERVICE_CONFIG;
exports.Filter = Filter;
exports.Trigger = Trigger;
exports.SystemInfoService = SystemInfoService;
exports.SystemInfoDefaultService = SystemInfoDefaultService;
exports.AccessLogService = AccessLogService;
exports.AccessLogDefaultService = AccessLogDefaultService;
exports.EndpointService = EndpointService;
exports.EndpointDefaultService = EndpointDefaultService;
exports.ReplicationService = ReplicationService;
exports.ReplicationDefaultService = ReplicationDefaultService;
exports.RepositoryService = RepositoryService;
exports.RepositoryDefaultService = RepositoryDefaultService;
exports.VerifiedSignature = VerifiedSignature;
exports.TagService = TagService;
exports.TagDefaultService = TagDefaultService;
exports.RequestQueryParams = RequestQueryParams;
exports.ScanningResultService = ScanningResultService;
exports.ScanningResultDefaultService = ScanningResultDefaultService;
exports.ConfigurationService = ConfigurationService;
exports.ConfigurationDefaultService = ConfigurationDefaultService;
exports.JobLogService = JobLogService;
exports.JobLogDefaultService = JobLogDefaultService;
exports.ProjectService = ProjectService;
exports.ProjectDefaultService = ProjectDefaultService;
exports.LabelService = LabelService;
exports.LabelDefaultService = LabelDefaultService;
exports.ErrorHandler = ErrorHandler;
exports.DefaultErrorHandler = DefaultErrorHandler;
exports.LOG_DIRECTIVES = LOG_DIRECTIVES;
exports.RecentLogComponent = RecentLogComponent;
exports.FILTER_DIRECTIVES = FILTER_DIRECTIVES;
exports.FilterComponent = FilterComponent;
exports.ENDPOINT_DIRECTIVES = ENDPOINT_DIRECTIVES;
exports.REPOSITORY_DIRECTIVES = REPOSITORY_DIRECTIVES;
exports.CREATE_EDIT_ENDPOINT_DIRECTIVES = CREATE_EDIT_ENDPOINT_DIRECTIVES;
exports.CREATE_EDIT_RULE_DIRECTIVES = CREATE_EDIT_RULE_DIRECTIVES;
exports.REPOSITORY_STACKVIEW_DIRECTIVES = REPOSITORY_STACKVIEW_DIRECTIVES;
exports.TAG_DIRECTIVES = TAG_DIRECTIVES;
exports.TagComponent = TagComponent;
exports.TagDetailComponent = TagDetailComponent;
exports.LIST_REPLICATION_RULE_DIRECTIVES = LIST_REPLICATION_RULE_DIRECTIVES;
exports.REPLICATION_DIRECTIVES = REPLICATION_DIRECTIVES;
exports.SearchOption = SearchOption;
exports.ReplicationComponent = ReplicationComponent;
exports.VULNERABILITY_DIRECTIVES = VULNERABILITY_DIRECTIVES;
exports.MIN_TIP_WIDTH = MIN_TIP_WIDTH;
exports.MAX_TIP_WIDTH = MAX_TIP_WIDTH;
exports.ResultTipComponent = ResultTipComponent;
exports.ResultGridComponent = ResultGridComponent;
exports.ResultBarChartComponent = ResultBarChartComponent;
exports.TranslateServiceInitializer = TranslateServiceInitializer;
exports.PUSH_IMAGE_BUTTON_DIRECTIVES = PUSH_IMAGE_BUTTON_DIRECTIVES;
exports.PushImageButtonComponent = PushImageButtonComponent;
exports.CopyInputComponent = CopyInputComponent;
exports.WindowTokenModule = WindowTokenModule;
exports.WINDOW = WINDOW;
exports.ClipboardModule = ClipboardModule;
exports.ClipboardDirective = ClipboardDirective;
exports.ClipboardService = ClipboardService;
exports.CLIPBOARD_SERVICE_PROVIDER_FACTORY = CLIPBOARD_SERVICE_PROVIDER_FACTORY;
exports.CLIPBOARD_SERVICE_PROVIDER = CLIPBOARD_SERVICE_PROVIDER;
exports.CONFIGURATION_DIRECTIVES = CONFIGURATION_DIRECTIVES;
exports.StringValueItem = StringValueItem;
exports.NumberValueItem = NumberValueItem;
exports.BoolValueItem = BoolValueItem;
exports.ComplexValueItem = ComplexValueItem;
exports.Configuration = Configuration;
exports.ReplicationConfigComponent = ReplicationConfigComponent;
exports.SystemSettingsComponent = SystemSettingsComponent;
exports.VulnerabilityConfigComponent = VulnerabilityConfigComponent;
exports.RegistryConfigComponent = RegistryConfigComponent;
exports.JOB_LOG_VIEWER_DIRECTIVES = JOB_LOG_VIEWER_DIRECTIVES;
exports.JobLogViewerComponent = JobLogViewerComponent;
exports.ChannelService = ChannelService;
exports.PROJECT_POLICY_CONFIG_DIRECTIVES = PROJECT_POLICY_CONFIG_DIRECTIVES;
exports.ProjectPolicy = ProjectPolicy;
exports.ProjectPolicyConfigComponent = ProjectPolicyConfigComponent;
exports.LABEL_DIRECTIVES = LABEL_DIRECTIVES;
exports.CREATE_EDIT_LABEL_DIRECTIVES = CREATE_EDIT_LABEL_DIRECTIVES;
exports.HBR_GRIDVIEW_DIRECTIVES = HBR_GRIDVIEW_DIRECTIVES;
exports.GridViewComponent = GridViewComponent;
exports.REPOSITORY_GRIDVIEW_DIRECTIVES = REPOSITORY_GRIDVIEW_DIRECTIVES;
exports.RepositoryGridviewComponent = RepositoryGridviewComponent;

Object.defineProperty(exports, '__esModule', { value: true });

})));
