export var CREATE_EDIT_ENDPOINT_TEMPLATE = "\n<clr-modal [(clrModalOpen)]=\"createEditDestinationOpened\" [clrModalStaticBackdrop]=\"staticBackdrop\" [clrModalClosable]=\"closable\">\n  <h3 class=\"modal-title\">{{modalTitle}}</h3>\n  <hbr-inline-alert class=\"modal-title\" (confirmEvt)=\"confirmCancel($event)\"></hbr-inline-alert>\n  <div class=\"modal-body\">\n    <div class=\"alert alert-warning\" *ngIf=\"!editable\">\n      <div class=\"alert-item static\">\n        <span class=\"alert-text\">\n          {{'DESTINATION.CANNOT_EDIT' | translate}}\n        </span>\n      </div>\n    </div>\n    <form #targetForm=\"ngForm\">\n      <section class=\"form-block\">\n        <div class=\"form-group\">\n          <label for=\"destination_name\" class=\"col-md-4 form-group-label-override required\">{{ 'DESTINATION.NAME' | translate }}</label>\n          <label class=\"col-md-8\" for=\"destination_name\" aria-haspopup=\"true\" role=\"tooltip\" [class.invalid]=\"targetName.errors && (targetName.dirty || targetName.touched)\" [class.valid]=\"targetName.valid\" class=\"tooltip tooltip-validation tooltip-sm tooltip-bottom-left\">\n            <input type=\"text\" id=\"destination_name\" [disabled]=\"testOngoing\" [readonly]=\"!editable\" [(ngModel)]=\"target.name\" name=\"targetName\" size=\"20\" #targetName=\"ngModel\" required> \n            <span class=\"tooltip-content\" *ngIf=\"targetName.errors && targetName.errors.required && (targetName.dirty || targetName.touched)\">\n              {{ 'DESTINATION.NAME_IS_REQUIRED' | translate }}\n            </span>\n          </label>\n        </div>\n        <div class=\"form-group\">\n          <label for=\"destination_url\" class=\"col-md-4 form-group-label-override required\">{{ 'DESTINATION.URL' | translate }}</label>\n          <label class=\"col-md-8\" for=\"destination_url\" aria-haspopup=\"true\" role=\"tooltip\" [class.invalid]=\"targetEndpoint.errors && (targetEndpoint.dirty || targetEndpoint.touched)\" [class.valid]=\"targetEndpoint.valid\" class=\"tooltip tooltip-validation tooltip-sm tooltip-bottom-left\">\n            <input type=\"text\" id=\"destination_url\" [disabled]=\"testOngoing\" [readonly]=\"!editable\" [(ngModel)]=\"target.endpoint\" size=\"20\" name=\"endpointUrl\" #targetEndpoint=\"ngModel\" required placeholder=\"http(s)://192.168.1.1\">\n            <span class=\"tooltip-content\" *ngIf=\"targetEndpoint.errors && targetEndpoint.errors.required && (targetEndpoint.dirty || targetEndpoint.touched)\">\n              {{ 'DESTINATION.URL_IS_REQUIRED' | translate }}\n            </span>\n          </label>\n        </div>\n        <div class=\"form-group\">\n          <label for=\"destination_username\" class=\"col-md-4 form-group-label-override\">{{ 'DESTINATION.USERNAME' | translate }}</label>\n          <input type=\"text\" class=\"col-md-8\" id=\"destination_username\" [disabled]=\"testOngoing\" [readonly]=\"!editable\" [(ngModel)]=\"target.username\" size=\"20\" name=\"username\" #username=\"ngModel\">\n        </div>\n        <div class=\"form-group\">\n          <label for=\"destination_password\" class=\"col-md-4 form-group-label-override\">{{ 'DESTINATION.PASSWORD' | translate }}</label>\n          <input type=\"password\" class=\"col-md-8\" id=\"destination_password\" [disabled]=\"testOngoing\" [readonly]=\"!editable\" [(ngModel)]=\"target.password\" size=\"20\" name=\"password\" #password=\"ngModel\">\n        </div>\n        <div class=\"form-group\">\n          <label for=\"destination_insecure\" class=\"col-md-4 form-group-label-override\">{{'CONFIG.VERIFY_REMOTE_CERT' | translate }}</label>\n          <clr-checkbox #insecure name=\"insecure\" id=\"destination_insecure\" [clrDisabled]=\"testOngoing || !editable\" [clrChecked]=\"!target.insecure\" [clrInline]=\"true\" (clrCheckedChange)=\"setInsecureValue($event)\">\n          </clr-checkbox>\n          <clr-tooltip>\n            <clr-icon clrTooltipTrigger shape=\"info-circle\" size=\"24\"></clr-icon>\n            <clr-tooltip-content clrPosition=\"top-right\" clrSize=\"md\" *clrIfOpen>\n              {{'CONFIG.TOOLTIP.VERIFY_REMOTE_CERT' | translate}}\n            </clr-tooltip-content>\n          </clr-tooltip>\n        </div>\n        <div class=\"form-group\">\n          <label for=\"spin\" class=\"col-md-4\"></label>\n          <span class=\"col-md-8 spinner spinner-inline\" [hidden]=\"!inProgress\"></span>\n        </div>\n      </section>\n    </form>\n  </div>\n  <div class=\"modal-footer\">\n      <button type=\"button\" class=\"btn btn-outline\" (click)=\"testConnection()\" [disabled]=\"inProgress || targetEndpoint.errors\">{{ 'DESTINATION.TEST_CONNECTION' | translate }}</button>\n      <button type=\"button\" class=\"btn btn-outline\" (click)=\"onCancel()\"  [disabled]=\"inProgress\">{{ 'BUTTON.CANCEL' | translate }}</button>\n      <button type=\"submit\" class=\"btn btn-primary\" (click)=\"onSubmit()\"  [disabled]=\"!isValid\">{{ 'BUTTON.OK' | translate }}</button>\n  </div>\n</clr-modal>";
//# sourceMappingURL=create-edit-endpoint.component.html.js.map