export var CREATE_EDIT_RULE_TEMPLATE = "\n<clr-modal [(clrModalOpen)]=\"createEditRuleOpened\" [clrModalStaticBackdrop]=\"true\" [clrModalClosable]=\"false\">\n  <h3 class=\"modal-title\">{{headerTitle | translate}}</h3>\n  <hbr-inline-alert class=\"modal-title\" (confirmEvt)=\"confirmCancel($event)\"></hbr-inline-alert>\n  <div class=\"modal-body\" style=\"max-height: 85vh;\">\n    <form [formGroup]=\"ruleForm\"  novalidate>\n     <section class=\"form-block\">\n      <div class=\"form-group form-group-override\">\n       <label class=\"form-group-label-override required\">{{'REPLICATION.NAME' | translate}}</label>\n       <label aria-haspopup=\"true\" role=\"tooltip\" class=\"tooltip tooltip-validation tooltip-md tooltip-bottom-left\"\n              [class.invalid]='(ruleForm.controls.name.touched && ruleForm.controls.name.invalid) || isRuleNameExist'>\n        <input type=\"text\" id=\"ruleName\" pattern=\"^[a-z0-9]+(?:[._-][a-z0-9]+)*$\" class=\"inputWidth\" required maxlength=\"255\" formControlName=\"name\" #ruleName (keyup)='checkRuleName()' autocomplete=\"off\">\n        <span class=\"tooltip-content\">{{ruleNameTooltip | translate}}</span>\n       </label><span class=\"spinner spinner-inline spinner-pos\" [hidden]=\"!inNameChecking\"></span>\n      </div>\n      <!--Description-->\n      <div class=\"form-group form-group-override\">\n       <label class=\"form-group-label-override\">{{'REPLICATION.DESCRIPTION' | translate}}</label>\n       <textarea type=\"text\" id=\"ruleDescription\" class=\"inputWidth\" row= 3; formControlName=\"description\"></textarea>\n      </div>\n      <!--Projects-->\n      <div class=\"form-group form-group-override\">\n       <label class=\"form-group-label-override required\">{{'REPLICATION.SOURCE_PROJECT' | translate}}</label>\n       <div formArrayName=\"projects\">\n        <div class=\"projectInput inputWidth\" *ngFor=\"let project of projects.controls; let i= index\" [formGroupName]=\"i\" (mouseleave)=\"leaveInput()\">\n         <input *ngIf=\"!projectId\" formControlName=\"name\" type=\"text\" class=\"inputWidth\"  value=\"name\" required\n                pattern=\"^[a-z0-9]+(?:[._-][a-z0-9]+)*$\" (keyup)='handleValidation()' (focus)=\"focusClear($event)\" autocomplete=\"off\">\n         <input *ngIf=\"projectId\" formControlName=\"name\" type=\"text\"  class=\"inputWidth\"  value=\"name\" readonly>\n         <div class=\"selectBox inputWidth\"  [style.display]=\"selectedProjectList.length ? 'block' : 'none'\" >\n          <ul>\n           <li *ngFor=\"let project of selectedProjectList\" (click)=\"selectedProjectName(project?.name)\">{{project?.name}}</li>\n          </ul>\n         </div>\n        </div>\n       </div>\n       <label *ngIf=\"noProjectInfo.length != 0\" class=\"colorRed alertLabel\">{{noProjectInfo | translate}}</label>\n      </div>\n    \n    <!--images/Filter-->\n      <div class=\"form-group form-group-override\">\n       <label class=\"form-group-label-override\">{{'REPLICATION.SOURCE_IMAGES_FILTER' | translate}}</label>\n       <div formArrayName=\"filters\">\n        <div class=\"filterSelect\" *ngFor=\"let filter of filters.controls; let i=index\"  [formGroupName]=\"i\">\n         <div>\n          <div class=\"select floatSetPar\">\n           <select formControlName=\"kind\" (change)=\"filterChange($event)\"  id=\"{{i}}\" name=\"{{filterListData[i]?.name}}\">\n            <option *ngFor=\"let filter of filterListData[i]?.options;\" value=\"{{filter}}\">{{filter}}</option>\n           </select>\n          </div>\n          <label aria-haspopup=\"true\" role=\"tooltip\" class=\"tooltip tooltip-validation tooltip-md tooltip-bottom-left\"\n                 [class.invalid]='ruleForm.controls.filters.controls[i].controls.pattern.touched && ruleForm.controls.filters.controls[i].controls.pattern.invalid'>\n           <input type=\"text\" #filterValue required size=\"14\" formControlName=\"pattern\">\n           <span class=\"tooltip-content\">{{'TOOLTIP.EMPTY' | translate}}</span>\n          </label>\n          <clr-icon shape=\"times-circle\" class=\"is-solid\"  (click)=\"deleteFilter(i)\"></clr-icon>\n         </div>\n        </div>\n       </div>\n        <clr-icon shape=\"plus-circle\" class=\"is-solid\" [hidden]=\"isFilterHide\" (click)=\"addNewFilter()\" style=\"margin-top: 11px;\"></clr-icon>\n      </div>\n      <!--Targets-->\n      <div class=\"form-group form-group-override\">\n       <label class=\"form-group-label-override  required\">{{'DESTINATION.ENDPOINT' | translate}}</label>\n       <div formArrayName=\"targets\">\n        <div class=\"select endpointSelect pull-left\" *ngFor=\"let target of targets.controls; let i= index\" [formGroupName]=\"i\">\n          <select id=\"ruleTarget\" (change)=\"targetChange($event)\"  formControlName=\"id\">\n           <option *ngFor=\"let target of targetList\" value=\"{{target.id}}\">{{target.name}}-{{target.endpoint}}</option>\n          </select>\n         </div>\n       </div>\n       <label *ngIf=\"noEndpointInfo.length != 0\" class=\"colorRed alertLabel\">{{noEndpointInfo | translate}}</label>\n       <span class=\"alertLabel goLink\" *ngIf=\"noEndpointInfo.length != 0\" (click)=\"goRegistry()\">{{'REPLICATION.ENDPOINTS' | translate}}</span>\n       </div>\n\n      <!--Trigger-->\n      <div class=\"form-group form-group-override\">\n       <label class=\"form-group-label-override\">{{'REPLICATION.TRIGGER_MODE' | translate}}</label>\n       <div  formGroupName=\"trigger\">\n        <!--on trigger-->\n        <div class=\"select floatSetPar\">\n         <select id=\"ruleTrigger\" formControlName=\"kind\"  (change)=\"selectTrigger($event)\">\n          <option value=\"Manual\">{{'REPLICATION.MANUAL' | translate}}</option>\n          <option value=\"Immediate\">{{'REPLICATION.IMMEDIATE' | translate}}</option>\n          <option value=\"Scheduled\">{{'REPLICATION.SCHEDULE' | translate}}</option>\n         </select>\n        </div>\n        <!--on push-->\n        <div formGroupName=\"schedule_param\">\n          <div class=\"select floatSet\" [hidden]=\"!isScheduleOpt\">\n           <select name=\"scheduleType\" formControlName=\"type\" (change)=\"selectSchedule($event)\">\n            <option value=\"Daily\">{{'REPLICATION.DAILY' | translate}}</option>\n            <option value=\"Weekly\">{{'REPLICATION.WEEKLY' | translate}}</option>\n           </select>\n          </div>\n          <!--weekly-->\n          <span [hidden]=\"!weeklySchedule || !isScheduleOpt\">on &nbsp;</span>\n          <div  [hidden]=\"!weeklySchedule || !isScheduleOpt\" class=\"select floatSet\" style=\"width:104px\">\n           <select name=\"scheduleDay\" formControlName=\"weekday\">\n            <option value=\"1\">{{'WEEKLY.MONDAY' | translate}}</option>\n            <option value=\"2\">{{'WEEKLY.TUESDAY' | translate}}</option>\n            <option value=\"3\">{{'WEEKLY.WEDNESDAY' | translate}}</option>\n            <option value=\"4\">{{'WEEKLY.THURSDAY' | translate}}</option>\n            <option value=\"5\">{{'WEEKLY.FRIDAY' | translate}}</option>\n            <option value=\"6\">{{'WEEKLY.SATURDAY' | translate}}</option>\n            <option value=\"7\">{{'WEEKLY.SUNDAY' | translate}}</option>\n           </select>\n          </div>\n          <!--daily/time-->\n          <span [hidden]=\"!isScheduleOpt\">at &nbsp;</span>\n          <input [hidden]=\"!isScheduleOpt\" type=\"time\" formControlName=\"offtime\"  required value=\"08:00\" />\n        </div>\n       </div>\n       <div style=\"width: 100%;\" [hidden]=\"!isImmediate\">\n        <clr-checkbox [clrChecked]=\"false\" id=\"ruleDeletion\" formControlName=\"replicate_deletion\">\n         {{'REPLICATION.DELETE_REMOTE_IMAGES' | translate}}\n        </clr-checkbox>\n       </div>\n       <div  style=\"width: 100%;\" >\n        <clr-checkbox [clrChecked]=\"true\" id=\"ruleExit\" formControlName=\"replicate_existing_image_now\">\n         {{'REPLICATION.REPLICATE_IMMEDIATE' | translate}}\n        </clr-checkbox>\n       </div>\n      </div>\n      <div style=\"display:block;text-align:center\">\n       <span class=\"spinner spinner-inline\" [hidden]=\"inProgress === false\"></span>\n     </div>\n     </section>\n    </form>\n  </div>\n  <div class=\"modal-footer\">\n    <button type=\"button\" id=\"ruleBtnCancel\" class=\"btn btn-outline\" [disabled]=\"this.inProgress\" (click)=\"onCancel()\">{{ 'BUTTON.CANCEL' | translate }}</button>\n    <button type=\"submit\" id=\"ruleBtnOk\" class=\"btn btn-primary\"  (click)=\"onSubmit()\" [disabled]=\"!ruleForm.valid || !isValid || !hasFormChange()\">{{ 'BUTTON.SAVE' | translate }}</button>\n  </div>\n</clr-modal>";
//# sourceMappingURL=create-edit-rule.component.html.js.map