/**
 * Define the inline template and styles with ts variables
 */
/**
 * Define the inline template and styles with ts variables
 */ export var LOG_TEMPLATE = "\n<div>\n    <h2 class=\"h2-log-override\" *ngIf=\"withTitle\">{{'SIDE_NAV.LOGS' | translate}}</h2>\n    <div class=\"row flex-items-xs-between flex-items-xs-bottom\">\n        <div></div>\n        <div class=\"action-head-pos rightPos\">\n            <hbr-filter [withDivider]=\"true\" filterPlaceholder='{{\"AUDIT_LOG.FILTER_PLACEHOLDER\" | translate}}' (filter)=\"doFilter($event)\" [currentValue]=\"currentTerm\"></hbr-filter>\n            <span (click)=\"refresh()\" class=\"refresh-btn\">\n            <clr-icon shape=\"refresh\" [hidden]=\"inProgress\" ng-disabled=\"inProgress\"></clr-icon>\n            <span class=\"spinner spinner-inline\" [hidden]=\"!inProgress\"></span>\n            </span>\n        </div>\n    </div>\n    <div>\n        <clr-datagrid (clrDgRefresh)=\"load($event)\" [clrDgLoading]=\"loading\">\n            <clr-dg-column [clrDgField]=\"'username'\">{{'AUDIT_LOG.USERNAME' | translate}}</clr-dg-column>\n            <clr-dg-column [clrDgField]=\"'repo_name'\">{{'AUDIT_LOG.REPOSITORY_NAME' | translate}}</clr-dg-column>\n            <clr-dg-column [clrDgField]=\"'repo_tag'\">{{'AUDIT_LOG.TAGS' | translate}}</clr-dg-column>\n            <clr-dg-column [clrDgField]=\"'operation'\">{{'AUDIT_LOG.OPERATION' | translate}}</clr-dg-column>\n            <clr-dg-column [clrDgSortBy]=\"opTimeComparator\">{{'AUDIT_LOG.TIMESTAMP' | translate}}</clr-dg-column>\n            <clr-dg-placeholder>We couldn't find any logs!</clr-dg-placeholder>\n            <clr-dg-row *ngFor=\"let l of recentLogs\">\n                <clr-dg-cell>{{l.username}}</clr-dg-cell>\n                <clr-dg-cell>{{l.repo_name}}</clr-dg-cell>\n                <clr-dg-cell>{{l.repo_tag}}</clr-dg-cell>\n                <clr-dg-cell>{{l.operation}}</clr-dg-cell>\n                <clr-dg-cell>{{l.op_time | date: 'short'}}</clr-dg-cell>\n            </clr-dg-row>\n            <clr-dg-footer>\n            {{pagination.firstItem + 1}} - {{pagination.lastItem + 1}}\n    {{'AUDIT_LOG.OF' | translate}} {{pagination.totalItems}} {{'AUDIT_LOG.ITEMS' | translate}}\n            <clr-dg-pagination #pagination [(clrDgPage)]=\"currentPage\" [clrDgPageSize]=\"pageSize\" [clrDgTotalItems]=\"totalCount\"></clr-dg-pagination>\n            </clr-dg-footer>\n        </clr-datagrid>\n    </div>\n</div>\n";
export var LOG_STYLES = "\n.h2-log-override {\n    margin-top: 0px !important;\n}\n\n.action-head-pos {\n    padding-right: 18px;\n    height: 24px;\n}\n\n.refresh-btn {\n    cursor: pointer;\n}\n\n.refresh-btn:hover {\n    color: #007CBB;\n}\n\n.custom-lines-button {\n    padding: 0px !important;\n    min-width: 25px !important;\n}\n\n.lines-button-toggole {\n    font-size: 16px;\n    text-decoration: underline;\n}\n\n.log-select {\n    width: 130px;\n    display: inline-block;\n    top: 1px;\n}\n\n.item-divider {\n    height: 24px;\n    display: inline-block;\n    width: 1px;\n    background-color: #ccc;\n    opacity: 0.55;\n    margin-left: 12px;\n    top: 8px;\n    position: relative;\n}\n.rightPos {\n    position: absolute;\n    z-index: 100;\n    right: 35px;\n    margin-top: 4px;\n}\n";
//# sourceMappingURL=recent-log.template.js.map