export var PROJECT_POLICY_CONFIG_TEMPLATE = "\n<form #projectPolicyForm=\"ngForm\">\n    <section class=\"form-block\">\n        <div class=\"form-group\">\n          <label for=\"projectPolicyForm\">{{ 'PROJECT_CONFIG.REGISTRY' | translate }}</label>\n          <div class=\"form-content\">\n            <clr-checkbox [(ngModel)]=\"projectPolicy.Public\" name=\"public\"\n              [clrDisabled]=\"!hasProjectAdminRole\">{{ 'PROJECT_CONFIG.PUBLIC_TOGGLE' | translate }}</clr-checkbox>\n            <div>\n              <label> {{ 'PROJECT_CONFIG.PUBLIC_POLICY' | translate }} </label>\n            </div>\n          </div>\n        </div>\n        <div class=\"form-group\" *ngIf=\"withNotary || withClair\">\n          <label for=\"projectPolicyForm\">{{ 'PROJECT_CONFIG.SECURITY' | translate }}</label>\n          <div class=\"form-content\">\n            <div *ngIf=\"withNotary\">\n              <clr-checkbox [(ngModel)]=\"projectPolicy.ContentTrust\" name=\"content-trust\" \n                [clrDisabled]=\"!hasProjectAdminRole\">{{ 'PROJECT_CONFIG.CONTENT_TRUST_TOGGLE' | translate }}</clr-checkbox>\n              <div class=\"chk-explain\"><label> {{ 'PROJECT_CONFIG.CONTENT_TRUST_POLCIY' | translate }} </label></div>\n            </div>\n            <div *ngIf=\"withClair\">\n              <clr-checkbox [(ngModel)]=\"projectPolicy.PreventVulImg\" name=\"prevent-vulenrability-image\" [clrDisabled]=\"!hasProjectAdminRole\">{{ 'PROJECT_CONFIG.PREVENT_VULNERABLE_TOGGLE' | translate }}</clr-checkbox>\n              <div class=\"chk-explain\">\n                <label>\n                  <div id=\"severity-blk\">\n                    <div>{{ 'PROJECT_CONFIG.PREVENT_VULNERABLE_1' | translate }}</div>\n                    <div class=\"select\">\n                      <select id=\"severity\" name=\"severity\" [(ngModel)]=\"projectPolicy.PreventVulImgSeverity\" [disabled]=\"!projectPolicy.PreventVulImg\">\n                        <option *ngFor='let s of severityOptions' [ngValue]=\"s.severity\">{{ s.severityLevel | translate | uppercase }}</option>                      \n                      </select>\n                    </div> \n                    <div> {{ 'PROJECT_CONFIG.PREVENT_VULNERABLE_2' | translate }} </div>\n                  </div>\n                </label>\n              </div>\n            </div>\n          </div>\n        </div>\n        <div class=\"form-group\" *ngIf=\"withClair\">\n          <label for=\"projectPolicyForm\">{{ 'PROJECT_CONFIG.SCAN' | translate }}</label>\n          <div class=\"form-content\">\n            <clr-checkbox [(ngModel)]=\"projectPolicy.ScanImgOnPush\" name=\"scan-image-on-push\" [clrDisabled]=\"!hasProjectAdminRole\">{{ 'PROJECT_CONFIG.AUTOSCAN_TOGGLE' | translate }}</clr-checkbox>\n            <div class=\"chk-explain\"><label> {{ 'PROJECT_CONFIG.AUTOSCAN_POLICY' | translate }}</label></div>\n          </div>\n        </div>\n       <button type=\"button\" class=\"btn btn-primary\" (click)=\"save()\" [disabled]=\"!isValid() || !hasChanges() || !hasProjectAdminRole\">{{'BUTTON.SAVE' | translate}}</button>\n       <button type=\"button\" class=\"btn btn-outline\" (click)=\"cancel()\" [disabled]=\"!isValid() || !hasChanges() || !hasProjectAdminRole\">{{'BUTTON.CANCEL' | translate}}</button>\n       <confirmation-dialog #cfgConfirmationDialog (confirmAction)=\"confirmCancel($event)\"></confirmation-dialog>       \n    </section>\n</form>";
//# sourceMappingURL=project-policy-config.component.html.js.map