export var REPLICATION_TEMPLATE = "\n<div class=\"row\" style=\"position:relative;\">\n  <div>\n    <div class=\"row flex-items-xs-between rightPos\">\n      <div class=\"flex-xs-middle option-right\">\n        <hbr-filter [withDivider]=\"true\" filterPlaceholder='{{\"REPLICATION.FILTER_POLICIES_PLACEHOLDER\" | translate}}' (filter)=\"doSearchRules($event)\" [currentValue]=\"search.ruleName\"></hbr-filter>\n        <span class=\"refresh-btn\" (click)=\"refreshRules()\">\n          <clr-icon shape=\"refresh\"></clr-icon>\n        </span>\n      </div>\n    </div>\n    </div>\n    <div class=\"col-lg-12 col-md-12 col-sm-12 col-xs-12\">\n      <hbr-list-replication-rule #listReplicationRule [projectId]=\"projectId\" [isSystemAdmin]=\"isSystemAdmin\"  (replicateManual)=replicateManualRule($event) (selectOne)=\"selectOneRule($event)\" (hideJobs)=\"hideJobs()\"  (openNewRule)=\"openModal()\" (editOne)=\"openEditRule($event)\" (reload)=\"reloadRules($event)\" [loading]=\"loading\" [withReplicationJob]=\"withReplicationJob\" (redirect)=\"customRedirect($event)\"></hbr-list-replication-rule>\n    </div>\n    <div class=\"col-lg-12 col-md-12 col-sm-12 col-xs-12\" style=\"padding-left:0px;\" [hidden]='hiddenJobList'>\n    <div *ngIf=\"withReplicationJob\" class=\"col-lg-12 col-md-12 col-sm-12 col-xs-12\">\n      <div class=\"row flex-items-xs-between\" style=\"height:60px;\">\n        <h5 class=\"flex-items-xs-bottom option-left-down\" style=\"margin-left: 14px;\">{{'REPLICATION.REPLICATION_JOBS' | translate}}</h5>\n        <div class=\"flex-items-xs-bottom option-right-down\">\n          <button class=\"btn btn-link\" (click)=\"toggleSearchJobOptionalName(currentJobSearchOption)\">{{toggleJobSearchOption[currentJobSearchOption] | translate}}</button>\n          <hbr-filter [withDivider]=\"true\" filterPlaceholder='{{\"REPLICATION.FILTER_JOBS_PLACEHOLDER\" | translate}}' (filter)=\"doSearchJobs($event)\" [currentValue]=\"search.repoName\" ></hbr-filter>\n          <span class=\"refresh-btn\" (click)=\"refreshJobs()\">\n            <clr-icon shape=\"refresh\"></clr-icon>\n          </span>\n        </div>\n      </div>\n      <div class=\"row flex-items-xs-right option-right\" [hidden]=\"currentJobSearchOption === 0\">\n        <div class=\"select\" style=\"float: left;\">\n          <select (change)=\"doFilterJobStatus($event)\">\n          <option *ngFor=\"let j of jobStatus\" value=\"{{j.key}}\" [selected]=\"currentJobStatus.key === j.key\">{{j.description | translate}}</option>\n          </select>\n        </div>\n        <div class=\"flex-items-xs-middle\">    \n          <hbr-datetime [dateInput]=\"search.startTime\" (search)=\"doJobSearchByStartTime($event)\"></hbr-datetime>\n          <hbr-datetime [dateInput]=\"search.endTime\" [oneDayOffset]=\"true\" (search)=\"doJobSearchByEndTime($event)\"></hbr-datetime>\n        </div>\n      </div>\n    </div>\n    <div *ngIf=\"withReplicationJob\" class=\"col-lg-12 col-md-12 col-sm-12 col-xs-12\">\n      <clr-datagrid [clrDgLoading]=\"jobsLoading\" (clrDgRefresh)=\"clrLoadJobs($event)\"><clr-dg-action-bar>\n            <div class=\"btn-group\">\n                <button type=\"button\" class=\"btn btn-sm btn-secondary\" *ngIf=\"isSystemAdmin\" [disabled]=\"!(jobs && jobs.length>0) || isStopOnGoing\" (click)=\"stopJobs()\">{{'REPLICATION.STOPJOB' | translate}}</button>\n            </div>\n        </clr-dg-action-bar>\n        <clr-dg-column [clrDgField]=\"'repository'\">{{'REPLICATION.NAME' | translate}}</clr-dg-column>\n        <clr-dg-column [clrDgField]=\"'status'\">{{'REPLICATION.STATUS' | translate}}</clr-dg-column>\n        <clr-dg-column [clrDgField]=\"'operation'\">{{'REPLICATION.OPERATION' | translate}}</clr-dg-column>\n        <clr-dg-column [clrDgSortBy]=\"creationTimeComparator\">{{'REPLICATION.CREATION_TIME' | translate}}</clr-dg-column>\n        <clr-dg-column [clrDgSortBy]=\"updateTimeComparator\">{{'REPLICATION.UPDATE_TIME' | translate}}</clr-dg-column>\n        <clr-dg-column>{{'REPLICATION.LOGS' | translate}}</clr-dg-column>\n        <clr-dg-placeholder>{{'REPLICATION.JOB_PLACEHOLDER' | translate }}</clr-dg-placeholder>\n        <clr-dg-row *ngFor=\"let j of jobs\">\n            <clr-dg-cell>{{j.repository}}</clr-dg-cell>\n            <clr-dg-cell>{{j.status}}</clr-dg-cell>\n            <clr-dg-cell>{{j.operation}}</clr-dg-cell>\n            <clr-dg-cell>{{j.creation_time | date: 'short'}}</clr-dg-cell>\n            <clr-dg-cell>{{j.update_time | date: 'short'}}</clr-dg-cell>\n            <clr-dg-cell>\n             <span *ngIf=\"j.status=='pending'; else elseBlock\" class=\"label\">{{'REPLICATION.NO_LOGS' | translate}}</span>\n                <ng-template #elseBlock>\n                    <a href=\"javascript:void(0);\" (click)=\"viewLog(j.id)\">\n                <clr-icon shape=\"clipboard\"></clr-icon>\n              </a></ng-template>\n            </clr-dg-cell>\n        </clr-dg-row>\n        <clr-dg-footer>\n            <span *ngIf=\"showPaginationIndex\">{{pagination.firstItem + 1}} - {{pagination.lastItem + 1}} {{'REPLICATION.OF' | translate}}</span>\n            {{pagination.totalItems}} {{'REPLICATION.ITEMS' | translate}}\n            <clr-dg-pagination #pagination [(clrDgPage)]=\"currentPage\" [clrDgPageSize]=\"pageSize\" [clrDgTotalItems]=\"totalCount\"></clr-dg-pagination>\n        </clr-dg-footer>\n      </clr-datagrid>\n    </div>\n    </div>\n    <job-log-viewer #replicationLogViewer></job-log-viewer>\n    <hbr-create-edit-rule  *ngIf=\"isSystemAdmin\" [projectId]=\"projectId\" [projectName]=\"projectName\" (goToRegistry)=\"goRegistry()\" (reload)=\"reloadRules($event)\"></hbr-create-edit-rule>\n    <confirmation-dialog #replicationConfirmDialog [batchInfors]=\"batchDelectionInfos\" (confirmAction)=\"confirmReplication($event)\"></confirmation-dialog>\n</div>";
//# sourceMappingURL=replication.component.html.js.map