export var REPOSITORY_GRIDVIEW_TEMPLATE = "\n<div>\n    <div class=\"row\" style=\"position:relative;\">\n        <div class=\"toolbar\">\n            <div class=\"row flex-items-xs-right option-right rightPos\">\n                <div class=\"flex-xs-middle\">\n                    <hbr-push-image-button style=\"display: inline-block;\" [registryUrl]=\"registryUrl\" [projectName]=\"projectName\"></hbr-push-image-button>\n                    <hbr-filter [withDivider]=\"true\" filterPlaceholder=\"{{'REPOSITORY.FILTER_FOR_REPOSITORIES' | translate}}\" (filter)=\"doSearchRepoNames($event)\" [currentValue]=\"lastFilteredRepoName\"></hbr-filter>\n                    <span class=\"card-btn\" (click)=\"showCard(true)\" (mouseenter) =\"mouseEnter('card') \"  (mouseleave) =\"mouseLeave('card')\">\n                        <clr-icon [ngClass]=\"{'is-highlight': isCardView || isHovering('card') }\" shape=\"view-cards\"></clr-icon>\n                    </span>\n                    <span class=\"list-btn\" (click)=\"showCard(false)\" (mouseenter) =\"mouseEnter('list') \"  (mouseleave) =\"mouseLeave('list')\">\n                        <clr-icon [ngClass]=\"{'is-highlight': !isCardView || isHovering('list') }\"shape=\"view-list\"></clr-icon>\n                    </span>\n                    <span class=\"filter-divider\"></span>\n                    <span class=\"refresh-btn\" (click)=\"refresh()\"><clr-icon shape=\"refresh\"></clr-icon></span>\n                </div>\n            </div>\n        </div>\n    </div>\n    <div *ngIf=\"!isCardView\" class=\"col-lg-12 col-md-12 col-sm-12 col-xs-12\">\n      <clr-datagrid (clrDgRefresh)=\"clrLoad($event)\" [clrDgLoading]=\"loading\"  [(clrDgSelected)]=\"selectedRow\" (clrDgSelectedChange)=\"selectedChange()\">\n        <clr-dg-action-bar>\n          <button *ngIf=\"withAdmiral\" type=\"button\" class=\"btn btn-sm btn-secondary\" (click)=\"provisionItemEvent($event, selectedRow[0])\" [disabled]=\"!(selectedRow.length===1 && hasProjectAdminRole)\"><clr-icon shape=\"times\" size=\"16\"></clr-icon>&nbsp;{{'REPOSITORY.DEPLOY' | translate}}</button>\n          <button *ngIf=\"withAdmiral\" type=\"button\" class=\"btn btn-sm btn-secondary\" (click)=\"itemAddInfoEvent($event, selectedRow[0])\" [disabled]=\"!(selectedRow.length===1 && hasProjectAdminRole)\"><clr-icon shape=\"times\" size=\"16\"></clr-icon>&nbsp;{{'REPOSITORY.ADDITIONAL_INFO' | translate}}</button>\n          <button type=\"button\" class=\"btn btn-sm btn-secondary\" (click)=\"deleteRepos(selectedRow)\" [disabled]=\"!(selectedRow.length && hasProjectAdminRole)\"><clr-icon shape=\"times\" size=\"16\"></clr-icon>&nbsp;{{'REPOSITORY.DELETE' | translate}}</button>\n        </clr-dg-action-bar>\n        <clr-dg-column [clrDgField]=\"'name'\">{{'REPOSITORY.NAME' | translate}}</clr-dg-column>\n        <clr-dg-column [clrDgSortBy]=\"tagsCountComparator\">{{'REPOSITORY.TAGS_COUNT' | translate}}</clr-dg-column>\n        <clr-dg-column [clrDgSortBy]=\"pullCountComparator\">{{'REPOSITORY.PULL_COUNT' | translate}}</clr-dg-column>\n        <clr-dg-placeholder>{{'REPOSITORY.PLACEHOLDER' | translate }}</clr-dg-placeholder>\n        <clr-dg-row *ngFor=\"let r of repositories\"  [clrDgItem]=\"r\">\n          <clr-dg-cell><a href=\"javascript:void(0)\" (click)=\"watchRepoClickEvt(r)\"><span *ngIf=\"withAdmiral\" class=\"list-img\"><img [src]=\"getImgLink(r)\"/></span>{{r.name}}</a></clr-dg-cell>\n          <clr-dg-cell>{{r.tags_count}}</clr-dg-cell>\n          <clr-dg-cell>{{r.pull_count}}</clr-dg-cell>\n        </clr-dg-row>\n        <clr-dg-footer>\n          <span *ngIf=\"showDBStatusWarning\" class=\"db-status-warning\">\n            <clr-icon shape=\"warning\" class=\"is-warning\" size=\"24\"></clr-icon>\n            {{'CONFIG.SCANNING.DB_NOT_READY' | translate }}\n          </span>\n          <span *ngIf=\"pagination.totalItems\">{{pagination.firstItem + 1}} - {{pagination.lastItem + 1}} {{'REPOSITORY.OF' | translate}}</span>\n          {{pagination.totalItems}} {{'REPOSITORY.ITEMS' | translate}}\n          <clr-dg-pagination #pagination [(clrDgPage)]=\"currentPage\" [clrDgPageSize]=\"pageSize\" [clrDgTotalItems]=\"totalCount\"></clr-dg-pagination>\n        </clr-dg-footer>\n      </clr-datagrid>\n    </div>\n    <hbr-gridview *ngIf=\"isCardView\" #gridView style=\"position:relative;\" [items]=\"repositories\" [loading]=\"loading\" [pageSize]=\"pageSize\"\n        [currentPage]=\"currentPage\" [totalCount]=\"totalCount\" [expectScrollPercent]=\"90\" [withAdmiral]=\"withAdmiral\" (loadNextPageEvent)=\"loadNextPage()\">\n        <ng-template let-item=\"item\">\n            <a class=\"card clickable\" (click)=\"watchRepoClickEvt(item)\">\n                <div class=\"card-header\">\n                    <div [ngClass]=\"{'card-media-block': true, 'wrap': !withAdmiral }\">\n                        <img *ngIf=\"withAdmiral\" [src]=\"getImgLink(item)\"/>\n                        <div class=\"card-media-description\">\n                            <span class=\"card-media-title\">{{item.name}}</span>\n                            <p class=\"card-media-text\">{{registryUrl}}</p>\n                        </div>\n                    </div>\n                </div>\n                <div class=\"card-block\">\n                    <div class=\"card-text\">\n                        {{getRepoDescrition(item)}}\n                    </div>\n                    <div class=\"form-group\">\n                        <label>{{'REPOSITORY.TAGS_COUNT' | translate}}</label>\n                        <div>{{item.tags_count}}</div>\n                    </div>\n                    <div class=\"form-group\">\n                        <label>{{'REPOSITORY.PULL_COUNT' | translate}}</label>\n                        <div>{{item.pull_count}}</div>\n                    </div>\n                </div>\n                <div class=\"card-footer\">\n                    <clr-dropdown [clrCloseMenuOnItemClick]=\"false\">\n                        <button *ngIf=\"withAdmiral\" type=\"button\" class=\"btn btn-link\" (click)=\"provisionItemEvent($event, item)\" [disabled]=\"!hasProjectAdminRole\">{{'REPOSITORY.DEPLOY' | translate}}</button>\n                        <button type=\"button\" class=\"btn btn-link\" (click)=\"$event.stopPropagation()\" [disabled]=\"!hasProjectAdminRole\" clrDropdownTrigger>\n                            {{'REPOSITORY.ACTION' | translate}}\n                            <clr-icon shape=\"caret down\"></clr-icon>\n                        </button>\n                        <clr-dropdown-menu clrPosition=\"top-left\" *clrIfOpen>\n                            <button *ngIf=\"withAdmiral\" type=\"button\" class=\"btn btn-link\" clrDropdownItem (click)=\"itemAddInfoEvent($event, item)\" [disabled]=\"!hasProjectAdminRole\">\n                                {{'REPOSITORY.ADDITIONAL_INFO' | translate}}\n                            </button>\n                            <button type=\"button\" class=\"btn btn-link\" clrDropdownItem (click)=\"deleteItemEvent($event, item)\" [disabled]=\"!hasProjectAdminRole\">\n                                {{'REPOSITORY.DELETE' | translate}}\n                            </button>\n                        </clr-dropdown-menu>\n                    </clr-dropdown>\n                </div>\n            </a>\n        </ng-template>\n    </hbr-gridview>\n  <confirmation-dialog #confirmationDialog [batchInfors]=\"batchDelectionInfos\" (confirmAction)=\"confirmDeletion($event)\"></confirmation-dialog>\n</div>\n";
//# sourceMappingURL=repository-gridview.component.html.js.map