export var TIP_COMPONENT_HTML = "\n<div class=\"tip-wrapper tip-position\" [style.width]='maxWidth'>\n    <clr-tooltip>\n        <div clrTooltipTrigger>\n        <div class=\"tip-wrapper tip-block bar-block-high\" [style.width]='tipWidth(5)'></div>\n        <div class=\"tip-wrapper tip-block bar-block-medium\" [style.width]='tipWidth(4)'></div>\n        <div class=\"tip-wrapper tip-block bar-block-low\" [style.width]='tipWidth(3)'></div>\n        <div class=\"tip-wrapper tip-block bar-block-unknown\" [style.width]='tipWidth(2)'></div>\n        <div class=\"tip-wrapper tip-block bar-block-none\" [style.width]='tipWidth(1)'></div>\n        </div>\n        <clr-tooltip-content [clrPosition]=\"'top-right'\" [clrSize]=\"'lg'\" *clrIfOpen>\n            <div [ngSwitch]=\"scanLevel\" class=\"bar-tooltip-font-larger\">\n                <ng-template [ngSwitchCase]=\"5\">\n                    <clr-icon shape=\"exclamation-circle\" class=\"is-error\" size=\"32\"></clr-icon>\n                    <span>{{'VULNERABILITY.OVERALL_SEVERITY' | translate }} <span class=\"font-weight-600\">{{'VULNERABILITY.SEVERITY.HIGH' | translate | titlecase }}</span></span>\n                </ng-template>\n                <ng-template [ngSwitchCase]=\"4\">\n                    <clr-icon *ngIf=\"hasMedium\" shape=\"exclamation-triangle\" class=\"tip-icon-medium\" size=\"30\"></clr-icon>\n                    <span>{{'VULNERABILITY.OVERALL_SEVERITY' | translate }} <span class=\"font-weight-600\">{{'VULNERABILITY.SEVERITY.MEDIUM' | translate | titlecase}}</span></span>\n                </ng-template>\n                <ng-template [ngSwitchCase]=\"3\">\n                    <clr-icon shape=\"play\" class=\"tip-icon-low rotate-90\" size=\"28\"></clr-icon>\n                    <span>{{'VULNERABILITY.OVERALL_SEVERITY' | translate }} <span class=\"font-weight-600\">{{'VULNERABILITY.SEVERITY.LOW' | translate | titlecase }}</span></span>\n                </ng-template>\n                <ng-template [ngSwitchCase]=\"2\">\n                    <clr-icon shape=\"help\" size=\"24\" style=\"margin-left: 3px;\"></clr-icon>\n                    <span>{{'VULNERABILITY.OVERALL_SEVERITY' | translate }} <span class=\"font-weight-600\">{{'VULNERABILITY.SEVERITY.UNKNOWN' | translate | titlecase }}</span></span>\n                </ng-template>\n                <ng-template [ngSwitchCase]=\"1\">\n                    <clr-icon shape=\"check-circle\"  class=\"is-success\" size=\"32\"></clr-icon>\n                    <span>{{'VULNERABILITY.NO_VULNERABILITY' | translate }}</span>\n                </ng-template>\n            </div>\n            <hr>\n            <div>\n                <span class=\"bar-tooltip-font bar-tooltip-font-title\">{{tipTitle}}</span>\n            </div>\n            <div class=\"bar-summary bar-tooltip-fon\">\n                <div *ngIf=\"hasHigh\" class=\"bar-summary-item\">\n                    <span><clr-icon shape=\"exclamation-circle\" class=\"is-error\" size=\"24\"></clr-icon></span>\n                    <span>{{highCount}}</span><span>{{'VULNERABILITY.SEVERITY.HIGH' | translate }}</span>\n                </div>\n                <div *ngIf=\"hasMedium\" class=\"bar-summary-item\">\n                    <span><clr-icon *ngIf=\"hasMedium\" shape=\"exclamation-triangle\" class=\"tip-icon-medium\" size=\"22\"></clr-icon></span>\n                    <span>{{mediumCount}}</span><span>{{'VULNERABILITY.SEVERITY.MEDIUM' | translate }}</span>\n                </div>\n                <div *ngIf=\"hasLow\" class=\"bar-summary-item\">\n                    <span><clr-icon shape=\"play\" class=\"tip-icon-low rotate-90\" size=\"20\"></clr-icon></span>\n                    <span>{{lowCount}}</span><span>{{'VULNERABILITY.SEVERITY.LOW' | translate }}</span>\n                </div>\n                <div *ngIf=\"hasUnknown\" class=\"bar-summary-item\">\n                    <span><clr-icon shape=\"help\" size=\"18\"></clr-icon></span>\n                    <span>{{unknownCount}}</span><span>{{'VULNERABILITY.SEVERITY.UNKNOWN' | translate }}</span>\n                </div>\n                <div *ngIf=\"hasNone\" class=\"bar-summary-item\">\n                    <span><clr-icon shape=\"check-circle\" class=\"is-success\" size=\"24\"></clr-icon></span>\n                    <span>{{noneCount}}</span><span>{{'VULNERABILITY.SEVERITY.NONE' | translate }}</span>\n                </div>\n            </div>\n            <div>\n                <span class=\"bar-scanning-time\">{{'VULNERABILITY.CHART.SCANNING_TIME' | translate}} </span>\n                <span>{{completeTimestamp | date:'MM/dd/y HH:mm:ss'}}</span>\n            </div>\n        </clr-tooltip-content>\n    </clr-tooltip>\n</div>\n";
export var GRID_COMPONENT_HTML = "\n<div class=\"row\"  style=\"position:relative;\">\n  <div>  \n    <div class=\"row flex-items-xs-right rightPos\">\n      <div class=\"flex-xs-middle option-right\">\n        <hbr-filter [withDivider]=\"true\" filterPlaceholder=\"{{'VULNERABILITY.PLACEHOLDER' | translate}}\" (filter)=\"filterVulnerabilities($event)\"></hbr-filter>  \n        <span class=\"refresh-btn\" (click)=\"refresh()\"><clr-icon shape=\"refresh\"></clr-icon></span>\n      </div>\n    </div>\n  </div>\n  <div class=\"col-lg-12 col-md-12 col-sm-12 col-xs-12\">\n    <clr-datagrid>\n        <clr-dg-action-bar>\n          <button type=\"button\" class=\"btn btn-sm btn-secondary\" (click)=\"scanNow()\"><clr-icon shape=\"shield-check\" size=\"16\"></clr-icon>&nbsp;{{'VULNERABILITY.SCAN_NOW' | translate}}</button>\n        </clr-dg-action-bar>\n        <clr-dg-column [clrDgField]=\"'id'\">{{'VULNERABILITY.GRID.COLUMN_ID' | translate}}</clr-dg-column>\n        <clr-dg-column [clrDgField]=\"'severity'\">{{'VULNERABILITY.GRID.COLUMN_SEVERITY' | translate}}</clr-dg-column>\n        <clr-dg-column [clrDgField]=\"'package'\">{{'VULNERABILITY.GRID.COLUMN_PACKAGE' | translate}}</clr-dg-column>\n        <clr-dg-column [clrDgField]=\"'version'\">{{'VULNERABILITY.GRID.COLUMN_VERSION' | translate}}</clr-dg-column>\n        <clr-dg-column [clrDgField]=\"'fixedVersion'\">{{'VULNERABILITY.GRID.COLUMN_FIXED' | translate}}</clr-dg-column>\n\n        <clr-dg-placeholder>{{'VULNERABILITY.GRID.PLACEHOLDER' | translate}}</clr-dg-placeholder>\n        <clr-dg-row *clrDgItems=\"let res of scanningResults\">\n            <clr-dg-cell><a href=\"{{res.link}}\" target=\"_blank\">{{res.id}}</a></clr-dg-cell>\n            <clr-dg-cell [ngSwitch]=\"res.severity\">\n              <span *ngSwitchCase=\"5\" class=\"label label-danger\">{{severityText(res.severity) | translate}}</span>\n              <span *ngSwitchCase=\"4\" class=\"label label-medium\">{{severityText(res.severity) | translate}}</span>\n              <span *ngSwitchCase=\"3\" class=\"label label-low\">{{severityText(res.severity) | translate}}</span>\n              <span *ngSwitchCase=\"1\" class=\"label\">{{severityText(res.severity) | translate}}</span>\n              <span *ngSwitchDefault>{{severityText(res.severity) | translate}}</span>\n            </clr-dg-cell>\n            <clr-dg-cell>{{res.package}}</clr-dg-cell>\n            <clr-dg-cell>{{res.version}}</clr-dg-cell>\n            <clr-dg-cell>\n                 <div *ngIf=\"res.fixedVersion; else elseBlock\">\n                    <clr-icon shape=\"wrench\" class=\"is-success\" size=\"20\"></clr-icon>&nbsp;<span class=\"font-color-green\">{{res.fixedVersion}}</span>\n                 </div>\n                <ng-template #elseBlock>{{res.fixedVersion}}</ng-template>\n            </clr-dg-cell>\n            <clr-dg-row-detail *clrIfExpanded>\n            {{'VULNERABILITY.GRID.COLUMN_DESCRIPTION' | translate}}: {{res.description}}\n            </clr-dg-row-detail>\n        </clr-dg-row>\n\n        <clr-dg-footer>\n            <span *ngIf=\"pagination.totalItems\">{{pagination.firstItem + 1}} - {{pagination.lastItem + 1}} {{'VULNERABILITY.GRID.FOOT_OF' | translate}}</span>\n             {{pagination.totalItems}} {{'VULNERABILITY.GRID.FOOT_ITEMS' | translate}}\n            <clr-dg-pagination #pagination [clrDgPageSize]=\"25\" [clrDgTotalItems]=\"scanningResults.length\"></clr-dg-pagination>\n        </clr-dg-footer>\n    </clr-datagrid>\n  </div>\n</div>\n";
export var BAR_CHART_COMPONENT_HTML = "\n<div class=\"bar-wrapper\">\n    <div *ngIf=\"stopped\" class=\"bar-state\">\n       <span class=\"label\">{{'VULNERABILITY.STATE.STOPPED' | translate}}</span>\n    </div>\n    <div *ngIf=\"queued\" class=\"bar-state\">\n        <span class=\"label label-orange\">{{'VULNERABILITY.STATE.QUEUED' | translate}}</span>\n    </div>\n    <div *ngIf=\"error\" class=\"bar-state bar-state-error\">\n        <a href=\"javascript:void(0);\" class=\"error-text\" (click)=\"viewLog()\">\n            <clr-icon shape=\"error\" class=\"is-error\" size=\"24\"></clr-icon>\n            {{'VULNERABILITY.STATE.ERROR' | translate}}\n        </a>\n    </div>\n    <div *ngIf=\"scanning\" class=\"bar-state bar-state-chart\">\n        <div>{{'VULNERABILITY.STATE.SCANNING' | translate}}</div>\n        <div class=\"progress loop\" style=\"height:2px;\"><progress></progress></div>\n    </div>\n    <div *ngIf=\"completed\" class=\"bar-state bar-state-chart\">\n        <hbr-vulnerability-summary-chart [summary]=\"summary\"></hbr-vulnerability-summary-chart>\n    </div>\n    <div *ngIf=\"unknown\" class=\"bar-state\">\n        <clr-icon shape=\"warning\" class=\"is-warning\" size=\"24\"></clr-icon>\n        <span style=\"margin-left:-5px;\">{{'VULNERABILITY.STATE.UNKNOWN' | translate}}</span>\n    </div>\n    <job-log-viewer #scanningLogViewer [jobType]=\"'scan'\"></job-log-viewer>\n</div>\n";
//# sourceMappingURL=scanning.html.js.map